-- region *.lua
-- Date
-- 此文件由[BabeLua]插件自动生成

game.CAssetGameGroundFlag =
{
    ice_ground  = 1,
}

local ice_ground_add_effect = function(ground,object)
    object.ground_flag = game.CAssetGameGroundFlag.ice_ground
end

local ice_ground_remove_efect = function(ground,object)
    object.ground_flag = nil
end

game.CAssetGameGround = {
    ["grass"] =
    {
        file_type = "image",
        file_path = { 
            single = "images/map/grass.png",
            group = {
                "images/map/grass_1.png",
                "images/map/grass_2.png",
                "images/map/grass_3.png",
            },
        },
        can_collide = true,
    },
    ["air_grass"] =
    {
        file_type = "image",
        file_path = { 
            single = "images/map/air_grass.png",
            group = {
                "images/map/air_grass_1.png",
                "images/map/air_grass_2.png",
                "images/map/air_grass_3.png",
            },
        },
    },
    ["sand"] =
    {
        file_type = "image",
        file_path = { 
            single = "tmx/tile/sand.png", 
            group = {
                "tmx/tile/sand.png", 
                "tmx/tile/sand.png", 
                "tmx/tile/sand.png", 
            },
        },
        decelerate_speed = 0.7,
        add_effect = function(ground, object)
            local move_component = object.component_list.move
            if move_component then
                move_component:ChgXSpeed(move_component:GetXSpeed() * ground.decelerate_speed)
            end
        end,
        remove_effect = function(ground, object)
            local move_component = object.component_list.move
            if move_component then
                move_component:ChgXSpeed(move_component:GetXSpeed() / ground.decelerate_speed)
            end
        end,
    },
    ["hill"] =
    {
        file_type = "image",
        file_path = { 
            single = "tmx/tile/hill.png", 
            group = {
                "tmx/tile/hill.png", 
                "tmx/tile/hill.png", 
                "tmx/tile/hill.png", 
            },
        },
    },
    ["box"] =
    {
        file_type = "image",
        file_path = { 
            single = "tmx/tile/box.png", 
            group = {
                "tmx/tile/box.png", 
                "tmx/tile/box.png", 
                "tmx/tile/box.png", 
            },
        },
        top = true,
    },
    ["ice"] = 
    {
        file_type = "image",
        file_path = { 
            single = "images/map/ice.png",
            group = {
                "images/map/ice_1.png", 
                "images/map/ice_2.png", 
                "images/map/ice_3.png",
            },
        },
        add_effect = ice_ground_add_effect,
        remove_effect = ice_ground_add_effect,
        decelerate_speed = 20,
        --class_name = "game_ground_ice",
        can_collide = true,
    },
    ["air_ice_1"] =
    {
        file_type = "image",
        file_path = {
            single = "images/map/air_ice_2.png",
            group = {
                "images/map/air_ice_1.png", 
                "images/map/air_ice_2.png", 
                "images/map/air_ice_3.png", 
            },
        },
        decelerate_speed = 20,
        add_effect = ice_ground_add_effect,
        remove_effect = ice_ground_add_effect,
        --class_name = "game_ground_ice",
    },
    ["air_ice_2"] = 
    {
        file_type = "image",
        file_path = {
            single = "images/map/air_ice_2_2.png",
            group = {
                "images/map/air_ice_2_1.png", 
                "images/map/air_ice_2_2.png", 
                "images/map/air_ice_2_3.png", 
            },
        },
        decelerate_speed = 20,
        add_effect = ice_ground_add_effect,
        remove_effect = ice_ground_add_effect,
        --class_name = "game_ground_ice",
    },
    ["air_ice_3"] = 
    {
        file_type = "image",
        file_path = {
            single = "images/map/air_ice.png",
            group = {
                "images/map/air_ice_3_1.png", 
                "images/map/air_ice_3_2.png", 
                "images/map/air_ice_3_3.png", 
            },
        },
        decelerate_speed = 20,
        add_effect = ice_ground_add_effect,
        remove_effect = ice_ground_add_effect,
        --class_name = "game_ground_ice",
    },
    ["volcano"] = {
        file_type = "image",
        file_path = { 
            single = "images/map/volcano.png",
            group = {
                "images/map/volcano_1.png",
                "images/map/volcano_2.png",
                "images/map/volcano_3.png",
            },
        },
        can_collide = true,
    },
    ["air_volcano"] = {
        file_type = "image",
        file_path = { 
            single = "images/map/air_volcano.png",
            group = {
                "images/map/air_volcano_1.png",
                "images/map/air_volcano_2.png",
                "images/map/air_volcano_3.png",
            },
        },
    },
}

for key, value in pairs(game.CAssetGameGround) do
    value.id = key
end

return game.CAssetGameGround

-- endregion
