-- region *.lua
-- Date
-- 此文件由[BabeLua]插件自动生成

local weapon_item_effect = function(object, target_object)
    if not object or not target_object then
        return false
    end

    if target_object.PickupWeapon then
        target_object:PickupWeapon(object.config.weapon_id, object.config.weapon_count)
    end
end

-- 物件朝向
game.GameObjectDirection = {
    left = 1,
    right = 2,
}

game.CAssetGameObject = {

    --##########################################################
    -- 森林房子
    ["forest_house"] =
    {
        file_type = "image",
        file_path = "images/map/real_object/start.png",
        is_static = true,
    },

    -- 雪地房子
    ["snowfield_house"] =
    {
        file_type = "image",
        file_path = "images/map/real_object/ice_start.png",
        is_static = true,
    },

    -- 火山房子
    ["volcano_house"] = 
    {
        file_type = "image",
        file_path = "images/map/real_object/volcano_start.png",
        is_static = true,
    },

    -- 起点
    ["start"] =
    {
        class_name = "game_object_start",
        onLoad = function(tmx_config, x, y)
            tmx_config.start_pos = cc.p((x - 1) * game.CAssetGame.tile_width,(y - 1) * game.CAssetGame.tile_height)
        end,
        is_static = true,
    },

    -- 终点
    ["end"] =
    {
        class_name = "game_object_end",
        onLoad = function(tmx_config, x, y)
            tmx_config.end_pos = cc.p((x - 1) * game.CAssetGame.tile_width,(y - 1) * game.CAssetGame.tile_height)
        end,
        is_static = true,
    },

    -- 老婆对象
    ["start_wife"] =
    {
        class_name = "game_object_start_wife",
        file_type = "spine",
        file_path = "spine/woman/skeleton",
        shadow_file_path = "images/map/real_object/shadow.png",
        default_animation = "curse",
    },

    ["end_wife"] =
    {
        class_name = "game_object_end_wife",
        file_type = "spine",
        file_path = "spine/woman/skeleton",
        shadow_file_path = "images/map/real_object/shadow.png",
        default_animation = "stand",
    },

    --##########################################################
    --地刺
    ["stake"] =
    {
        class_name = "game_object_stake",
        file_type = "image",
        file_path = "tmx/object/stake.png",
        name = "game_object_name_stake",
        desc = "game_object_desc_stake",
    },

    --猴子
    ["monkey"] =
    {
        class_name = "game_object_monkey",
        file_type = "spine",
        file_path = "spine/monkey/skeleton",
        default_animation = nil,
        shadow_file_path = "images/map/real_object/shadow.png",
        name = "game_object_name_monkey",
        desc = "game_object_desc_monkey",
        move_speed = -50,
        jump_speed = 1200,
        jump_cd = 1.5,
    },

    --蜗牛
    ["snail"] =
    {
        class_name = "game_object_snail",
        file_type = "spine",
        file_path = "spine/snail/skeleton",
        shadow_file_path = "images/map/real_object/shadow.png",
        name = "game_object_name_snail",
        desc = "game_object_desc_snail",
        move_speed = -150,
        max_hp = 1
    },

    --乌鸦
    ["crow"] =
    {
        class_name = "game_object_crow",
        file_type = "spine",
        file_path = "spine/crow/skeleton",
        move_speed = -350,
        enter_sound = assets.sound.config.sound.game_object_crow_enter
    },

    -- 篝火
    ["fire"] =
    {
        class_name = "game_object_fire",
        file_type = "spine",
        file_path = "spine/fire/skeleton",
        is_static = true,
    },

    -- 弹簧
    ["spring"] =
    {
        class_name = "game_object_spring",
        file_type = "image",
        file_path = "tmx/object/tanhuang.png",
        add_jump = 1.5,
        is_static = true,
    },

    --蜘蛛
    ["spider"] =
    {
        class_name = "game_object_spider",
        file_type = "spine",
        file_path = "spine/spider/skeleton",
        attack_distance = 200,
        move_speed = 450,
        move_distance = 200,
        pause_time = 0.5
    },

    -- 穿山甲
    ["pangolin"] =
    {
        class_name = "game_object_pangolin",
        file_type = "image",
        file_path = "images/map/real_object/pangolin.png",
        shadow_file_path = "images/map/real_object/shadow.png",
        attack_distance = 50,
        move_speed = 500,
        move_distance = 500
    },

    -- 升降地刺
    ["stake_updown"] =
    {
        class_name = "game_object_stake_updown",
        file_type = "image",
        file_path = "tmx/object/stake_updown.png"
    },

    -- 大象
    ["elephant"] =
    {
        class_name = "game_object_elephant",
        file_type = "spine",
        file_path = "spine/elephant/skeleton",
        shadow_file_path = "images/map/real_object/shadow.png",
        default_animation = "run",
        throw_count = 1,
        throw_object_id = { "snail"},
        throw_sound = assets.sound.config.sound.game_object_monkey_throw,
        y_throw_speed_min = 0,
        y_throw_speed_max = 500,
        x_throw_speed_min = 0,
        x_throw_speed_max = -50,
        attack_cd = 2,
        run_sound = assets.sound.config.sound.game_object_elephant_run,
        hurt_sound = assets.sound.config.sound.game_object_elephant_hurt,
        die_sound = assets.sound.config.sound.game_object_elephant_die,
        die_reward = { 
            { id = "move_gold", count = 10 }, 
        },
        fury_percent = 0.34,
        fury_throw_count = 2,
        fury_attack_cd = 1.2,
    },

    -- 攻击道具
    ["skill_shit"] =
    {
        class_name = "game_object_skill_shit",
        file_type = "image",
        file_path = "images/map/real_object/shit.png",
    },

    -- 引导用的跑步者
    ["runner"] = 
    {
        class_name = "game_object_runner",
        file_type = "image",
        file_path = "tmx/object/runner.png",
    },

    -- 球
    ["ball"] = 
    {
        class_name = "game_object_item",
        file_type = "image",
        file_path = "tmx/object/ball.png",
        ignore_gravity = true,
    },

    -- 火山熔岩
    ["fulgurite"] = 
    {
        class_name = "game_object_falling",
        file_type = "image",
        file_path = "images/map/real_object/fulgurite.png",
        enter_sound = assets.sound.config.sound.game_object_fulgurite_enter,
        is_static = true,
    },

    -- 老鹰
    ["eagle"] = 
    {
        class_name = "game_object_eagle",
        file_type = "spine",
        file_path = "spine/pterosaur/skeleton",
        direction = game.GameObjectDirection.left,
        enter_sound = assets.sound.config.sound.game_object_crow_enter,
        throw_count = 1,
        throw_object_id = { "snail"},
        y_throw_speed_min = 0,
        y_throw_speed_max = 500,
        x_throw_speed_min = 0,
        x_throw_speed_max = -50,
        attack_cd = 2.5,
		hurt_sound = assets.sound.config.sound.game_object_eagle_hurt,
        die_sound = assets.sound.config.sound.game_object_eagle_die,
        fury_percent = 0.34,
        fury_throw_count = 2,
        fury_attack_cd = 1.2,
    },

    -- 毒蛇
    ["snake"] = {
        class_name = "game_object_attack_monster",
        file_type = "image",
        file_path = "tmx/object/snake.png",
        ignore_gravity = true,
        attack_obejct = "fire",
        throw_count = 2,
        throw_object_id = { "snail"},
        y_throw_speed_min = 0,
        y_throw_speed_max = 1000,
        x_throw_speed_min = 0,
        x_throw_speed_max = 0,
        attack_cd = 2
    },

    -- 蝎子
    ["scorpion"] = {
        class_name = "game_object_snail",
        file_type = "spine",
        file_path = "spine/scorpion/skeleton",
        move_speed = -300,
        default_animation = "run",
		enter_sound = assets.sound.config.sound.game_object_scorpion_run,
    },

    -- 暴风
    ["storm"] = {
        class_name = "game_object_snail",
        file_type = "image",
        file_path = "tmx/object/storm.png",
        move_speed = -200,
    },

    -- 蜥蜴
    ["lizard"] =
    {
        class_name = "game_object_pangolin",
        file_type = "image",
        file_path = "tmx/object/lizard.png",
        attack_distance = 50,
        move_speed = 500,
        move_distance = 500
    },

    -- 藤
    ["rattan"] = 
    {
        class_name = "game_object_fire",
        file_type = "image",
        file_path = "tmx/object/rattan.png",
    },

    -- 石头
    ["stone"] = 
    {
        class_name = "game_object_fire",
        file_type = "image",
        file_path = "tmx/object/stone.png",
    },

    -- 雪狐
    ["snow_fox"] = 
    {
        class_name = "game_object_snail",
        file_type = "spine",
        file_path = "spine/snowfox/skeleton",
        move_speed = -250,
        default_animation = "run",
    },

    -- 雪人
    ["snowman"] = 
    {
        class_name = "game_object_fire",
        file_type = "spine",
        file_path = "spine/snowman/skeleton",
        buff = game.CAssetGameBuff.decelerate
    },

    -- 雪橇
    ["sled"] = 
    {
        class_name = "game_object_item",
        file_type = "image",
        file_path = "tmx/object/sled.png",
        buff = game.CAssetGameBuff.sled,
        effect = function(object,target_object)
            target_object:AddBuff(object.config.buff)
        end
    },

    -- 仙人掌
    ["cacti"] = 
    {
        class_name = "game_object_fire",
        file_type = "image",
        file_path = "tmx/object/cacti.png",
    },

    -- 触发投石鸟
    ["throw_stone_bird_event"] = 
    {
        class_name = "game_object_event",
        file_type = "image",
        file_path = "tmx/object/event.png",
        bird_height = 500,
        bird_move_speed = 100,
        create_object_id = "throw_stone_bird",
        on_event = function(event,map)
            if not event or not map then return end
            map.tmx:CreateObjectByID(event.config.create_object_id,-map.tmx:getPositionX() - 100,event.config.bird_height)
        end
    },

    -- 投石鸟
    ["throw_stone_bird"] = 
    {
        class_name = "game_object_attack_monster",
        file_type = "image",
        file_path = "images/map/real_object/eagle.png",
        ignore_gravity = true,
        throw_count = 2,
        throw_object_id = { "stone"},
        y_throw_speed_min = 0,
        y_throw_speed_max = -100,
        x_throw_speed_min = 0,
        x_throw_speed_max = 0,
        attack_cd = 2,
        move_speed = 600,        
    },

    -- 大脚
    ["foot"] = 
    {
        class_name = "game_object_foot",
        file_type = "image",
        file_path = "tmx/object/foot.png",
        drop_time = 1,
        move_speed = -900,
        attack_distance = 500
    },

    -- 黄蜂
    ["hornet"] = 
    {
        class_name = "game_object_hornet",
        file_type = "image",
        file_path = "tmx/object/foot.png",
        r = 100,
        fly_time = 2,
        fly_cd = 0.5
    },

    -- 一串猴子
    ["hang_monkey"] = {
        class_name = "game_object_hang_monkey",
        file_type = "image",
        file_path = "images/map/real_object/monkey.png",
        rotate_angle = 60,
        rotate_time = 0.8,
        monkey_count = 3
    },

    -- 火山
    ["volcano"] = 
    {
        class_name = "game_object_stake",
        file_type = "spine",
        file_path = "spine/volcano/skeleton",
        is_static = true,
    },

    --##########################################################
    -- 大便道具
    ["item_shit"] =
    {
        class_name = "game_object_item",
        file_type = "image",
        file_path = "images/map/real_object/shit.png",
        weapon_count = 1,
        weapon_id = "shit",
        effect = weapon_item_effect
    },

    -- 斧子
    ["item_axe"] = {
        class_name = "game_object_item",
        file_type = "spine",
        file_path = "spine/axe/skeleton",
        default_animation = "",
        weapon_count = 1,
        weapon_id = "axe",
        effect = weapon_item_effect,
        ignore_gravity = true,
        is_static = true,
    },

    -- 飞刀
    ["item_knife"] = {
        class_name = "game_object_item",
        file_type = "image",
        file_path = "images/map/real_object/shit.png",
        weapon_count = 1,
        weapon_id = "knife",
        effect = weapon_item_effect
    },

    -- 斧子
    ["skill_axe"] = {
        class_name = "game_object_skill_shit",
        file_type = "spine",
        file_path = "spine/axe/skeleton",
    },

    -- 飞刀
    ["skill_knife"] = {
        class_name = "game_object_skill_shit",
        file_type = "image",
        file_path = "images/map/real_object/shit.png",
    },

    -- 护盾道具
    ["shield"] = {
        class_name = "game_object_item",
        file_type = "image",
        file_path = "images/map/real_object/Shield.png",
        effect = function(object, target_object)
            target_object:AddBuff(game.CAssetGameBuff.item_shield)
        end,
        ignore_gravity = true,
        is_static = true,
		pickup_sound = assets.sound.config.sound.game_object_pickup_shield,
    },

    -- 回血道具
    ["hp"] = {
        class_name = "game_object_item",
        file_type = "spine",
        file_path = "spine/chicken/skeleton",
        default_animation = "idle",
        effect = function(object, target_object)

            if target_object.will_die then 
                return
            end

            local hp = 70
            target_object.component_list.hp:ChgHP(hp)

            local number = require("app.views.game.game_score"):Create(hp, cc.c3b(0,255,0))
            if number then
                number:setPosition(cc.p(0, target_object:GetBodyRect().height/2))
                target_object:addChild(number)
            end
        end,
        ignore_gravity = true,
        is_static = true,
		pickup_sound = assets.sound.config.sound.game_object_pickup_up_hp,
    },

    -- 吸铁石
    ["magnet"] = 
    {
        class_name = "game_object_item",
        file_type = "image",
        file_path = "images/map/real_object/magnet.png",
        effect = function(object,target_object)
            target_object:AddBuff(game.CAssetGameBuff.item_magnet)
        end,
        ignore_gravity = true,
        is_static = true,
		pickup_sound = assets.sound.config.sound.game_object_pickup_lodestone,
    },

    -- 无敌
    ["invincible"] = 
    {
        class_name = "game_object_item",
        file_type = "image",
        file_path = "images/map/real_object/Invincible.png",
        effect = function(object,target_object)
            target_object:AddBuff(game.CAssetGameBuff.item_invincible)
        end,
        ignore_gravity = true,
        is_static = true,
		pickup_sound = assets.sound.config.sound.game_object_pickup_invincible,
    },

    -- 冲刺
    ["super_dash"] = 
    {
        class_name = "game_object_item",
        file_type = "image",
        file_path = "images/map/real_object/sprint.png",
        effect = function(object,target_object)
            target_object:SuperDash(game.CAssetGame.super_dash_distance)
        end,
        ignore_gravity = true,
        is_static = true,
		pickup_sound = assets.sound.config.sound.game_object_pickup_super_dash,
    },

    -- 双倍积分
    ["double_score"] = 
    {
        class_name = "game_object_item",
        file_type = "image",
        file_path = "images/map/real_object/ScorePromotion.png",
        effect = function(object,target_object)
            target_object:AddBuff(game.CAssetGameBuff.more_score)
        end,
        ignore_gravity = true,
        is_static = true,
		pickup_sound = assets.sound.config.sound.game_object_pickup_double_score,
    },

    --##########################################################
    -- 苹果
    ["apple"] = {
        class_name = "game_object_item",
        file_type = "image",
        file_path = "images/map/real_object/apple.png",
        score = 10,
        ignore_gravity = true,
        ignore_ground = true,
        is_static = true,
        name = "game_object_name_apple",
        desc = "game_object_desc_apple",
        pickup_sound = assets.sound.config.sound.game_object_pickup_fruit,
    },
    -- 香蕉
    ["banana"] = 
    {
        class_name = "game_object_item",
        file_type = "image",
        file_path = "images/map/real_object/banana.png",
        score = 10,
        ignore_gravity = true,
        ignore_ground = true,
        is_static = true,
        name = "game_object_name_banana",
        desc = "game_object_desc_banana",
        pickup_sound = assets.sound.config.sound.game_object_pickup_fruit,
    },
    -- 葡萄
    ["grape"] = 
    {
        class_name = "game_object_item",
        file_type = "image",
        file_path = "images/map/real_object/grape.png",
        score = 10,
        ignore_gravity = true,
        ignore_ground = true,
        is_static = true,
        name = "game_object_name_grape",
        desc = "game_object_desc_grape",
        pickup_sound = assets.sound.config.sound.game_object_pickup_fruit,
    },
    -- 金币
    ["gold"] = {
        class_name = "game_object_item",
        --file_type = "spine",
        --file_path = "spine/gold/skeleton",
        file_type = "image",
        file_path = "images/map/real_object/gold.png",
        score = 10,
        is_static = true,
        name = "game_object_name_gold",
        desc = "game_object_desc_gold",
        pickup_sound = assets.sound.config.sound.game_object_pickup_gold,
        effect = function(_, game_object) game_object:PlayGoldDivisionAnimation() end
    },
    ["move_gold"] = {
        class_name = "game_object_item",
        file_type = "spine",
        file_path = "spine/gold/skeleton",
        score = 10,
        name = "game_object_name_gold",
        desc = "game_object_desc_gold",
        pickup_sound = assets.sound.config.sound.game_object_pickup_gold,
    },

    --##########################################################
    -- 滑板车
    ["item_scooter"] = 
    {
        class_name = "game_object_item",
        file_type = "image",
        file_path = "tmx/object/scooter.png",
        mount_id = game.CAssetGameMount.scooter.id,
        effect = function(object,target_object)
            print("--------------------------------")
            if not object or not target_object then
                return false
            end

            --骑上坐骑
            target_object:Ride(object.config.mount_id)
        end
    },

    --##########################################################
    -- 平台
    ["platform"] = 
    {
        class_name = "game_object_platform",
        file_type = "image",
        file_path = "tmx/tile/up_down_platform.png",
        x_move_speed = 100,
    },

    -- 左右移动平台
    ["left_right_platform"] = 
    {
        class_name = "game_object_platform",
        file_type = "image",
        file_path = "tmx/tile/up_down_platform.png",
        x_move_speed = 100,
        y_move_speed = 0,
    },

    -- 上下移动平台
    ["up_down_platform"] = 
    {
        class_name = "game_object_platform",
        file_type = "image",
        file_path = "tmx/tile/up_down_platform.png",
        x_move_speed = 100,
        y_move_speed = 100,
    },
}

for key, value in pairs(game.CAssetGameObject) do
    value.id = key
    value.direction = value.direction or game.GameObjectDirection.right
end

return game.CAssetGameObject

-- endregion
