-- region *.lua
-- Date
-- 此文件由[BabeLua]插件自动生成

game.CAssetGuideOpration = {

    -- 第一步直接进入到游戏关卡
    {
        condition_type = "join_stage",
        guide = function(callback)

            local next_function = function() 

                -- 进入关卡1-1
                require("app.views.game.game_ui"):Show("normal", 1, 1)

                -- 界面初始化
                local game_ui = dxm.CUIManager:GetInstancePtr().layer_ui._background
                if game_ui ~= nil then

                    -- 关闭暂停，冲刺，跳跃按钮
                    game_ui:SetWidgetEnableAndVisible(false, "ButtonStart")
                    game_ui:SetWidgetEnableAndVisible(false, "PanelButtonRightTouch")
                    game_ui:SetWidgetEnableAndVisible(false, "PanelButtonATouch")

                    -- 禁止角色自由冲刺与跳跃
                    local player = game_ui.map.player
                    if player then
                        player:AddFlag(game.CAssetGameFlag.cannot_jump)
                        player:AddFlag(game.CAssetGameFlag.cannot_move_dash)
                    end
                end

                -- 播放剧情对话
                dxm.UIHelper:Open("app.views.game_story.game_story_ui", 1, function()

                    -- 开始进行游戏
                    game.CCtrlBattle:StartStage("normal", 1, 1)
                    callback()
                end )
            end

            -- 播放四格漫画
            sUI:Open("app.views.ui.cartoon.cartoon_ui", next_function)
            return true
        end,
    },

    -- 跑过一定距离以后引导跳跃
    {
        condition_type = "move_distance",
        condition_value = 1600,
        guide = function(callback)

            local game_ui = dxm.CUIManager:GetInstancePtr().layer_ui._background
            if game_ui ~= nil then

                -- 打开跳跃按钮
                game_ui:SetWidgetEnableAndVisible(true, "PanelButtonATouch")

                -- 强调跳跃按钮
                local button = game_ui:GetWidget("ButtonA")
                if button then
                    button:runAction(cc.RepeatForever:create(cc.Sequence:create(cc.ScaleTo:create(0.2, 1.2), 
                    cc.ScaleTo:create(0.5, 0.8), 
                    cc.DelayTime:create(0.5))))

                    button:setOpacity(255)
                end

                -- 允许角色跳跃
                local player = game_ui.map.player
                if player then
                    player:RemoveFlag(game.CAssetGameFlag.cannot_jump)
                end

                -- 暂停游戏内核
                game_ui.map:Pause()

                -- 显示需要提示的内容
                game_ui:ShowCustomDesc(sStrings:GetString("press_button_jump_to_dodge"))

                -- TODO: 显示需要用户点击跳跃按钮的文本提示
            end

            -- 完成回调
            callback()

            return true
        end,
    },

    -- 角色跳跃
    {
        condition_type = "press_jump",
        guide = function(callback)

            local game_ui = dxm.CUIManager:GetInstancePtr().layer_ui._background
            if game_ui ~= nil then

                -- 恢复跳跃按钮
                local button = game_ui:GetWidget("ButtonA")
                if button then
                    button:setScale(1)
                    button:stopAllActions()
                end

                -- 变成不可点击
                game_ui:SetWidgetEnable(false, "PanelButtonATouch")

                -- 继续游戏内核
                game_ui.map:Resume()

                -- 显示需要提示的内容
                game_ui:ShowCustomDesc(nil)
            end

            -- 完成回调
            callback()

            return false
        end,
    },

    -- 正式跳跃
    {
        condition_type = "jump",
        guide = function(callback)

            local game_ui = dxm.CUIManager:GetInstancePtr().layer_ui._background
            if game_ui ~= nil then

                -- 禁止角色跳跃
                local player = game_ui.map.player
                if player then
                    player:AddFlag(game.CAssetGameFlag.cannot_jump)
                end
            end

            -- 完成回调
            callback()

            return false
        end,
    },

    -- 跑过一定距离以后引导冲刺
    {
        condition_type = "move_distance",
        condition_value = 2880,
        guide = function(callback)

            local game_ui = dxm.CUIManager:GetInstancePtr().layer_ui._background
            if game_ui ~= nil then

                -- 打开冲刺按钮
                game_ui:SetWidgetEnableAndVisible(true, "PanelButtonRightTouch")

                -- 强调冲刺按钮
                local button = game_ui:GetWidget("ButtonRight")
                if button then
                    button:runAction(cc.RepeatForever:create(cc.Sequence:create(cc.ScaleTo:create(0.2, 1.2), 
                    cc.ScaleTo:create(0.5, 0.8), 
                    cc.DelayTime:create(0.5))))

                    button:setOpacity(255)
                end

                -- 允许角色冲刺
                local player = game_ui.map.player
                if player then
                    player:RemoveFlag(game.CAssetGameFlag.cannot_move_dash)
                end

                -- 暂停游戏内核
                game_ui.map:Pause()

                -- 显示需要提示的内容
                game_ui:ShowCustomDesc(sStrings:GetString("press_button_dash_to_speedup"))
            end

            -- 完成回调
            callback()

            return true
        end,    
    },

    -- 角色做出冲刺动作
    {
        condition_type = "press_dash",
        guide = function(callback)

            local game_ui = dxm.CUIManager:GetInstancePtr().layer_ui._background
            if game_ui ~= nil then

                -- 恢复冲刺按钮
                local button = game_ui:GetWidget("ButtonRight")
                if button then
                    button:setScale(1)
                    button:stopAllActions()
                end

                -- 变成不可点击
                game_ui:SetWidgetEnable(false, "PanelButtonRightTouch")

                -- 继续游戏内核
                game_ui.map:Resume()

                -- 显示需要提示的内容
                game_ui:ShowCustomDesc(nil)
            end

            -- 完成回调
            callback()

            return false
        end,
    },

    -- 正式冲刺
    {
        condition_type = "dash",
        guide = function(callback)

            local game_ui = dxm.CUIManager:GetInstancePtr().layer_ui._background
            if game_ui ~= nil then

                -- 禁止角色冲刺
                local player = game_ui.map.player
                if player then
                    player:AddFlag(game.CAssetGameFlag.cannot_move_dash)
                end
            end

            -- 完成回调
            callback()

            return false
        end,
    },

    -- 跑过一定距离以后引导跳跃+冲刺
    {
        condition_type = "move_distance",
        condition_value = 4320,
        guide = function(callback)

            local game_ui = dxm.CUIManager:GetInstancePtr().layer_ui._background
            if game_ui ~= nil then

                -- 打开跳跃按钮
                game_ui:SetWidgetEnableAndVisible(true, "PanelButtonATouch")

                -- 强调跳跃按钮
                local button = game_ui:GetWidget("ButtonA")
                if button then
                    button:runAction(cc.RepeatForever:create(cc.Sequence:create(cc.ScaleTo:create(0.2, 1.2), 
                    cc.ScaleTo:create(0.5, 0.8), 
                    cc.DelayTime:create(0.5))))

                    button:setOpacity(255)
                end

                -- 允许角色跳跃
                local player = game_ui.map.player
                if player then
                    player:RemoveFlag(game.CAssetGameFlag.cannot_jump)
                end

                -- 暂停游戏内核
                game_ui.map:Pause()

                -- 显示需要提示的内容
                game_ui:ShowCustomDesc(sStrings:GetString("press_button_jump"))
            end

            -- 完成回调
            callback()

            return true
        end,
    },

    -- 角色跳跃
    {
        condition_type = "press_jump",
        guide = function(callback)

            local game_ui = dxm.CUIManager:GetInstancePtr().layer_ui._background
            if game_ui ~= nil then

                -- 恢复跳跃按钮
                local button = game_ui:GetWidget("ButtonA")
                if button then
                    button:setScale(1)
                    button:stopAllActions()
                end

                -- 变成不可点击
                game_ui:SetWidgetEnable(false, "PanelButtonATouch")

                -- 继续游戏内核
                game_ui.map:Resume()

                -- 显示需要提示的内容
                game_ui:ShowCustomDesc(nil)
            end

            -- 完成回调
            callback()

            return false
        end,
    },

    -- 正式跳跃
    {
        condition_type = "jump",
        guide = function(callback)

            local game_ui = dxm.CUIManager:GetInstancePtr().layer_ui._background
            if game_ui ~= nil then

                -- 禁止角色跳跃
                local player = game_ui.map.player
                if player then
                    player:AddFlag(game.CAssetGameFlag.cannot_jump)
                end
            end

            -- 完成回调
            callback()

            return false
        end,
    },

    -- 跳跃即将下落
    {
        condition_type = "jump_down",
        guide = function(callback)

            local game_ui = dxm.CUIManager:GetInstancePtr().layer_ui._background
            if game_ui ~= nil then

                -- 打开冲刺按钮
                game_ui:SetWidgetEnableAndVisible(true, "PanelButtonRightTouch")

                -- 强调冲刺按钮
                local button = game_ui:GetWidget("ButtonRight")
                if button then
                    button:runAction(cc.RepeatForever:create(cc.Sequence:create(cc.ScaleTo:create(0.2, 1.2), 
                    cc.ScaleTo:create(0.5, 0.8), 
                    cc.DelayTime:create(0.5))))

                    button:setOpacity(255)
                end

                -- 允许角色冲刺
                local player = game_ui.map.player
                if player then
                    player:RemoveFlag(game.CAssetGameFlag.cannot_move_dash)
                end

                -- 暂停游戏内核
                game_ui.map:Pause()

                -- 显示需要提示的内容
                game_ui:ShowCustomDesc(sStrings:GetString("press_button_dash_to_move_in_the_air"))
            end

            -- 完成回调
            callback()

            return true
        end,    
    },

    -- 角色做出冲刺动作
    {
        condition_type = "press_dash",
        guide = function(callback)

            local game_ui = dxm.CUIManager:GetInstancePtr().layer_ui._background
            if game_ui ~= nil then

                -- 恢复冲刺按钮
                local button = game_ui:GetWidget("ButtonRight")
                if button then
                    button:setScale(1)
                    button:stopAllActions()
                end

                -- 变成不可点击
                game_ui:SetWidgetEnable(false, "PanelButtonRightTouch")

                -- 继续游戏内核
                game_ui.map:Resume()

                -- 显示需要提示的内容
                game_ui:ShowCustomDesc(nil)
            end

            -- 完成回调
            callback()

            return false
        end,
    },

    -- 正式冲刺
    {
        condition_type = "dash",
        guide = function(callback)

            local game_ui = dxm.CUIManager:GetInstancePtr().layer_ui._background
            if game_ui ~= nil then

                -- 禁止角色冲刺
                local player = game_ui.map.player
                if player then
                    player:AddFlag(game.CAssetGameFlag.cannot_move_dash)
                end
            end

            -- 完成回调
            callback()

            return false
        end,
    },

    -- ================================ 二段跳引导 ============================================

    -- 跑过一定距离以后引导跳跃+跳跃
    {
        condition_type = "move_distance",
        condition_value = 6240,
        guide = function(callback)

            local game_ui = dxm.CUIManager:GetInstancePtr().layer_ui._background
            if game_ui ~= nil then

                -- 打开跳跃按钮
                game_ui:SetWidgetEnableAndVisible(true, "PanelButtonATouch")

                -- 强调跳跃按钮
                local button = game_ui:GetWidget("ButtonA")
                if button then
                    button:runAction(cc.RepeatForever:create(cc.Sequence:create(cc.ScaleTo:create(0.2, 1.2), 
                    cc.ScaleTo:create(0.5, 0.8), 
                    cc.DelayTime:create(0.5))))

                    button:setOpacity(255)
                end

                -- 允许角色跳跃
                local player = game_ui.map.player
                if player then
                    player:RemoveFlag(game.CAssetGameFlag.cannot_jump)
                end

                -- 暂停游戏内核
                game_ui.map:Pause()

                -- 显示需要提示的内容
                game_ui:ShowCustomDesc(sStrings:GetString("press_button_jump"))
            end

            -- 完成回调
            callback()

            return true
        end,
    },

    -- 角色跳跃
    {
        condition_type = "press_jump",
        guide = function(callback)

            local game_ui = dxm.CUIManager:GetInstancePtr().layer_ui._background
            if game_ui ~= nil then

                -- 恢复跳跃按钮
                local button = game_ui:GetWidget("ButtonA")
                if button then
                    button:setScale(1)
                    button:stopAllActions()
                end

                -- 变成不可点击
                game_ui:SetWidgetEnable(false, "PanelButtonATouch")

                -- 继续游戏内核
                game_ui.map:Resume()

                -- 显示需要提示的内容
                game_ui:ShowCustomDesc(nil)
            end

            -- 完成回调
            callback()

            return false
        end,
    },

    -- 正式跳跃
    {
        condition_type = "jump",
        guide = function(callback)

            local game_ui = dxm.CUIManager:GetInstancePtr().layer_ui._background
            if game_ui ~= nil then

                -- 禁止角色跳跃
                local player = game_ui.map.player
                if player then
                    player:AddFlag(game.CAssetGameFlag.cannot_jump)
                end
            end

            -- 完成回调
            callback()

            return false
        end,
    },

    -- 跳跃即将下落
    {
        condition_type = "jump_down",
        guide = function(callback)

            local game_ui = dxm.CUIManager:GetInstancePtr().layer_ui._background
            if game_ui ~= nil then

                -- 打开冲刺按钮
                game_ui:SetWidgetEnableAndVisible(true, "PanelButtonATouch")

                -- 强调冲刺按钮
                local button = game_ui:GetWidget("ButtonA")
                if button then
                    button:runAction(cc.RepeatForever:create(cc.Sequence:create(cc.ScaleTo:create(0.2, 1.2), 
                    cc.ScaleTo:create(0.5, 0.8), 
                    cc.DelayTime:create(0.5))))

                    button:setOpacity(255)
                end

                -- 允许角色冲刺
                local player = game_ui.map.player
                if player then
                    player:RemoveFlag(game.CAssetGameFlag.cannot_jump)
                end

                -- 暂停游戏内核
                game_ui.map:Pause()

                -- 显示需要提示的内容
                game_ui:ShowCustomDesc(sStrings:GetString("press_button_jump_to_jump_higher"))
            end

            -- 完成回调
            callback()

            return true
        end,    
    },

    -- 角色做出冲刺动作
    {
        condition_type = "press_jump",
        guide = function(callback)

            local game_ui = dxm.CUIManager:GetInstancePtr().layer_ui._background
            if game_ui ~= nil then

                -- 恢复冲刺按钮
                local button = game_ui:GetWidget("ButtonA")
                if button then
                    button:setScale(1)
                    button:stopAllActions()
                end

                -- 变成不可点击
                game_ui:SetWidgetEnable(false, "PanelButtonATouch")

                -- 继续游戏内核
                game_ui.map:Resume()

                -- 显示需要提示的内容
                game_ui:ShowCustomDesc(nil)
            end

            -- 完成回调
            callback()

            return false
        end,
    },

    -- 正式冲刺
    {
        condition_type = "jump",
        guide = function(callback)

            local game_ui = dxm.CUIManager:GetInstancePtr().layer_ui._background
            if game_ui ~= nil then

                -- 引导结束，恢复界面按钮
                local button = game_ui:GetWidget("ButtonA")
                if button then
                    button:setOpacity(255)
                end
                button = game_ui:GetWidget("ButtonA")
                if button then
                    button:setOpacity(255)
                end
                game_ui:SetWidgetEnable(true, "PanelButtonRightTouch")
                game_ui:SetWidgetEnable(true, "PanelButtonATouch")
                game_ui:SetWidgetEnableAndVisible(true, "ButtonStart")

                -- 禁止角色跳跃
                local player = game_ui.map.player
                if player then
                    player:AddFlag(game.CAssetGameFlag.cannot_jump)
                end
            end

            -- 完成回调
            callback()

            return false
        end,
    },
}

return game.CAssetGuideOpration

-- endregion
