--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local map_config = {

    name = "map_name_0",
    section_group_list = {
        {
            background = { 
                { file_path = "images/map/night.png", z = 100, }
            },
            static_section_list = {

                -- 起点，另外加入一个赛跑者
                { tmx_file = "tmx/stage_beginner_1.tmx", },

                -- 加速引导，超过屏幕中的赛跑者就胜利
                {
                    desc = "please_press_accelerate_button",
                    onEnter = function(map, data) 
                        local ui = dxm.CUIManager:GetInstancePtr().layer_ui._stack_top_ui
                        if ui then
                            local widget = ui:GetWidget("ButtonRight")
                            if widget then
                                data.handle = widget:runAction(cc.RepeatForever:create(
                                cc.Sequence:create(cc.ScaleTo:create(1,0.8), cc.DelayTime:create(2), cc.ScaleTo:create(0.5,1), cc.DelayTime:create(0.5))
                                ))
                            end
                        end
                    end,
                    onExit = function(map, data) 
                        local ui = dxm.CUIManager:GetInstancePtr().layer_ui._stack_top_ui
                        if ui then
                            local widget = ui:GetWidget("ButtonRight")
                            if widget and data.handle then
                                widget:stopAction(data.handle)
                                widget:setScale(1)
                                data.handle = nil
                            end
                        end
                    end,
                    onUpdate = function(map) 

                        local runner = map.tmx:GetObjectByID("runner")
                        if runner and map.player:getPositionX() > runner:getPositionX() then
                            runner:Rest()
                            return true
                        end
                        return false
                    end,

                    tmx_file = "tmx/stage_beginner_2.tmx",
                },

                -- 跳跃引导，并与赛跑者有剧情对话
                {
                    desc = "please_press_jump_button",
                    onEnter = function(map, data) 
                        local ui = dxm.CUIManager:GetInstancePtr().layer_ui._stack_top_ui
                        if ui then
                            local widget = ui:GetWidget("ButtonA")
                            if widget then
                                data.handle = widget:runAction(cc.RepeatForever:create(
                                cc.Sequence:create(cc.ScaleTo:create(0.2,0.8), cc.ScaleTo:create(0.2,1), cc.DelayTime:create(2))
                                ))
                            end
                        end
                        --[[
                        map:Pause()
                        sUI:Open("app.views.game_story.game_story_ui", 1, function()
                            map:Resume()
                        end)
                        ]]--
                    end,
                    onExit = function(map, data) 
                        local ui = dxm.CUIManager:GetInstancePtr().layer_ui._stack_top_ui
                        if ui then
                            local widget = ui:GetWidget("ButtonA")
                            if widget and data.handle then
                                widget:stopAction(data.handle)
                                widget:setScale(1)
                                data.handle = nil
                            end
                        end
                    end,
                    onUpdate = function(map, data) 
                        --[[
                        if map.player.pickup_list["ball"] and map.player.pickup_list["ball"] >= 2 then
                            return true
                        end
                        return false
                        ]]--
                        if map.player.component_list.hp.hp >= map.player.config.max_hp then
                            return true
                        else
                            map.player.component_list.hp.hp = map.player.config.max_hp
                            return false
                        end
                    end,

                    tmx_file = "tmx/stage_beginner_3.tmx",
                },

                -- 长距离跳跃引导，并与赛跑者有剧情对话
                {
                    desc = "please_press_accelerate_and_jump_button",
                    onEnter = function(map, data) 
                        local ui = dxm.CUIManager:GetInstancePtr().layer_ui._stack_top_ui
                        if ui then
                            local widget = ui:GetWidget("ButtonRight")
                            if widget then
                                data.handle1 = widget:runAction(cc.RepeatForever:create(
                                cc.Sequence:create(cc.ScaleTo:create(1,0.8), cc.DelayTime:create(2), cc.ScaleTo:create(0.5,1), cc.DelayTime:create(0.5))
                                ))
                            end
                            widget = ui:GetWidget("ButtonA")
                            if widget then
                                data.handle2 = widget:runAction(cc.RepeatForever:create(
                                cc.Sequence:create(cc.DelayTime:create(1), cc.ScaleTo:create(0.2,0.8), cc.ScaleTo:create(0.2,1), cc.DelayTime:create(2.6))
                                ))
                            end
                        end
                        --[[
                        map:Pause()
                        sUI:Open("app.views.game_story.game_story_ui", 1, function()
                            map:Resume()
                        end)
                        ]]--
                    end,
                    onExit = function(map, data) 
                        local ui = dxm.CUIManager:GetInstancePtr().layer_ui._stack_top_ui
                        if ui then
                            local widget = ui:GetWidget("ButtonRight")
                            if widget and data.handle1 then
                                widget:stopAction(data.handle1)
                                widget:setScale(1)
                                data.handle1 = nil
                            end

                            widget = ui:GetWidget("ButtonA")
                            if widget and data.handle2 then
                                widget:stopAction(data.handle2)
                                widget:setScale(1)
                                data.handle2 = nil
                            end
                        end
                    end,
                    onUpdate = function(map, data) 
                        --[[
                        if map.player.pickup_list["ball"] and map.player.pickup_list["ball"] >= 2 then
                            return true
                        end
                        return false
                        ]]--
                        if map.player.component_list.hp.hp >= map.player.config.max_hp then
                            return true
                        else
                            map.player.component_list.hp.hp = map.player.config.max_hp
                            return false
                        end
                    end,

                    tmx_file = "tmx/stage_beginner_4.tmx",
                },

                -- 到达终点
                {
                    tmx_file = "tmx/stage_beginner_5.tmx",
                },
            },
        },
    }
}

return map_config

--endregion
