--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CCtrlBattle = {}
local CCtrlBattle = game.CCtrlBattle

-- 关卡模式游戏
function CCtrlBattle:GotoStage()

    local stage_info = sPlayer.player_modules.stage:GetTopStageInfo("normal")
    if not stage_info or not stage_info.top_stage_id or stage_info.top_stage_id == 0 then
        sUI:Open("app.views.ui.stage.stage_list_ui", "normal", 1)
    elseif stage_info.top_stage_id > game.CAssetStage.normal.stage_count then
        sUI:Open("app.views.ui.stage.stage_list_ui", "normal", game.CAssetStage.normal.stage_count)
    else
        sUI:Open("app.views.ui.stage.stage_list_ui", "normal", stage_info.top_stage_id)
    end
end

function CCtrlBattle:StartStage(stage_type, stage_id, child_stage_id)

    local entry = sPlayer.player_modules.stage:GetChildStageEntry(stage_type, stage_id, child_stage_id)
    if not entry then
        return false
    end

    -- 判断关卡是否开放
    local top_stage_info = sPlayer.player_modules.stage:GetTopStageInfo(stage_type)
    if top_stage_info and (stage_id > top_stage_info.top_stage_id or (stage_id == top_stage_info.top_stage_id and child_stage_id > top_stage_info.top_child_stage_id)) then
        dxm.CMessageTipUI:Show(sStrings:GetString("stage_is_not_open"))
        return false
    end

    -- 体力判断
    entry.action_point = entry.action_point or game.CAssetGame.default_action_point
    if entry.action_point > sPlayer.player_modules.action_point:GetActionPoint() then
        game.CCtrlItem:ActionPointIsNotEnough()
        return false
    end
    sPlayer.player_modules.action_point:Change(-entry.action_point)

    -- 进入关卡
    sPlayer.player_modules.stage:StageStart(stage_type, stage_id, child_stage_id)

    -- 暂时以界面化的形式来做效果
    local game_ui = dxm.CUIManager:GetInstancePtr().layer_ui._background
    if game_ui then
        game_ui:Start()
    end
    return true
end

function CCtrlBattle:StageCompleted(stage_type, stage_id, child_stage_id, is_win, record)

    if stage_type == "infinite" then
        sPlayer.player_modules.stage:StageLose(stage_type, stage_id, child_stage_id, record)

        -- 弹出新记录界面
        if record.best_score > record.old_best_score then
            sUI:Open("app.views.ui.stage.stage_result_infinite_new_record_ui", function()
                sUI:Open("app.views.ui.stage.stage_result_infinite_ui", stage_type,stage_id,child_stage_id,record)
            end)
        else
            sUI:Open("app.views.ui.stage.stage_result_infinite_ui", stage_type,stage_id,child_stage_id,record)
        end
    elseif stage_type == "compete" then
        
        if is_win then
            sPlayer.player_modules.stage:StageWin(stage_type, stage_id, child_stage_id, record)

            -- 显示最终排名界面
            sUI:Open("app.views.ui.stage.stage_complete_ui", function() 
                sUI:Open("app.views.ui.stage.stage_result_compete_ui", stage_type,stage_id,child_stage_id,record,is_win)
            end)
        else
            sPlayer.player_modules.stage:StageLose(stage_type, stage_id, child_stage_id, record)
            sUI:Open("app.views.ui.stage.stage_result_compete_ui", stage_type,stage_id,child_stage_id,record,is_win)
        end
    else
        if is_win then
            sPlayer.player_modules.stage:StageWin(stage_type, stage_id, child_stage_id, record)

            -- 打开胜利界面
            sUI:Open("app.views.ui.stage.stage_complete_ui", function() 
                sUI:Open("app.views.ui.stage.stage_result_win_ui", stage_type,stage_id,child_stage_id,record)
            end)
        else
            sPlayer.player_modules.stage:StageLose(stage_type, stage_id, child_stage_id, record)
            -- 打开失败界面
            sUI:Open("app.views.ui.stage.stage_result_fail_ui", stage_type, stage_id, child_stage_id)
        end

        -- 通关礼包
        sCtrlAutoPop:AutoPopStageLose(0, function() end)
    end
end

function CCtrlBattle:GotoMain()
    sCtrlMainMenu:BackGame()
end

-- 无尽模式游戏
function CCtrlBattle:GotoInfinite()   

    local infinite_lock = sPlayer.player_modules.stage:GetCompletedStageID()<assets.stages.infinite_unlock_stage 
    if infinite_lock then
        dxm.CMessageTipUI:Show(sStrings:GetString("infinite_lock"), 35)
        return
    end

    sUI:Open("app.views.ui.battle.fb_stage_info_ui", 0)
end

return CCtrlBattle
--endregion
