--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CCtrlMainMenu = {}

cc.exports.sCtrlMainMenu = game.CCtrlMainMenu
local CCtrlMainMenu = game.CCtrlMainMenu


function CCtrlMainMenu:EnterGame()

    local scene = require("app.views.scene.main_scene"):Create()
    cc.Director:getInstance():replaceScene(scene) 

    self:OpenHome()

    sActionUtils:Delay(1, function() 
        sCtrlMainMenu:WelcomeBack()
    end)  

    if not sPlayer.player_modules.info:IsCreateRoleFinish() then
        sUI:Open("app.views.ui.name.create_role_ui", function()
            sCtrlAutoPop:AutoPopEnterGame(function()
                sCtrlGuide:Listen("start_game")
            end)
        end)
    else
        sCtrlAutoPop:AutoPopEnterGame(function()
            sCtrlGuide:Listen("start_game")
        end)
    end

    sPlayer.player_modules.ad:ForcePop()
end

function CCtrlMainMenu:BackGame()

    local scene = require("app.views.scene.main_scene"):Create()
    cc.Director:getInstance():replaceScene(scene) 

    sCtrlAutoPop:AutoPopBackMain(function() end)
end

-- 打开主界面
function CCtrlMainMenu:OpenHome()

   sUI:Open(true, "app.views.ui.stage.stage_mode_ui", true)
end

--打开背包
function CCtrlMainMenu:OpenPackageUI()

    sUI:OpenWithClearStack(true, "app.views.ui.package.package_ui")
end

--打开设置
function CCtrlMainMenu:OpenSettingUpUI()

    sUI:Open(true, "app.views.ui.main.game_setting_up_ui")
end

--打开商城
function CCtrlMainMenu:OpenShopUI(shop_tap, show_bottom)

    local CShopUI = require "app.views.ui.shop.shop_ui"
    if CShopUI:CheckTypeRef() then  
        if shop_tap == "item" then
            CShopUI.ui:ShowPropShop()
        elseif shop_tap == enum.NumberType.kTypeGamebill then
            CShopUI.ui:ShowGamebillShop()
        elseif shop_tap == "diamon" then
            CShopUI.ui:ShowDiamondsShop()
        elseif shop_tap == "action_point" then
            CShopUI.ui:ShowActionPointShop()
        end        
        return
    end

    if show_bottom==false then
        sUI:Open(true,"app.views.ui.shop.shop_ui", shop_tap, false)
    else
        sUI:OpenWithClearStack(true,"app.views.ui.shop.shop_ui", shop_tap, true)
    end
end

function CCtrlMainMenu:OpenShopDialogUI(shop_tap, show_bottom)

    local CShopUI = require "app.views.ui.shop.shop_dialog_ui"
    if CShopUI:CheckTypeRef() then  
        if shop_tap == "item" then
            CShopUI.ui:ShowPropShop()
        elseif shop_tap == "gamebill" then
            CShopUI.ui:ShowGamebillShop()
        elseif shop_tap == "diamon" then
            CShopUI.ui:ShowDiamondsShop()
        elseif shop_tap == "action_point" then
            CShopUI.ui:ShowActionPointShop()
        end        
        return
    end
    sUI:Open(true, "app.views.ui.shop.shop_dialog_ui", shop_tap, false)
end

--打开转盘界面
function CCtrlMainMenu:OpenTurnTableUI()
    sUI:Open("app.views.ui.turn_table.turn_table_ui")
end

function CCtrlMainMenu:OpenSignUI(close_callback)
    sUI:Open(true,"app.views.ui.sign.sign_ui", close_callback)
end

function CCtrlMainMenu:OpenRolesUI()
    sUI:OpenWithClearStack(true,"app.views.ui.roles.roles_ui")
end

function CCtrlMainMenu:OpenFriendUI()
    if game.CAssetGame.all_open then
        sUI:OpenWithClearStack(true, "app.views.ui.friend.friend_ui")
    else
        dxm.CMessageTipUI:Show(sStrings:GetString("system_is_not_open"))
    end
end


-- 打开云
function CCtrlMainMenu:OpenCloud(callback)
    -- spine/battle_scene/scene_transition
    if not self.cloud then 
        self.cloud = sSpineUtils:CreateWidgetAnimation("spine/battle_scene/scene_transition", true)
        self.cloud:retain()
        self.cloud:setPosition(dxm.VisibleRect:center().x, dxm.VisibleRect:center().y)
        cc.Director:getInstance():getRunningScene():addChild(self.cloud, 100000)
    end
    if self.cloud then
        sSpineUtils:PlayEffect(self.cloud, "appear", function() if callback then callback() end end)
    else
        if callback then callback() end
    end

    --[[
    sSpineUtils:PlayEffect("spine/battle_scene/scene_transition", "appear", 
        cc.Director:getInstance():getRunningScene(), dxm.VisibleRect:center().x, dxm.VisibleRect:center().y, 
        function() if callback then callback() end end, 1, 10000)
    ]]--
end

-- 关闭云
function CCtrlMainMenu:CloseCloud(callback, scene)
    -- spine/battle_scene/scene_transition
    if scene == nil then 
        scene = cc.Director:getInstance():getRunningScene() 
    end 

    if self.cloud and scene then
        self.cloud:removeFromParent()
        self.cloud:setPosition(dxm.VisibleRect:center().x, dxm.VisibleRect:center().y)
        scene:addChild(self.cloud, 100000)
        sActionUtils:Delay(0.1, function() 
            sSpineUtils:PlayEffect(self.cloud, "disappear", function() 
                sMessageDispatcher:Dispatch("cloud_closed")
                if callback then callback() end 
                self.cloud:removeFromParent()
                sActionUtils:Delay(0, function() 
                    self.cloud:release()
                    self.cloud = nil
                end)
            end)        
        end)
    else
        if callback then callback() end
    end

    --[[
    sSpineUtils:PlayEffect("spine/battle_scene/scene_transition", "disappear", 
            scene, dxm.VisibleRect:center().x, dxm.VisibleRect:center().y, 
            function() if callback then callback() end end, 1, 10000)
    ]]--
end

function CCtrlMainMenu:WelcomeBack()
    require("app.views.ui.main.welcome_back_tip_ui"):Show()
end

function CCtrlMainMenu:OpenRewardBox(stage_id, close_callback)

    if player.player_modules.stage_reward:HasReward(stage_id) == "no_error" then
        sUI:Open("app.views.ui.battle.fb_stage_reward_ui", stage_id, close_callback)
    else
        if close_callback then close_callback() end
    end
end

-- close_callback(unlock): unlock[true|false]
function CCtrlMainMenu:OpenStageLevelUnlock(stage_level_id, close_callback)

    if player.player_modules.stage_level:IsReachUnlockStageLevel(stage_level_id) == true then
        local  error_string = player.player_modules.stage_level:Unlock(stage_level_id, "star")
        if  error_string == "no_error" then
            if close_callback then close_callback(true) end
        else
            sUI:Open("app.views.ui.battle.fb_stage_level_unlock_ui", stage_level_id, close_callback)
        end
    else
        if close_callback then close_callback() end
    end
end

function CCtrlMainMenu:OpenSkinAndMountUI(tab_name)
    local CSkinAndMountUI = require "app.views.ui.skin_and_mount.skin_and_mount_ui"
    if CSkinAndMountUI:CheckTypeRef() then  
        if tab_name == "mount" then
            CSkinAndMountUI.ui:ShowMount()
        else
            CSkinAndMountUI.ui:ShowSkin()
        end        
        return
    end
    sUI:OpenWithClearStack("app.views.ui.skin_and_mount.skin_and_mount_ui", tab_name)
end

function CCtrlMainMenu:OpenNormalStageListUI(replace_scene)

    if replace_scene then
        --cc.Director:getInstance():replaceScene(cc.TransitionSlideInR:create(0.5,require("app.views.game.game_scene"):Create()))
        cc.Director:getInstance():replaceScene(require("app.views.game.game_scene"):Create())
    end
    local stage_info = sPlayer.player_modules.stage:GetTopStageInfo("normal")
    if not stage_info or not stage_info.top_stage_id or stage_info.top_stage_id == 0 then
        sUI:Open("app.views.ui.stage.stage_list_ui", "normal", 1)
    elseif stage_info.top_stage_id > game.CAssetStage.normal.stage_count then
        sUI:Open("app.views.ui.stage.stage_list_ui", "normal", game.CAssetStage.normal.stage_count)
    else
        sUI:Open("app.views.ui.stage.stage_list_ui", "normal", stage_info.top_stage_id)
    end
end


return CCtrlMainMenu
--endregion
