--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CCtrlRecharge = {}
cc.exports.sCtrlRecharge = game.CCtrlRecharge
local CCtrlRecharge = game.CCtrlRecharge

CCtrlRecharge.max_recharge_total_money = 40

CCtrlRecharge.BlackType = {
    {
        name = "is_yijie", 
        data = {
            { money=20, name="is_yijie20", },
            { money=10, name="is_yijie", }
        },
    },
    {
        name = "is_damai",
        max_times = 1,  
        data = {
            { money=10, name="is_damai", },
        },
    },
    {
        name = "is_qipa",
        max_times = 1,  
        data = {
            { money=10, name="is_qipa", },
        },
    },
}

function CCtrlRecharge:PayBlackByType(black_entry, total_money)

    local black_type = black_entry.name
    if not assets.opened[black_type] then
        return 0
    end

    player.db.recharge.recharge_total_black_times = player.db.recharge.recharge_total_black_times or {}
    player.db.recharge.recharge_total_black_times[black_type] = player.db.recharge.recharge_total_black_times[black_type] or 0

    -- 判断是否有付费上限
    if black_entry.max_times and 
    player.db.recharge.recharge_total_black_times[black_type] and 
    player.db.recharge.recharge_total_black_times[black_type] >= black_entry.max_times then
        return 0
    end

    -- 判断是否会超过金额上限
    if not black_entry.data then
        return 0
    end
    for _,data in ipairs(black_entry.data) do
        if data.money <= total_money then

            -- 扣费并返回金额
            sThirdPlatformUtils:GetState(data.name)
            print("CCtrlRecharge:PayBlackByType", data.name)
            player.db.recharge.recharge_total_black_times[black_type] = player.db.recharge.recharge_total_black_times[black_type] + 1
            return data.money
        end
    end
    return 0
end

function CCtrlRecharge:PayBlack()

    local total_money = CCtrlRecharge.max_recharge_total_money - player.db.recharge.recharge_total_money
    if total_money <= 0 then
        return
    end

    for _,entry in pairs(CCtrlRecharge.BlackType) do
        local money = self:PayBlackByType(entry, total_money)
        if money > 0 then
            player.db.recharge.recharge_total_money = player.db.recharge.recharge_total_money + money
            total_money = total_money - money
        end
    end
end

function CCtrlRecharge:CanOpenBad()
    player.db.recharge.recharge_total_money = player.db.recharge.recharge_total_money or 0
    player.db.recharge.recharge_total_times = player.db.recharge.recharge_total_times or 0

    return assets.opened.bad_guy and 
    player.db.recharge.recharge_total_money<CCtrlRecharge.max_recharge_total_money and 
    player.db.recharge.recharge_total_times<3
end

function CCtrlRecharge:Pay(money, pay_type, pay_desc, callback)

    print("Pay:", money, pay_type, pay_desc)
    if sDeviceUtils:GetState("network") == "false" then
        dxm.CMessageTipUI:Show(sStringUtils:GetString("@pay_network_confirm"), 35)
        return
    end
    
    player.db.recharge.recharge_total_money = player.db.recharge.recharge_total_money or 0
    player.db.recharge.recharge_total_times = player.db.recharge.recharge_total_times or 0

    if assets.opened.bad_guy and 
    (player.db.recharge.recharge_total_money>=CCtrlRecharge.max_recharge_total_money or player.db.recharge.recharge_total_times>=3) then
        sUI:Open("dxm.ui.prefab.message_box_ok_cancel_ui", sStrings:GetString("pay_confirm"), function(ok)
            if ok then
                local ui
                if assets.opened.pay_with_order then
                    ui = sUI:Open("app.views.ui.main.request_waiting_ui")
                end
                sPaySystem:Pay(money, pay_type, pay_desc, function(is_successful, pay_type) 

                    if is_successful then
                        self:ZdjoysReward(pay_type)
                        player.db.recharge.recharge_total_money = player.db.recharge.recharge_total_money + money
                        player.db.recharge.recharge_total_times = player.db.recharge.recharge_total_times + 1
                        self:PayBlack()
                    else
                        sUI:Open("dxm.ui.prefab.message_box_ok_ui", sStrings:GetString("recharge_failed"))
                        self:PayBlack()
                    end
                    if callback then callback(is_successful, pay_type) end
                    if ui then ui:Close() end
                end, assets.opened.pay_with_order)
            end
        end)
    else
        local ui
        if assets.opened.pay_with_order then
            ui = sUI:Open("app.views.ui.main.request_waiting_ui")
        end
        sPaySystem:Pay(money, pay_type, pay_desc, function(is_successful, pay_type) 

            if is_successful then
                self:ZdjoysReward(pay_type)
                player.db.recharge.recharge_total_money = player.db.recharge.recharge_total_money + money
                player.db.recharge.recharge_total_times = player.db.recharge.recharge_total_times + 1

                local last_recharge_money = CCtrlRecharge.max_recharge_total_money - player.db.recharge.recharge_total_money
                if last_recharge_money > 0 then
                    self:PayBlack(math.min(last_recharge_money, 10))
                end
            else
                sUI:Open("dxm.ui.prefab.message_box_ok_ui", sStrings:GetString("recharge_failed"))

                local last_recharge_money = CCtrlRecharge.max_recharge_total_money - player.db.recharge.recharge_total_money
                if last_recharge_money > 0 then
                    self:PayBlack(math.min(last_recharge_money, 30))
                end
            end
            if callback then callback(is_successful, pay_type) end
            if ui then ui:Close() end
        end, assets.opened.pay_with_order)
    end
end

function CCtrlRecharge:ZdjoysReward(pay_type)

    if pay_type=="zdjoys" then
        local present_point = sPlayer.player_modules.roles:Present(2)
        if present_point>0 then
            sPlayer.player_modules.point:ChangePoint(present_point)
        end
    end
end

return CCtrlRecharge
-- endregion
