--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CCtrlReward = {}
cc.exports.sCtrlReward = game.CCtrlReward
local CCtrlReward = game.CCtrlReward

-- 汇总权值
local double_times_weight = {}
local total_double_times_weight = 0
local max_double_times = 20
for i=1,max_double_times do
    local weight = 1/i
    double_times_weight[i] = weight
    total_double_times_weight = total_double_times_weight + weight
end

local function GetDoubleTimes()

    local weight = 0
    local number = math.random()*total_double_times_weight
    for i=1,max_double_times do
        weight = weight + double_times_weight[i]
        if number <= weight then
            return i
        end
    end
    return max_double_times
end

function CCtrlReward:GetAdPointCD()

    local cd = 0
    if sPlayer.db.ad.ad_point_time then
        cd = (sPlayer.db.ad.ad_point_time + game.CAssetGame.ad_point_cd) - os.time()
        if cd < 0 then
            cd = 0
        end
    end
    return cd
end

function CCtrlReward:AdPoint(callback)

    -- 判断次数
    if sPlayer.player_modules.ad:IsPop(1) == false then
        dxm.CMessageTipUI:Show(sStrings:GetString("ad_point_times_over"))
        return
    end

    -- 判断时间
    local cd = sCtrlReward:GetAdPointCD()
    if cd > 0 then
        dxm.CMessageTipUI:Show(sStrings:GetString("ad_point_in_cd"))
        return
    end

    sPlayer.player_modules.ad:Pop(1, function(is_ok, reward_type, reward_param) 
        if is_ok then

            -- 判断是否存在翻倍的可能
            if reward_type == game.CPlayerModuleAD.RewardType.kTypeReward and assets.version.branch == "baidu" then

                -- 获取本次翻倍
                local double_times = GetDoubleTimes()

                -- 进行翻倍操作
                local reward_list = game.CRewardList:ParseFromString(reward_param)
                for _,reward in pairs(reward_list.list) do
                    reward.count = math.floor(reward.count * double_times)
                end
                player.player_modules.reward:TakeRewardList(reward_list)
                    
                -- 记录新的时间
                sPlayer.db.ad.ad_point_time = os.time()

                -- 弹出翻倍数字
                sUI:Open("app.views.ui.main.ad_reward_ui", reward_list, double_times)
            else
                self:AdReward(reward_type, reward_param)
            end

            if callback then callback() end
        end
    end)
end

function CCtrlReward:AdReward(reward_type, reward_param)

    if reward_type == game.CPlayerModuleAD.RewardType.kTypeReward then

        -- 给予物品奖励;
        player.player_modules.reward:TakeRewardString(reward_param)
    elseif reward_type == game.CPlayerModuleAD.RewardType.kTypeRewardDouble then

        -- 胜利后奖励翻倍, 这个只能放在战斗逻辑给予奖励;

    elseif reward_type == game.CPlayerModuleAD.RewardType.kTypeOpenBox then

        -- 立刻打开宝箱;
        local pos = sPlayer.player_modules.item_box:GetUnlockSlotPos()
        if pos == 0 then pos = 1 end
        local item_box = sPlayer.player_modules.item_box:GetBox(pos)
        if item_box then
            -- 播放开箱界面;
            local entry = assets.item_boxes:GetEntry(item_box.id)   
            sPlayer.player_modules.item_box:OpenBox(pos, true)
            sUI:Open("app.views.ui.stage.stage_item_box_reward_ui", entry)
        end
    end
end

return CCtrlReward
--endregion
