--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CCtrlStartup = {}
local CCtrlStartup = game.CCtrlStartup

-- 启动
function CCtrlStartup:Start()

    -- if true then return end 
    dxm.audio:playMusic(assets.sound.config.music.main, true)

    local ui
    -- 打开界面;
    sHttpUser.http_request.event_request_waiting:Connect(function() 
        -- ui = sUI:Open("app.views.ui.main.request_waiting_ui")
    end)
    -- 打开界面;
    sHttpUser.http_request.event_request_done:Connect(function() 
        -- 关闭界面;
        -- ui:Close()
    end)

    sCtrlApplication:Init()

    self:PreLoad(function() sCtrlMainMenu:EnterGame() end)
    sThirdPlatformUtils:LogEvent("enter_game", '{"desc":""}')

    if assets.opened.is_dev then
        --cc.Director:getInstance():setAnimationInterval(1.0/60) 
        cc.Director:getInstance():setDisplayStats(assets.opened.is_dev)
    end
end

-- 显示LOGO
function CCtrlStartup:ShowLogo()
    local scene = game.CFBUpdateScene:Create()
    cc.Director:getInstance():replaceScene(scene) 
    sUI:Open("app.views.ui.update.logo_ui")
end

function CCtrlStartup:PreLoad(callback)
    local pre_load_task_list = {}

    -- image
    --[[
    for _,file_list in pairs(game.CAssetGameBackground) do
        for _,file in pairs(file_list) do
            cc.Director:getInstance():getTextureCache():addImage(file.file_path)
        end
    end
    ]]--

    -- 预加载所有物件的动画
    for _,object_entry in pairs(game.CAssetGameObject) do
        if object_entry.file_type == "spine" then
            local animation_name = object_entry.file_path
            sSpineUtils:CreateNodeSkeletonAnimation(animation_name..".json", animation_name..".atlas", true)
        end
    end

    -- 预加载冲刺动画
    local animation_name = game.CAssetGame.super_dash_animation
    spine.CSpineHelper:GetInstancePtr():CreateNodeSkeletonAnimation(animation_name..".json", animation_name..".atlas", true)

    -- 预加载BUFF动画
    for _,animation_name in pairs(game.CAssetGameBuffSpine) do
        spine.CSpineHelper:GetInstancePtr():CreateNodeSkeletonAnimation(animation_name..".json", animation_name..".atlas", true)
    end

    -- spine 
    -- pre_load_task_list[#pre_load_task_list+1] = sLoaderUtils:LoadSpineTask("spine/battle/bomb")

    -- ui    
    -- pre_load_task_list[#pre_load_task_list+1] = sLoaderUtils:LoadUITask("csd/Checkpoint/CheckpointFunction")

    -- sound
    for key,value in pairs(assets.sound.config.sound) do
        pre_load_task_list[#pre_load_task_list+1] = function() dxm.audio:preloadEffect(value) end
    end

    -- tmx
    pre_load_task_list[#pre_load_task_list+1] = function() sTmxCache:Add("tmx/stage_1_start.tmx") end
    pre_load_task_list[#pre_load_task_list+1] = function() sTmxCache:Add("tmx/stage_2_start.tmx") end
    pre_load_task_list[#pre_load_task_list+1] = function() sTmxCache:Add("tmx/volcano_start.tmx") end

    -- 打开加载界面
    local ui = require("dxm.ui.prefab.loading_ui"):Create(pre_load_task_list, function()        
        if callback then callback() end
    end)
    if ui then ui:Open() end
end

function CCtrlStartup:SwitchLocale()

    local scene = dxm.CBaseScene.Create()
    cc.Director:getInstance():replaceScene(scene) 

    -- 清理缓存
    dxm.CWidgetCacheManager:GetInstancePtr():UncacheAllWidget()
    spine.CSpineHelper:GetInstancePtr():Clear()

    if dxm.CLocale.locale_name == "chs" then
        dxm.CLocale:SetLocale("en")
    else
        dxm.CLocale:SetLocale("chs")
    end

    self:PreLoad(function() 
        local scene = game.CFBMenuScene.Create()
        cc.Director:getInstance():replaceScene(scene) 
    end)
end

return CCtrlStartup
--endregion
