--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

require "app.models.attribute.effect_lasting"

game.CPlayerModuleAttributes = class("game.CPlayerModuleAttributes")

local CPlayerModuleAttributes = game.CPlayerModuleAttributes

-- 构造;
function CPlayerModuleAttributes:ctor()

    self.effect_lasting_list = {}
    self.attributes = {}
end

-- 初始化;
function CPlayerModuleAttributes:OnInit()

end


-- 添加持续效果;
function CPlayerModuleAttributes:AddEffectLasting(slot_name, effect_lasting)

    self:RemoveEffectLasting(slot_name)
    for attribute_name, attribute in pairs(effect_lasting.attributes) do
        self:_Chg(attribute_name, attribute)
    end
    self.effect_lasting_list[slot_name] = effect_lasting
end

-- 删除持续效果;
function CPlayerModuleAttributes:RemoveEffectLasting(slot_name)

    local effect_lasting = self.effect_lasting_list[slot_name]
    if effect_lasting then
        for attribute_name, attribute in pairs(effect_lasting.attributes) do
            self:_Chg(attribute_name, -attribute)
        end
        self.effect_lasting_list[slot_name] = nil
    end
end

-- 获取值;
function CPlayerModuleAttributes:Get(attribute_name)
    return self.attributes[attribute_name] or 0
end

function CPlayerModuleAttributes:GetAll()
    return self.attributes
end

-- 设置值;
function CPlayerModuleAttributes:_Set(attribute_name, attribute)

    self.attributes[attribute_name] = attribute
end

-- 改变值;
function CPlayerModuleAttributes:_Chg(attribute_name, attribute)

    local current_attribute = self:Get(attribute_name)
    local old_attribute = self:Get(attribute_name)
    current_attribute = current_attribute + attribute
    if current_attribute < 0 then
        if force then
            current_attribute = 0
        else
            return false
        end
    end

    if self:Get(attribute_name) == current_attribute then
        return false
    end

    self:_Set(attribute_name, current_attribute)
    sMessageDispatcher:Dispatch("player_attribute_changed", attribute_name, current_attribute-old_attribute)
    return true
end

return CPlayerModuleAttributes

--endregion
