--region *.lua
--Date
--此文件由[BabeLua]插件自动生成


-- 点击广告奖励模块;
-- 每天可点击次数为10次, 每10分钟可点击一次;
game.CPlayerModuleAD = class("game.CPlayerModuleAD")

local CPlayerModuleAD = game.CPlayerModuleAD

CPlayerModuleAD.RewardType = {
    kTypeReward = "reward",
    kTypeRewardDouble = "reward_double",
    kTypeOpenBox = "open_box",
}

function CPlayerModuleAD:ctor()

    player.db.ad = player.db.ad or {}
    player.db.ad.click_times_map = player.db.ad.click_times_map or {}
end

-- 默认初始化;
function CPlayerModuleAD:OnInit()

    for _, ad in pairs(assets.ad.config) do
        player.db.ad.click_times_map[ad.id] = player.db.ad.click_times_map[ad.id] or {}
        player.db.ad.click_times_map[ad.id].times = player.db.ad.click_times_map[ad.id].times or 0
    end 

    sPlayer.player_modules.scheduler:AddDaily(function()
        for _, ad in pairs(assets.ad.config) do
            player.db.ad.click_times_map[ad.id] = {}
            player.db.ad.click_times_map[ad.id].times = 0
        end       
    end)   
end

-- 是否弹出广告
function CPlayerModuleAD:IsPop(id)

    if not assets.opened.ad or not sThirdPlatformUtils:IsAdvertisedLoadedV2("") then
        return false
    end

    if not assets.opened.ad_reward[id] then
        return false
    end

    local entry = assets.ad:GetEntry(id)
    if entry then
        if player.db.ad.click_times_map[id].times>=entry.daily_times then
            return false
        end

        local probability = math.random(1,100)
        if probability <= entry.probability then
            return true
        end
    end
    return false
end

-- 弹出广告
function CPlayerModuleAD:Pop(id, callback)

    local entry = assets.ad:GetEntry(id)
    if entry then

        if not self.ad_reward_from_type then

            self.ad_reward_from_type = {}
            if assets.opened.ad_reward_from_dyd then
                self.ad_reward_from_type[#self.ad_reward_from_type+1] = "dyd"
            end
            if assets.opened.ad_reward_from_dxt then
                self.ad_reward_from_type[#self.ad_reward_from_type+1] = "dxt"
            end
            self.ad_reward_from_type_index = 0
        end

        local ad_param = entry.ad_param
        if #self.ad_reward_from_type > 0 then
            self.ad_reward_from_type_index = self.ad_reward_from_type_index + 1
            if self.ad_reward_from_type_index > #self.ad_reward_from_type then
                self.ad_reward_from_type_index = 1
            end
            ad_param = self.ad_reward_from_type[self.ad_reward_from_type_index]
        end

        sThirdPlatformUtils:PopAdvertisedV2(ad_param, function(is_ok) 
            print("CPlayerModuleAD:Pop", id, is_ok)
            if is_ok then
                player.db.ad.click_times_map[id].times = player.db.ad.click_times_map[id].times + 1
            end
            if callback then callback(is_ok, entry.reward_type, entry.reward_param) end
        end)
    else
        if callback then callback(false) end
    end
end

function CPlayerModuleAD:ForcePop(pop_probability)

    if not assets.opened.ad then
        return
    end

    -- 几率
    pop_probability = pop_probability or 100
    local probability = math.random(1,100)
    if probability > pop_probability then
        return
    end

    -- 广告平台选择
    if not self.ad_pop_from_type then

        self.ad_pop_from_type = {}
        if assets.opened.ad_pop_from_dyd then
            self.ad_pop_from_type[#self.ad_pop_from_type+1] = "dyd"
        end
        if assets.opened.ad_pop_from_dxt then
            self.ad_pop_from_type[#self.ad_pop_from_type+1] = "dxt"
        end
        self.ad_pop_from_type_index = 0
    end

    local ad_param = ""
    if #self.ad_pop_from_type > 0 then
        self.ad_pop_from_type_index = self.ad_pop_from_type_index + 1
        if self.ad_pop_from_type_index > #self.ad_pop_from_type then
            self.ad_pop_from_type_index = 1
        end
        ad_param = self.ad_pop_from_type[self.ad_pop_from_type_index]
    end

    sThirdPlatformUtils:PopAdvertisedV2(ad_param, function(is_ok) 
        print("CPlayerModuleAD:ForcePop click", is_ok)
    end)
end

return CPlayerModuleAD

--endregion
