--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CPlayerModuleActionPoint = class("game.CPlayerModuleActionPoint")

local CPlayerModuleActionPoint = game.CPlayerModuleActionPoint
local fix_action_point = 174152

function CPlayerModuleActionPoint:ctor()
    
    player.db.action_point.action_point = player.db.action_point.action_point or assets.const.player_max_action_point
    player.db.action_point.last_recover_action_point_time = player.db.action_point.last_recover_action_point_time or tostring(os.time())

    self.add_action_point = 0
    self.use_action_point_event = dxm.CEvent.new()
end

function CPlayerModuleActionPoint:OnInit()
    sPlayer.player_modules.scheduler:AddUpdate(function()
        self:AutoRecover()
    end)   
end

function CPlayerModuleActionPoint:SetActionPoint(action_point)

    player.db.action_point.action_point = action_point
end

function CPlayerModuleActionPoint:GetActionPoint()
    return player.db.action_point.action_point
end

function CPlayerModuleActionPoint:Change(number, force, is_auto)

    local action_point = self:GetActionPoint() + number
    if action_point < 0 then
        action_point = 0
    end

    if is_auto and action_point > assets.const.player_max_action_point then
        return
    end

    if number > 0 and not force and action_point > assets.const.player_max_action_point then
        action_point = assets.const.player_max_action_point
    end

    if self:GetActionPoint() == action_point then
        return
    end

    --不计算自动回复
    if not is_auto and number > 0 then
        self.add_action_point = self.add_action_point + number
    end

    self:SetActionPoint(action_point)
    
    sMessageDispatcher:Dispatch("action_point_changed")

    --响应使用体力事件
    if number < 0  and self.use_action_point_event then
        self.use_action_point_event:Fire(math.abs(number))
    end
end

function CPlayerModuleActionPoint:AutoRecover()
    local time = self:GetAutoRecoverTime()
    if time <= 0 then
        if self:IsFull() then
            player.db.action_point.last_recover_action_point_time = tostring(os.time())
        else
            player.db.action_point.last_recover_action_point_time = player.db.action_point.last_recover_action_point_time + assets.const.auto_recover_action_point_time
            self:Change(assets.const.auto_recover_action_point_number,false,true)
        end
    end
end

function CPlayerModuleActionPoint:GetAutoRecoverTime()
    local time = assets.const.auto_recover_action_point_time - (os.time() - tonumber(player.db.action_point.last_recover_action_point_time))

    return time
end

function CPlayerModuleActionPoint:GetRecoverFullTime()
    return (assets.const.player_max_action_point - self:GetActionPoint() - assets.const.auto_recover_action_point_number) * assets.const.auto_recover_action_point_time + self:GetAutoRecoverTime() 
end

function CPlayerModuleActionPoint:IsFull()
    return self:GetActionPoint() >= assets.const.player_max_action_point
end

return CPlayerModuleActionPoint

--endregion
