--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CPlayerModuleFriend = class("game.CPlayerModuleFriend")

local CPlayerModuleFriend = game.CPlayerModuleFriend

CPlayerModuleFriend.ErrorCode = {
    "ok",
    "is_already_given_action_point",
    "is_already_asked_for_action_point",
    "is_already_asked_for_unlock_stage",
    "not_enough_take_action_point_times",
    "incorrect_stage_id",
    "is_already_unlocked_stage",
    "too_busy",
}

for key,value in pairs(CPlayerModuleFriend.ErrorCode) do
    CPlayerModuleFriend.ErrorCode[value] = key
end

function CPlayerModuleFriend:ctor()

    player.db.friend.is_already_given_action_point = player.db.friend.is_already_given_action_point or {}
    player.db.friend.is_already_asked_for_action_point = player.db.friend.is_already_asked_for_action_point or {}
    player.db.friend.is_already_asked_for_unlock_stage = player.db.friend.is_already_asked_for_unlock_stage or {}
    player.db.friend.take_action_point_times = player.db.friend.take_action_point_times or 0
    player.db.friend.unlock_stage_times = player.db.friend.unlock_stage_times or {}
    player.db.friend.unlock_stage_source_user = player.db.friend.unlock_stage_source_user or {}

    sPlayer.player_modules.scheduler:AddDaily(function() self:DailyClear() end)

    self.ask_for_unlock_stage_time = nil

    player.db.friend.friend_data = player.db.friend.friend_data or {}
    sFriendSystem.init_friend_function = function(friend) self:FillFriendInfo(friend) end

    self.give_action_point_event = dxm.CEvent.new()
end

function CPlayerModuleFriend:OnInit()

end

function CPlayerModuleFriend:FillFriendInfo(friend)
    if friend == nil then
        return
    end

    local friend_data = player.db.friend.friend_data[friend.user_id] or {}
    if friend_data.user_info == nil then
        friend_data.user_info = {}
    end
    local is_filled = false

    if friend.user_name == nil then
        if friend_data.user_name == nil then
            friend_data.user_name = assets.names:Get()
            is_filled = true
        end
        friend.user_name = friend_data.user_name
    end

    if friend.user_info == nil then
        friend.user_info = {}
    end
    if friend.user_info.head_icon == nil then
        if friend_data.user_info.head_icon == nil then
            friend_data.user_info.head_icon = math.random(1, 4)
            is_filled = true
        end
        friend.user_info.head_icon = friend_data.user_info.head_icon
    end
    if friend.user_info.level == nil then
        if friend_data.user_info.level == nil then
            friend_data.user_info.level = math.random(5, 30)
            is_filled = true
        end
        friend.user_info.level = friend_data.user_info.level
    end
    if friend.user_info.completed_stage_id == nil then
        if friend_data.user_info.completed_stage_id == nil then

            local stage_id = math.random(1, #game.CAssetStage.normal.stage)
            local child_stage_id = 1
            local stage_entry = game.CAssetStage.normal.stage[stage_id]
            if stage_entry then
                child_stage_id = math.random(1, stage_entry.child_stage_count)
            end
            friend_data.user_info.completed_stage_id = stage_id*100+child_stage_id
            is_filled = true
        end
        friend.user_info.completed_stage_id = friend_data.user_info.completed_stage_id
    end
    if friend.user_info.star_count == nil then
        if friend_data.user_info.star_count == nil then
            local stage_id = math.floor(friend.user_info.completed_stage_id/100)
            local child_stage_id =  friend.user_info.completed_stage_id%100
            local child_stage_count = 0
            for i=1, stage_id do

                local stage_entry = game.CAssetStage.normal.stage[i]
                if not stage_entry then
                    break
                end

                local max_child_stage_id = stage_entry.child_stage_count
                if i == stage_id then
                    max_child_stage_id = child_stage_id
                end
                child_stage_count = child_stage_count + max_child_stage_id
            end
            friend_data.user_info.star_count = math.random(child_stage_count*2, child_stage_count*3)
            is_filled = true
        end
        friend.user_info.star_count = friend_data.user_info.star_count
    end
    if friend.user_info.roles == nil then
        if friend_data.user_info.roles == nil then
            local roles = {}
            for i=1,friend.user_info.head_icon do
                roles[i]={id=i,level=1}
            end
            friend_data.user_info.roles = json.encode(roles)
            is_filled = true
        end
        friend.user_info.roles = friend_data.user_info.roles
    end
    if friend.user_info.infinite_best_score == nil then
        if friend_data.user_info.infinite_best_score == nil then
            friend_data.user_info.infinite_best_score = math.random(5000, 40000)
            is_filled = true
        end
        friend.user_info.infinite_best_score = friend_data.user_info.infinite_best_score
    end

    if is_filled then
        player.db.friend.friend_data[friend.user_id] = friend_data
    end
end

function CPlayerModuleFriend:CanAskForActionPoint(target_user) 

    if target_user and player.db.friend.is_already_asked_for_action_point[target_user.user_id] then
        return CPlayerModuleFriend.ErrorCode.is_already_asked_for_action_point
    end
    return CPlayerModuleFriend.ErrorCode.ok 
end

function CPlayerModuleFriend:AskForActionPoint(target_user)

    local error_code = self:CanAskForActionPoint(target_user)
    if error_code ~= CPlayerModuleFriend.ErrorCode.ok then
        return error_code
    end

    -- 记录已经请求某玩家赠送体力
    player.db.friend.is_already_asked_for_action_point[target_user.user_id] = true
    

    -- 好友系统发送赠送体力信息
    sFriendSystem:RequestCustom(target_user.user_id, "ask_for_action_point", {}, nil)

    return error_code
end

function CPlayerModuleFriend:CanGiveActionPoint(target_user) 

    if player.db.friend.is_already_given_action_point[target_user.user_id] then
        return CPlayerModuleFriend.ErrorCode.is_already_given_action_point
    end
    return CPlayerModuleFriend.ErrorCode.ok 
end

function CPlayerModuleFriend:GiveActionPoint(target_user)

    local error_code = self:CanGiveActionPoint(target_user)
    if error_code ~= CPlayerModuleFriend.ErrorCode.ok then
        return error_code
    end

    -- 记录已经给与某玩家体力
    player.db.friend.is_already_given_action_point[target_user.user_id] = true

    -- 好友系统发送赠送体力信息
    sFriendSystem:RequestCustom(target_user.user_id, "give_action_point", {}, nil)
    self.give_action_point_event:Fire()
    return error_code
end

function CPlayerModuleFriend:CanTakeActionPoint(source_user)

    if player.db.friend.take_action_point_times >= assets.const.take_friend_action_point_times then
        return CPlayerModuleFriend.ErrorCode.not_enough_take_action_point_times
    end
    return CPlayerModuleFriend.ErrorCode.ok 
end

function CPlayerModuleFriend:TakeActionPoint(source_user)

    local error_code = self:CanTakeActionPoint(source_user)
    if error_code ~= CPlayerModuleFriend.ErrorCode.ok then
        return error_code
    end

    -- 领取次数增加
    player.db.friend.take_action_point_times = player.db.friend.take_action_point_times + 1
    

    -- 正式领取奖励
    sPlayer.player_modules.reward:TakeRewardString(assets.const.friend_action_point_reward)

    return error_code
end

function CPlayerModuleFriend:CanAskForUnlockStage(stage_id)

    if not sPlayer.player_modules.stage_level:IsLockByStageID(stage_id) then
        return CPlayerModuleFriend.ErrorCode.incorrect_stage_id
    end

    if self.ask_for_unlock_stage_time ~= nil and os.time() - self.ask_for_unlock_stage_time < 10 then
        return CPlayerModuleFriend.ErrorCode.too_busy
    end
    return CPlayerModuleFriend.ErrorCode.ok 
end

function CPlayerModuleFriend:AskForUnlockStage(stage_id)

    print("CPlayerModuleFriend:AskForUnlockStage", stage_id)
    local error_code = self:CanAskForUnlockStage(stage_id)
    if error_code ~= CPlayerModuleFriend.ErrorCode.ok then
        return error_code
    end

    -- 记录时间
    self.ask_for_unlock_stage_time = os.time()

    -- 遍历所有好友请求解锁关卡
    self:RequestGetFriends(function() 

        for _,friend in pairs(sFriendSystem.friends) do
            print(friend.user_id)
            sFriendSystem:RequestCustom(friend.user_id, "ask_for_unlock_stage", { stage_id = stage_id }, nil)
        end
    end)
    return error_code
end

function CPlayerModuleFriend:CanConfirmUnlockStage(target_user, stage_id)
    return CPlayerModuleFriend.ErrorCode.ok 
end

function CPlayerModuleFriend:ConfirmUnlockStage(target_user, stage_id)

    print("CPlayerModuleFriend:ConfirmUnlockStage", target_user.user_id, stage_id)
    local error_code = self:CanConfirmUnlockStage(target_user, stage_id)
    if error_code ~= CPlayerModuleFriend.ErrorCode.ok then
        return error_code
    end

    -- 好友系统发送解锁信息
    sFriendSystem:RequestCustom(target_user.user_id, "confirm_unlock_stage", { stage_id = stage_id }, nil)

    return error_code
end

function CPlayerModuleFriend:CanUnlockStage(source_user, stage_id)

    -- 关卡是否为当前最新关卡
    if not sPlayer.player_modules.stage_level:IsLockByStageID(stage_id) then
        return CPlayerModuleFriend.ErrorCode.incorrect_stage_id
    end

    -- 判断该玩家是否已经投票解锁
    for _,unlock_source_user in ipairs(player.db.friend.unlock_stage_source_user) do
        if unlock_source_user.user_id == source_user.user_id then
            return CPlayerModunlockuleFriend.ErrorCode.is_already_unlocked_stage
        end
    end
    return CPlayerModuleFriend.ErrorCode.ok
end

function CPlayerModuleFriend:UnlockStage(source_user, stage_id)

    print("CPlayerModuleFriend:UnlockStage", source_user.user_id, stage_id)
    local error_code = self:CanUnlockStage(source_user, stage_id)
    if error_code ~= CPlayerModuleFriend.ErrorCode.ok then
        return error_code
    end

    -- 增加一次解锁确认次数
    player.db.friend.unlock_stage_times[tostring(stage_id)] = player.db.friend.unlock_stage_times[tostring(stage_id)] or 0
    player.db.friend.unlock_stage_times[tostring(stage_id)] = player.db.friend.unlock_stage_times[tostring(stage_id)] + 1
    player.db.friend.unlock_stage_source_user[tostring(stage_id)] = player.db.friend.unlock_stage_source_user[tostring(stage_id)] or {}
    player.db.friend.unlock_stage_source_user[tostring(stage_id)][tostring(source_user.user_id)] = source_user
    

    return error_code
end

function CPlayerModuleFriend:GetUnlockSourceUser(stage_id)
    return player.db.friend.unlock_stage_source_user[tostring(stage_id)] or {}
end

function CPlayerModuleFriend:GetUnlockTimes(stage_id)
    return player.db.friend.unlock_stage_times[tostring(stage_id)] or 0
end

function CPlayerModuleFriend:ClearUnlockSourceUser(stage_id)
    player.db.friend.unlock_stage_times[tostring(stage_id)] = nil
    player.db.friend.unlock_stage_source_user[tostring(stage_id)] = nil
    
end

function CPlayerModuleFriend:DailyClear()
    player.db.friend.is_already_given_action_point = {}
    player.db.friend.is_already_asked_action_point = {}
    player.db.friend.take_action_point_times = 0
end

function CPlayerModuleFriend:GetFriendByStageID(stage_id)
    for _,friend in pairs(sFriendSystem.friends) do
        if friend and friend.user_info and friend.user_info.completed_stage_id == stage_id then
            return friend
        end
    end
    return nil
end

function CPlayerModuleFriend:MakeSureFriendExist(callback)

    -- 判断用户是否存在
    local has_friends = false
    for _,friend in pairs(sFriendSystem.friends) do
        if friend ~= nil then
            has_friends = true
            break
        end
    end

    -- 如果当前没有好友，则需要立即申请获取附近的人并自动添加为好友
    if not has_friends then
        sHttpUser:SearchPlayersNearBy(0, 5200, 10, function(code,data) 
            if code == 0 then
                for _,friend in pairs(data.users_nearby) do
                    sPlayer.player_modules.friend:FillFriendInfo(friend)
                    sFriendSystem:RequestAddFriendQuickly(friend, true, nil)
                end

                if callback then
                    callback(true)
                end
            end
        end)
    end

    if callback then
        callback(false)
    end
end

return CPlayerModuleFriend

--endregion
