--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CPlayerModuleLevel = class("game.CPlayerModuleLevel")

local CPlayerModuleLevel = game.CPlayerModuleLevel

function CPlayerModuleLevel:ctor()

    player.db.level = player.db.level or {}
    player.db.level.level = player.db.level.level or 1
    player.db.level.exp = player.db.level.exp or 0 

    self.next_level_exp = 100
    self.max_level = 30

    self.level_changed_event = dxm.CEvent.new()
    self:_ResetNextLevelExp()
end

function CPlayerModuleLevel:OnInit()
    
end

function CPlayerModuleLevel:GetLevel()
    return player.db.level.level
end

function CPlayerModuleLevel:GetExp()
    return player.db.level.exp
end

function CPlayerModuleLevel:SetLevel( level )
	if player.db.level.level ~= level then

        self.level_changed_event:Fire(level, level-player.db.level.level)

		player.db.level.level = level
		
		-- 根据实体等级获取下一级所需要的经验值
		self:_ResetNextLevelExp();

		-- 更新事件
		sMessageDispatcher:Dispatch("player_exp_changed")

        -- 提交角色等级
        sHttpUser:RequestCommitUserInfo("level", level, function() end)
	end
end

function CPlayerModuleLevel:SetExp( exp )
	if exp_ ~= exp then
		exp_ = exp
		-- 更新事件;
		sMessageDispatcher:Dispatch("player_exp_changed")
	end
end

function CPlayerModuleLevel:AddExp( exp )
	if self.next_level_exp > 0 then
		local level_changed = fals

		--	判断经验是否足够升级;
		player.db.level.exp = player.db.level.exp + exp
		
        local level_added = 0
		while player.db.level.exp >= self.next_level_exp do

			if self.max_level ~= 0 and player.db.level.level >= self.max_level then
				player.db.level.exp = self.next_level_exp
				break
			end
			-- 扣除本级经验;
			player.db.level.exp = player.db.level.exp - self.next_level_exp
            -- 升级
			player.db.level.level = player.db.level.level + 1
            -- 
			level_added = level_added + 1
            -- 设置下一级经验;
			self:_ResetNextLevelExp()

			if self.next_level_exp == 0 then
				player.db.level.exp = 0
				break
			end
		end
        if level_added > 0 then
            self.level_changed_event:Fire(player.db.level.level, level_added)
        end
		 sMessageDispatcher:Dispatch("player_exp_changed", level_added)
    end
end

function CPlayerModuleLevel:_ResetNextLevelExp( void )
	self.next_level_exp = self:GetNextLevelExp(player.db.level.level)
    print("ooooooo", self.next_level_exp, player.db.level.level)
end

function CPlayerModuleLevel:SetMaxLevel( max_level)
	self.max_level = max_level
	self:_ResetNextLevelExp()
end

function CPlayerModuleLevel:GetMaxLevel()
    return self.max_level
end

function CPlayerModuleLevel:GetNextLevelExp( level )

	return assets.player_levels:GetLevelExp(level or player.db.level.level)
end

return CPlayerModuleLevel

--endregion
