--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CPlayerModuleMounts = class("game.CPlayerModuleMounts")
local CPlayerModuleMounts = game.CPlayerModuleMounts

function CPlayerModuleMounts:ctor()

    player.db.mounts.mount_list = player.db.mounts.mount_list or {}
    player.db.mounts.active_mount_id = player.db.mounts.active_mount_id or 0

    self.mount_count_event = dxm.CEvent.new()
    self.mount_upgrade_event = dxm.CEvent.new()
end

function CPlayerModuleMounts:OnInit()

    local has_mount = false
    for _,_ in pairs(player.db.mounts.mount_list) do
        has_mount = true
        break
    end

    -- 初始化所有坐骑;
    for key, mount in pairs(player.db.mounts.mount_list) do
        local entry = assets.mounts:GetEntry(mount.id)
        if not entry then
            player.db.mounts.mount_list[key] = nil
        end
    end

    for key, entry in pairs(assets.mounts.config) do
        local mount = player.db.mounts.mount_list[tostring(key)]
        if not mount then 
            mount = {}            
            mount.level = entry.InitLevel   
            if entry.ID == assets.mounts.init_select_mount then
                if player.db.mounts.active_mount_id==0 then
                    player.db.mounts.active_mount_id = mount.id
                end
                mount.buyed = true
            else
                mount.buyed = (entry.InitState  == 'true')
            end
        else        
            if not mount.buyed then
                mount.buyed = (entry.InitState  == 'true')
            end
        end   

        mount.id = entry.ID
        mount.skill_list = {}
        for _, skill_id in pairs(entry.SkillList) do
            mount.skill_list[tostring(skill_id)] = skill_id
        end
        player.db.mounts.mount_list[tostring(key)] = mount
    end

    self:_ResetActiveMount()
    self.mount_count_event:Fire()

    -- 首次启动该系统时提交
    sHttpUser:RequestCommitUserInfo("mounts", self:MakeCommitUserInfoData(), function() end)
end

-- 坐骑状态判定
function CPlayerModuleMounts:IsBuyed(mount_id)
    
    local mount = player.db.mounts.mount_list[tostring(mount_id)]
    if mount then
        return mount.buyed
    end 
    return false
end

function CPlayerModuleMounts:IsUnlock(mount_id)
    
    local mount = player.db.mounts.mount_list[tostring(mount_id)]
    if mount then
        local entry = assets.mounts:GetEntry(mount_id)
        if entry then
            if entry.LockConditionType == "stage" then
                return player.player_modules.stage:GetCompletedStageID()>=entry.LockConditionValue
            end
            if entry.LockConditionType == "level" then
                return player.player_modules.level:GetLevel()>=entry.LockConditionValue
            end
            return true
        end
    end 
    return false
end

-- 坐骑激活
function CPlayerModuleMounts:_ResetActiveMount()

    -- 初始化技能;
    local mount = player.db.mounts.mount_list[tostring(player.db.mounts.active_mount_id)]
    if mount then
        local effect_lasting = game.CEffectLasting:new()
        local level = level or mount.level
        for _, skill_id in pairs(mount.skill_list) do
            local entry = assets.skills:GetEntry(skill_id)
            if entry then
                effect_lasting:Chg(entry.Type, assets.skills:GetValue(skill_id, level))
            end
        end   
        sPlayer.player_modules.attributes:AddEffectLasting("mount", effect_lasting)    
    else
        sPlayer.player_modules.attributes:RemoveEffectLasting("mount")  
    end
end

function CPlayerModuleMounts:SetActiveMount(mount_id)

    if mount_id==0 or (self:IsBuyed(mount_id) and self:IsUnlock(mount_id)) then
        player.db.mounts.active_mount_id = mount_id
    end
    self:_ResetActiveMount()
end

function CPlayerModuleMounts:GetActiveMount()

    return player.db.mounts.mount_list[tostring(player.db.mounts.active_mount_id)]
end

function CPlayerModuleMounts:GetMount(mount_id)

    mount_id = mount_id or player.db.mounts.active_mount_id
    return player.db.mounts.mount_list[tostring(mount_id)]
end

function CPlayerModuleMounts:IsActiveMount(id)

    return player.db.mounts.active_mount_id == id
end


function CPlayerModuleMounts:GetActiveMountSpine()
    local mount = player.db.mounts.mount_list[tostring(player.db.mounts.active_mount_id)]
    if mount then
        local entry = assets.mounts:GetEntry(player.db.mounts.active_mount_id)
        return entry.Spine
    end
    return ""
end

function CPlayerModuleMounts:GetActiveMountSkillValue(skill_id)

    return self:GetMountSkillValue(player.db.mounts.active_mount_id, skill_id)
end

function CPlayerModuleMounts:GetMountSkillValue(mount_id, skill_id, level)

    local mount = player.db.mounts.mount_list[tostring(mount_id)]
    local level = level or mount.level
    if mount then
        return assets.skills:GetValue(skill_id, level)
    end
    return 0
end

-- 坐骑购买
function CPlayerModuleMounts:Buy(mount_id)

    local mount = player.db.mounts.mount_list[tostring(mount_id)]
    if mount then
        if self:IsBuyed(mount_id) then
            return "mount_buyed"
        end

        if not self:IsUnlock(mount_id) then
            return "mount_lock"
        end

        local entry = assets.mounts:GetEntry(mount_id)
        if entry.BuyValue > 0 then                
            if entry.BuyType == "gamebill" then
                local gamebill = entry.BuyValue
                if gamebill > player.player_modules.numbers:Get("gamebill") then
                    return "not_enough_gamebill"
                end           
                player.player_modules.numbers:Chg("gamebill", -gamebill, true)   
            elseif entry.BuyType == "point" then
                if entry.BuyValue > player.player_modules.point:GetPoint()  then
                    return "not_enough_point"         
                end            
                player.player_modules.point:SubPoint(entry.BuyValue)    
                sThirdPlatformUtils:LogEvent("item_purchase", '{"item":"mount_'..mount_id..'", "item_count":1, "price":'..entry.BuyValue.."}")    
            end
        end
        mount.buyed = true

        self.mount_count_event:Fire()
        sMessageDispatcher:Dispatch("buy_mount_ok", mount_id)

        -- 提交坐骑信息
        sHttpUser:RequestCommitUserInfo("mounts", self:MakeCommitUserInfoData(), function() end)
    end
    return nil
end

-- 奖励
function CPlayerModuleMounts:Reward(mount_id)

    local mount = player.db.mounts.mount_list[tostring(mount_id)]
    if mount then
        local entry = assets.mounts:GetEntry(mount_id)
        if self:IsBuyed(mount_id) then
            if entry.BuyType == "gamebill" then
                player.player_modules.numbers:Chg("gamebill", math.ceil(entry.BuyValue/2), true)   
            elseif entry.BuyType == "point" then
                player.player_modules.point:ChangePoint( math.ceil(entry.BuyValue/2) ) 
            end            
            return "mount_buyed"
        end

        if not self:IsUnlock(mount_id) then
            return "mount_lock"
        end

        mount.buyed = true

        self.mount_count_event:Fire()
        sMessageDispatcher:Dispatch("buy_mount_ok", mount_id)

        -- 提交坐骑信息
        sHttpUser:RequestCommitUserInfo("mounts", self:MakeCommitUserInfoData(), function() end)
    end
    return nil
end

-- 获取提交数据
function CPlayerModuleMounts:MakeCommitUserInfoData()

    local data = {}
    for mount_id,mount in pairs(player.db.mounts.mount_list) do
        data[mount_id] = {id=tonumber(mount_id),level=mount.level}
    end
    return json.encode(data)
end

-- 坐骑升级
function CPlayerModuleMounts:IsFullLevel(mount_id)
    local mount = player.db.mounts.mount_list[tostring(mount_id)]
    if mount then
        local entry = assets.mounts:GetEntry(mount_id)
        if mount.level < entry.MaxLevel then
            return false
        end
    end
    return true
end

function CPlayerModuleMounts:GetLevelUpGamebill(mount_id)

    local mount = player.db.mounts.mount_list[tostring(mount_id)]
    if mount then
        return assets.mounts:GetLevelGamebill(mount.level)
    end
    return 0
end

function CPlayerModuleMounts:Upgrade(mount_id)

    local mount = player.db.mounts.mount_list[tostring(mount_id)]
    if mount then
        local entry = assets.mounts:GetEntry(mount_id)
        if mount.level >= entry.MaxLevel then            
            return "full_level"
        end
        local gamebill = assets.mounts:GetLevelGamebill(mount.level)
        if gamebill > player.player_modules.numbers:Get("gamebill") then
            return "not_enough_gamebill"
        end
              
        player.player_modules.numbers:Chg("gamebill", -gamebill, true)
        mount.level = mount.level + 1

        self.mount_upgrade_event:Fire(mount_id, mount.level, 1)
        self.mount_count_event:Fire()
        sMessageDispatcher:Dispatch("upgrade_mount_ok", mount_id)

        -- 提交坐骑信息
        sHttpUser:RequestCommitUserInfo("mounts", self:MakeCommitUserInfoData(), function() end)

        self:_ResetActiveMount()
    end

    return nil
end

function CPlayerModuleMounts:OneKeyUpgrade(mount_id, callback)

    local mount = player.db.mounts.mount_list[tostring(mount_id)]
    if mount then
        local entry = assets.mounts:GetEntry(mount_id)
        if mount.level >= entry.MaxLevel then            
            return "full_level"
        end
        sCtrlRecharge:Pay(entry.OneKeyUpgradePayMoney, entry.OneKeyUpgradePayID, "one_key_upgrade_mounts_"..mount_id, function(is_successful)        
            if is_successful then
                sHttpUser:RequestSavePayinfo(entry.OneKeyUpgradePayMoney, assets.version.branch)
              
                mount.level = entry.MaxLevel

                self.mount_upgrade_event:Fire(mount_id, mount.level, 1)
                self.mount_count_event:Fire()

                sMessageDispatcher:Dispatch("upgrade_mount_ok", mount_id)

                -- 提交坐骑信息
                sHttpUser:RequestCommitUserInfo("mounts", self:MakeCommitUserInfoData(), function() end)

                self:_ResetActiveMount()
            end
            if callback then callback(is_successful) end
        end)
    end

    return nil
end

function CPlayerModuleMounts:GetCount(min_level)

    min_level = min_level or 0
    local count = 0
    for _, mount in pairs(player.db.mounts.mount_list) do
        if mount.buyed and mount.level >= min_level then
            count = count + 1
        end
    end
    return count
end

return CPlayerModuleMounts
--endregion
