--region *.lua
--Date
--此文件由[BabeLua]插件自动生成
game.CPlayerModulePackage = class("game.CPlayerModulePakage")
local CPlayerModulePackage = game.CPlayerModulePackage

function CPlayerModulePackage:ctor()

    player.db.package.item_list = player.db.package.item_list or {}

    self.reward_item_count = 0
    self.use_item_event = dxm.CEvent.new()
end

function CPlayerModulePackage:AddItem(item_id, count)

    if not item_id then return end

    -- 获取物品配置
    local item_entry = assets.items:GetEntry(item_id)
    if not item_entry then
        return
    end
    
    print("add item, item_id :"..item_id.."count :"..count, current_count)

    self.reward_item_count = self.reward_item_count + count

    -- 判断物品类型是否为随机BUFF
    if item_entry.item_type == assets.items.ItemType.kTypeRandomItem and count > 0 then
        sPlayer.player_modules.random_item:Random()
    else

        -- 累计物品数量
        local current_count = self:GetItemCount(item_id)
        count = current_count + count
        if count <= 0 then
            player.db.package.item_list[tostring(item_id)] = nil
        else
            player.db.package.item_list[tostring(item_id)] = count
        end
    end
    sMessageDispatcher:Dispatch("add_item", item_id, count)
end

function CPlayerModulePackage:AddItemList(item_list)

    for k , v in pairs(item_list) do
        self:AddItem(k,v)
    end
end

function CPlayerModulePackage:GetItemCount(item_id)
    
    if not item_id then return 0 end
    return player.db.package.item_list[tostring(item_id)] or 0
end

function CPlayerModulePackage:GetItemList()

    return player.db.package.item_list
end

function CPlayerModulePackage:UseItem(item_id, count)

    if self:GetItemCount(item_id) < count then
        return false
    end

    local entry = assets.items:GetEntry(item_id)
    if entry.item_type == assets.items.ItemType.kTypeActionPointBox and sPlayer.player_modules.action_point:IsFull() then
        return false
    end 

    print("use item", entry.item_type, item_id)
    -- 使用物品获得效果
    if entry.item_type == assets.items.ItemType.kTypeBox or entry.item_type == assets.items.ItemType.kTypeActionPointBox then     
        
        -- 礼包和体力恢复药剂   
        for i = 1 ,count do
            sPlayer.player_modules.reward:TakeRewardString(entry.value)
        end
    end

    -- 消耗物品
    self:AddItem(item_id, -count)
    
    -- 事件通知与日志
    sMessageDispatcher:Dispatch("use_item", item_id, count)
    sThirdPlatformUtils:LogEvent("item_use", "{\"item\":\"item_"..item_id.."\", \"item_count\":"..count.."}")

    -- 触发事件
    if self.use_item_event then
        self.use_item_event:Fire(item_id, count)
    end
    return true
end

return CPlayerModulePackage

--endregion
