--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CPlayerModuleRank = class("game.CPlayerModuleRank")
local CPlayerModuleRank = game.CPlayerModuleRank

function CPlayerModuleRank:ctor()
    player.db.rank.user_rank_info_v2 = player.db.rank.user_rank_info_v2 or {}
    player.db.rank.user_rank_top = player.db.rank.user_rank_top or {}
    player.db.rank.user_rank_less_me = player.db.rank.user_rank_less_me or {}
    player.db.rank.user_rank_large_me = player.db.rank.user_rank_large_me or {}
    player.db.rank.user_rank_top_with_friend = player.db.rank.user_rank_top_with_friend or {}
    player.db.rank.refresh_time = player.db.rank.refresh_time or {}
end

function CPlayerModuleRank:GetRankTop(rank_name)

    player.db.rank.user_rank_top[rank_name] = player.db.rank.user_rank_top[rank_name] or { }
    local db_rank_top = player.db.rank.user_rank_top[rank_name]:Clone()
    local rank_top = {}
    for key, rank_player in pairs(db_rank_top) do
        rank_top[tonumber(key)] = rank_player
    end
    return rank_top
end

function CPlayerModuleRank:GetMyRankNumber(rank_name)
    return player.db.rank.user_rank_info_v2[rank_name] or nil
end

function CPlayerModuleRank:GetRankTopWithFriend(rank_name)

    player.db.rank.user_rank_top_with_friend[rank_name] = player.db.rank.user_rank_top_with_friend[rank_name] or { }
    local db_rank_top = player.db.rank.user_rank_top_with_friend[rank_name]:Clone()
    local rank_top = {}
    for key, rank_player in pairs(db_rank_top) do
        rank_top[tonumber(key)] = rank_player
    end
    return rank_top
end

function CPlayerModuleRank:RequestGetRank(rank_name, rank_order, callback)

    if not rank_name then return end

    sHttpUser:RequestGetRankInfo(rank_name, rank_order, function(code, data) 

        if code==0 then 
            if sHttpUser.user_rank_info[rank_name] and sHttpUser.user_rank_info[rank_name].pos then 
                player.db.rank.user_rank_info_v2[rank_name] = sHttpUser.user_rank_info[rank_name]
            end
            if sHttpUser.user_rank_top[rank_name] then
                player.db.rank.user_rank_top[rank_name] = sHttpUser.user_rank_top[rank_name]
            end
            if sHttpUser.user_rank_less_me[rank_name] then
                player.db.rank.user_rank_less_me[rank_name] = sHttpUser.user_rank_less_me[rank_name]
            end
            if sHttpUser.user_rank_large_me[rank_name] then
                player.db.rank.user_rank_large_me[rank_name] = sHttpUser.user_rank_large_me[rank_name]
            end
            if sHttpUser.user_rank_top_with_friend[rank_name] then
                player.db.rank.user_rank_top_with_friend[rank_name] = sHttpUser.user_rank_top_with_friend[rank_name]
            end
            player.db.rank.refresh_time[rank_name] = sTimeUtils:Now()
        end
    end)
    self:AdjustRank(rank_name)
    if callback then callback() end
end

function CPlayerModuleRank:CommitUserRankValue(rank_name, value, subvalue, rank_order)

    if not rank_name then return end

    sHttpUser:RequestCommitUserRankValue(rank_name, value, subvalue, rank_order, function(code, data)
        if code==0 then 
            if sHttpUser.user_rank_info[rank_name] and sHttpUser.user_rank_info[rank_name].pos then 
                player.db.rank.user_rank_info_v2[rank_name] = sHttpUser.user_rank_info[rank_name] 
            end
            if sHttpUser.user_rank_top[rank_name] then
                player.db.rank.user_rank_top[rank_name] = sHttpUser.user_rank_top[rank_name]
            end
            if sHttpUser.user_rank_less_me[rank_name] then
                player.db.rank.user_rank_less_me[rank_name] = sHttpUser.user_rank_less_me[rank_name]
            end
            if sHttpUser.user_rank_large_me[rank_name] then
                player.db.rank.user_rank_large_me[rank_name] = sHttpUser.user_rank_large_me[rank_name]
            end
            if sHttpUser.user_rank_top_with_friend[rank_name] then
                player.db.rank.user_rank_top_with_friend[rank_name] = sHttpUser.user_rank_top_with_friend[rank_name]
            end
            player.db.rank.refresh_time[rank_name] = sTimeUtils:Now()            
        end        
    end) 
    self:AdjustRank(rank_name)
    self:AdjustSelf(rank_name, value, subvalue, rank_order)
    if callback then callback() end

    --关卡排行事件
    local ranking = nil
    if player.db.rank.user_rank_info_v2[rank_name] then
        ranking = player.db.rank.user_rank_info_v2[rank_name].pos
    end
end

function CPlayerModuleRank:AdjustRank(rank_name)

    -- 世界排行
    local rank_top = self:GetRankTop(rank_name)
    local max_pos = 1
    local min_value = nil
    local min_sub_value = nil
    for _, rank_player in ipairs(rank_top) do
        max_pos = rank_player.pos + 1
        min_value = rank_player.value
        min_sub_value = rank_player.subvalue
        if not rank_player.user_name or rank_player.user_name == "nickname" or rank_player.user_name=="" then
            rank_player.user_name = assets.names:Get()
        end
    end
    for pos = max_pos, 50 do
        local rank_player = sPlayer.player_modules.rank:RandomPlayer(rank_name, min_value, min_sub_value)
        rank_player.pos = pos
        rank_top[#rank_top + 1] = rank_player

        min_value = rank_player.value
        min_sub_value = rank_player.subvalue
    end
    player.db.rank.user_rank_top[rank_name] = rank_top

    -- 好友排行
    local rank_top_with_friend = self:GetRankTopWithFriend(rank_name)
    local rank_player_exists = {}
    for _,rank_player in pairs(rank_top_with_friend) do
        rank_player_exists[rank_player.user_id] = rank_player

        -- 数据赋值
        player.player_modules.friend:FillFriendInfo(rank_player)
    end

    local create_rank_player = false
    for _,friend in pairs(sFriendSystem.friends) do
        if rank_player_exists[friend.user_id] == nil then
            local rank_player = nil
            if rank_name == "infinite" then
                rank_player = self:CreatePlayer(friend.user_id, friend.user_name, friend.user_info.infinite_best_score)
            elseif rank_name == "stage" then
                rank_player = self:CreatePlayer(friend.user_id, friend.user_name, friend.user_info.completed_stage_id, friend.user_info.star_count)
            end
            if rank_player then
                create_rank_player = true
                rank_top_with_friend[#rank_top_with_friend+1] = rank_player
            end
        end
    end

    if create_rank_player then
        table.sort(rank_top_with_friend, function(a,b) 

            if tonumber(a.value) > tonumber(b.value) then
                return true
            elseif tonumber(a.value) == tonumber(b.value) then 
                return a.subvalue and b.subvalue and tonumber(a.subvalue) > tonumber(b.subvalue)
            else
                return false
            end
        end)

        for key,value in ipairs(rank_top_with_friend) do
            value.pos = key

            -- 如果发现自己的帐号，则调整排行
            if value.user_id == player.db.info.user_id then
                player.db.rank.user_rank_info_v2 = player.db.rank.user_rank_info_v2 or {}
                player.db.rank.user_rank_info_v2[rank_name] = player.db.rank.user_rank_info_v2[rank_name] or {}
                player.db.rank.user_rank_info_v2[rank_name].pos_with_friend = key
            end
        end
    end
    player.db.rank.user_rank_top_with_friend[rank_name] = rank_top_with_friend
end

function CPlayerModuleRank:AdjustSelf(rank_name, value, subvalue, rank_order)
    
    value = value or 0
    subvalue = subvalue or 0
    rank_order = rank_order or 0

    player.db.rank.user_rank_info_v2 = player.db.rank.user_rank_info_v2 or {}
    player.db.rank.user_rank_info_v2[rank_name] = player.db.rank.user_rank_info_v2[rank_name] or {}
    player.db.rank.user_rank_info_v2[rank_name].pos = player.db.rank.user_rank_info_v2[rank_name].pos or math.random(180000, 280000)
    player.db.rank.user_rank_info_v2[rank_name].value = tonumber(player.db.rank.user_rank_info_v2[rank_name].value) or 0
    player.db.rank.user_rank_info_v2[rank_name].subvalue = tonumber(player.db.rank.user_rank_info_v2[rank_name].subvalue) or 0
    player.db.rank.user_rank_info_v2[rank_name].pos_with_friend = player.db.rank.user_rank_info_v2[rank_name].pos_with_friend or math.random(180000, 280000)

    local user_rank_info = player.db.rank.user_rank_info_v2[rank_name]
    if value>user_rank_info.value or (user_rank_info.value==value and subvalue>user_rank_info.subvalue) then
        if user_rank_info.pos > 53 then
            user_rank_info.pos = user_rank_info.pos - math.random(1, 3)
        end
    end

    user_rank_info.rank_name = rank_name
    user_rank_info.pos = player.db.rank.user_rank_info_v2[rank_name].pos
    user_rank_info.value = value
    user_rank_info.subvalue = subvalue
    user_rank_info.user_id = player.db.rank.user_rank_info_v2[rank_name].user_id or 0
    user_rank_info.user_name = player.db.rank.user_name
    user_rank_info.user_info = {}
    user_rank_info.user_info.head_icon = player.db.rank.head_icon
    user_rank_info.pos_with_friend = player.db.rank.user_rank_info_v2[rank_name].pos_with_friend

    --player.db.rank.user_rank_info_v2[rank_name] = user_rank_info

    -- 世界排行
    local rank_top = self:GetRankTop(rank_name)
    local new_rank_top = {}

    local is_inserted = false
    for _, rank_player in pairs(rank_top) do      
    
        local need_add = true
        if not is_inserted then  

            if rank_player.user_id ~= player.db.info.user_id then

                if rank_order == 0 or rank_order==1 then
                    rank_player.value = tonumber(rank_player.value) or 0
                    rank_player.subvalue = tonumber(rank_player.subvalue) or 0
                    if (value > rank_player.value) or (value == rank_player.value and subvalue > rank_player.subvalue) then
                        user_rank_info.pos = #new_rank_top+1
                        new_rank_top[#new_rank_top+1] = user_rank_info:Clone()
                        is_inserted = true
                    end         
                else
                    if (value < rank_player.value) or (value == rank_player.value and subvalue < rank_player.subvalue) then
                        user_rank_info.pos = #new_rank_top+1
                        new_rank_top[#new_rank_top+1] = user_rank_info:Clone()
                        is_inserted = true
                    end             
                end
            end
        elseif rank_player.user_id == player.db.info.user_id then
            need_add = false
        end

        if need_add then
            rank_player.pos = #new_rank_top+1
            if rank_player.pos >= 50 then
                break
            end
            new_rank_top[#new_rank_top+1] = rank_player
        end
    end
    player.db.rank.user_rank_top[rank_name] = new_rank_top

    -- 好友排行
    rank_top = self:GetRankTopWithFriend(rank_name)
    new_rank_top = {}

    for _, rank_player in pairs(rank_top) do        
        local need_add = true
        if not is_inserted then  

            if rank_player.user_id ~= player.db.info.user_id then

                if rank_order == 0 or rank_order==1 then
                    rank_player.value = tonumber(rank_player.value) or 0
                    rank_player.subvalue = tonumber(rank_player.subvalue) or 0
                    if (value > rank_player.value) or (value == rank_player.value and subvalue > rank_player.subvalue) then
                        user_rank_info.pos = #new_rank_top+1
                        new_rank_top[#new_rank_top+1] = user_rank_info:Clone()
                        is_inserted = true
                    end         
                else
                    if (value < rank_player.value) or (value == rank_player.value and subvalue < rank_player.subvalue) then
                        user_rank_info.pos = #new_rank_top+1
                        new_rank_top[#new_rank_top+1] = user_rank_info:Clone()
                        is_inserted = true
                    end             
                end
            end
        elseif rank_player.user_id == player.db.info.user_id then
            need_add = false
        end

        if need_add then
            rank_player.pos = #new_rank_top+1
            if rank_player.pos >= 50 then
                break
            end
            new_rank_top[#new_rank_top+1] = rank_player
        end
    end
    player.db.rank.user_rank_top_with_friend[rank_name] = new_rank_top
end

function CPlayerModuleRank:RandomPlayer(rank_name, min_value, min_sub_value)
    local rank_player = {}
    rank_player.user_name = assets.names:Get()

    if rank_name == "stage" then

        -- TODO: 
        min_value = min_value or 305

        local min_stage_id = math.floor(min_value/100)
        local min_child_stage_id = min_value%100

        local stage_id = math.random(1, min_stage_id)
        local child_stage_id = 1
        local child_stage_count = 0
        for i=1,stage_id do

            local stage_entry = game.CAssetStage.normal.stage[i]
            if not stage_entry then
                break
            end

            local max_child_stage_id = stage_entry.child_stage_count
            if i == stage_id and min_child_stage_id then
                child_stage_id = math.random(1, min_child_stage_id)
                max_child_stage_id = child_stage_id
            end
            child_stage_count = child_stage_count + max_child_stage_id
        end
        rank_player.value = stage_id*100+child_stage_id

        min_sub_value = min_sub_value or child_stage_count*3
        rank_player.subvalue = math.random(child_stage_count*2, min_sub_value)
    else
        min_value = min_value or 100000
        rank_player.value = math.random(5000, min_value)

        rank_player.subvalue = 0
    end
    return rank_player
end

function CPlayerModuleRank:CreatePlayer(user_id, user_name, value, subvalue)
    local rank_player = {}
    rank_player.user_id = user_id
    rank_player.user_name = user_name
    rank_player.value = value
    rank_player.subvalue = subvalue
    return rank_player
end

return CPlayerModuleRank
--endregion
