--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CPlayerModuleRecharge = class("game.CPlayerModuleRecharge")

local CPlayerModuleRecharge = game.CPlayerModuleRecharge

function CPlayerModuleRecharge:ctor()

    if player.db.is_first_recharged == nil then player.db.is_first_recharged = false end
    player.db.recharge.recharge_money_total = player.db.recharge.recharge_money_total or 0
    player.db.recharge.recharge_reward_times = player.db.recharge.recharge_reward_times or 0 
    player.db.recharge.gift_package_buyed = player.db.recharge.gift_package_buyed or {}
    player.db.recharge.recharged_list = player.db.recharge.recharged_list or {}
end

function CPlayerModuleRecharge:OnInit()
   
   player.player_modules.scheduler:AddDaily(function() 
        self:GiftPackageDailyClear()
   end)
end


-- # 充值相关操作
-- 获取额外奖励点券;
function CPlayerModuleRecharge:GetGiftPoint(recharge_id)
    local entry = assets.shop_point.config[recharge_id]
    
    if entry then
        if player.db.recharge.recharged_list[recharge_id] then
            return entry.normal_gift_point or 0
        else
            --首次充值
            return entry.first_gift_point or 0
        end
    else
        return 0
    end
end
-- 是否显示充值项, 针对一次性的充值项;
function CPlayerModuleRecharge:IsShowRecharge(recharge_id)

    local entity = assets.shop_point.config[recharge_id]    
    if entity then
        if player.db.recharge.recharged_list[recharge_id] then
            return not entity.recharge_once
        end
        return true
    else
        return false
    end
end

-- 是否充值过该项;
function CPlayerModuleRecharge:IsRecharged(recharge_id)

    return player.db.recharge.recharged_list[recharge_id]
end


-- 充值;
function CPlayerModuleRecharge:Recharge(recharge_id)
    self:_Recharge(recharge_id)
end

function CPlayerModuleRecharge:_Recharge(recharge_id)
    local entry = assets.shop_point.config[recharge_id]

    local point_count = 0
    if player.db.recharge.recharged_list[recharge_id] then
        local gift = entry.normal_gift_point or 0
        point_count = entry.point + gift
        sPlayer.player_modules.point:ChangePoint(entry.point + gift)
    else
        --首次充值
        local gift = entry.first_gift_point or 0
        player.db.recharge.recharged_list[recharge_id] = true
        point_count = entry.point + gift
        sPlayer.player_modules.point:ChangePoint(entry.point + gift)
        sThirdPlatformUtils:LogEvent("recharge_first", "{\"desc\":\""..sPlayer.player_modules.stage:GetCompletedStageID().."_"..recharge_id.."_"..entry.money.."\"}")
    end
    sThirdPlatformUtils:LogEvent("recharge", "{\"desc\":\""..sPlayer.player_modules.stage:GetCompletedStageID().."_"..recharge_id.."_"..entry.money.."\"}")

    --响应充值金额
    if self.recharge_money_event then
        self.recharge_money_event:Fire(entry.money)
    end
    player.db.recharge.recharge_money_total = player.db.recharge.recharge_money_total + entry.money

    print(">> player.db.recharge.is_first_recharged",player.db.recharge.is_first_recharged)
    print(">> player.db.recharge.recharge_money_total",player.db.recharge.recharge_money_total)

    --首次充值
    if not player.db.recharge.is_first_recharged then
        player.db.recharge.is_first_recharged = true
        sMessageDispatcher:Dispatch("first_recharge")
    end

    sMessageDispatcher:Dispatch("recharge_payed")
end

-- # 首充奖励相关操作
-- 是否首充
function CPlayerModuleRecharge:IsFirstRecharged()

    return player.db.recharge.is_first_recharged
end

-- 是否首充奖励领取;
function CPlayerModuleRecharge:IsFirstRechargeRewarded()

    return player.db.recharge.is_first_recharged_rewarded
end

-- 获得首充奖励;
function CPlayerModuleRecharge:FetchFirstRechargeReward()
    
    if player.db.recharge.is_first_recharged_rewarded then
        return
    end
    
    sPlayer.player_modules.reward:TakeRewardString(assets.const.first_rechage_box)

    player.db.recharge.is_first_recharged_rewarded = true

    local center_pos = dxm.VisibleRect:center()
    require("app.views.ui.reward_pop.reward_pop_ui"):Show(center_pos,assets.const.first_rechage_box,cc.p(0,-150))

    sMessageDispatcher:Dispatch("first_recharge_reward_fetched")
end

-- #充值进阶奖励
-- 是否有充值进阶奖励;
function CPlayerModuleRecharge:HasRechargeReward()
    local times = player.db.recharge.recharge_reward_times + 1
    local entry = assets.const.recharge_reward_config[times]
    if entry then
        return true
    end
    return false
end

-- 获取充值进阶奖励条件;
function CPlayerModuleRecharge:GetRechargeRewardCondition()
    local times = player.db.recharge.recharge_reward_times + 1
    local entry = assets.const.recharge_reward_config[times]
    if entry then 
        return entry.condition
    end
    return 0
end

-- 获取充值奖励的次数;
function CPlayerModuleRecharge:GetRechargeRewardTimes()
    return player.db.recharge.recharge_reward_times or 0
end

-- 获取已充值的总值;
function CPlayerModuleRecharge:GetRechargeMoneyTotal()
    return player.db.recharge.recharge_money_total or 0
end

-- 是否可以获得充值奖励;
function CPlayerModuleRecharge:CanFetchRechargeReward()
    local condition = self:GetRechargeRewardCondition()
    return player.db.recharge.recharge_money_total>=condition
end

-- 获取进阶充值奖励的奖品
function CPlayerModuleRecharge:GetRechargeRewardString()
    local times = player.db.recharge.recharge_reward_times + 1
    local entry = assets.const.recharge_reward_config[times]
    if not entry then 
        return ""
    end
    return entry.reward_box
end

-- 获取进阶型充值奖励;
function CPlayerModuleRecharge:FetchRechargeReward()
    
    if not self:IsRechargeRewardEnable() then
        return
    end

    local times = player.db.recharge.recharge_reward_times + 1
    local entry = assets.const.recharge_reward_config[times]
    if not entry then 
        return
    end
    sPlayer.player_modules.reward:TakeRewardString(entry.reward_box)
    player.db.recharge.recharge_reward_times = times
    
    sMessageDispatcher:Dispatch("recharge_reward_fetched")
end

-- #礼包
-- 礼包是否已经购买
function CPlayerModuleRecharge:IsGiftPackageBuyed(id)
    return player.db.recharge.gift_package_buyed[tostring(id)]
end

-- 购买礼包;
function CPlayerModuleRecharge:BuyGiftPackage(id, callback)

    if self:IsGiftPackageBuyed(id) then
        if callback then callback(false) end
        return
    end

    local entry = assets.shop_gift_package.config[id]
    if not entry then
        if callback then callback(false) end
        return
    end

    sCtrlRecharge:Pay(entry.price, entry.pay_id, "gift_package_"..id, function(is_successful)        
        if is_successful then
            sHttpUser:RequestSavePayinfo(entry.price, assets.version.branch)
            sPlayer.player_modules.reward:TakeRewardString(entry.reward)
            player.db.recharge.gift_package_buyed[tostring(id)] = true
            sMessageDispatcher:Dispatch("buy_gift_package", id)
        end
        if callback then callback(is_successful) end
    end)
end

function CPlayerModuleRecharge:GiftPackageDailyClear()

    for _, entry in pairs(assets.shop_gift_package.config) do
        if entry.is_daily_clear == "true" then
            player.db.recharge.gift_package_buyed[tostring(entry.id)] = false
            sMessageDispatcher:Dispatch("gift_package_daily_clear", entry.id)
        end
    end
end

return CPlayerModuleRecharge

--endregion
