--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CPlayerModuleShop = class("game.CPlayerModuleShop")

local CPlayerModuleShop = game.CPlayerModuleShop

function CPlayerModuleShop:ctor()

    player.db.shop.recharged_list = player.db.shop.recharged_list or {}
end

function CPlayerModuleShop:OnInit()
   
end

-- 购买物品;
function CPlayerModuleShop:CheckBuyItem(id)

    local entry = assets.shop_item.config[id]
    if not entry then
        return "no_entry"
    end

    if sPlayer.player_modules.numbers:Get("gamebill") < entry.price then
        return "no_money"
    end

    return nil
end

function CPlayerModuleShop:BuyItem(id, callback)

    local err = self:CheckBuyItem(id)
    if err then  
        if callback then 
            callback(false)
        end   
        return
    end

    local entry = assets.shop_item.config[id]
    sPlayer.player_modules.numbers:Chg("gamebill", -entry.price, true)

    -- 记录日志
    local reward_list = game.sRewardHelper:ParseFromString(entry.reward)
    if reward_list then
        for k,v in pairs (reward_list.list) do  
            if v.reward_type == "item" then
                sThirdPlatformUtils:LogEvent("item_purchase", "{\"item\":\""..v.reward_type.."_"..v.id.."\", \"item_count\":"..v.count..", \"price\":"..entry.price.."}")
            else
                sThirdPlatformUtils:LogEvent("item_purchase", "{\"item\":\""..v.reward_type.."\", \"item_count\":"..v.count..", \"price\":"..entry.price.."}")
            end
        end    
    end

    -- 购买物品
    sPlayer.player_modules.reward:TakeRewardString(entry.reward)

    -- 执行回调函数
    if callback then
        callback(true)
    end
end

function CPlayerModuleShop:GetGiftGamebill(buy_id)
    local entry = assets.shop_gamebill.config[buy_id]
    
    if entry then
        if player.db.shop.recharged_list[recharge_id] then
            return entry.normal_gift_gamebill or 0
        else
            --首次充值
            return entry.first_gift_gamebill or 0
        end
    else
        return 0
    end
end

function CPlayerModuleShop:IsGamebillBuyed(buy_id)

    return player.db.shop.gamebill_buyed_list[buy_id]
end

-- 购买金币
function CPlayerModuleShop:CheckBuyGamebill(id)

    local entry = assets.shop_gamebill.config[id]
    if not entry then
        return "no_entry"
    end

    if sPlayer.player_modules.point:GetPoint() < entry.price then
        return "no_money"
    end

    return nil
end

function CPlayerModuleShop:BuyGamebill(id, callback)

    local err = self:CheckBuyGamebill(id)
    if err then  
        if callback then 
            callback(false)
        end   
        return
    end

    local entry = assets.shop_gamebill.config[id]
    sPlayer.player_modules.point:SubPoint(entry.price, function(is_successful)
        if is_successful then
            local entry = assets.shop_gamebill.config[id]
            local gamebill_count = 0
            if player.db.shop.gamebill_buyed_list[recharge_id] then
                local gift = entry.normal_gift_gamebill or 0
                gamebill_count = entry.gamebill + gift
                sPlayer.player_modules.numbers:Chg(enum.NumberType.kTypeGamebill, entry.gamebill + gift)
            else
                local gift = entry.first_gift_gamebill or 0
                player.db.shop.gamebill_buyed_list[recharge_id] = true
                gamebill_count = entry.gamebill + gift
                sPlayer.player_modules.numbers:Chg(enum.NumberType.kTypeGamebill, entry.gamebill + gift)
            end
        end

        callback(is_successful)
    end)
end


function CPlayerModuleShop:CheckBuyActionPoint(id)

    local entry = assets.shop_action_point.config[id]
    if not entry then
        return "no_entry"
    end

    if sPlayer.player_modules.point:GetPoint() < entry.price then
        return "no_money"
    end

    return nil
end

function CPlayerModuleShop:BuyActionPoint(id, callback)

    local err = self:CheckBuyActionPoint(id)
    if err then  
        if callback then 
            callback(false)
        end   
        return
    end

    local entry = assets.shop_action_point.config[id]
    sPlayer.player_modules.point:SubPoint(entry.price, function(is_successful)
        if is_successful then
            local entry = assets.shop_action_point.config[id]
            player.player_modules.action_point:Change(entry.action_point, true)
        end
        if callback then callback(is_successful) end
    end)
end

return CPlayerModuleShop

--endregion
