--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CPlayerModuleSkins = class("game.CPlayerModuleSkins")
local CPlayerModuleSkins = game.CPlayerModuleSkins

function CPlayerModuleSkins:ctor()

    player.db.skins.skin_list = player.db.skins.skin_list or {}
    player.db.skins.active_skin_id = player.db.skins.active_skin_id or 1

    self.skin_count_event = dxm.CEvent.new()
    self.skin_upgrade_event = dxm.CEvent.new()
end

function CPlayerModuleSkins:OnInit()

    local has_skin = false
    for _,_ in pairs(player.db.skins.skin_list) do
        has_skin = true
        break
    end

    -- 初始化所有坐骑;
    for key, skin in pairs(player.db.skins.skin_list) do
        local entry = assets.skins:GetEntry(skin.id)
        if not entry then
            player.db.skins.skin_list[key] = nil
        end
    end

    for key, entry in pairs(assets.skins.config) do
        local skin = player.db.skins.skin_list[tostring(key)]
        if not skin then 
            skin = {}            
            skin.level = entry.InitLevel   
            if entry.ID == assets.skins.init_select_skin then
                if player.db.skins.active_skin_id==0 then
                    player.db.skins.active_skin_id = skin.id
                end
                skin.buyed = true
            else
                skin.buyed = (entry.InitState  == 'true')
            end
        else        
            if not skin.buyed then
                skin.buyed = (entry.InitState  == 'true')
            end
        end   

        skin.id = entry.ID
        skin.skill_list = {}
        for _, skill_id in pairs(entry.SkillList) do
            skin.skill_list[tostring(skill_id)] = skill_id
        end
        player.db.skins.skin_list[tostring(key)] = skin
    end

    self:_ResetActiveSkin()

    self.skin_count_event:Fire()

    -- 首次启动该系统时提交
    sHttpUser:RequestCommitUserInfo("skins", self:MakeCommitUserInfoData(), function() end)
end

-- 坐骑状态判定
function CPlayerModuleSkins:IsBuyed(skin_id)
    
    local skin = player.db.skins.skin_list[tostring(skin_id)]
    if skin then
        return skin.buyed
    end 
    return false
end

function CPlayerModuleSkins:IsUnlock(skin_id)
    
    local skin = player.db.skins.skin_list[tostring(skin_id)]
    if skin then
        local entry = assets.skins:GetEntry(skin_id)
        if entry then
            if entry.LockConditionType == "stage" then
                return player.player_modules.stage:GetCompletedStageID()>=entry.LockConditionValue
            end
            if entry.LockConditionType == "level" then
                return player.player_modules.level:GetLevel()>=entry.LockConditionValue
            end
            return true
        end
    end 
    return false
end

-- 坐骑激活
function CPlayerModuleSkins:_ResetActiveSkin()

    -- 初始化技能;
    local skin = player.db.skins.skin_list[tostring(player.db.skins.active_skin_id)]
    if skin then
        local effect_lasting = game.CEffectLasting:new()
        local level = level or skin.level
        for _, skill_id in pairs(skin.skill_list) do
            local entry = assets.skills:GetEntry(skill_id)
            if entry then
                effect_lasting:Chg(entry.Type, assets.skills:GetValue(skill_id, level))
            end
        end   
        sPlayer.player_modules.attributes:AddEffectLasting("skin", effect_lasting)    
    end
end

function CPlayerModuleSkins:SetActiveSkin(skin_id)

    if self:IsBuyed(skin_id) and self:IsUnlock(skin_id) then
        player.db.skins.active_skin_id = skin_id
        sMessageDispatcher:Dispatch("active_skin_changed", skin_id)
        sPlayer.player_modules.info:SetHeadIcon(skin_id)
    end
    self:_ResetActiveSkin()
end

function CPlayerModuleSkins:GetActiveSkin()

    return player.db.skins.skin_list[tostring(player.db.skins.active_skin_id)]
end

function CPlayerModuleSkins:GetSkin(skin_id)

    skin_id = skin_id or player.db.skins.active_skin_id
    return player.db.skins.skin_list[tostring(skin_id)]
end

function CPlayerModuleSkins:IsActiveSkin(id)

    return player.db.skins.active_skin_id == id
end


function CPlayerModuleSkins:GetActiveSkinSpine()
    local skin = player.db.skins.skin_list[tostring(player.db.skins.active_skin_id)]
    if skin then
        local entry = assets.skins:GetEntry(player.db.skins.active_skin_id)
        return entry.Spine
    end
    return ""
end

function CPlayerModuleSkins:GetActiveSkinSkillValue(skill_id)

    return self:GetSkinSkillValue(player.db.skins.active_skin_id, skill_id)
end

function CPlayerModuleSkins:GetSkinSkillValue(skin_id, skill_id, level)

    local skin = player.db.skins.skin_list[tostring(skin_id)]
    local level = level or skin.level
    if skin then
        return assets.skills:GetValue(skill_id, level)
    end
    return 0
end

-- 坐骑购买
function CPlayerModuleSkins:Buy(skin_id)

    local skin = player.db.skins.skin_list[tostring(skin_id)]
    if skin then
        if self:IsBuyed(skin_id) then
            return "skin_buyed"
        end

        if not self:IsUnlock(skin_id) then
            return "skin_lock"
        end

        local entry = assets.skins:GetEntry(skin_id)
        if entry.BuyValue > 0 then                
            if entry.BuyType == "gamebill" then
                local gamebill = entry.BuyValue
                if gamebill > player.player_modules.numbers:Get("gamebill") then
                    return "not_enough_gamebill"
                end           
                player.player_modules.numbers:Chg("gamebill", -gamebill, true)   
            elseif entry.BuyType == "point" then
                if entry.BuyValue > player.player_modules.point:GetPoint()  then
                    return "not_enough_point"         
                end            
                player.player_modules.point:SubPoint(entry.BuyValue)    
                sThirdPlatformUtils:LogEvent("item_purchase", '{"item":"skin_'..skin_id..'", "item_count":1, "price":'..entry.BuyValue.."}")    
            end
        end
        skin.buyed = true

        self.skin_count_event:Fire()
        sMessageDispatcher:Dispatch("buy_skin_ok", skin_id)

        -- 提交坐骑信息
        sHttpUser:RequestCommitUserInfo("skins", self:MakeCommitUserInfoData(), function() end)
    end
    return nil
end

-- 奖励
function CPlayerModuleSkins:Reward(skin_id)

    local skin = player.db.skins.skin_list[tostring(skin_id)]
    if skin then
        local entry = assets.skins:GetEntry(skin_id)
        if self:IsBuyed(skin_id) then
            if entry.BuyType == "gamebill" then
                player.player_modules.numbers:Chg("gamebill", math.ceil(entry.BuyValue/2), true)   
            elseif entry.BuyType == "point" then
                player.player_modules.point:ChangePoint( math.ceil(entry.BuyValue/2) ) 
            end            
            return "skin_buyed"
        end

        if not self:IsUnlock(skin_id) then
            return "skin_lock"
        end
        skin.buyed = true

        self.skin_count_event:Fire()
        sMessageDispatcher:Dispatch("buy_skin_ok", skin_id)

        -- 提交坐骑信息
        sHttpUser:RequestCommitUserInfo("skins", self:MakeCommitUserInfoData(), function() end)
    end
    return nil
end

-- 获取提交数据
function CPlayerModuleSkins:MakeCommitUserInfoData()

    local data = {}
    for skin_id,skin in pairs(player.db.skins.skin_list) do
        data[skin_id] = {id=tonumber(skin_id),level=skin.level}
    end
    return json.encode(data)
end

-- 坐骑升级
function CPlayerModuleSkins:IsFullLevel(skin_id)
    local skin = player.db.skins.skin_list[tostring(skin_id)]
    if skin then
        local entry = assets.skins:GetEntry(skin_id)
        if skin.level < entry.MaxLevel then
            return false
        end
    end
    return true
end

function CPlayerModuleSkins:GetLevelUpGamebill(skin_id)

    local skin = player.db.skins.skin_list[tostring(skin_id)]
    if skin then
        return assets.skins:GetLevelGamebill(skin.level)
    end
    return 0
end

function CPlayerModuleSkins:Upgrade(skin_id)

    local skin = player.db.skins.skin_list[tostring(skin_id)]
    if skin then
        local entry = assets.skins:GetEntry(skin_id)
        if skin.level >= entry.MaxLevel then            
            return "full_level"
        end
        local gamebill = assets.skins:GetLevelGamebill(skin.level)
        if gamebill > player.player_modules.numbers:Get("gamebill") then
            return "not_enough_gamebill"
        end
              
        player.player_modules.numbers:Chg("gamebill", -gamebill, true)
        skin.level = skin.level + 1

        sMessageDispatcher:Dispatch("upgrade_skin_ok", skin_id)
        self.skin_upgrade_event:Fire(skin_id, skin.level, 1)
        self.skin_count_event:Fire()

        -- 提交坐骑信息
        sHttpUser:RequestCommitUserInfo("skins", self:MakeCommitUserInfoData(), function() end)

        self:_ResetActiveSkin()
    end

    return nil
end

function CPlayerModuleSkins:OneKeyUpgrade(skin_id, callback)

    local skin = player.db.skins.skin_list[tostring(skin_id)]
    if skin then
        local entry = assets.skins:GetEntry(skin_id)
        if skin.level >= entry.MaxLevel then            
            return "full_level"
        end
        sCtrlRecharge:Pay(entry.OneKeyUpgradePayMoney, entry.OneKeyUpgradePayID, "one_key_upgrade_skins_"..skin_id, function(is_successful)        
            if is_successful then
                sHttpUser:RequestSavePayinfo(entry.OneKeyUpgradePayMoney, assets.version.branch)
              
                skin.level = entry.MaxLevel

                self.skin_upgrade_event:Fire(skin_id, skin.level, 1)
                self.skin_count_event:Fire()

                sMessageDispatcher:Dispatch("upgrade_skin_ok", skin_id)

                -- 提交坐骑信息
                sHttpUser:RequestCommitUserInfo("skins", self:MakeCommitUserInfoData(), function() end)

                self:_ResetActiveSkin()
            end
            if callback then callback(is_successful) end
        end)
    end

    return nil
end

function CPlayerModuleSkins:GetCount(min_level)

    min_level = min_level or 0
    local count = 0
    for _, skin in pairs(player.db.skins.skin_list) do
        if skin.buyed and skin.level >= min_level then
            count = count + 1
        end
    end
    return count
end


return CPlayerModuleSkins
--endregion
