--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CPlayerModuleStage = class("game.CPlayerModuleStage")
local CPlayerModuleStage = game.CPlayerModuleStage

function CPlayerModuleStage:ctor()

    -- 关卡信息;
    player.db.stage.stages = player.db.stage.stages or {}
    player.db.stage.completed_stage_id = player.db.stage.completed_stage_id or 0
    player.db.stage.free_resurrection_times = player.db.stage.free_resurrection_times or assets.stages.free_resurrection_times or 0
    player.db.stage.top_stage_info = player.db.stage.top_stage_info or {}

    -- 关卡完成回调;
    self.stage_clear_event = dxm.CEvent.new()

    self.failed_times = 0
end

function CPlayerModuleStage:OnInit()
    sPlayer.player_modules.scheduler:AddDaily(function()
        player.db.stage.free_resurrection_times = assets.stages.free_resurrection_times
    end)
end

function CPlayerModuleStage:GetFreeResurrenctionTimes()
    return player.db.stage.free_resurrection_times
end

function CPlayerModuleStage:UseFreeResurrenctionTimes()
    if player.db.stage.free_resurrection_times <=0 then
        return 
    end
    player.db.stage.free_resurrection_times = player.db.stage.free_resurrection_times - 1
end

local function InitStageData(stage_type, stage_id, child_stage_id)

    local stage_name = stage_type .."-"..stage_id.."-"..child_stage_id
    player.db.stage.stages[stage_name] = player.db.stage.stages[stage_name] or {}
    player.db.stage.stages[stage_name].best_star = player.db.stage.stages[stage_name].best_star or 0
    player.db.stage.stages[stage_name].best_score = player.db.stage.stages[stage_name].best_score or 0
    player.db.stage.stages[stage_name].win_best_score = player.db.stage.stages[stage_name].win_best_score or 0
    player.db.stage.stages[stage_name].star_info =  player.db.stage.stages[stage_name].star_info or {}
    player.db.stage.stages[stage_name].best_meter = player.db.stage.stages[stage_name].best_meter or 0
end

function CPlayerModuleStage:StageStart(stage_type, stage_id, child_stage_id)

    print("debug: stage start")

    sThirdPlatformUtils:LogEvent("mission_begin", "{\"mission\":\""..stage_type.."_"..stage_id.."_"..child_stage_id.."\"}")
end

function CPlayerModuleStage:StageLose(stage_type, stage_id, child_stage_id, record, reason)

    print("debug: stage lose")

    reason = reason or ""

    sThirdPlatformUtils:LogEvent("mission_failed", "{\"mission\":\""..stage_type.."_"..stage_id.."_"..child_stage_id.."\",\"reason\":\""..reason.."\"}")

    -- 初始化关卡数据
    local stage_info = self:GetStageInfo(stage_type, stage_id, child_stage_id)

    record.old_best_score = stage_info.best_score
    record.old_best_meter = stage_info.best_meter
    record.old_best_star = stage_info.best_star
    record.old_win_best_score = stage_info.win_best_score

    if record.score >  stage_info.best_score then
        stage_info.best_score = record.score
    end

    if not stage_info.best_meter or record.meter >  stage_info.best_meter then
        stage_info.best_meter = record.meter
    end

    -- 对record进行二次处理
    record.star = 0
    record.best_score = stage_info.best_score
    record.best_meter = stage_info.best_meter
    record.best_star = stage_info.best_star
    record.win_best_score = stage_info.win_best_score

    -- 触发回调
    if self.stage_clear_event then
        self.stage_clear_event:Fire(stage_type, stage_id, child_stage_id, false, record)
    end

    -- 是否为无尽模式
    if stage_type == "infinite" then

        -- 添加奖励
        local gold = (record.meter / 24) + (record.score / 240)
        if gold > 0 then

            -- 计算奖励并领取
            local reward_list = game.CRewardList.new()
            reward_list:Add(game.RewardType.kTypeGamebill, math.floor(gold))
            sPlayer.player_modules.reward:TakeRewardList(reward_list)

            -- 记录奖励
            record.reward = reward_list:SerializeToString()
        end

        -- 提交个人成绩
        sHttpUser:RequestCommitUserInfo("infinite_best_score", record.best_score, function() end)
        game.CCtrlRank:CommitInfiniteRank(record.best_score)
    end
end

function CPlayerModuleStage:StageWin(stage_type, stage_id, child_stage_id, record)

    print("debug: stage win", stage_type, stage_id, child_stage_id)

    sThirdPlatformUtils:LogEvent("mission_completed", "{\"mission\":\""..stage_type.."_"..stage_id.."_"..child_stage_id.."\"}")

    -- 奖励配置
    local reward_list = game.CRewardList.new()

    -- 通关可以额外获取奖励
    local child_stage_entry = self:GetChildStageEntry(stage_type, stage_id, child_stage_id)
    if child_stage_entry and child_stage_entry.reward then
        reward_list:Add(child_stage_entry.reward)
    end

    -- 最高关卡信息
    local top_stage_info = self:GetTopStageInfo(stage_type)
    if top_stage_info and top_stage_info.top_stage_id == stage_id and top_stage_info.top_child_stage_id == child_stage_id then
        
        -- 进度刷新
        local stage_entry = self:GetStageEntry(stage_type, stage_id)
        if stage_entry ~= nil then
            if top_stage_info.top_child_stage_id >= stage_entry.child_stage_count then
                top_stage_info.top_stage_id = top_stage_info.top_stage_id + 1
                top_stage_info.top_child_stage_id = 1
            else
                top_stage_info.top_child_stage_id = top_stage_info.top_child_stage_id + 1
            end
        end

        -- 奖励翻倍
        reward_list:Double()
    end

    -- 获取关卡信息
    local stage_info = self:GetStageInfo(stage_type, stage_id, child_stage_id)
    record.old_best_score = stage_info.best_score
    record.old_best_meter = stage_info.best_meter
    record.old_best_star = stage_info.best_star
    record.old_win_best_score = stage_info.win_best_score
    if record.score > stage_info.best_score then
        stage_info.best_score = record.score
    end

    if not stage_info.best_meter or record.meter > stage_info.best_meter then
        stage_info.best_meter = record.meter
    end

    if record.score > stage_info.win_best_score then
        stage_info.win_best_score = record.score
    end
    
    -- 计算星数
    local star_info = self:CompletedStageStar(stage_type, stage_id, child_stage_id, record)
    stage_info.star_info = star_info

    local star = 0
    for i = 1 , #star_info do
        if star_info[i] then
            star = star + 1
        end
    end

    if star >  stage_info.best_star then
        if star == 1 then
            sPlayer.player_modules.action_point:Change(1, true)
        elseif star == 2 then
            sPlayer.player_modules.action_point:Change(3, true)
        elseif star == 3 then
            sPlayer.player_modules.action_point:Change(5, true)
        end
        stage_info.best_star = star
    end

    -- 提交个人信息
    sHttpUser:RequestCommitUserInfo("completed_stage_id", top_stage_info.top_stage_id*100+top_stage_info.top_child_stage_id, function() end)
    sHttpUser:RequestCommitUserInfo("star_count", self:GetAllStageStar(), function() end)

    -- 提交排行榜
    game.CCtrlRank:CommitStageRank()

    -- 如果是关卡模式，尝试获取宝箱奖励
    if stage_type == "normal" then

        local item_box_id = self:RandomItemBoxes()
        if item_box_id then
            reward_list:Add(game.RewardType.kTypeItemBox, item_box_id, 1)
        end
    end

    -- 领取奖励
    sPlayer.player_modules.reward:TakeRewardList(reward_list)

    -- 对record进行二次处理
    record.star = star
    record.best_score = stage_info.best_score
    record.best_meter = stage_info.best_meter
    record.best_star = stage_info.best_star
    record.win_best_score = stage_info.win_best_score
    record.reward = reward_list:SerializeToString()

    -- 触发回调
    if self.stage_clear_event then
        self.stage_clear_event:Fire(stage_type, stage_id, child_stage_id, true, record)
    end
end

function CPlayerModuleStage:GetStageInfo(stage_type, stage_id, child_stage_id)
    local stage_name = stage_type .."-"..stage_id.."-"..child_stage_id
    if not player.db.stage.stages[stage_name] then
        InitStageData(stage_type, stage_id, child_stage_id)
    end
    return player.db.stage.stages[stage_name]
end

function CPlayerModuleStage:GetCompletedStageID()
    return player.db.stage.completed_stage_id
end

function CPlayerModuleStage:SetInfiniteBestScore(score)
    if score > player.db.infinite_best_score then
        player.db.infinite_best_score = score
        sHttpUser:RequestCommitUserInfo("infinite_best_score", score, function() end)
    end
end

function CPlayerModuleStage:GetStageBestScore(stage_type, stage_id, child_stage_id)
    local stage_name = stage_type .."-"..stage_id.."-"..child_stage_id
    if not stage_name then return 0 end
    if not player.db.stage.stages[stage_name] then return 0 end
    if not player.db.stage.stages[stage_name].best_score then return 0 end
    return player.db.stage.stages[stage_name].best_score
end

function CPlayerModuleStage:GetStageBestStar(stage_type, stage_id, child_stage_id)
    local stage_name = stage_type .."-"..stage_id.."-"..child_stage_id
    if not stage_name then return 0 end
    if not player.db.stage.stages[stage_name] then return 0 end
    if not player.db.stage.stages[stage_name].best_star then return 0 end
    return player.db.stage.stages[stage_name].best_star
end

-- 获取大关卡星数;
function CPlayerModuleStage:GetStageLevelStarTotal(stage_level)  
     
    if not stage_level then return 0 end

    local star_total = 0
    local stage_entry = game.CAssetStage.normal.stage[stage_level]
    if stage_entry then
        
        for i=1,stage_entry.child_stage_count do
            star_total = star_total + self:GetStageBestStar("normal", stage_level, i)
        end
    end
    return star_total
end

function CPlayerModuleStage:GetAllStageStar()

    local count = 0
    local top_stage_info = self:GetTopStageInfo("normal")
    if top_stage_info then
        
        for i=1,top_stage_info.top_stage_id do
            
            local stage_entry = game.CAssetStage.normal.stage[i]
            if stage_entry then

                local child_stage_count = stage_entry.child_stage_count
                if i == top_stage_info.top_stage_id then
                    child_stage_count = top_stage_info.top_child_stage_id
                end

                for j=1,child_stage_count do
                    count = count + self:GetStageBestStar("normal", i, j)
                end
            end
        end
    end
    return count
end

function CPlayerModuleStage:CompletedStageStar(stage_type, stage_id, child_stage_id, record)
    stage_id = tonumber(stage_id)
    local star_list = {}
    local entry = self:GetChildStageEntry(stage_type, stage_id, child_stage_id)
    if entry.star_condition then
        for index,condition in pairs(entry.star_condition) do
            local is_completed = false
            if condition.type == game.CAssetGameCondition.win then
                is_completed = true
            elseif condition.type == game.CAssetGameCondition.item_collect then
                is_completed = self:CompleteItemCollect(condition,record.item_collect)
            elseif condition.type == game.CAssetGameCondition.score then
                is_completed = condition.value <= record.score
            elseif condition.type == game.CAssetGameCondition.time then
                is_completed = condition.value >= record.time
            end
            star_list[index] = is_completed
        end
    end

    return star_list
end

function CPlayerModuleStage:CompleteItemCollect(condition, item_collect)
    local collect_count = 0
    if item_collect and item_collect[condition.param] then
        collect_count = item_collect[condition.param]
    end
    if collect_count >= condition.value then
        return true
    end
    return false
end

function CPlayerModuleStage:GetStageTypeEntry(stage_type)
    return game.CAssetStage[stage_type]
end

function CPlayerModuleStage:GetStageEntry(stage_type, stage_id)
    local stage_type_entry = self:GetStageTypeEntry(stage_type)
    if stage_type_entry == nil or stage_id > stage_type_entry.stage_count then
        return nil
    end
    return stage_type_entry.stage[stage_id]
end

function CPlayerModuleStage:GetChildStageCount(stage_type, stage_id, child_stage_id)

    local child_stage_count = 0
    local stage_type_entry = self:GetStageTypeEntry(stage_type)
    if stage_type_entry == nil then
        return child_stage_count
    end
    for i=1,stage_id-1 do
        local stage_entry = stage_type_entry.stage[i]
        if stage_entry then
            child_stage_count = child_stage_count + stage_entry.child_stage_count
        end
    end
    child_stage_count = child_stage_count + child_stage_id
    return child_stage_count
end

function CPlayerModuleStage:GetChildStageEntry(stage_type, stage_id, child_stage_id)
    local stage_entry = self:GetStageEntry(stage_type, stage_id)
    if stage_entry == nil or child_stage_id > stage_entry.child_stage_count then
        return nil
    end
    local child_stage_entry = require("app.assets.stage.asset_stage_" .. stage_type .. "_" .. stage_id .. "_" .. child_stage_id)
    if child_stage_entry ~= nil then
        -- TODO: 
    end
    return child_stage_entry
end

function CPlayerModuleStage:GetTopStageInfo(stage_type)
    player.db.stage.top_stage_info[stage_type] = player.db.stage.top_stage_info[stage_type] or {}
    player.db.stage.top_stage_info[stage_type].top_stage_id = player.db.stage.top_stage_info[stage_type].top_stage_id or 1
    player.db.stage.top_stage_info[stage_type].top_child_stage_id = player.db.stage.top_stage_info[stage_type].top_child_stage_id or 1
    return player.db.stage.top_stage_info[stage_type]
end

function CPlayerModuleStage:RandomItemBoxes()

    -- 判断当前箱子是否满
    if player.player_modules.item_box:IsFull() then
        return nil
    end

    -- 随机箱子
    local random_pass_number = 0
    local random_number = math.random(0, game.CAssetGame.stage_drop_item_boxes.total_random_weight)
    for i=1,#game.CAssetGame.stage_drop_item_boxes do
        local entry = game.CAssetGame.stage_drop_item_boxes[i]
        if random_number <= random_pass_number + entry.random_weight then
            return entry.item_boxes_id
        end
        random_pass_number = random_pass_number + entry.random_weight
    end
    return nil
end

return CPlayerModuleStage
--endregion
