--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CPlayerModuleStageLevel = class("game.CPlayerModuleStageLevel")
local CPlayerModuleStageLevel = game.CPlayerModuleStageLevel

function CPlayerModuleStageLevel:ctor()

    -- 关卡信息;
    player.db.stage_level.unlock_map = player.db.stage_level.unlock_map or {}
    player.db.stage_level.unlock_map[tostring(1)] = true
end

function CPlayerModuleStageLevel:OnInit()
  
end

function CPlayerModuleStageLevel:GetEntryByStageID(stage_id)

    if not stage_id then return nil end

    local stage_level_entry = assets.stage_level:GetEntryByStageID(stage_id)
    if not stage_level_entry then return nil end

    return stage_level_entry
end

-- 获取解锁状态;
function CPlayerModuleStageLevel:IsLock(stage_level_id)

    if not stage_level_id or stage_level_id<=1 then return false end

    if not player.db.stage_level.unlock_map[tostring(stage_level_id)] then         
        return true
    end
    return not player.db.stage_level.unlock_map[tostring(stage_level_id)]
end

function CPlayerModuleStageLevel:IsLockByStageID(stage_id)

    local stage_level_entry = self:GetEntryByStageID(stage_id)
    if not stage_level_entry then return false end
    return self:IsLock(stage_level_entry.id)
end

function CPlayerModuleStageLevel:IsLockByMinStageID(stage_id)

    local stage_level_entry = self:GetEntryByStageID(stage_id)
    if not stage_level_entry then return false end
    if stage_level_entry.min~=stage_id then return false end
    return self:IsLock(stage_level_entry.id)
end

function CPlayerModuleStageLevel:GetNewStageID()

    local new_stage_id = sPlayer.player_modules.stage:GetCompletedStageID()+1
    if self:IsLockByStageID(new_stage_id) then
        local stage_level_entry = assets.stage_level:GetEntryByStageID(new_stage_id)
        if stage_level_entry then
            stage_level_entry = assets.stage_level:GetEntry(stage_level_entry.id-1)
            if stage_level_entry then
                new_stage_id = stage_level_entry.max
            else
                new_stage_id = new_stage_id - 1
            end
        else
            new_stage_id = new_stage_id - 1
        end        
    end
    return new_stage_id
end

-- 获取解锁星数;
function CPlayerModuleStageLevel:GetUnlockStar(stage_level_id)

    if not stage_level_id then return 0 end

    local entry = assets.stage_level:GetEntry(stage_level_id)
    if not entry then return 0 end
    return entry.star_unlock_condition
end

-- 获取解锁需要点赞数;
function CPlayerModuleStageLevel:GetUnlockRate(stage_level_id)

    return 5
end

-- 获取解锁钻石;
function CPlayerModuleStageLevel:GetUnlockPoint(stage_level_id)

    if not stage_level_id then return 0 end

    local entry = assets.stage_level:GetEntry(stage_level_id)
    if not entry then return 0 end
    return entry.star_unlock_point
end

-- 获取解锁金钱, 运营商直扣方式做准备, 策划暂时还没有这个需求;
function CPlayerModuleStageLevel:GetUnlockMoney(stage_level_id)

    if not stage_level_id then return 0 end

    local entry = assets.stage_level:GetEntry(stage_level_id)
    if not entry then return 0 end
    return entry.star_unlock_money
end

-- 获取大关卡星数;
function CPlayerModuleStageLevel:GetStageLevelStarTotal(stage_level)  
     
    return sPlayer.player_modules.stage:GetStageLevelStarTotal(stage_level)
end

-- 解锁星数是否满足;
function CPlayerModuleStageLevel:IsUnlockStarEnough(stage_level_id)

    local stage_level_star = self:GetStageLevelStarTotal(stage_level_id-1)
    local stage_level_unlock_star = self:GetUnlockStar(stage_level_id)
    return stage_level_star >= stage_level_unlock_star
end

-- 解锁操作;
function CPlayerModuleStageLevel:Unlock(stage_level_id, unlock_type)

    if not self:IsLock(stage_level_id) then 
        return "is_unlock"
    end

    unlock_type = unlock_type or "star"
    if unlock_type == "star" then
        if not self:IsUnlockStarEnough(stage_level_id) then
            return "not_enough_star"
        end
    elseif unlock_type == "point" then
        local need_point = self:GetUnlockPoint(stage_level_id)
        local total_point = sPlayer.player_modules.point:GetPoint()
        if need_point > total_point then
            return "not_enough_point"
        end
        sPlayer.player_modules.point:SubPoint(need_point)
    elseif unlock_type == "friend" then
        if sPlayer.player_modules.friend:GetUnlockTimes(stage_level_id) < assets.const.unlock_stage_times then
            return "not_enough_friend_confirm_times"
        end
        sPlayer.player_modules.friend:ClearUnlockSourceUser(assets.stage_level:GetMinStageID(stage_level_id))
    end

    player.db.stage_level.unlock_map[tostring(stage_level_id)] = true
    sMessageDispatcher:Dispatch("stage_Level_unlock", stage_level_id)
    return "no_error"
end

-- 是否已经到达解锁大关卡
function CPlayerModuleStageLevel:IsReachUnlockStageLevel(stage_level_id)

    local new_stage_id = sPlayer.player_modules.stage:GetCompletedStageID()+1
    local stage_level_entry = assets.stage_level:GetEntry(stage_level_id)
    if not stage_level_entry then return false end
    return new_stage_id>=stage_level_entry.min
end

return CPlayerModuleStageLevel
--endregion
