--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CPlayerModuleStageReward = class("game.CPlayerModuleStageReward")
local CPlayerModuleStageReward = game.CPlayerModuleStageReward

function CPlayerModuleStageReward:ctor()
    
    player.db.stage_reward = player.db.stage_reward or {}
    player.db.stage_reward.fetched_map = player.db.stage_reward.fetched_map or {}
end

function CPlayerModuleStageReward:OnInit()
  
end

-- 是否拥有奖励;
function CPlayerModuleStageReward:HasReward(stage_id) 

    -- 无标识
    if not stage_id then 
        return "stage_id_is_nil"
    end

    -- 无配置
    local entry = assets.stages:GetEntry(stage_id)
    if not entry then 
        return "no_stage" 
    end   

    -- 没有奖励
    if not entry.reward_box then 
        return "no_reward" 
    end

    -- 已经领取
    if player.db.stage_reward.fetched_map[tostring(stage_id)]==true then
        return "reward_fetched"
    end

    return "no_error"
end 

-- 是否可以领取奖励;
function CPlayerModuleStageReward:CanFetchReward(stage_id)     
  
    if not stage_id then 
        return "stage_id_is_nil" 
    end

    if sPlayer.player_modules.stage_level:IsLockByStageID(stage_id) then
        return "lock_stage"
    end

    local error_string = self:HasReward(stage_id)
    if error_string ~= "no_error" then
        return error_string
    end

    if stage_id > sPlayer.player_modules.stage:GetCompletedStageID()+1 then
        return "not_enough_stage"
    end

    return "no_error"
end

-- 获取奖励字串;
function CPlayerModuleStageReward:GetRewardString(stage_id) 
    if not stage_id then return nil end
    local entry = assets.stages:GetEntry(stage_id)
    if not entry then return nil end
    if not entry.reward_box then return nil end
    return entry.reward_box
end

-- 获取关卡奖励;
function CPlayerModuleStageReward:FetchReward(stage_id)     

    local error_string = self:CanFetchReward(stage_id)
    if error_string ~= "no_error" then
        return error_string
    end

    local reward_string = self:GetRewardString(stage_id)
    sPlayer.player_modules.reward:TakeRewardString(reward_string)
    player.db.stage_reward.fetched_map[tostring(stage_id)] = true
    

    sMessageDispatcher:Dispatch("stage_reward_fetch_reward", stage_id)
    return "no_error"
end



return CPlayerModuleStageReward
--endregion
