--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CPlayerModuleStageStarReward = class("game.CPlayerModuleStageStarReward")
local CPlayerModuleStageStarReward = game.CPlayerModuleStageStarReward

function CPlayerModuleStageStarReward:ctor()
    
    player.db.stage_star_reward.map = player.db.stage_star_reward.map or {}
end

function CPlayerModuleStageStarReward:OnInit()
  
end

-- 获取大关卡星数;
function CPlayerModuleStageStarReward:GetStageLevelStarCount(stage_level)  
     
    return sPlayer.player_modules.stage:GetStageLevelStarTotal(stage_level)
end

function CPlayerModuleStageStarReward:GetStageLevelStarTotal(stage_level)  
     
    local entry = assets.stage_level:GetEntry(stage_level)
    if not entry then return 0 end
    return (entry.max-entry.min+1)*3
end

-- 是否已经领取;
function CPlayerModuleStageStarReward:IsFetched(stage_level, step)   
    
    if not stage_level then return 0 end

    player.db.stage_star_reward.map[tostring(stage_level)] = player.db.stage_star_reward.map[tostring(stage_level)] or {}
    return player.db.stage_star_reward.map[tostring(stage_level)][tostring(step)]==true
end

-- 是否可以领取;
function CPlayerModuleStageStarReward:CanFetchReward(stage_level, step)   
    
    if self:IsFetched(stage_level, step) then return "fetched" end

    local count = self:GetStageLevelStarCount(stage_level)
    local condition = self:GetCondition(stage_level, step)
    if condition == 0 then 
        return "no_set_asset"
    end
    if count < condition then
        return "not_enough_condition"
    end
    return "no_error"
end

-- 获取条件
function CPlayerModuleStageStarReward:GetCondition(stage_level, step)       
    if not stage_level then return 0 end

    local entry = assets.stage_level:GetEntry(stage_level)
    if not entry then return 0 end

    local step_condition = entry["star_reward_condition_"..step] or 0
    return step_condition
end

function CPlayerModuleStageStarReward:GetRewardString(stage_level, step)     
    if not stage_level then return "" end

    local entry = assets.stage_level:GetEntry(stage_level)
    if not entry then return "" end

    local step_reward = entry["star_reward_item_"..step] or ""
    return step_reward
end

function CPlayerModuleStageStarReward:FetchReward(stage_level, step)       

    if self:CanFetchReward(stage_level, step) then
        local reward_string = self:GetRewardString(stage_level, step)
        sPlayer.player_modules.reward:TakeRewardString(reward_string)

        -- 获取星级奖励;
        player.db.stage_star_reward.map[tostring(stage_level)] = player.db.stage_star_reward.map[tostring(stage_level)] or {}
        player.db.stage_star_reward.map[tostring(stage_level)][tostring(step)] = true
        

        sMessageDispatcher:Dispatch("star_reward_fetched", stage_level, step)
    end
end

return CPlayerModuleStageStarReward
--endregion
