--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CPlayerModuleTurnTable = class("game.CPlayerModuleTurnTable")

local CPlayerModuleTurnTable = game.CPlayerModuleTurnTable

function CPlayerModuleTurnTable:ctor()

    player.db.turn_table.free_times = player.db.turn_table.free_times or assets.turn_table.free_times
end

function CPlayerModuleTurnTable:OnInit()

    sPlayer.player_modules.scheduler:AddDaily(function()
        player.db.turn_table.free_times = assets.turn_table.free_times
        
    end)   
end

function CPlayerModuleTurnTable:GetFreeTimes()

    return player.db.turn_table.free_times
end

function CPlayerModuleTurnTable:Run()

    if player.db.turn_table.free_times == 0 then 
        -- 非免费, 判断点券是否足够;
        if assets.turn_table.point_per_once > sPlayer.player_modules.point:GetPoint()  then
            return "not_enough_point"         
        end
    end

    -- 获取随机ID;
    self.random_id = assets.turn_table:GetRandomID()
    return nil
end

function CPlayerModuleTurnTable:FetchReward()

    if player.db.turn_table.free_times == 0 then 
        -- 非免费, 扣点券;
        if assets.turn_table.point_per_once > sPlayer.player_modules.point:GetPoint()  then
            return "not_enough_point"         
        end    
        sThirdPlatformUtils:LogEvent("item_purchase", '{"item":"turn_table'..'", "item_count":1, "price":'..assets.turn_table.point_per_once.."}") 
        sPlayer.player_modules.point:SubPoint(assets.turn_table.point_per_once)    
    else
        -- 免费;
        player.db.turn_table.free_times = player.db.turn_table.free_times - 1
    end

    -- 购买获得随机ID的物品;   
    local entry = assets.turn_table:GetEntry(self.random_id) 
    if entry then
        sPlayer.player_modules.reward:TakeRewardString(entry.reward)
    end
    
    sMessageDispatcher:Dispatch("turn_table_fetch_reward")
end

return CPlayerModuleTurnTable

--endregion
