--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

cc.exports.sPlayer = player
local CPlayer = player

function CPlayer:Init()

    if self.inited then return end

    self.inited = true
    self.db = sDatabase.data    
    
    self.player_modules = {}

    -- common
    self.player_modules.scheduler = require("app.models.common.player_module_scheduler").new()
    self.player_modules.setting = require("app.models.common.player_module_setting").new()
    self.player_modules.numbers = require("app.models.common.player_module_numbers").new()
    self.player_modules.ad = require("app.models.common.player_module_ad").new()    
    self.player_modules.game_recommender = require("app.models.common.player_module_game_recommender").new()    
    self.player_modules.attributes = require("app.models.attribute.player_module_attributes").new()

    -- reward
    self.player_modules.reward = require("app.models.reward.player_module_reward").new()

    -- game
    self.player_modules.info = require("app.models.game.player_module_info").new()
    self.player_modules.rank = require("app.models.game.player_module_rank").new()
    self.player_modules.shop = require("app.models.game.player_module_shop").new()
    
    self.player_modules.point = require("app.models.game.player_module_point").new()
    self.player_modules.action_point = require("app.models.game.player_module_action_point").new()

    self.player_modules.package = require("app.models.game.player_module_package").new()
    self.player_modules.recharge = require("app.models.game.player_module_recharge").new()
    self.player_modules.sign = require("app.models.game.player_module_sign").new()
    self.player_modules.stage = require("app.models.game.player_module_stage").new()
    self.player_modules.stage_level = require("app.models.game.player_module_stage_level").new()
    self.player_modules.stage_reward = require("app.models.game.player_module_stage_reward").new()
    self.player_modules.stage_star_reward = require("app.models.game.player_module_stage_star_reward").new()
    self.player_modules.stage_unlock = require("app.models.game.player_module_stage_unlock").new()
    self.player_modules.friend = require("app.models.game.player_module_friend").new()
    self.player_modules.turn_table = require("app.models.game.player_module_turn_table").new()

    self.player_modules.condition = require("app.models.task.player_module_condition").new()
    self.player_modules.daily_task = require("app.models.task.player_module_daily_task").new()
    self.player_modules.achievement = require("app.models.task.player_module_achievement").new()

    self.player_modules.skins = require("app.models.game.player_module_skins").new()
    self.player_modules.mounts = require("app.models.game.player_module_mounts").new()

    self.player_modules.random_item = require("app.models.game.player_module_random_item").new()
    self.player_modules.level = require("app.models.game.player_module_level").new()

    self.player_modules.item_box = require("app.models.game.player_module_item_box").new()
    self.player_modules.stat = require("app.models.game.player_module_stat").new()

    for k , v in pairs(self.player_modules) do
        if v.OnInit then
            v:OnInit()
        end

        if v.OnUpdate then
            self.player_modules.scheduler:AddUpdate(function(dt) 
                v:OnUpdate(dt)
            end)
        end
    end

    -- 0.5 秒保存一次数据库;
    self.last_save_seconds = 0
    self.player_modules.scheduler:AddUpdate(function(dt) 
        self.last_save_seconds = self.last_save_seconds + dt
        if self.last_save_seconds > 0.5 then
            self.last_save_seconds = 0
            sDatabase:Save()
        end
    end)
end

return CPlayer
--endregion
