--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CCondition = class("game.CCondition")

local CCondition = game.CCondition

function CCondition:ctor()

   self.target_complete_times = 0
   self.current_complete_times = 0
   self.is_completed = false
   self.condition_type = nil
   self.param_list = {}

   self.complete_times_change_event = dxm.CEvent.new()
   self.complete_change_event = dxm.CEvent.new()
end

function CCondition:Init(condition_type,condition_param,complete_times)

    self.condition_type = condition_type
    
    if condition_param then

        local param_token = dxm.CToken:Parse(condition_param,"/")
        local pos = 1
        while pos <= #param_token do

            local key = param_token[pos]
            pos = pos +1
            local value = tonumber(param_token[pos])        
            --不是数字参数
            if not value then
                value = param_token[pos]
            end

            self.param_list[key] = value

            pos = pos + 1 
        end
    end
    
    self.target_complete_times = complete_times
    return true
end

function CCondition:Create(...)
    local condition = CCondition.new()

    if condition and condition:Init(...) then
        return condition
    end
   
    return nil
end

function CCondition:Update(times)

    times = times or 1
    times = math.ceil(times)
    if self.is_completed then
        return
    end

    self.current_complete_times = self.current_complete_times + times
    if self.current_complete_times >= self.target_complete_times then
        self.is_completed = true
        self.current_complete_times = self.target_complete_times
        self.complete_change_event:Fire(true)
    end
    
    self.complete_times_change_event:Fire(self.current_complete_times)
end

function CCondition:SetProgress(progress)

    progress = math.ceil(progress)
    self.current_complete_times = progress

    if self.current_complete_times >= self.target_complete_times then
        self.is_completed = true
        self.complete_change_event:Fire(true)
    end

    self.complete_times_change_event:Fire(self.current_complete_times)
end

return CCondition
--endregion
