--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

--region *.lua
--Date
--此文件由[BabeLua]插件自动生成
require("app.models.task.task")
require("app.models.task.condition")

game.CPlayerModuleAchievement = class("game.CPlayerModuleAchievement")

local CPlayerModuleAchievement = game.CPlayerModuleAchievement

function CPlayerModuleAchievement:ctor()

    -- 逻辑任务列表, 保存 task 对象;
    self.task_list = {}
    -- 所有成就任务的状态及进度;
    player.db.achievement.achievement_data_list_v2 = player.db.achievement.achievement_data_list_v2 or {}
    -- 成就组进度, 保存完成的成就组的任务数;
    player.db.achievement.achievement_group_status = player.db.achievement.achievement_group_status or {}
end

function CPlayerModuleAchievement:OnInit()

    -- 创建任务，避免任务在打开任务界面后才被创建监听
    if #self.task_list == 0 then
       self:CreateTaskList()
    end
end

function CPlayerModuleAchievement:CreateTaskList()

    -- 创建任务
    for group_id, achivement_group in pairs(assets.achievement.config) do
        for id, achievement in pairs(achivement_group) do
            local task = game.CTask:Create(game.CTask.TaskType.kTypeAchievement,group_id, id)
            if task then
                if self.task_list[group_id] == nil then
                    self.task_list[group_id] = {}
                end

                self.task_list[group_id][id] = task

                -- 加载任务信息
                local data = player.db.achievement.achievement_data_list_v2[tostring(task.entry.id)]
                if data then
                    task:SetStatus(data.status)
                    task:SetProgress(data.progress)
                end

                -- 监听任务
                local condition = task:GetCondition()
                if condition and task.status == game.CTask.TaskStatus.kTypeNotComplete then
                    sPlayer.player_modules.condition:Register(condition)

                    condition.complete_change_event:Connect( function(is_complete)
                        self:ConditionCompleteChangeCallback(task, is_complete)
                    end )

                    condition.complete_times_change_event:Connect( function(completed_times)
                        self:ConditionCompleteTimesChangeCallback(task, completed_times)
                    end )
                end
            end
        end
    end
end

function CPlayerModuleAchievement:ConditionCompleteChangeCallback(task, is_completed)

    if is_completed == true then
        task:SetStatus(game.CTask.TaskStatus.kTypeCompleted)
        self:Save(task)
    end
end

function CPlayerModuleAchievement:ConditionCompleteTimesChangeCallback(task,completed_times)

    task:SetProgress(completed_times)
    self:Save(task)
end

function CPlayerModuleAchievement:GetAchievementList()

    if #self.task_list == 0 then
       self:CreateTaskList()
    end
    return self.task_list or {}
end

function CPlayerModuleAchievement:CheckReceiveReward(task)
    if not task then return false end
    
    if task.status ~= game.CTask.TaskStatus.kTypeCompleted then
        return false
    end
    return true
end

function CPlayerModuleAchievement:ReceiveReward(task) 

    sThirdPlatformUtils:LogEvent("mission_begin", "{\"mission\":\"achievement_"..task.entry.id.."\"}")
    sThirdPlatformUtils:LogEvent("mission_completed", "{\"mission\":\"achievement_"..task.entry.id.."\"}")
    sPlayer.player_modules.reward:TakeRewardString(task.entry.reward)
    task:SetStatus(game.CTask.TaskStatus.kTypeReceived)
    self:Save(task)
end

function CPlayerModuleAchievement:Save(task)

    local task_id = tostring(task.entry.id)
    player.db.achievement.achievement_data_list_v2[task_id] = {}
    player.db.achievement.achievement_data_list_v2[task_id].id = task.entry.id
    player.db.achievement.achievement_data_list_v2[task_id].status = task.status
    player.db.achievement.achievement_data_list_v2[task_id].progress = task.progress
    
    --任务组进度增加
    local task_group_id = tostring(task.entry.group_id)
    if task.status == game.CTask.TaskStatus.kTypeReceived then
        if self:GetGroupStatus(task.entry.group_id) < #assets.achievement.config[task.entry.group_id] then
            player.db.achievement.achievement_group_status[task_group_id] = player.db.achievement.achievement_group_status[task_group_id] + 1
            print(" --任务组进度增加")
        end
    end
end

function CPlayerModuleAchievement:GetGroupStatus(group_id)

    group_id = tostring(group_id)
    player.db.achievement.achievement_group_status[group_id] = player.db.achievement.achievement_group_status[group_id] or 1
    return player.db.achievement.achievement_group_status[group_id]
end

function CPlayerModuleAchievement:GetCurrentTask(group_id)
    
    local achievement = self.task_list[group_id]
    local task = nil
    local task_pos = self:GetGroupStatus(group_id)
    if achievement and task_pos <= #assets.achievement.config[group_id] then         
        task = achievement[task_pos]
    end
    return task
end

return CPlayerModuleAchievement

--endregion

--endregion
