--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

require("app.models.task.condition")

game.CPlayerModuleCondition = class("game.CPlayerModuleCondition")

local CPlayerModuleCondition = game.CPlayerModuleCondition
local ConditionType = enum.ConditionType

function CPlayerModuleCondition:ctor()
    --条件监听列表
    self.listeners = {}
    self.conditions = {}
    for k , v in pairs (ConditionType) do
        self.conditions[v] = {}
    end
end

function CPlayerModuleCondition:OnInit()
    --初始化列表

   self.listeners[ConditionType.kTypeUseGamebill] = 
        sPlayer.player_modules.numbers.chg_event:Connect(function(...) self:ChgGamebillCallback(...) end)  

   self.listeners[ConditionType.kTypeUsePoint] = 
        sPlayer.player_modules.point.chg_event:Connect(function(...) self:ChgPointCallback(...) end)  

   self.listeners[ConditionType.kTypeUpgradePlayer] = 
        sPlayer.player_modules.level.level_changed_event:Connect(function(...) self:UpgradePlayerCallback(...) end)  

   self.listeners[ConditionType.kTypeUpgradeMount] = 
        sPlayer.player_modules.mounts.mount_upgrade_event:Connect(function(...) self:UpgradeMountCallback(...) end)  

   self.listeners[ConditionType.kTypeCountMount] = 
        sPlayer.player_modules.mounts.mount_count_event:Connect(function(...) self:CountMountCallback(...) end) 
         
   self.listeners[ConditionType.kTypeUpgradeSkin] = 
        sPlayer.player_modules.skins.skin_upgrade_event:Connect(function(...) self:UpgradeSkinCallback(...) end)  

   self.listeners[ConditionType.kTypeGiveFriendActionPoint] = 
        sPlayer.player_modules.friend.give_action_point_event:Connect(function(...) self:GiveFriendActionPointCallback(...) end)  

   self.listeners[ConditionType.kTypeCountSkin] = 
        sPlayer.player_modules.skins.skin_count_event:Connect(function(...) self:CountSkinCallback(...) end)  

   self.listeners[ConditionType.kTypeUseItem] = 
       sPlayer.player_modules.package.use_item_event:Connect(function(...) self:UseItemCallback(...) end)  
   
   self.listeners[ConditionType.kTypeStageClear] = 
       sPlayer.player_modules.stage.stage_clear_event:Connect(function(...) self:StageClearCallback(...) end)  
   
   self.listeners[ConditionType.kTypeStageMeter] = 
       sPlayer.player_modules.stage.stage_clear_event:Connect(function(...) self:StageClearMeterCallback(...) end)  

   self.listeners[ConditionType.kTypeStageClearInfinite] = 
       sPlayer.player_modules.stage.stage_clear_event:Connect(function(...) self:StageClearInfiniteCallback(...) end)  
   
   self.listeners[ConditionType.kTypeStageMeterInfinite] = 
       sPlayer.player_modules.stage.stage_clear_event:Connect(function(...) self:StageClearMeterInfiniteCallback(...) end)  
   
   self.listeners[ConditionType.kTypeUseDoubleJumps] = 
       sPlayer.player_modules.stage.stage_clear_event:Connect(function(...) self:StageClearUseDoubleJumpsCallback(...) end)  
   
   -- self.listeners[ConditionType.kTypeUseSkill] = 
   --     sPlayer.player_modules.point.chg_event:Connect(function(...) self:StageClearUseSkillCallback(...) end)  
   -- 

   self.listeners[ConditionType.kTypeEatItem] = 
       sPlayer.player_modules.stage.stage_clear_event:Connect(function(...) self:StageClearEatItemCallback(...) end)  
end

function CPlayerModuleCondition:Register(condition)

    if not condition or not self.conditions[condition.condition_type] then
        return
    end
    self.conditions[condition.condition_type][condition] = condition
end

function CPlayerModuleCondition:Remove(condition)

    if not condition or not self.conditions[condition.condition_type] then
        return
    end

    self.conditions[condition.condition_type][condition] = nil
end

function CPlayerModuleCondition:ChgGamebillCallback(number_name, number, delta)

    if delta < 0 then
        local complete_list = {}
        if number_name == enum.NumberType.kTypeGamebill then
            for _,v in pairs(self.conditions[ConditionType.kTypeUseGamebill]) do
                
                v:Update(-delta)
                if v.is_completed then
                    table.insert(complete_list,v)
                end
            end
        end

        for _,v in pairs(complete_list) do
            self:Remove(v)
        end
    end
end

function CPlayerModuleCondition:ChgPointCallback(point, delta)

    if delta < 0 then
        local complete_list = {}
        for _,v in pairs(self.conditions[ConditionType.kTypeUsePoint]) do
            v:Update(-delta)

            if v.is_completed then
                table.insert(complete_list,v)
            end
        end

        for _,v in pairs(complete_list) do
            self:Remove(v)
        end
    end
end

function CPlayerModuleCondition:UpgradePlayerCallback(level, delta)

    if delta > 0 then
        local complete_list = {}
        for _,v in pairs(self.conditions[ConditionType.kTypeUpgradePlayer]) do

            v:SetProgress(level)
            if v.is_completed then
                table.insert(complete_list,v)
            end
        end

        for _,v in pairs(complete_list) do
            self:Remove(v)
        end
    end
end

function CPlayerModuleCondition:UpgradeMountCallback(mount_id, level, delta)

    if delta > 0 then
        local complete_list = {}
        for _,v in pairs(self.conditions[ConditionType.kTypeUpgradeMount]) do
            if  not v.param_list["mount"] or v.param_list["mount"]==mount_id then
                v:Update()
            end
            if v.is_completed then
                table.insert(complete_list,v)
            end
        end

        for _,v in pairs(complete_list) do
            self:Remove(v)
        end
    end
end

function CPlayerModuleCondition:CountMountCallback()

    local complete_list = {}
    for _,v in pairs(self.conditions[ConditionType.kTypeCountMount]) do
        
        v:SetProgress(sPlayer.player_modules.mounts:GetCount(v.param_list["level"]))

        if v.is_completed then
            table.insert(complete_list,v)
        end
    end

    for _,v in pairs(complete_list) do
        self:Remove(v)
    end
end

function CPlayerModuleCondition:UpgradeSkinCallback(skin_id, level, delta)

    if delta > 0 then
        local complete_list = {}
        for _,v in pairs(self.conditions[ConditionType.kTypeUpgradeSkin]) do
            if  not v.param_list["skin"] or v.param_list["skin"]==skin_id then
                v:Update()
            end
            if v.is_completed then
                table.insert(complete_list,v)
            end
        end

        for _,v in pairs(complete_list) do
            self:Remove(v)
        end
    end
end

function CPlayerModuleCondition:CountSkinCallback()

    local complete_list = {}
    for _,v in pairs(self.conditions[ConditionType.kTypeCountSkin]) do
        v:SetProgress(sPlayer.player_modules.skins:GetCount(v.param_list["level"]))
        if v.is_completed then
            table.insert(complete_list,v)
        end
    end

    for _,v in pairs(complete_list) do
        self:Remove(v)
    end
end

function CPlayerModuleCondition:GiveFriendActionPointCallback()
    local complete_list = {}
    for _,v in pairs(self.conditions[ConditionType.kTypeGiveFriendActionPoint]) do
        v:Update()
        if v.is_completed then
            table.insert(complete_list,v)
        end
    end

    for _,v in pairs(complete_list) do
        self:Remove(v)
    end
end

function CPlayerModuleCondition:UseItemCallback(item_id, count)

    local complete_list = {}
    for _,v in pairs(self.conditions[ConditionType.kTypeUseItem]) do
        if  not v.param_list["item"] or v.param_list["item"]==item_id then
            v:Update(count)
        end
        if v.is_completed then
            table.insert(complete_list,v)
        end
    end

    for _,v in pairs(complete_list) do
        self:Remove(v)
    end
end

function CPlayerModuleCondition:StageClearCallback(stage_type, stage_id, child_stage_id, is_win, record)
    
    local complete_list = {}
    for _,v in pairs(self.conditions[ConditionType.kTypeStageClear]) do
        --判断参数
        if  (not v.param_list["stage_type"] or v.param_list["stage_type"]==stage_type)
            and (not v.param_list["stage_id"] or v.param_list["stage_id"]==stage_id)
            and (not v.param_list["child_stage_id"] or v.param_list["child_stage_id"]==child_stage_id)
            and (not v.param_list["score"] or v.param_list["score"]<=record.score)
            and (not v.param_list["star"] or v.param_list["star"]<=record.star)
            and (not v.param_list["time"] or v.param_list["time"]>=record.time)
            and (not v.param_list["mount"] or v.param_list["mount"]==record.mount_id)
            and (not v.param_list["meter"] or v.param_list["meter"]<=record.meter)
            and (not v.param_list["skin"] or v.param_list["skin"]==record.player_id) then
            v:Update()    
        end

        if v.is_completed then
            table.insert(complete_list,v)
        end
    end

    for _,v in pairs (complete_list) do
        self:Remove(v)
    end
end

function CPlayerModuleCondition:StageClearMeterCallback(stage_type, stage_id, child_stage_id, is_win, record)
    
    local complete_list = {}

    for _,v in pairs(self.conditions[ConditionType.kTypeStageMeter]) do
        --判断参数
        if  (not v.param_list["stage_type"] or v.param_list["stage_type"]==stage_type)
            and (not v.param_list["stage_id"] or v.param_list["stage_id"]==stage_id)
            and (not v.param_list["child_stage_id"] or v.param_list["child_stage_id"]==child_stage_id)
            and (not v.param_list["score"] or v.param_list["score"]<=record.score)
            and (not v.param_list["star"] or v.param_list["star"]<=record.star)
            and (not v.param_list["time"] or v.param_list["time"]<=record.time)
            and (not v.param_list["mount"] or v.param_list["mount"]==record.mount_id)
            and (not v.param_list["skin"] or v.param_list["skin"]==record.player_id) then
            v:Update(record.meter)    
        end
        if v.is_completed then
            table.insert(complete_list,v)
        end
    end

    for _,v in pairs (complete_list) do
        self:Remove(v)
    end
end


function CPlayerModuleCondition:StageClearInfiniteCallback(stage_type, stage_id, child_stage_id, is_win, record)
    
    local complete_list = {}
    for _,v in pairs(self.conditions[ConditionType.kTypeStageClearInfinite]) do
        --判断参数
        if  (not v.param_list["stage_type"] or v.param_list["stage_type"]==stage_type)
            and (not v.param_list["stage_id"] or v.param_list["stage_id"]==stage_id)
            and (not v.param_list["child_stage_id"] or v.param_list["child_stage_id"]==child_stage_id)
            and (not v.param_list["score"] or v.param_list["score"]<=record.score)
            and (not v.param_list["star"] or v.param_list["star"]<=record.star)
            and (not v.param_list["time"] or v.param_list["time"]>=record.time)
            and (not v.param_list["mount"] or v.param_list["mount"]==record.mount_id)
            and (not v.param_list["meter"] or v.param_list["meter"]<=record.meter)
            and (not v.param_list["skin"] or v.param_list["skin"]==record.player_id) then
            v:Update()    
        end

        if v.is_completed then
            table.insert(complete_list,v)
        end
    end

    for _,v in pairs (complete_list) do
        self:Remove(v)
    end
end

function CPlayerModuleCondition:StageClearMeterInfiniteCallback(stage_type, stage_id, child_stage_id, is_win, record)
    
    local complete_list = {}

    for _,v in pairs(self.conditions[ConditionType.kTypeStageMeterInfinite]) do
        --判断参数
        if  (not v.param_list["stage_type"] or v.param_list["stage_type"]==stage_type)
            and (not v.param_list["stage_id"] or v.param_list["stage_id"]==stage_id)
            and (not v.param_list["child_stage_id"] or v.param_list["child_stage_id"]==child_stage_id)
            and (not v.param_list["score"] or v.param_list["score"]<=record.score)
            and (not v.param_list["star"] or v.param_list["star"]<=record.star)
            and (not v.param_list["time"] or v.param_list["time"]<=record.time)
            and (not v.param_list["mount"] or v.param_list["mount"]==record.mount_id)
            and (not v.param_list["skin"] or v.param_list["skin"]==record.player_id) then
            v:Update(record.meter)    
        end
        if v.is_completed then
            table.insert(complete_list,v)
        end
    end

    for _,v in pairs (complete_list) do
        self:Remove(v)
    end
end

function CPlayerModuleCondition:StageClearUseSkillCallback(stage_type, stage_id, child_stage_id, is_win, record)
    
    -- TODO:
    local complete_list = {}
    for _,v in pairs(self.conditions[ConditionType.kTypeUseSkill]) do
        if  (not v.param_list["skill"] or v.param_list["skill"]==mode) then
            v:Update()    
        end
        if v.is_completed then
            table.insert(complete_list,v)
        end
    end

    for _,v in pairs (complete_list) do
        self:Remove(v)
    end
end

function CPlayerModuleCondition:StageClearEatItemCallback(stage_type, stage_id, child_stage_id, is_win, record)
    
    local complete_list = {}

    for _,v in pairs(self.conditions[ConditionType.kTypeEatItem]) do

        local total_count = 0
        for id,count in pairs(record.pickup_list) do
            if not v.param_list["item"] then
                total_count = total_count + count
            elseif id == v.param_list["item"] then
                total_count = total_count + count
                break
            end
        end
        v:Update(total_count)    

        if v.is_completed then
            table.insert(complete_list,v)
        end
    end

    for _,v in pairs (complete_list) do
        self:Remove(v)
    end
end

function CPlayerModuleCondition:StageClearUseDoubleJumpsCallback(stage_type, stage_id, child_stage_id, is_win, record)
    
    local complete_list = {}
    for _,v in pairs(self.conditions[ConditionType.kTypeUseDoubleJumps]) do

        v:Update(record.jump_twice_times)    
        if v.is_completed then
            table.insert(complete_list,v)
        end
    end

    for _,v in pairs (complete_list) do
        self:Remove(v)
    end
end

return CPlayerModuleCondition

--endregion
