--region *.lua
--Date
--此文件由[BabeLua]插件自动生成
require("app.models.task.task")
require("app.models.task.condition")

game.CPlayerModuleDailyTask = class("game.CPlayerModuleDailyTask")

local CPlayerModuleDailyTask = game.CPlayerModuleDailyTask

function CPlayerModuleDailyTask:ctor()

    self.task_list = {}
    player.db.daily_task.daily_task_activity = player.db.daily_task.daily_task_activity or 0
    player.db.daily_task.daily_task_data_list = player.db.daily_task.daily_task_data_list or {}
    player.db.daily_task.silver_box_opend = player.db.daily_task.silver_box_opend or false
    player.db.daily_task.copper_box_opend = player.db.daily_task.copper_box_opend or false
    player.db.daily_task.glod_box_opend = player.db.daily_task.glod_box_opend or false
end

function CPlayerModuleDailyTask:OnInit()

    self:DailyClear()
    --创建出任务,避免任务在打开任务界面后才被创建监听
    self:GetDailyTaskList()
end

function CPlayerModuleDailyTask:GetActivity()

    return player.db.daily_task.daily_task_activity
end

function CPlayerModuleDailyTask:CreateTaskList()

    --创建任务
    local task_count = 0
    for k ,v in pairs (assets.daily_task.config) do

        local task = game.CTask:Create(game.CTask.TaskType.kTypeDaily,k)
        if task then
            self.task_list[k] = task

            --加载任务信息
            local data = player.db.daily_task.daily_task_data_list[tostring(k)]
            if data then
                self.task_list[k]:SetStatus(data.status)
                self.task_list[k]:SetProgress(data.progress)
            end

            --监听任务
            local condition = self.task_list[k]:GetCondition()
            if condition and self.task_list[k].status == game.CTask.TaskStatus.kTypeNotComplete then
                sPlayer.player_modules.condition:Register(condition)
            
                condition.complete_change_event:Connect(function(is_complete) 
                    self:ConditionCompleteChangeCallback(self.task_list[k],is_complete) 
                end)
            
                condition.complete_times_change_event:Connect(function(completed_times)
                    self:ConditionCompleteTimesChangeCallback(self.task_list[k],completed_times)
                end)
            end
            task_count = task_count+1
        end
    end
end

function CPlayerModuleDailyTask:ConditionCompleteChangeCallback(task,is_completed)

    if is_completed == true then
        task:SetStatus(game.CTask.TaskStatus.kTypeCompleted)
        self:Save(task.entry.id)
    end
end

function CPlayerModuleDailyTask:ConditionCompleteTimesChangeCallback(task,completed_times)
    task:SetProgress(completed_times)
    self:Save(task.entry.id)
end

function CPlayerModuleDailyTask:GetDailyTaskList()
    if #self.task_list == 0 then
       self:CreateTaskList()
    end

    return self.task_list or {}
end

function CPlayerModuleDailyTask:CheckReceiveReward(task_id)
    local task = self.task_list[task_id]

    if not task then return false end
    
    if task.status ~= game.CTask.TaskStatus.kTypeCompleted then
        return false
    end
    return true
end

function CPlayerModuleDailyTask:ReceiveReward(task_id) 

    sThirdPlatformUtils:LogEvent("mission_begin", "{\"mission\":\"daily_"..task_id.."\"}")
    sThirdPlatformUtils:LogEvent("mission_completed", "{\"mission\":\"daily_"..task_id.."\"}")

    sPlayer.player_modules.reward:TakeRewardString(self.task_list[task_id].entry.reward)
    self.task_list[task_id]:SetStatus(game.CTask.TaskStatus.kTypeReceived)
    
    player.db.daily_task.daily_task_activity = player.db.daily_task.daily_task_activity + self.task_list[task_id].entry.activity
    
    if player.db.daily_task.daily_task_activity > assets.const.daily_task_max_activity then
        player.db.daily_task.daily_task_activity = assets.const.daily_task_max_activity
    end
    
    self:Save(task_id)
end

function CPlayerModuleDailyTask:GetActivity()
    return player.db.daily_task.daily_task_activity
end

function CPlayerModuleDailyTask:Save(task_id)
    
    local task = self.task_list[task_id]
    player.db.daily_task.daily_task_data_list[tostring(task_id)] = {}
    player.db.daily_task.daily_task_data_list[tostring(task_id)].id = task.entry.id
    player.db.daily_task.daily_task_data_list[tostring(task_id)].status = task.status
    player.db.daily_task.daily_task_data_list[tostring(task_id)].progress = task.progress
end

CPlayerModuleDailyTask.OpenBoxError = 
{
    kTypeOpenBoxErrorOk = 1,
    kTypeOpenBoxErrorNotActivity = 2,
    kTypeOpenBoxErrorReceived = 3
}

function CPlayerModuleDailyTask:CheckOpenCopperBox()
    if player.db.daily_task.daily_task_activity < assets.const.copper_box_need_activity then
        return CPlayerModuleDailyTask.OpenBoxError.kTypeOpenBoxErrorNotActivity
    end

    if player.db.daily_task.copper_box_opend == true then
        return CPlayerModuleDailyTask.OpenBoxError.kTypeOpenBoxErrorReceived
    end

    return CPlayerModuleDailyTask.OpenBoxError.kTypeOpenBoxErrorOk
end

function  CPlayerModuleDailyTask:OpenCopperBox()
    sPlayer.player_modules.reward:TakeRewardString(assets.const.copper_box_reward)
    player.db.daily_task.copper_box_opend = true
    
end

function CPlayerModuleDailyTask:CheckOpenSilverBox()
    if player.db.daily_task.daily_task_activity < assets.const.silver_box_need_activity then
        return CPlayerModuleDailyTask.OpenBoxError.kTypeOpenBoxErrorNotActivity
    end

    if player.db.daily_task.silver_box_opend == true then
        return CPlayerModuleDailyTask.OpenBoxError.kTypeOpenBoxErrorReceived
    end

    return CPlayerModuleDailyTask.OpenBoxError.kTypeOpenBoxErrorOk
end

function  CPlayerModuleDailyTask:OpenSilverBox()
    sPlayer.player_modules.reward:TakeRewardString(assets.const.silver_box_reward)
    player.db.daily_task.silver_box_opend = true
    
end

function CPlayerModuleDailyTask:CheckOpenGlodBox()
    if player.db.daily_task.daily_task_activity < assets.const.glod_box_need_activity then
        return CPlayerModuleDailyTask.OpenBoxError.kTypeOpenBoxErrorNotActivity
    end

    if player.db.daily_task.glod_box_opend == true then
        return CPlayerModuleDailyTask.OpenBoxError.kTypeOpenBoxErrorReceived
    end

    return CPlayerModuleDailyTask.OpenBoxError.kTypeOpenBoxErrorOk
end

function  CPlayerModuleDailyTask:OpenGlodBox()
    sPlayer.player_modules.reward:TakeRewardString(assets.const.glod_box_reward)
    player.db.daily_task.glod_box_opend = true
    
end

function CPlayerModuleDailyTask:DailyClear()
    sPlayer.player_modules.scheduler:AddDaily(function()
        player.db.daily_task.daily_task_data_list = {}
        player.db.daily_task.silver_box_opend = false
        player.db.daily_task.copper_box_opend = false
        player.db.daily_task.glod_box_opend = false
        player.db.daily_task.daily_task_activity = 0

        --游戏未关闭情况
        if self.task_list then
            --移除任务监听
            for k , v  in pairs(self.task_list) do
                local condition = v:GetCondition()
                sPlayer.player_modules.condition:Remove(condition)
            end
            self.task_list = {}
        end
        --重新创建任务
        self:CreateTaskList()
    end)
end

function CPlayerModuleDailyTask:HasCompleteTask()
    for _,task in pairs(self.task_list) do
        if task.status == game.CTask.TaskStatus.kTypeCompleted then
            return true
        end
    end
end

return CPlayerModuleDailyTask

--endregion
