--region *.lua
--Date
--此文件由[BabeLua]插件自动生成
require("app.models.task.task")

game.CPlayerModuleMainTask = class("game.CPlayerModuleMainTask")

local CPlayerModuleMainTask = game.CPlayerModuleMainTask

function CPlayerModuleMainTask:ctor()
    --加载
    self.task_list = {}
    player.db.current_main_task_id = player.db.current_main_task_id or 1
    player.db.main_task_data_list = player.db.main_task_data_list or {}
end

function CPlayerModuleMainTask:OnInit()
    self:CreateTaskList()
end

function CPlayerModuleMainTask:CreateTaskList()
    --创建任务
    for k ,v in pairs (assets.main_task.config) do
        
        local task = game.CTask:Create(game.CTask.TaskType.kTypeMain,k)
        if task then
            self.task_list[k] = task

            --加载任务信息
            local data = player.db.main_task_data_list[k]            
            if data then
                self.task_list[k]:SetStatus(data.status)
                self.task_list[k]:SetProgress(data.progress)
            end

            --监听任务
            local condition = self.task_list[k]:GetCondition()
            if condition and self.task_list[k].status == game.CTask.TaskStatus.kTypeNotComplete then
                sPlayer.player_modules.condition:Register(condition)
            
                condition.complete_change_event:Connect(function(is_complete) 
                    self:ConditionCompleteChangeCallback(self.task_list[k],is_complete) 
                end)
            
                condition.complete_times_change_event:Connect(function(completed_times)
                    self:ConditionCompleteTimesChangeCallback(self.task_list[k],completed_times)
                end)
            end
        end
    end
end

function CPlayerModuleMainTask:GetCurrentTask()
    if self:IsAllCompleted() then
        return nil
    end

    return self.task_list[player.db.current_main_task_id]
end

function CPlayerModuleMainTask:ReceiveMainTaskReward()
    sThirdPlatformUtils:LogEvent("mission_begin", "{\"mission\":\"main_"..player.db.current_main_task_id.."\"}")
    sThirdPlatformUtils:LogEvent("mission_completed", "{\"mission\":\"main_"..player.db.current_main_task_id.."\"}")
    --领取奖励
    local current_task = self.task_list[player.db.current_main_task_id]
    if current_task.status == game.CTask.TaskStatus.kTypeCompleted then
        sPlayer.player_modules.reward:TakeRewardString(current_task.entry.reward)
        --取到下一任务
        player.db.current_main_task_id = player.db.current_main_task_id + 1
        
        return true
    end

    return false
end

function CPlayerModuleMainTask:ConditionCompleteChangeCallback(task,is_completed)
    if is_completed == true then
        task:SetStatus(game.CTask.TaskStatus.kTypeCompleted)
        self:Save(task.entry.id)
    end
end

function CPlayerModuleMainTask:ConditionCompleteTimesChangeCallback(task,completed_times)
    task:SetProgress(completed_times)
    self:Save(task.entry.id)
end

function CPlayerModuleMainTask:Save(task_id)
    
    local task = self.task_list[task_id]
    player.db.main_task_data_list[task_id] = {}
    player.db.main_task_data_list[task_id].id = task.entry.id
    player.db.main_task_data_list[task_id].status = task.status
    player.db.main_task_data_list[task_id].progress = task.progress
end

function CPlayerModuleMainTask:IsAllCompleted()
    if player.db.current_main_task_id > #self.task_list then return true end
    return false
end

return CPlayerModuleMainTask
--endregion
