--region *.lua
--Date
--此文件由[BabeLua]插件自动生成
require("app.models.task.condition")

game.CTask = class("game.CTask")

local CTask = game.CTask

CTask.TaskType = 
{
    kTypeMain = 1,
    kTypeDaily = 2,
    kTypeAchievement = 3
}

CTask.TaskStatus = 
{
    --未完成
    kTypeNotComplete = 1,
    --已完成
    kTypeCompleted = 2,
    --已领取奖励
    kTypeReceived = 3
}

function CTask:ctor()
    self.entry = nil
    self.status = CTask.TaskStatus.kTypeNotComplete
    self.task_type = CTask.TaskType.kTypeMain
    self.progress = 0
end

function CTask:Init(entry)
    self.entry = entry
    return true
end

function CTask:_Create(entry)
    if not entry then
        return nil
    end

    local task = CTask.new()
    if task and task:Init(entry) then
        return task
    end
    return nil
end

function CTask:Create(task_type,task_id,id)

    local entry;
    if task_type == CTask.TaskType.kTypeMain then
        entry = assets.main_task.config[task_id]
    elseif task_type == CTask.TaskType.kTypeDaily then
        entry = assets.daily_task.config[task_id]
    elseif task_type == CTask.TaskType.kTypeAchievement then
        entry = assets.achievement.config[task_id][id]
    end
   
    if entry then
        return CTask:_Create(entry)
    end
end

function CTask:GetCondition()
    local condition = game.CCondition:Create(self.entry.condition_type, self.entry.condition_param, self.entry.complete_times)
    if condition then
        condition:SetProgress(self.progress)
        return condition
    end
    logerror("not condition task id "..self.entry.id)
    return nil
end

function CTask:SetStatus(status)
    self.status = status
end

function CTask:SetProgress(progress)
    self.progress = progress
end

return CTask
--endregion
