--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CGameBackground = class("game.CGameBackground", cc.Node)
local CGameBackground = game.CGameBackground

function CGameBackground:ctor()
end

function CGameBackground:Init(map, config)

    self.config = config
    self.map = map

    local base_image = cc.Sprite:create(self.config.file_path)
    if base_image == nil then
        return false
    end

    self.base_image_w = base_image:getContentSize().width / map.scale
    self.base_image_h = base_image:getContentSize().height / map.scale
    -- print( self.base_image_w,  self.base_image_h)

    self.image_list = {}

    -- 监听进入离开事件
    self:registerScriptHandler(function (event)
		if event == "enter" then
		elseif event == "exit" then
		elseif event == "cleanup" then
            self:Dispose()
		end
	end)

    -- 设置级联
    self:setCascadeColorEnabled(true)
    self:setCascadeOpacityEnabled(true)
    return true
end

function CGameBackground:Dispose()
end

function CGameBackground:Create(...)

    local background = CGameBackground.new()
    if background == nil or background:Init(...) == false then
        return nil
    end
    return background
end

function CGameBackground:Update(dt)

    self:UpdateVisible()
end

function CGameBackground:UpdateVisible()

    local visible_rect = self.map.tmx.visible_rect

    local new_x = visible_rect.x / math.abs(self.config.z)
    local new_y = visible_rect.y / math.abs(self.config.z)

    -- 先移动一段位置
    self:setPositionX(-new_x)
    self:setPositionY(-new_y-game.CAssetGame.min_height)

    -- 判断最新的循环块
    local start_index = math.floor(new_x / self.base_image_w)
    local end_index = math.floor((new_x + visible_rect.w) / self.base_image_w)

    -- 移除之前的图片
    for index,image in pairs(self.image_list) do

        if index < start_index or index > end_index then
            image:removeFromParent()
            self.image_list[index] = nil
        end
    end

    -- 根据显示坐标来决定显示哪些部分
    for index=start_index,end_index do

        if self.image_list[index] == nil then

            local image = cc.Sprite:create(self.config.file_path)
            if image then
                self:addChild(image)
                image:setScale(1/self.map.scale+0.1)
                image:setAnchorPoint(cc.p(0,0))
                image:setPosition(cc.p(index*self.base_image_w, 0))

                -- 设置级联
                image:setCascadeColorEnabled(true)
                image:setCascadeOpacityEnabled(true)

                self.image_list[index] = image
            end
        end
    end
end

return game.CGameBackground

--endregion
