--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CGameDummyRank = class("game.CGamePlayer")
local CGameDummyRank = game.CGameDummyRank


function CGameDummyRank:ctor()

    self.dummy_players = {}

    local self_player = {}
    self_player.name = sPlayer.player_modules.info:GetName()
    self_player.score = 0
    self_player.meter = 0
    self_player.is_self = true
    self_player.pos = 1
    self_player.head_icon = 1
    if player.db.info.user_info then
        self_player.head_icon = player.db.info.head_icon or 1
    end
    self.dummy_players[#self.dummy_players + 1] = self_player

    for i=2, 4 do
        local dummy_player = {}
        dummy_player.name = assets.names:Get()
        dummy_player.score = 0
        dummy_player.meter = 0
        dummy_player.pos = i
        dummy_player.head_icon = math.random(1, 4)
        self.dummy_players[#self.dummy_players + 1] = dummy_player
    end
end

function CGameDummyRank:SetMaxMeter(meter)
    self.max_meter = meter
end

function CGameDummyRank:AddItemScore(player_score_added)

    for _, rank_player in pairs(self.dummy_players) do
        if rank_player.is_self then
            rank_player.score = rank_player.score + player_score_added
        else
            rank_player.score = rank_player.score + math.random(player_score_added-10, player_score_added+10)
        end
    end

    self.dirty = true
end

function CGameDummyRank:AddMeterScore(player_score_added)

    for _, rank_player in pairs(self.dummy_players) do
        if rank_player.is_self then
            rank_player.score = rank_player.score + player_score_added
        else
            rank_player.score = rank_player.score + math.random(player_score_added-2, player_score_added+2)
        end
    end
    self.dirty = true
end

function CGameDummyRank:AddMeter(player_meter)

    for _, rank_player in pairs(self.dummy_players) do
        if rank_player.is_self then
            rank_player.meter = rank_player.meter + player_meter
        else
            rank_player.meter = rank_player.meter + math.random(player_meter-3, player_meter+3)
            if self.max_meter and rank_player.meter > self.max_meter then
                rank_player.meter = self.max_meter
            end
        end
    end
    self.dirty = true
end

function CGameDummyRank:Break()

    local min_score = 0
    for i=1,#self.dummy_players do
        local player = self.dummy_players[i]
        if player.is_self then
            min_score = player.score
            break
        end
    end

    for i=1,#self.dummy_players do
        local player = self.dummy_players[i]
        if not player.is_self then
            player.score = min_score + i
        end
    end
    self.dirty = true
end

function CGameDummyRank:GetList()

    if self.dirty then
        table.sort(self.dummy_players, function(a, b)   
            if a.score == b.score then
                return a.pos<b.pos
            end  
            return a.score > b.score
        end)
        self.dirty = false
    end
    return self.dummy_players
end

return CGameDummyRank

--endregion
