--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CGameEventVolcanicEruptions = class("game.CGameEventVolcanicEruptions", game.CGameEvent)
local CGameEventVolcanicEruptions = game.CGameEventVolcanicEruptions

function CGameEventVolcanicEruptions:ctor()
    CGameEventVolcanicEruptions.super.ctor(self)

    self.action_handle = nil
end

function CGameEventVolcanicEruptions:Init(map)
    CGameEventVolcanicEruptions.super.Init(self, map)

    return true
end

function CGameEventVolcanicEruptions:Create(...)
    local event = CGameEventVolcanicEruptions.new()
    if event and event:Init(...) then
        return event
    end
    return nil
end

function CGameEventVolcanicEruptions:Run()
    self.action_handle = self.map:runAction(cc.RepeatForever:create(
    cc.Sequence:create(cc.DelayTime:create(5), cc.CallFunc:create(function() self:Shake() end))))
end

function CGameEventVolcanicEruptions:Stop()
    self.map:stopAction(self.action_handle)
    self.action_handle = nil
end

function CGameEventVolcanicEruptions:Shake()

    -- 播放音效
    dxm.audio:playSound(assets.sound.config.sound.game_event_volcanic_shake)

    -- 屏幕震动效果
    self.map:runAction(cc.Sequence:create(
        cc.Repeat:create(cc.Sequence:create(
        cc.CallFunc:create( function()

            local randx = math.random(-10, 10)
            local randy = math.random(-10, 10)

            self.map:setPosition(randx, randy)
        end ),
        cc.DelayTime:create(0.02)),
        50),
        cc.CallFunc:create( function() self.map:setPosition(0, 0) self:Fall() end)
    ))
end

function CGameEventVolcanicEruptions:Fall()

    -- 停顿一段时间继续掉落
    self.map:runAction(cc.Repeat:create(cc.Sequence:create(cc.DelayTime:create(1), cc.CallFunc:create(function() self:_Fall() end)), 3))
end

function CGameEventVolcanicEruptions:_Fall()

    local h = self.map.random:RandomInt32(960, 1160)
    local y_speed = self.map.random:RandomInt32(-500, -400)
    local second = h / math.abs(y_speed)
    local x_distance = self.map.random:RandomInt32(self.map.current_section_group_config.move_speed*second, 
    (self.map.current_section_group_config.move_speed+self.map.player.config.accelerate_speed)*second + 200)

    local game_object = self.map.tmx:CreateObjectByID("fulgurite",
    self.map.player:getPositionX(),
    self.map.player:getPositionY() + h)
    if game_object then

        local component_move = game_object.component_list.move
        if component_move then
            component_move:ChgXSpeed(x_distance/second)
            component_move:ChgYSpeed(y_speed)
        end
    end
end

return game.CGameEventVolcanicEruptions

--endregion
