--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CGameGround = class("game.CGameGround", cc.Node)
local CGameGround = game.CGameGround

function CGameGround:ctor()
    self.collide_rect = nil
    self.body_rect = nil
end

function CGameGround:Init(map, config, index, tile_x, tile_y)

    -- 设置地图
    self.map = map

    -- 安装更新器
    if self.map.updater then
        self.map.updater:InstallOnNode(self)
    end

    self.tile_x = tile_x
    self.tile_y = tile_y

    -- 能力值
    self.config = config
    if self.config == nil then
        return false
    end

    self.run_drop_action = false

    -- 判断类型
    self.index = index
    if self.config.file_type == "image" then

        local file_name = nil
        if index == 0 then
            file_name = self.config.file_path.single
        else
            file_name = self.config.file_path.group[index]
        end
        if file_name then
            self.image = cc.Sprite:create(file_name)
            if self.image then
                self.image:setAnchorPoint(cc.p(0,1))
                self.image:setPosition(cc.p(0,game.CAssetGame.tile_height + 20))
                self:addChild(self.image)
            end
        end
    elseif self.config.file_type == "spine" then

        -- TODO: 
    end

    -- 监听进入离开事件
    self:registerScriptHandler(function (event)
		if event == "enter" then
		elseif event == "exit" then
		elseif event == "cleanup" then
            self:Dispose()
		end
	end)
    return true
end

function CGameGround:Dispose()
end

function CGameGround:Create(...)

    local ground = CGameGround.new()
    if ground == nil or ground:Init(...) == false then
        return nil
    end
    return ground
end

function CGameGround:Update(dt)
    self.collide_rect = nil
end

function CGameGround:OnCollide(object)

   
end

function CGameGround:CalcBodyRect()

    local rect = nil
    if self.image then
        rect = self.image:getBoundingBox()
    end
    return rect
end

function CGameGround:GetBodyRect()

    if not self.body_rect then
        self.body_rect = self:CalcBodyRect()
        if self.body_rect then
            if self.body_rect.width < 0 then
                self.body_rect.x = self.body_rect.x + self.body_rect.width
                self.body_rect.width = math.abs(self.body_rect.width)
            end
        end
    end
    return self.body_rect
end

function CGameGround:GetCollideRect()

    if not self.collide_rect then
        self.collide_rect = self:CalcCollideRect()
    end
    return self.collide_rect
end

function CGameGround:CalcCollideRect()

    local rect = clone(self:GetBodyRect())
    local x,y = self:getPosition()
    if rect then
        rect.x = rect.x + x
        rect.y = rect.y + y
    end
    return rect
end

return game.CGameGround

--endregion
