--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CGameHP = class("game.CGameHP", dxm.CUIWidget)

local CGameHP = game.CGameHP

function CGameHP:ctor()
    CGameHP.super.ctor(self)

    self.game_object = 0
    self.current_percent = 0
    self.target_percent = 0
end

function CGameHP:Init(game_object)

    if not game_object then
        return false
    end
    self.game_object = game_object
    return self:InitWithFile("csd/Game/BossHp")
end

function CGameHP:Create(...)

    local ui = CGameHP.new()
    if ui == nil or ui:Init(...) == false then
        return nil
    end
    return ui
end

function CGameHP:onEnter()
    self:UpdateHP(true)

    local component_hp = self.game_object.component_list.hp
    if component_hp then
        self.listener = component_hp.hp_changed_event:Connect(function() self:UpdateHP(false) end)
    end

    self.entry = cc.Director:getInstance():getScheduler():scheduleScriptFunc( function(dt) self:Update(dt) end, 0, false)
end

function CGameHP:onExit()

    local component_hp = self.game_object.component_list.hp
    if component_hp and self.listener then
        component_hp.hp_changed_event:Disconnect(self.listener)
        self.listener = nil
    end

    if self.entry then
        cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.entry)
        self.entry = nil
    end
end

function CGameHP:UpdateHP(ignore_action)

    local component_hp = self.game_object.component_list.hp
    if component_hp then

        self.target_percent = component_hp.hp / component_hp.max_hp
        if ignore_action then
            self.current_percent = self.target_percent
        end
    end
    self:_UpdateHP()
end

function CGameHP:Update(dt)

    if self.target_percent > self.current_percent then
        self.current_percent = self.current_percent + dt*0.3
        if self.current_percent > self.target_percent then
            self.current_percent = self.target_percent
        end
        self:_UpdateHP()
    elseif self.target_percent < self.current_percent then
        self.current_percent = self.current_percent - dt*0.3
        if self.current_percent < self.target_percent then
            self.current_percent = self.target_percent
        end
        self:_UpdateHP()
    end
end

function CGameHP:_UpdateHP()
    self:SetLoadingbarPercent(self.current_percent * 100, "LoadingBarBossHP")
end

return CGameHP

--endregion
