--region *.lua
--Date
--此文件由[BabeLua]插件自动生成
game.CGameMapRecording = class("game.CGameMapRecording")

local CGameMapRecording = game.CGameMapRecording

function CGameMapRecording:ctor()
    self.data = {}
    self.data.random_seed = 0
    self.data.command_list = {}
end

function CGameMapRecording:Init(random_seed)
    self.data = {}
    self.data.random_seed = random_seed
    self.data.command_list = {}
    return true
end

function CGameMapRecording:Create(...)
    local recording = CGameMapRecording.new()
    if recording and recording:Init(...) == true then
        return recording
    end
    return nil
end

function CGameMapRecording:PushCommand(frame, command)
    frame = tostring(frame)
    if not self.data.command_list[frame] then
        self.data.command_list[frame] = {}
    end
    local frame_command_list = self.data.command_list[frame]
    for _,frame_command in ipairs(frame_command_list) do
        if frame_command == command then
            return
        end
    end
    frame_command_list[#frame_command_list + 1] = command
    table.sort(frame_command_list, function(a,b) return a<b end)
end

function CGameMapRecording:Save(file_name)
    -- TODO: 保存到文件
    file_name = sSimpleDB:GetSavePath(file_name)
    local data_str = json.encode(self.data)
    
    dxm.CJsonUtils:Save(file_name, self.data)
end

function CGameMapRecording:SaveToString()
    local data_str = json.encode(self.data)
    local compress_data ,is_successful = sZlibUtils.Compress(data_str,"finish")
    print("compress_data",compress_data,is_successful)
    if is_successful == true then
        return compress_data
    end
    return nil   
end

function CGameMapRecording:SaveToFile(file_name)
    file_name = device.writablePath..file_name
    local ret = nil
    local s = self:SaveToString()

    if s == nil then
        return nil
    end
    if type(s) == "string" then
        if device.platform == "windows" then
            ret = sFileUtils:Write(file_name, s)
        else
            ret = sFileUtils:WriteSafe(file_name, s)
        end
    end

    return ret
end

function CGameMapRecording:LoadToFile(file_name)
    file_name = device.writablePath..file_name
    local file = sFileUtils:Read(file_name)
    if not file then
        return
    end
    local contents = file:GetString()
    self:LoadToString(contents)
end

function CGameMapRecording:LoadToString(contents)
    if type(contents) == "string" then
        local is_successful = nil
        contents, is_successful = sZlibUtils.Uncompress(contents)
        if is_successful == true then
            local values = json.decode(contents)
            if type(values) == "table" then
                self.data = values
                dump(self.data)
            end
        end
    end
end

return CGameMapRecording

--endregion
