-- region *.lua
-- Date
-- 此文件由[BabeLua]插件自动生成

game.CObjectComponentAnimation = class("game.CObjectComponentAnimation", game.CObjectComponent)

local CObjectComponentAnimation = game.CObjectComponentAnimation

function CObjectComponentAnimation:ctor()
    CObjectComponentAnimation.super.ctor(self)
    self.component_name = "animation"
    self.current_animation_status = nil
    self.current_animation = nil
    self.default_animation = nil
    self.is_runing = false
end

function CObjectComponentAnimation:Init(game_object)
    if CObjectComponentAnimation.super.Init(self, game_object) == false or not self.game_object.animation then
        return false
    end

    self.spine = self.game_object.animation
    self.animation_list = {}
    return true
end

function CObjectComponentAnimation:Create(...)
    local component = CObjectComponentAnimation.new()
    if component and component:Init(...) then
        return component
    end
    return nil
end

function CObjectComponentAnimation:Update(dt)
    CObjectComponentAnimation.super.Update(self,dt)

    if self.current_animation_status then
        local animation_entry = self.animation_list[self.current_animation_status]
        if animation_entry and animation_entry.play_function then
            animation_entry.play_function()
        end
    end
end

function CObjectComponentAnimation:SetDefaultLoopAnimation(animation_name)
    self.default_animation = animation_name
    self:PlayDefaultAnimation()
end

function CObjectComponentAnimation:PlayDefaultAnimation()
    self:Play(self.default_animation,true)
end

function CObjectComponentAnimation:Play(animation, loop, callback, event_callback)
    if self.current_animation == animation and self.current_animation_loop == loop then
        return false
    end

    if not self.spine then
        return false
    end

    if animation then

        if self.spine:setAnimation(0, animation, loop) == nil then
            return false
        end

        self.spine:setCompleteListener( function()
            if callback then
                callback()
            end
        end )
        self.spine:setEventListener(function(track_index, event_name)
            if event_callback then
                event_callback()
            end
        end)

        self.current_animation = animation
        self.current_animation_loop = loop

        self.is_runing = true
    else
        if callback then
            callback()
        end
        self.is_runing = false
    end
    return true
end

function CObjectComponentAnimation:RegisterAnimation(animation, loop, callback, event_callback)
    self.animation_list[animation] = {}
    self.animation_list[animation].play_function = function() 
        self:Play(animation, loop, callback, event_callback) 
    end
    self.animation_list[animation].is_loop = loop
end

function CObjectComponentAnimation:IsAnimationLoop(animation)
    local animation_entry = self.animation_list[animation]
    if not animation_entry then
        return false
    end
    return animation_entry.is_loop
end

function CObjectComponentAnimation:SetAnimationStatus(animation_status)
    self.current_animation_status = animation_status
end

function CObjectComponentAnimation:GetAnimationStatus()
    return self.current_animation_status
end

return CObjectComponentAnimation
-- endregion
