-- region *.lua
-- Date
-- 此文件由[BabeLua]插件自动生成

game.CObjectComponentShadow = class("game.CObjectComponentShadow")

local CObjectComponentShadow = game.CObjectComponentShadow

function CObjectComponentShadow:ctor()
    self.game_object = nil
end

function CObjectComponentShadow:Init(game_object)
    if not game_object then
        return false
    end
    self.game_object = game_object

    -- 创建影子
    if self.game_object.config.shadow_file_path then
        self.shadow = cc.Sprite:create(self.game_object.config.shadow_file_path)
        if self.shadow then
            self.shadow:setAnchorPoint(0.5,0.5)
            self.game_object.map.tmx:addChild(self.shadow, self.game_object:getZOrder()-1)
        end
    end
    return true
end

function CObjectComponentShadow:Create(...)
    local component = CObjectComponentShadow.new()
    if component and component:Init(...) then
        return component
    end
    return nil
end

function CObjectComponentShadow:Update(dt)

    -- 影子更新
    if self.shadow then

        local shadow_x = self.game_object:getPositionX()
        local shadow_y = 0

        -- 寻找object落脚地面
        local tile_x = math.floor(shadow_x / game.CAssetGame.tile_width) + 1
        local tile_y = math.floor(self.game_object:getPositionY() / game.CAssetGame.tile_height)
        if self.game_object.map.tmx.ground[tile_x] then
            for i = tile_y, 1, -1 do
                local ground = self.game_object.map.tmx.ground[tile_x][i]
                if ground then
                    shadow_y = self.game_object.map.tmx:GetGroundHeight(i)
                    break
                end
            end
        end

        --[[
        for _, platform in pairs(self.game_object.map.tmx.platform) do
            -- 判断X坐标
            if self.game_object:getPositionX() >= platform:getPositionX() and self.game_object:getPositionX() <= platform:getPositionX() + platform.image:getContentSize().width then
                if self.game_object:getPosition() >= platform:GetPlatformHeight() then
                    shadow_y = platform:GetPlatformHeight()
                    break
                end
            end
        end
        ]]--

        self.shadow:setPosition(cc.p(shadow_x, shadow_y))
        self.shadow:setVisible(shadow_y > 0)

        -- 计算缩放比例
        local shadow_distance_y = self.game_object:getPositionY() - shadow_y

        self.shadow:setScale(self.shadow:getContentSize().width /(shadow_distance_y + self.shadow:getContentSize().width))
        self.shadow:setScaleX(- self.shadow:getScaleX())
    end
end

return CObjectComponentShadow

-- endregion
