-- region *.lua
-- Date
-- 此文件由[BabeLua]插件自动生成

game.CGameObjectAttackMonster = class("game.CGameObjectAttackMonster", game.CGameObject)
local CGameObjectAttackMonster = game.CGameObjectAttackMonster

function CGameObjectAttackMonster:ctor()
    CGameObjectAttackMonster.super.ctor(self)
    self.ignore_ground = true

    self.can_attack = true
    self.attack_group = 1

    self.can_be_attacked = true
end

function CGameObjectAttackMonster:Init(map, config)

    if CGameObjectAttackMonster.super.Init(self, map, config) == false then
        return false
    end

    local move_component = self.component_list.move
    if move_component then
        move_component:ChgXSpeed(self.config.move_speed or 0)
    end

    local hp_component = self.component_list.hp
    if hp_component then
        hp_component:MoreHP(self.config.max_hp or 1)
    end

    self.ignore_gravity = self.config.ignore_gravity
    self.total_dt = 0
    return true
end

function CGameObjectAttackMonster:Dispose()
end

function CGameObjectAttackMonster:Create(...)

    local AttackMonster = CGameObjectAttackMonster.new()
    if AttackMonster == nil or AttackMonster:Init(...) == false then
        return nil
    end
    return AttackMonster
end

function CGameObjectAttackMonster:Update(dt)
    self.total_dt = self.total_dt + dt
    if self.total_dt >= self.config.attack_cd then
        self:Throw()
        self.total_dt = self.total_dt - self.config.attack_cd
    end
    return CGameObjectAttackMonster.super.Update(self, dt)
end

function CGameObjectAttackMonster:Throw()

    local count = self.map.random:RandomInt32(1, self.config.throw_count)
    for i = 1,count do

        local throw_object_id = self.config.throw_object_id
        local game_object = self.map.tmx:CreateObjectByID(throw_object_id[self.map.random:RandomInt32(1, #throw_object_id)], self:getPositionX(), self:getPositionY())
        if game_object then

            local component_move = game_object.component_list.move
            if component_move then
                component_move.x_speed = self.map.random:RandomInt32(self.config.x_throw_speed_min, self.config.x_throw_speed_max)
                component_move.y_speed = self.map.random:RandomInt32(self.config.y_throw_speed_min, self.config.y_throw_speed_max)
            end
        end
    end
end

return game.CGameObjectAttackMonster

-- endregion
