--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CGameObjectFoot = class("game.CGameObjectFoot",game.CGameObject)
local CGameObjectFoot = game.CGameObjectFoot

function CGameObjectFoot:ctor()
    CGameObjectFoot.super.ctor(self)
    self.can_attack = true
    self.attack_group = 1
end

function CGameObjectFoot:Init(map, config)
    if CGameObjectFoot.super.Init(self, map, config) == false then
        return false
    end

    self.ignore_gravity = true
    
    self.foot_status = "up"

    return true
end

function CGameObjectFoot:Create(...)
    local object = CGameObjectFoot.new()
    if object and object:Init(...) then
        return object
    end
end

function CGameObjectFoot:OnEnter()
    self.shadow_y = self:getPositionY()
    self.shadow_x = self:getPositionX()
    self:setPosition(cc.p(self:getPositionX(), self:getPositionY() + game.CGameMap.visible_size.height))
    local move_component = self.component_list.move
    if move_component then
        move_component:SetYStatus(game.CObjectComponentMove.YStatus.air)
    end
end

function CGameObjectFoot:OnExit()
    if self.shadow then
        self.shadow:removeFromParent()
    end
end

function CGameObjectFoot:Update(dt)
    if self.foot_status == "up" and self.map.player:getPositionX() + self.config.attack_distance >= self:getPositionX() then
        self.foot_status = "down"
        self:Drop()
    end

    return CGameObjectFoot.super.Update(self,dt)
end

function CGameObjectFoot:Drop()
    self.shadow = cc.Sprite:create("images/map/real_object/shadow.png")
    if self.shadow then
        self.shadow:setAnchorPoint(0, 1)
        self.map.tmx:addChild(self.shadow, 100)
        self.shadow:setScale(0.1)
    end

    self.shadow:setPosition(cc.p(self.shadow_x,self.shadow_y))

    local actions = { }
    actions[#actions + 1] = cc.ScaleTo:create(self.config.drop_time,5)
    actions[#actions + 1] = cc.CallFunc:create( function()
        self.ignore_gravity = false
        local move_component = self.component_list.move
        if move_component then
            move_component:ChgXSpeed(0)
            move_component:ChgYSpeed(self.config.move_speed)
        end
    end )
    local action = cc.Sequence:create(actions)
    self.shadow:runAction(action)
end

return CGameObjectFoot

--endregion
