--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CGameObjectHornet = class("game.CGameObjectHornet",game.CGameObject)
local CGameObjectHornet = game.CGameObjectHornet

function CGameObjectHornet:ctor()
    CGameObjectHornet.super.ctor(self)
    self.can_attack = true
    self.attack_group = 1
    self.ignore_gravity = true
end

function CGameObjectHornet:Init(map, config)
    if CGameObjectHornet.super.Init(self, map, config) == false then
        return false
    end

    self.status = "idle"
    self.fly_angle = 0
    self.total_dt = 1
    

    return true
end

function CGameObjectHornet:Create(...)
    local object = CGameObjectHornet.new()
    if object and object:Init(...) then
        return object
    end
end

function CGameObjectHornet:Update(dt)
    self.total_dt = self.total_dt + dt
    if self.total_dt >= self.config.fly_cd and self.status == "idle" then
        self.status = "fly"
        self.total_dt = self.total_dt - self.config.fly_cd
    end

    if self.status == "fly" then
        self:Fly(dt)
    end

    return CGameObjectHornet.super.Update(self,dt)
end

function CGameObjectHornet:OnEnter()
    CGameObjectHornet.super.OnEnter(self)
    --旋转点
    self.pivot = cc.p(self:getPositionX() - self.config.r,self:getPositionY())
    self.hornet = cc.Sprite:create("tmx/object/foot.png")
    if self.hornet then
        self.hornet:setPosition(cc.p(self:getPosition()))
        self.map.tmx:addChild(self.hornet)
    end
end

function CGameObjectHornet:Fly(dt)
    local rotate_angle = 360 / self.config.fly_time * dt
    self.fly_angle = self.fly_angle + rotate_angle
    if self.fly_angle >= 360 then
        self.status = "idle"
        self.fly_angle = 0
        self.total_dt = 0
        return
    end

    local pi = 3.1415926
    local position = cc.p(self.hornet:getPositionX(),self.hornet:getPositionY())
    local position = cc.pRotateByAngle(position,self.pivot,-(rotate_angle * pi / 180))
    self.hornet:setPosition(position)
end

return CGameObjectHornet

--endregion
