--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CGameObjectItem = class("game.CGameObjectItem",game.CGameObject)
local CGameObjectItem = game.CGameObjectItem

function CGameObjectItem:ctor()
    CGameObjectItem.super.ctor(self)

    self.can_be_picked_up = true

    self.zorder = 2
end

function CGameObjectItem:Init(map, object_id)
    if CGameObjectItem.super.Init(self, map, object_id) == false then
        return false
    end
    self.ignore_gravity = self.config.ignore_gravity or false
    self.ignore_ground = self.config.ignore_ground or false
    return true
end

function CGameObjectItem:Create(...)
    local item = CGameObjectItem.new()
    if item and item:Init(...) then
        return item
    end

    return nil
end

function CGameObjectItem:OnEnter()

    -- 监听空中状态变更
    local component_move = self.component_list.move
    if component_move then
        component_move.y_status_changed_event:Connect( function(y_status) self:YStatusChangedCallback(y_status) end)
    end
end

function CGameObjectItem:Effect(game_object)  
  
    -- 产生效果
    if game_object then
        -- TODO:
        if self.config.effect then
            self.config.effect(self,game_object)
        end
    end

    -- 纪录关卡获得道具
    self.map:AddItem(self.config.id)

    -- 道具已经失效
    self.is_dead = true

    -- 播放道具动画
    if self.animation then
        if not self.animation:setAnimation(0, "division", false) then
            self.is_removed = true
        else
            self.animation:setCompleteListener(function() self.is_removed = true end)
        end
    else
        self.is_removed = true
    end
end

function CGameObjectItem:YStatusChangedCallback(y_status)

    -- 着地处理
    if y_status == game.CObjectComponentMove.YStatus.ground then

        -- 重置速度
        local move_component = self.component_list.move
        if move_component then
            move_component:ChgXSpeed(0)
        end
    end    
end

return CGameObjectItem

--endregion
