--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CGameObjectMonkey = class("game.CGameObjectMonkey",game.CGameObject)
local CGameObjectMonkey = game.CGameObjectMonkey

function CGameObjectMonkey:ctor()
    CGameObjectMonkey.super.ctor(self)

    self.runaction = false

    self.can_attack = true
    self.attack_group = 1

    --self.can_be_attacked = true
end

function CGameObjectMonkey:Init(map,object_id)
    if CGameObjectMonkey.super.Init(self,map,object_id) == false then
        return false
    end

    local hp_component = self.component_list.hp
    if hp_component then
        hp_component:MoreHP(self.config.max_hp or 1)
    end

    if self.component_list.move then
        self.component_list.move.y_status_changed_event:Connect( function(y_status) self:YStatusChangedCallback(y_status) end)
    end

    self.animation:setScaleX(- self.animation:getScaleX())
    return true
end

function CGameObjectMonkey:Create(...)
    local monkey = CGameObjectMonkey.new()
    if monkey and monkey:Init(...) then
        return monkey
    end

    return nil
end

function CGameObjectMonkey:OnEnter()
    CGameObjectMonkey.super.OnEnter(self)
end

function CGameObjectMonkey:OnExit()
    CGameObjectMonkey.super.OnExit(self)
end

function CGameObjectMonkey:Update(dt)

    if CGameObjectMonkey.super.Update(self, dt) then
        return true
    end

    local move_component = self.component_list.move
    if not move_component then
        return false
    end

    if move_component.current_y_status == game.CObjectComponentMove.YStatus.ground and self.runaction == false then
        self.runaction = true
        local time = self.config.jump_cd
        local actions = {}
        actions[#actions + 1] = cc.DelayTime:create(time)
        actions[#actions + 1] = cc.CallFunc:create( function()
            
            -- 感叹号
            if not self.image_mark then
                self.image_mark = cc.Sprite:create("images/mark.png")
                if self.image_mark then
                    self:addChild(self.image_mark)

                    local body_rect = self:GetBodyRect()
                    self.image_mark:setAnchorPoint(cc.p(0.5, 0))
                    self.image_mark:setPosition(cc.p(body_rect.x+body_rect.width/2, body_rect.y+body_rect.height))
                end
            end
            if self.image_mark then
                self.image_mark:setScale(0)
                self.image_mark:setOpacity(255)
                self.image_mark:runAction(cc.Sequence:create(cc.ScaleTo:create(0.1, 1),
                cc.DelayTime:create(1),
                cc.FadeOut:create(0.1)))
            end
        end )
        actions[#actions + 1] = cc.DelayTime:create(0.5)
        actions[#actions + 1] = cc.CallFunc:create( function()
            if move_component.current_y_status == game.CObjectComponentMove.YStatus.ground then
                move_component:ChgXSpeed(self.config.move_speed)
                move_component:ChgYSpeed(self.config.jump_speed)
                self.animation:setAnimation(0, "animation", false)
                self.animation:setCompleteListener(function()
                    self.animation:clearTrack(0)
                end)
            end
            self.runaction = false

            -- 播放音效
            dxm.audio:playSound(assets.sound.config.sound.game_object_monkey_move)
        end )
        self:runAction(cc.Sequence:create(actions))
    end
    return false
end

function CGameObjectMonkey:YStatusChangedCallback(y_status)
    if y_status == game.CObjectComponentMove.YStatus.ground then
        self.component_list.move:ChgXSpeed(0)
    end
end

return CGameObjectMonkey

--endregion
