--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CGameObjectPangolin = class("game.CGameObjectPangolin",game.CGameObject)
local CGameObjectPangolin = game.CGameObjectPangolin

function CGameObjectPangolin:ctor()
    CGameObjectPangolin.super.ctor(self)

    self.ground_state = "down"

    self.can_attack = true
    self.attack_group = 1
    self.ignore_gravity = true

    --self.can_be_attacked = true
end

function CGameObjectPangolin:Init(map,object_id)
    if CGameObjectPangolin.super.Init(self,map,object_id) == false then
        return false
    end

    local hp_component = self.component_list.hp
    if hp_component then
        hp_component:MoreHP(self.config.max_hp or 1)
    end

    return true
end

function CGameObjectPangolin:Create(...)
    local pangolin = CGameObjectPangolin.new()
    if pangolin and pangolin:Init(...) then
        return pangolin
    end

    return nil
end

function CGameObjectPangolin:Update(dt)
    local ret = CGameObjectPangolin.super.Update(self,dt)

    if self.ground_state == "down" and math.abs(self.map.player:getPositionX() - self:getPositionX()) <= self.config.attack_distance then
        self.ground_state = "up"        
        self:runAction(cc.MoveBy:create(0.2,cc.p(0, game.CAssetGame.tile_height)))
    end

    return ret
end

function CGameObjectPangolin:OnEnter()
    self:setPosition(cc.p(self:getPositionX(),self:getPositionY() - game.CAssetGame.tile_height))
    
    local time = self.config.move_distance / self.config.move_speed

    local actions = {}
    actions[#actions + 1] = cc.MoveBy:create(time,cc.p(-self.config.move_distance,0))
    actions[#actions + 1] = cc.CallFunc:create(function() self:setScale(-1) end)
    actions[#actions + 1] = cc.MoveBy:create(time,cc.p(self.config.move_distance,0))
    actions[#actions + 1] = cc.CallFunc:create(function() self:setScale(1) end)
    self:runAction(cc.RepeatForever:create(cc.Sequence:create(actions)))
end

return CGameObjectPangolin

--endregion
