--region *.lua
--Date
--ļ[BabeLua]Զ

game.CGameObjectPlatform = class("game.CGameObjectPlatform",game.CGameObject)
local CGameObjectPlatform = game.CGameObjectPlatform

function CGameObjectPlatform:ctor()
    CGameObjectPlatform.super.ctor(self)

    self.ignore_gravity = true
    self.is_platform = true
end

function CGameObjectPlatform:Init(map,object_id)
    if CGameObjectPlatform.super.Init(self,map,object_id) == false then
        return false
    end

    -- ƶ
    local move_component = self.component_list.move
    if move_component then
        move_component:ChgXSpeed(self.config.x_move_speed or 0)
        move_component:ChgYSpeed(self.config.y_move_speed or 0)
    end

    return true
end

function CGameObjectPlatform:Create(...)
    local crow = CGameObjectPlatform.new()
    if crow and crow:Init(...) then
        return crow
    end

    return nil
end

function CGameObjectPlatform:Update(dt)
    local ret = CGameObjectPlatform.super.Update(self, dt)
    return ret
end

function CGameObjectPlatform:GetPlatformHeight()
    return self:getPositionY() + self:GetCollideRect().height - 40
end

function CGameObjectPlatform:OnEnter()
    CGameObjectPlatform.super.OnEnter(self)

    self.map.tmx:AddPlatform(self)
end
  

function CGameObjectPlatform:Dispose()
    CGameObjectPlatform.super.Dispose(self)
    self.map.tmx:RemovePlatform(self)
end

return CGameObjectPlatform

--endregion
