--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CGameObjectRunner = class("game.CGameObjectRunner", game.CGameObject)
local CGameObjectRunner = game.CGameObjectRunner

CGameObjectRunner.Status = {
    idle = 1,
    prepare = 2,
    rush = 3,
    run = 4,
    dead = 5,
}

function CGameObjectRunner:ctor()
    CGameObjectRunner.super.ctor(self)
end

function CGameObjectRunner:Init(map, config)
    if CGameObjectRunner.super.Init(self,map,config) == false then
        return false
    end

    -- 默认状态
    self.status = CGameObjectRunner.Status.idle

    -- 动作时间
    self.total_dt = 0

    return true
end

function CGameObjectRunner:Dispose()
end

function CGameObjectRunner:Create(...)

    local runner = CGameObjectRunner.new()
    if runner == nil or runner:Init(...) == false then
        return nil
    end
    return runner
end

function CGameObjectRunner:Update(dt)

    if self.status == CGameObjectRunner.Status.idle then

        self.total_dt = self.total_dt + dt
        if self.total_dt >= 0.5 then
            self.status = CGameObjectRunner.Status.prepare
            self.total_dt = 0
        end
    end
    
    if self.status == CGameObjectRunner.Status.prepare then
        self.status = CGameObjectRunner.Status.rush
    end

    if self.status == CGameObjectRunner.Status.rush then
        self.status = CGameObjectRunner.Status.run
    end

    if self.status == CGameObjectRunner.Status.run then

        local move_component = self.component_list.move
        if move_component then

            local distance = self.map.player:getPositionX() - self:getPositionX()
            if distance < -500 then
                move_component:ChgXSpeed(self.map.current_section_group_config.move_speed/2)
                self.status = CGameObjectRunner.Status.idle
                self.total_dt = 0
            elseif distance > 500 then
                move_component:ChgXSpeed(self.map.current_section_group_config.move_speed + self.map.player.config.accelerate_speed)
                self.status = CGameObjectRunner.Status.idle
                self.total_dt = 0
            else
                move_component:ChgXSpeed(self.map.current_section_group_config.move_speed)
            end
        end
    end

    return CGameObjectRunner.super.Update(self, dt)
end

function CGameObjectRunner:Rest()

    local move_component = self.component_list.move
    if move_component then
        move_component:ChgXSpeed(self.map.current_section_group_config.move_speed/2)
    end
    self.status = CGameObjectRunner.Status.idle
end

function CGameObjectRunner:Die()
    self.status = CGameObjectRunner.Status.dead

    local component_move = self.component_list.move
    if component_move then
        component_move.x_speed = 0
    end

    if self.image then
        self.image:stopAllActions()
        self.image:setColor(cc.c3b(50,50,50))
    end
end

return game.CGameObjectRunner

--endregion
