--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CGameObjectSnake = class("game.CGameObjectSnake",game.CGameObject)
local CGameObjectSnake = game.CGameObjectSnake

function CGameObjectSnake:ctor()
    CGameObjectSnake.super.ctor(self)
    self.total_dt = 0
    self.last_throw_dt = 0

    --self.can_be_attacked = true
end

function CGameObjectSnake:Init(map,config)
    if CGameObjectSnake.super.Init(self,map,config) == false then
        return false
    end
    
    local hp_component = self.component_list.hp
    if hp_component then
        hp_component:MoreHP(self.config.max_hp or 1)
    end
    
    return true
end

function CGameObjectSnake:Create(...)
    local object = CGameObjectSnake.new()

    if object and object:Init(...) then
        return object
    end
end

function CGameObjectSnake:Update(dt)
    self.total_dt = self.total_dt + dt
    if  self.total_dt - self.last_throw_dt >= self.config.attack_cd then
        self.last_throw_dt = self.total_dt
        self:Throw()
    end
end

function CGameObjectSnake:OnEnter()
    CGameObjectSnake.super.OnEnter(self)
end

function CGameObjectSnake:OnExit()
    CGameObjectSnake.super.OnExit(self)
end

function CGameObjectSnake:Throw()
    -- 扔火堆
    local count = self.map.random:RandomInt32(1,self.config.throw_count)
    for i=1,count do

        local throw_object_id = self.config.throw_object_id
        local game_object = self.map.tmx:CreateObjectByID(throw_object_id[self.map.random:RandomInt32(1,#throw_object_id)], self:getPositionX(), self:getPositionY()+100)
        if game_object then

            local component_move = game_object.component_list.move
            if component_move then
                component_move.x_speed = self.map.random:RandomInt32(self.config.x_throw_speed_min,self.config.x_throw_speed_max)
                component_move.y_speed = self.map.random:RandomInt32(self.config.y_throw_speed_min,self.config.y_throw_speed_max)
            end
        end
    end
end

return CGameObjectSnake

--endregion
