--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CGameObjectSpider = class("game.CGameObjectSpider",game.CGameObject)
local CGameObjectSpider = game.CGameObjectSpider

function CGameObjectSpider:ctor()
    CGameObjectSpider.super.ctor(self)

    self.last_move_time = nil

    self.ignore_gravity = true
    self.ignore_ground = true

    self.can_attack = true
    self.attack_group = 1

    --self.can_be_attacked = true
end

function CGameObjectSpider:Init(map,config)
    if CGameObjectSpider.super.Init(self,map,config) == false then
        return false
    end
    self.ground_state = "up"

    local hp_component = self.component_list.hp
    if hp_component then
        hp_component:MoreHP(self.config.max_hp or 1)
    end

    return true
end

function CGameObjectSpider:Create(...)
    local spider = CGameObjectSpider.new()
    if spider and spider:Init(...) then
        return spider
    end

    return nil
end

function CGameObjectSpider:Update(dt)

    if CGameObjectSpider.super.Update(self,dt) then
        return true
    end

    if self.ground_state == "up" and math.abs(self.map.player:getPositionX() - self:getPositionX()) <= self.config.attack_distance then
        self.ground_state = "down"        
        self:runAction(cc.MoveBy:create(self.config.move_distance / self.config.move_speed, cc.p(0, -self.config.move_distance)))

        -- 播放音效
        dxm.audio:playSound(assets.sound.config.sound.game_object_spider_move)
    end
    return false
end

function CGameObjectSpider:OnEnter()
end

return CGameObjectSpider

--endregion
