-- region *.lua
-- Date
-- 此文件由[BabeLua]插件自动生成

game.CGameRankMeterUI = class("game.CGameRankMeterUI", dxm.CBaseUI)


local CGameRankMeterUI = game.CGameRankMeterUI

function CGameRankMeterUI:ctor()
    CGameRankMeterUI.super.ctor(self)
end

function CGameRankMeterUI:Init(widget, game_rank, total_meter, show_others)
    
    self:set_widget(widget)
    self.game_rank = game_rank
    self.total_meter = total_meter
    self.show_others = show_others
    return true
end

function CGameRankMeterUI:Create(...)
    local ui = CGameRankMeterUI.new()
    if ui and ui:Init(...) then
        return ui
    end
end

function CGameRankMeterUI:onEnter()

    self:Refresh()
    
    self:ScheduleUpdate(function() 
        self:Refresh()
    end)
end

function CGameRankMeterUI:onExit()
    
end

function CGameRankMeterUI:Refresh()

    local loadingbar = self:GetWidget("LoadingGameSchedule")
    local x, _ = loadingbar:getPosition()
    local size = loadingbar:getContentSize()

    local left = x - size.width/2
    local right = x + size.width/2

    local rank_players = self.game_rank:GetList()
    for _, rank_player in pairs(rank_players) do

        local widget = self:GetWidget("PanelPlayer"..rank_player.pos)
        if not widget then
            break
        end

        -- 判断是否需要显示
        local is_visible = true
        if rank_player.pos ~= 1 then
            is_visible = self.show_others
        end
        widget:setVisible(is_visible)

        -- 显示才需要有新的逻辑支持
        if is_visible then

            self:SetImageViewPicture(sPathHelper:GetPlayerIconPath(rank_player.head_icon), widget, "ImageHeadPortrait")

            local delta_width = math.ceil(rank_player.meter/self.total_meter * size.width)
            local widget_x = left + delta_width
            local _, widget_y = widget:getPosition()
            widget:setPosition(cc.p(widget_x, widget_y))
        end
    end
end

return CGameRankMeterUI
-- endregion
