-- region *.lua
-- Date
-- 此文件由[BabeLua]插件自动生成

game.CGameRankUI = class("game.CGameRankUI", dxm.CBaseUI)


local CGameRankUI = game.CGameRankUI

function CGameRankUI:ctor()
    CGameRankUI.super.ctor(self)
end

function CGameRankUI:Init(widget, game_rank)
    
    self:set_widget(widget)
    self.game_rank = game_rank
    return true
end

function CGameRankUI:Create(...)
    local ui = CGameRankUI.new()
    if ui and ui:Init(...) then
        return ui
    end
end

function CGameRankUI:onEnter()

    self:Refresh()
    
    local total_dt = 0
    self:ScheduleUpdate(function(dt) 
        total_dt = total_dt + dt
        if total_dt >= 1 then
            total_dt = total_dt - 1
            self:Refresh()
        end
    end)
end

function CGameRankUI:onExit()
    
end

function CGameRankUI:Refresh()

    local rank_players = self.game_rank:GetList()
    local pos = 1
    for _, rank_player in pairs(rank_players) do

        local widget = self:GetWidget("PanelRank"..pos)
        if not widget then
            break
        end

        self:SetLabelText(rank_player.name, widget, "TextPlayerName")
        self:SetLabelText(math.floor(rank_player.score), widget, "TextFraction")

        local label1 = self:GetWidget(widget, "TextPlayerName")
        local label2 = self:GetWidget(widget, "TextFraction")
        if rank_player.is_self then
            label1:setColor(cc.c3b(0,255,0))
            label2:setColor(cc.c3b(0,255,0))
        else
            label1:setColor(cc.c3b(255,255,255))
            label2:setColor(cc.c3b(255,255,255))
        end

        pos = pos + 1
    end
end

return CGameRankUI
-- endregion
