--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

require "app.views.game.game_section.game_section_list"

game.CGameSectionStaticList = class("game.CGameSectionStaticList", game.CGameSectionList)
local CGameSectionStaticList = game.CGameSectionStaticList

function CGameSectionStaticList:ctor()
    CGameSectionStaticList.super.ctor(self)

    self.section_config_list = nil
    self.current_section_id = 0
end

function CGameSectionStaticList:Init(map, section_config_list)
    if #section_config_list <= 0 then
        return false
    end

    self.section_config_list = section_config_list

    CGameSectionStaticList.super.Init(self, map)
    return true
end

function CGameSectionStaticList:Create(...)

    local section_list = CGameSectionStaticList.new()
    if section_list and section_list:Init(...) then
        return section_list
    end
    return nil
end

function CGameSectionStaticList:GetNextSectionConfig(is_loop)
    self.current_section_id = self.current_section_id + 1
    if self.current_section_id > #self.section_config_list then

        if is_loop then
            self.current_section_id = 1
        else
            return nil
        end
    end
    return self.section_config_list[self.current_section_id]
end

function CGameSectionStaticList:GetMeter()

    local distance = 0
    local has_start = false
    for i=1,#self.section_config_list do

        local section_config = self.section_config_list[i]
        if section_config then
            
            local tmx_config = require("app.views.game.tmx_cache"):Add(section_config.tmx_file)
            if tmx_config then

                if not has_start and tmx_config.start_pos then
                    has_start = true
                    distance = -tmx_config.start_pos.x
                end 
                
                if has_start then
                    if tmx_config.end_pos then
                        distance = distance + tmx_config.end_pos.x
                        break
                    else
                        distance = distance + tmx_config.width * game.CAssetGame.tile_width
                    end
                end
            end
        end
    end

    local meter = (distance / game.CAssetGame.m_to_pixel)
    return meter
end

return CGameSectionStaticList

--endregion
