--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CReplayUI = class("game.CReplayUI", dxm.CStackUI)

local CReplayUI = game.CReplayUI

function CReplayUI:ctor()
    CReplayUI.super.ctor(self)

    self.map = nil
    self.keyboard_listener = nil
end

function CReplayUI:Init(recording, callback)
    self.recording = recording
    self.callback = callback

    return self:InitWithFile("csd/Game/Replay")
end

function CReplayUI:Create(...)

    local ui = CReplayUI.new()
    if ui == nil or ui:Init(...) == false then
        return nil
    end
    return ui
end

function CReplayUI:onEnter()

    -- 监听按钮
    self:AddReleaseEvent(function()  

        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)  
        if self.callback then
            self.callback()
        end
        -- self:Restart()
    end, "ButtonExit")
    
    -- 开始游戏
    self:Start()

    -- 监听总的更新体系
    self.entry = cc.Director:getInstance():getScheduler():scheduleScriptFunc(function(dt) self:Update(dt) end, 0, false)
end

function CReplayUI:onExit()

    if self.map then
        self.map:removeFromParent()
        self.map = nil
    end

    if self.entry then
        cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.entry)
        self.entry = nil
    end
end

function CReplayUI:Update(dt)
    self:UpdateHP()
end

function CReplayUI:UpdateHP()
    self:SetLoadingbarPercent(self.map.player.component_list.hp.hp / self.map.player.component_list.hp.max_hp * 100, "LoadingBarHP")
end

function CReplayUI:Restart()

    if self.map then
        self.map:removeFromParent()
        self.map = nil
    end

    self:Start()
end

function CReplayUI:Start()

    local panel_map = self:GetWidget("PanelMap")
    if panel_map then
        self.map = require("app.views.game.game_map"):CreateWithRecording(self.recording)

        if self.map then
            self.map.gameover_callback = function(is_win) 
                sUI:Open("dxm.ui.prefab.message_box_ok_ui", "ReplayOver", function() 
                    
                    if self.recording then
                        self.recording:SaveToFile("recording")
                    end

                    if self.callback then
                        self.callback()
                    end
                    -- self:Restart()
                end)
            end
            panel_map:addChild(self.map)
        end
    end
end

return CReplayUI

--endregion
