--region *.lua
--Date
--此文件由[BabeLua]插件自动生成


game.CGameStoryUI = class("game.CGameStoryUI", dxm.CDialogUI)

local CGameStoryUI = game.CGameStoryUI

local action_play_end = 0
local action_play_icon = 1
local action_play_context = 2

--[[
sUI:Open("app.views.game_story.game_story_ui", 1,
        function()
        end)
]]--

function CGameStoryUI:ctor()
    CGameStoryUI.super.ctor(self)

    self.action_play_state = action_play_end
    self.pos = 0

    self.icon_widget = 0
    self.text_widget = 0
    self.icon_widget_pos = 0
end

function CGameStoryUI:Init(story_id, callback)
    if self:InitWithFile("csd/Guide/GuidePlot") == false then
        return false
    end

    self.story_string_id_array = assets.story:GetStory(story_id)
    self.callback = callback
    return true
end

function CGameStoryUI:Create(...)

    local ui = CGameStoryUI.new()
    if ui == nil or ui:Init(...) == false then
        return nil
    end
    return ui
end

function CGameStoryUI:onEnter()

    self:AddReleaseEvent( function(sender)
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)  
        self:Click()
    end ,
    "Panel_5")

    self:SetWidgetVisible(false, "PanelRight")
    self:SetWidgetVisible(false, "PanelLeft")

    local widget = self:GetWidget("PanelLeft", "ImagePhoto")
    if widget then
        self.left_icon_pos = cc.p(widget:getPosition())
    end

    widget = self:GetWidget("PanelRight", "ImagePhoto")
    if widget then
        self.right_icon_pos = cc.p(widget:getPosition())
    end

    self.next_widget = self:GetWidget("TextNext")

    self:Next()
end

function CGameStoryUI:onExit()
    local widget = self:GetWidget("PanelLeft", "ImagePhoto")
    if widget then
        widget:setPosition(self.left_icon_pos)
    end

    widget = self:GetWidget("PanelRight", "ImagePhoto")
    if widget then
        widget:setPosition(self.right_icon_pos)
    end

    if self.animation ~= nil then
        self.animation:removeFromParent()
        self.animation = nil
    end
end

function CGameStoryUI:Click()
    if self.action_play_state == action_play_end then
        self:Next()
    elseif self.action_play_state == action_play_icon then
        self:Next()
    elseif self.action_play_state == action_play_context then  
        self:ShowContext(true)
    end
end

function CGameStoryUI:Next()

    if self.action_play_state == action_play_end then
        self:ShowIcon()
    elseif self.action_play_state == action_play_icon then
        self:ShowContext()
    elseif self.action_play_state == action_play_context then  
        self:ShowContext()
    end
    
    --[[
    if self.playing then        
        self.playing = false
    else
        self.playing = true
    end
    ]]-- 
end

function CGameStoryUI:ShowIcon()

    self.pos = self.pos + 1
    local entry = assets.story:GetEntry(self.story_string_id_array[self.pos])
    if not entry then
        print("ShowIconX")
        if self.callback  then self.callback () end
        self:Close()
        return
    end

    local left = entry.Location == "left"
    self:SetWidgetVisible(not left, "PanelRight")
    self:SetWidgetVisible(left, "PanelLeft")
    self:ShowNextButton(false)

    if left then
        self.icon_widget = self:GetWidget("PanelLeft", "ImagePhoto")
        self.text_widget = self:GetWidget("PanelLeft", "TextInformation")
        self.icon_widget_pos = self.left_icon_pos
        self.icon_widget:setPosition(self.icon_widget_pos.x-200, self.icon_widget_pos.y)
    else
        self.icon_widget = self:GetWidget("PanelRight", "ImagePhoto")
        self.text_widget = self:GetWidget("PanelRight", "TextInformation")
        self.icon_widget_pos = self.right_icon_pos
        self.icon_widget:setPosition(self.icon_widget_pos.x+200, self.icon_widget_pos.y)
    end

    self.story_string = sStrings:GetString(entry.Context)
    self.story_string_show_length = 1

    if self.animation ~= nil then
        self.animation:removeFromParent()
        self.animation = nil
    end

    self.animation = spine.CSpineHelper:GetInstancePtr():CreateNodeSkeletonAnimation(entry.SpinePath..".json", entry.SpinePath..".atlas", true)
    if self.animation ~= nil then
        self.icon_widget:addChild(self.animation)
        self.animation:setAnimation(0, "idle2", true)
        self.animation:update(0)
        self.icon_widget:setContentSize(self.animation:getContentSize())
    end
    self.icon_widget:setOpacity(0)
    self.text_widget:setOpacity(0)
    --self.icon_widget:loadTexture(entry.ImagePath)
    --self.icon_widget:setContentSize(self.icon_widget:getVirtualRenderer():getContentSize())

    local actions = {}
    actions[#actions+1] = cc.Spawn:create(cc.FadeIn:create(0.5), cc.MoveTo:create(0.5, self.icon_widget_pos))
    actions[#actions+1] = cc.CallFunc:create(function() self:Next() end)
    self.icon_widget:runAction(cc.Sequence:create(actions))

    self.action_play_state = action_play_icon
end

function CGameStoryUI:ShowContext(click)

    local entry = assets.story:GetEntry(self.story_string_id_array[self.pos])
    self.icon_widget:setPosition(self.icon_widget_pos)
    self.icon_widget:setOpacity(255)
    self.icon_widget:stopAllActions()
    self.text_widget:setOpacity(255)

    local length = dxm.UTF8:length(self.story_string)
    self.story_string_show_length = self.story_string_show_length+1
    if click or self.story_string_show_length >= length then
        self.text_widget:stopAllActions()
        self.story_string_show_length = length
        self.text_widget:setString(self.story_string)    
        self:ShowNextButton(true)

        self.action_play_state = action_play_end
    else
        local story_string = dxm.UTF8:sub(self.story_string, 1, self.story_string_show_length)
        self.text_widget:setString(story_string)

        local actions = {}
        actions[#actions+1] = cc.DelayTime:create(0.03)
        actions[#actions+1] = cc.CallFunc:create(function() self:Next() end)
        self.text_widget:runAction(cc.Sequence:create(actions))
        self.action_play_state = action_play_context
    end
end

function CGameStoryUI:ShowNextButton(show)

    if self.next_widget then
        self.next_widget:stopAllActions()
        self.next_widget:setVisible(show)
        if show then
            self.next_widget:setOpacity(0)
            self.next_widget:runAction(cc.FadeIn:create(0.5))
        end
    end
end
return CGameStoryUI

--endregion
