--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CHeartAnimationUI = class("game.CHeartAnimationUI",dxm.CNoticeUI)

local CHeartAnimationUI = game.CHeartAnimationUI

function CHeartAnimationUI:ctor()
    CHeartAnimationUI.super.ctor(self)
end

function CHeartAnimationUI:Init(move_pos,callback)
    self:InitWithFile("csd/Main/MainFunctionTop")
    self.move_pos = move_pos
    self.callback = callback
    return true
end

function CHeartAnimationUI:Create(move_pos,callback)
    local ui = CHeartAnimationUI.new()
    if ui == nil or ui:Init(move_pos,callback) == false then
        return nil
    end
    
    return ui
end

function CHeartAnimationUI:Show(move_pos,callback)
    local ui = self:Create(move_pos,callback)
    if ui then dxm.CUIManager:GetInstancePtr():OpenUI(ui,dxm.UIOrder.kUIOrderNotice) end
end

function CHeartAnimationUI:onEnter()
    self:SetWidgetVisible(false,"PanelTopLayer")
    local target_widget = self:GetWidget("ImageTL","ImageIcon1")
    local x,y = target_widget:getPositionX(),target_widget:getPositionY()
    local move_to_world_pos = target_widget:convertToWorldSpace(cc.p(x,y))
    
    local spine = sSpineUtils:CreateWidgetAnimation("spine/main_menu/supplement_heart", true)
    if spine then
        local visible_rect = dxm.VisibleRect
        local center = visible_rect:center()
        local widget = self:GetWidget("Panel_5")
        local spine_pos = widget:convertToNodeSpace(center)
        local move_to_pos = widget:convertToNodeSpace(self.move_pos or move_to_world_pos)
        if widget then 
            widget:addChild(spine)
        end
        spine:setPosition(spine_pos)
        spine:setAnimation(0,"appear",false)
        spine:setCompleteListener(function(trackIndex, loopCount)
            spine:setAnimation(0,"disappear",false)
            spine:setCompleteListener(function()
            end)
            local action = cc.Sequence:create(
                cc.MoveTo:create(0.45,move_to_pos),
                cc.CallFunc:create(function()
                    local ui = sShortcutHelper:GetTop()
                    if ui then
                        ui:PlayHeartShake()
                    end
                    spine:removeFromParent()
                    self:Close()
                    if self.callback then
                        self.callback()
                    end
                end)
            )
            spine:runAction(action)
        end)
    end
end


function CHeartAnimationUI:onExit()
    self:SetWidgetVisible(true, "PanelTopLayer")
end

return CHeartAnimationUI

--endregion
