--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CFriendAddCellUI = class("game.CFriendAddCellUI",dxm.CBaseUI)

local CFriendAddCellUI = game.CFriendAddCellUI

function CFriendAddCellUI:ctor()
    CFriendAddCellUI.super.ctor(self)

    self.friend = nil
    self.is_added = false
end

function CFriendAddCellUI:Init(friend)
    if self:InitWithFile("csd/Friends/FriendsStrip") == false then
        return false
    end
    self.friend = friend
    sPlayer.player_modules.friend:FillFriendInfo(self.friend)

    -- 判断该角色是否已经发送过申请
    self.is_added = (sFriendSystem:GetFriend(self.friend.user_id) ~= nil)
    return true
end

function CFriendAddCellUI:Create(...)
    local ui = CFriendAddCellUI.new()
    if ui and ui:Init(...) then
        return ui
    end
    return nil
end

function CFriendAddCellUI:onEnter()

    -- 显示角色头像
    local icon_path = nil
    if self.friend.user_info then 
        self.friend.user_info.head_icon=tonumber(self.friend.user_info.head_icon) 
    end
    self:SetImageViewPicture(sPathHelper:GetPlayerIconPath(self.friend.user_info.head_icon), "ImageHeadPortrait")

    -- 全条目点击
    self:AddReleaseEvent(function()
        dxm.audio:playSound(assets.sound.config.sound.ui_button_release)
        sUI:Open("app.views.ui.friend.friend_info_ui", self.friend)
    end)

    -- 显示名称
    self:SetLabelText(self.friend.user_name or "ID:"..(tonumber(self.friend.user_id)+assets.const.min_user_id), "TextPlayerName")

    -- 显示关卡
    local stage_id = "?"
    local child_stage_id = "?"
    if self.friend.user_info ~= nil then
        local value = tonumber(self.friend.user_info.completed_stage_id) or 0
        stage_id = math.floor(value / 100)
        child_stage_id = value % 100
    end
    self:SetLabelText(stage_id.."-"..child_stage_id, "TextCheckpoint")

    -- 显示星数
    local star_count = "?"
    if self.friend.user_info ~= nil then
        star_count = self.friend.user_info.star_count or 0
    end
    self:SetLabelText(star_count, "TextHaveStar")

    -- 添加好友
    self:AddReleaseEvent(function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
        sFriendSystem:RequestAddFriendQuickly(self.friend, true, function(error_code) 
            dxm.CMessageTipUI:Show(sStrings:GetString("add_friend_error_"..sFriendSystem.ErrorCode[error_code]), 35)
        end)
    end,"ButtonFriends")

    -- 刷新选择按钮的内容
    self:SetWidgetTouchEnable(false, "CheckBox")
    self:SetWidgetVisible(false, "CheckBox")

    -- 调整按钮状态
    self:UpdateButton()

    -- 自动更新
    self.update_entry = cc.Director:getInstance():getScheduler():scheduleScriptFunc( function(dt) self:Update(dt) end, 0, false)
end

function CFriendAddCellUI:onExit()

    -- 取消自我更新
    cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.update_entry)
end

function CFriendAddCellUI:Update(dt)

    local is_added = (sFriendSystem:GetFriend(self.friend.user_id) ~= nil)
    if is_added ~= self.is_added then
        self.is_added = is_added
        self:UpdateButton()
    end
end

function CFriendAddCellUI:UpdateButton()
    self:SetWidgetEnableAndVisible(not self.is_added, "ButtonFriends")
    self:SetWidgetEnableAndVisible(self.is_added, "ImageTag")
end

return CFriendAddCellUI

--endregion
