--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CFriendAddLocationUI = class("game.CFriendAddLocationUI", dxm.CBaseUI)

local CFriendAddLocationUI = game.CFriendAddLocationUI

function CFriendAddLocationUI:ctor()
    CFriendAddLocationUI.super.ctor(self)

    self.scrollview = nil
    self.player_nearby = {}
    self.refresh_time = nil
end

function CFriendAddLocationUI:Init(widget)
    return self:InitWithWidget(widget)
end

function CFriendAddLocationUI:Create(...)
    local ui = CFriendAddLocationUI.new()
    if ui and ui:Init(...) then
        return ui
    end
    return nil
end

function CFriendAddLocationUI:onEnter()

    -- 换一批推荐按钮
    self:AddReleaseEvent(function()
        dxm.audio:playSound(assets.sound.config.sound.ui_button_release)
        self:Refresh()
    end,"ButtonChange")
    self:SetWidgetEnableAndVisible(true, "ButtonChange")

    -- 滚动层
    self.scroll_view = dxm.CScrollViewUI:Create(self:GetWidget("ScrollView"))
    if self.scroll_view ~= nil then
        self:AddChild(self.scroll_view)
        self.scroll_view.fix_tail = 380
    end

    -- 全部添加
    self:AddReleaseEvent(function()
        dxm.audio:playSound(assets.sound.config.sound.ui_button_release)
        self:AddAll()
    end,"ButtonAddAll")

    self:AddReleaseEvent(function(sender)
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)   
        self:Close()
    end,
    "ButtonReturn") 

    self:SetWidgetEnableAndVisible(false,"ButtonAddAll")

    -- 自动刷新一次身边的人
    self:Refresh()

    -- 自更新开启
    self:ScheduleUpdate(function(dt) self:Update(dt) end)
end

function CFriendAddLocationUI:onExit()

    if self.scroll_view ~= nil then
        self.scroll_view:RemoveFromParent()
        self.scroll_view = nil
    end

end

function CFriendAddLocationUI:UpdateScrollview()

    if self.scroll_view ~= nil then
        self.scroll_view:RemoveAllCells()

        -- 填充附近的好友到滚动层中
        for _,friend in ipairs(self.player_nearby) do
            local friend_cell_ui = require("app.views.ui.friend.friend_add_cell_ui"):Create(friend)
            if friend_cell_ui ~= nil then
                self.scroll_view:AddCell(friend_cell_ui)
            end
        end

        self.scroll_view:InitPosition()
    end
end

function CFriendAddLocationUI:Refresh()

    self.refresh_time = os.time()

    sHttpUser:SearchPlayersNearBy(0, 20, 10, function(code,data) 

        if code ~= 0 then
            return
        end

        self.player_nearby = {}
        for _, t_player in pairs(data.users_nearby) do
            player.player_modules.friend:FillFriendInfo(t_player)
            self.player_nearby[#self.player_nearby+1] = t_player
        end
        self:UpdateScrollview()

        -- 判断是否显示添加全部的按钮
        self:SetWidgetEnableAndVisible(#self.player_nearby > 0,"ButtonAddAll")
    end)
end

function CFriendAddLocationUI:AddAll()

    for _,value in pairs(self.player_nearby) do
        sFriendSystem:RequestAddFriendQuickly(value, true, nil)
    end
    dxm.CMessageTipUI:Show(sStrings:GetString("add_friend_error_ok"), 35)
end

function CFriendAddLocationUI:Update(dt)
    self:SetWidgetEnableAndVisible(self.refresh_time == nil or os.time() - self.refresh_time >= 5, "ButtonChange")
end

return CFriendAddLocationUI

--endregion
