--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CFriendAddRecommenderUI = class("game.CFriendAddRecommenderUI", dxm.CBaseUI)

local CFriendAddRecommenderUI = game.CFriendAddRecommenderUI

function CFriendAddRecommenderUI:ctor()
    CFriendAddRecommenderUI.super.ctor(self)

    self.scrollview = nil
    self.player_recommender = {}
    self.refresh_time = nil
end

function CFriendAddRecommenderUI:Init(widget)
    return self:InitWithWidget(widget)
end

function CFriendAddRecommenderUI:Create(...)
    local ui = CFriendAddRecommenderUI.new()
    if ui and ui:Init(...) then
        return ui
    end
    return nil
end

function CFriendAddRecommenderUI:onEnter()

    -- 换一批推荐按钮
    self:AddReleaseEvent(function()
        dxm.audio:playSound(assets.sound.config.sound.ui_button_release)
        self:Refresh()
    end,"ButtonChange")

    -- 滚动层
    self.scroll_view = dxm.CScrollViewUI:Create(self:GetWidget("ScrollView"))
    if self.scroll_view ~= nil then
        self:AddChild(self.scroll_view)
        self.scroll_view.fix_tail = 380
    end

    self:AddReleaseEvent(function(sender)
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)   
        self:Close()
    end,
    "ButtonReturn") 

    -- 全部添加
    self:AddReleaseEvent(function()
        dxm.audio:playSound(assets.sound.config.sound.ui_button_release)
        self:AddAll()
    end,"ButtonAddAll")
    self:SetWidgetEnableAndVisible(false,"ButtonAddAll")

    -- 刷新内容
    self:Refresh()

    -- 自更新开启
    self:ScheduleUpdate(function(dt) self:Update(dt) end)
end

function CFriendAddRecommenderUI:onExit()

end

function CFriendAddRecommenderUI:Update(dt)
    self:SetWidgetEnableAndVisible(self.refresh_time == nil or os.time() - self.refresh_time >= 5, "ButtonChange")
end

function CFriendAddRecommenderUI:UpdateScrollview()

    if self.scroll_view ~= nil then
        self.scroll_view:RemoveAllCells()

        for _,friend in ipairs(self.player_recommender) do
            local friend_cell_ui = require("app.views.ui.friend.friend_add_cell_ui"):Create(friend)
            if friend_cell_ui ~= nil then
                self.scroll_view:AddCell(friend_cell_ui)
            end
        end

        self.scroll_view:InitPosition()
    end
end

function CFriendAddRecommenderUI:AddAll()

    for _,value in ipairs(self.player_recommender) do
        sFriendSystem:RequestAddFriendQuickly(value, true, nil)
    end
    dxm.CMessageTipUI:Show(sStrings:GetString("add_friend_error_ok"), 35)
end

function CFriendAddRecommenderUI:Refresh()

    self.refresh_time = os.time()

    -- 获取排行榜并获得附近的人
    local rank_name = "stage"
    sHttpUser:RequestGetRankInfo(rank_name, 0, function(code, data) 

        if code==0 then 

            -- 合并一些可利用的角色排行榜资源
            local player_recommender = {}
            if sHttpUser.user_rank_top[rank_name] ~= nil then
                for _,value in pairs(sHttpUser.user_rank_top[rank_name]) do 
                    player_recommender[value.user_id] = value
                end
            end
            if sHttpUser.user_rank_large_me[rank_name] ~= nil then
                for _,value in pairs(sHttpUser.user_rank_large_me[rank_name]) do 
                    player_recommender[value.user_id] = value
                end
            end
            if sHttpUser.user_rank_less_me[rank_name] ~= nil then
                for _,value in pairs(sHttpUser.user_rank_less_me[rank_name]) do 
                    player_recommender[value.user_id] = value
                end
            end

            -- 进行重新的整理排序
            local new_player_recommender = {}
            for _,value in pairs(player_recommender) do
                new_player_recommender[#new_player_recommender+1] = value
                value.random_number = math.random()
            end
            table.sort(new_player_recommender, function(a,b) return a.random_number < b.random_number end)

            --  取前10位的角色
            self.player_recommender = {}
            for _,value in ipairs(new_player_recommender) do
                self.player_recommender[#self.player_recommender+1] = value
                if #self.player_recommender >= 10 then
                    break
                end
            end

            -- 判断是否显示添加全部的按钮
            self:SetWidgetEnableAndVisible(#self.player_recommender > 0,"ButtonAddAll")
        end
        self:UpdateScrollview()
    end)
end

return CFriendAddRecommenderUI

--endregion
