--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CFriendAddUI = class("game.CFriendAddUI", dxm.CDialogUI)

local CFriendAddUI = game.CFriendAddUI

CFriendAddUI.AddType = {
    "qr_code",
    "account",
    "recommender",
    "location",
}

for key,value in ipairs(CFriendAddUI.AddType) do
    CFriendAddUI.AddType[value] = key
end

local ui_lua_file = {
    "app.views.ui.friend.friend_add_qr_code_ui",
    "app.views.ui.friend.friend_add_account_ui",
    "app.views.ui.friend.friend_add_recommender_ui",
    "app.views.ui.friend.friend_add_location_ui",
}

function CFriendAddUI:ctor()
    CFriendAddUI.super.ctor(self)

    self.add_type = nil
    self.add_type_ui = {}
end

function CFriendAddUI:Init(add_type)
    if self:InitWithFile("csd/Friends/FriendsID") == false then
        return false
    end
    self.add_type = add_type or CFriendAddUI.AddType.recommender
    return true
end

function CFriendAddUI:Create(...)
    local ui = CFriendAddUI.new()
    if ui and ui:Init(...) then
        return ui
    end
    return nil
end

function CFriendAddUI:onEnter()

    -- 关闭界面
    self:AddReleaseEvent(function()
        dxm.audio:playSound(assets.sound.config.sound.ui_button_release)
        self:Close()
    end,"ButtonClose")

    -- 二维码标签按钮
    self:AddReleaseEvent(function()
        dxm.audio:playSound(assets.sound.config.sound.ui_button_release)
        self:SwitchType(CFriendAddUI.AddType.qr_code)
    end,"ButtonButton1")

    -- 帐号标签按钮
    self:AddReleaseEvent(function()
        dxm.audio:playSound(assets.sound.config.sound.ui_button_release)
        self:SwitchType(CFriendAddUI.AddType.account)
    end,"ButtonButton2")

    -- 系统推荐标签按钮
    self:AddReleaseEvent(function()
        dxm.audio:playSound(assets.sound.config.sound.ui_button_release)
        self:SwitchType(CFriendAddUI.AddType.recommender)
    end,"ButtonButton3")

    -- 附近的人标签按钮
    self:AddReleaseEvent(function()
        dxm.audio:playSound(assets.sound.config.sound.ui_button_release)
        self:SwitchType(CFriendAddUI.AddType.location)
    end,"ButtonButton4")

    -- 滚动层
    self.scroll_view = dxm.CScrollViewUI:Create(self:GetWidget("ScrollView"))
    if self.scroll_view ~= nil then
        self:AddChild(self.scroll_view)
        self.scroll_view.fix_tail = 380
    end

    self:AddReleaseEvent(function(sender)
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)   
        self:Close()
    end,
    "ButtonReturn") 

    -- 构建子面板
    for i=1,#CFriendAddUI.AddType do
        local ui = sUI:Create(ui_lua_file[i], self:GetWidget("PanelSelect"..i))
        if ui ~= nil then
            self:AddChild(ui)
            self.add_type_ui[i] = ui
        end
    end

    -- 显示当前默认面板
    self:ShowType()
end

function CFriendAddUI:onExit()

    if self.scroll_view ~= nil then
        self.scroll_view:RemoveFromParent()
    end

    for _,ui in pairs(self.add_type_ui) do
        ui:RemoveFromParent()
    end
end

function CFriendAddUI:SwitchType(add_type)

    if self.add_type == add_type then
        return
    end
    self.add_type = add_type
    self:ShowType()
end

function CFriendAddUI:ShowType()

    print(self.add_type, #CFriendAddUI.AddType)

    -- 对面板进行对应的开关
    for i=1,#CFriendAddUI.AddType do
        self:SetWidgetEnableAndVisible(self.add_type==i, "PanelSelect"..i)
        self:SetWidgetEnable(self.add_type~=i, "ButtonButton"..i)
    end
end

return CFriendAddUI

--endregion
