--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CFriendCellUI = class("game.CFriendCellUI",dxm.CBaseUI)

local CFriendCellUI = game.CFriendCellUI

function CFriendCellUI:ctor()
    CFriendCellUI.super.ctor(self)

    self.friend = nil
    self.is_select_mode = false
    self.is_selected = false
    self.select_callback = nil
end

function CFriendCellUI:Init(friend, select_callback)
    if self:InitWithFile("csd/Friends/FriendsStrip") == false then
        return false
    end
    self.friend = friend
    sPlayer.player_modules.friend:FillFriendInfo(self.friend)
    self.select_callback = select_callback
    return true
end

function CFriendCellUI:Create(...)
    local ui = CFriendCellUI.new()
    if ui and ui:Init(...) then
        return ui
    end
    return nil
end

function CFriendCellUI:onEnter()

    -- 显示角色头像
    if self.friend.user_info then 
        self.friend.user_info.head_icon=tonumber(self.friend.user_info.head_icon) 
    end
    self:SetImageViewPicture(sPathHelper:GetPlayerIconPath(self.friend.user_info.head_icon), "ImageHeadPortrait")

    -- 全条目点击
    self:AddReleaseEvent(function()
        dxm.audio:playSound(assets.sound.config.sound.ui_button_release)
        -- sUI:Open("app.views.ui.friend.friend_info_ui", self.friend)
        if self.scroll_view_ui then
            self.scroll_view_ui:SwitchDrawer(self, "csd/Friends/FriendsStripOpen")
        end
    end, "PanelTouch")

    -- 切换选中状态
    self:AddReleaseEvent(function()
        dxm.audio:playSound(assets.sound.config.sound.ui_button_release)
        self:SwitchSelectMode()
    end,"CheckBox")

    -- 显示名称
    self:SetLabelText(self.friend.user_name or "ID:"..(tonumber(self.friend.user_id)+assets.const.min_user_id), "TextPlayerName")

    -- 显示关卡
    local stage_id = "?"
    local child_stage_id = "?"
    if self.friend.user_info ~= nil then
        local value = tonumber(self.friend.user_info.completed_stage_id) or 0
        stage_id = math.floor(value / 100)
        child_stage_id = value % 100
    end
    self:SetLabelText(stage_id.."-"..child_stage_id, "TextCheckpoint")

    -- 显示星数
    local star_count = "?"
    if self.friend.user_info ~= nil then
        star_count = self.friend.user_info.star_count or 0
    end
    self:SetLabelText(star_count, "TextHaveStar")

    -- 添加好友
    self:SetWidgetEnableAndVisible(false, "ButtonFriends")

    -- 已添加标记
    self:SetWidgetEnableAndVisible(false, "ImageTag")

    -- 刷新选择按钮的内容
    self:UpdateSelectButton()

    self:FIonEnter()
end

function CFriendCellUI:onExit()

    self:FIonExit()
end

function CFriendCellUI:EnterSelectMode()

    if self.is_select_mode then
        return
    end
    self.is_select_mode = true

    -- 开始默认为非选中
    self.is_selected = false

    -- 按钮显示调整
    self:UpdateSelectButton()
end

function CFriendCellUI:SwitchSelectMode()

    if not self.is_select_mode then
        return
    end
    self.is_selected = not self.is_selected

     -- 按钮显示调整
    self:UpdateSelectButton()

    if self.select_callback ~= nil then
        self.select_callback(self.is_selected)
    end
end

function CFriendCellUI:LeaveSelectMode()

    if self.is_select_mode == false then
        return
    end
    self.is_select_mode = false

    -- 按钮显示调整
    self:UpdateSelectButton()
end

function CFriendCellUI:UpdateSelectButton()
    self:SetWidgetTouchEnable(self.is_select_mode, "CheckBox")
    self:SetWidgetVisible(self.is_select_mode, "CheckBox")

    local checkbox = self:GetWidget("CheckBox")
    if checkbox ~= nil then
        checkbox:setSelected(self.is_selected)
    end
    --self:SetWidgetEnable(self.is_selected, "CheckBox")
end


function CFriendCellUI:FIonEnter()

    -- 显示角色头像
    self:SetImageViewPicture(sPathHelper:GetPlayerIconPath(self.friend.user_info.head_icon), "ImagePhoto")

    -- 显示名字
    self:SetLabelText(self.friend.user_name, "TextName")

    -- 显示编号
    self:SetLabelText((tonumber(self.friend.user_id)+assets.const.min_user_id), "TextID")

    -- 显示称号
    local title_name = ""
    if self.friend.user_info and self.friend.user_info.title_id then

        local title_entry = assets.title.config[tonumber(self.friend.user_info.title_id)]
        if title_entry then
            title_name = sStrings:GetString(title_entry.name)
        end
    end
    self:SetLabelText(title_name, "TextTitle")

    -- 显示关卡
    local stage_id = "?"
    local child_stage_id = "?"
    if self.friend.user_info ~= nil then
        local value = tonumber(self.friend.user_info.completed_stage_id) or 0
        stage_id = math.floor(value / 100)
        child_stage_id = value % 100
    end
    self:SetLabelText(stage_id.."-"..child_stage_id, "TextCheckpoint")

    -- 显示总星数
    local star_count = "0"
    if self.friend.user_info and self.friend.user_info.star_count then
        star_count = self.friend.user_info.star_count
    end
    self:SetLabelText(star_count, "TextStar")

    -- 显示无尽最高分
    local score_endless = "0"
    if self.friend.user_info and self.friend.user_info.infinite_best_score then
        score_endless = self.friend.user_info.infinite_best_score
    end
    self:SetLabelText(score_endless, "TextEndless")

    -- 显示宠物
    self.scroll_view_roles = dxm.CScrollViewUI:Create(self:GetWidget("PanelPet", "ScrollView"))
    if self.scroll_view_roles then
        self:AddChild(self.scroll_view_roles)

        local roles = {}
        if self.friend.user_info and self.friend.user_info.roles then
            roles = json.decode(self.friend.user_info.roles)
        end
        for _,role in pairs(roles) do
            local icon_ui = sUI:Create("app.views.ui.roles.role_icon_ui", role)
            if icon_ui then
                self.scroll_view_roles:AddCell(icon_ui)
            end
        end
        self.scroll_view_roles:InitPosition()
    end

    -- 显示勋章墙
    self.scroll_view_medals = dxm.CScrollViewUI:Create(self:GetWidget("PanelMedal", "ScrollView"))
    if self.scroll_view_medals then
        self:AddChild(self.scroll_view_medals)       

        local my_medals = {}
        if self.friend.user_info and self.friend.user_info.medals then      
            my_medals = json.decode(self.friend.user_info.medals)
        end

        if assets.medal_task then
            for group_id,_ in ipairs(assets.medal_task.config) do

                -- 获取勋章等级
                local level = 0
                local medal = my_medals[tostring(group_id)]
                if medal then
                    level = medal.level
                end

                local icon_ui = sUI:Create("app.views.ui.medal.medal_icon2_ui", group_id, level, nil)
                if icon_ui then
                    self.scroll_view_medals:AddCell(icon_ui)
                end
            end
            self.scroll_view_medals:InitPosition()
        end
    end

    -- 索要体力按钮
    self:AddReleaseEvent(function()
        dxm.audio:playSound(assets.sound.config.sound.ui_button_release)
        local error_code = player.player_modules.friend:AskForActionPoint(self.friend)
        dxm.CMessageTipUI:Show(sStrings:GetString("ask_for_action_point_error_"..game.CPlayerModuleFriend.ErrorCode[error_code]), 35)
    end,"ButtonApply")

    -- 赠送体力按钮
    self:AddReleaseEvent(function()
        dxm.audio:playSound(assets.sound.config.sound.ui_button_release)
        local error_code = player.player_modules.friend:GiveActionPoint(self.friend)
        dxm.CMessageTipUI:Show(sStrings:GetString("give_action_point_error_"..game.CPlayerModuleFriend.ErrorCode[error_code]), 35)
    end,"ButtonGive")

    -- 删除好友按钮
    self:AddReleaseEvent(function()
        dxm.audio:playSound(assets.sound.config.sound.ui_button_release)
        sUI:Open("dxm.ui.prefab.message_box_ok_cancel_ui", sStringUtils:GetString("@delete_friend_confirm"), function(ok)
            if ok then
                sFriendSystem:RequestRemoveFriend(self.friend.user_id, function(error_code) 
                    if error_code == sFriendSystem.ErrorCode.ok then
                        self:FIRefresh()
                    end
                end)
            end
        end)
    end,"ButtonDelete")

    -- 添加好友按钮
    self:AddReleaseEvent(function()
        dxm.audio:playSound(assets.sound.config.sound.ui_button_release)
        sFriendSystem:RequestAddFriendQuickly(self.friend, true, function(error_code) 
            dxm.CMessageTipUI:Show(sStrings:GetString("add_friend_error_"..sFriendSystem.ErrorCode[error_code]), 35)
        end)
    end,"ButtonAddFriends")

    -- 分享名片按钮
    self:AddReleaseEvent(function()
        dxm.audio:playSound(assets.sound.config.sound.ui_button_release)
        -- TODO: 
    end,"ButtonSend")

    -- 关闭界面
    self:AddReleaseEvent(function()
        dxm.audio:playSound(assets.sound.config.sound.ui_button_release)
        self:Close()
    end,"ButtonClose")

    -- 刷新面板
    self:FIRefresh()

    self:ScheduleUpdate(function(dt) self:FIUpdate(dt) end)
end

function CFriendCellUI:FIonExit()

    if self.scroll_view_roles then
        self.scroll_view_roles:RemoveFromParent()
        self.scroll_view_roles = nil
    end

    if self.scroll_view_medals then
        self.scroll_view_medals:RemoveFromParent()
        self.scroll_view_medals = nil
    end

end

function CFriendCellUI:FIUpdate(dt)

    if self.scroll_view_medals then
        self:SetWidgetEnableAndVisible(self.scroll_view_medals:HasCellOutsideInFront(), "ImageArrowLeft")
        self:SetWidgetEnableAndVisible(self.scroll_view_medals:HasCellOutsideInBack(), "ImageArrowRight")
    end
end

function CFriendCellUI:FIRefresh()

    -- TODO: 显示对应的关系面板
    for i=1,3 do
        self:SetWidgetEnableAndVisible(i==2, "PanelButton"..i)
    end
end

return CFriendCellUI

--endregion
