--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CFriendUI = class("game.CFriendUI",dxm.CStackUI)

local CFriendUI = game.CFriendUI

function CFriendUI:ctor()
    CFriendUI.super.ctor(self)

    self.scroll_view = nil
    self.is_delete_mode = false
    self.is_friend_changed = false
end

function CFriendUI:Init(tab_type)
    if self:InitWithFile("csd/Friends/FriendsMainUi") == false then
        return false
    end
    self.tab_type = tab_type
    return true
end

function CFriendUI:Create()
    local ui = CFriendUI.new()
    if ui and ui:Init() then
        return ui
    end
    return nil
end

function CFriendUI:onEnter()

    sShortcutHelper:OpenTop()
    sShortcutHelper:OpenBottom()
       
    -- 添加好友按钮
    self:AddReleaseEvent(function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
        sUI:Open("app.views.ui.friend.friend_add_ui")
    end,"ButtonAddFriends")

    -- 招募好友按钮
    self:AddReleaseEvent(function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
        dxm.CMessageTipUI:Show(sStrings:GetString("not_open_recruit_friend"))
    end,"ButtonRecruit")
    self:SetWidgetEnableAndVisible(false, "ButtonRecruit")

    -- 删除好友按钮
    self:AddReleaseEvent(function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
        self:EnterDeleteMode()
    end,"ButtonDelete")

    -- 确定删除好友按钮
    self:AddReleaseEvent(function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
        self:ConfirmDelete()
    end,"ButtonDetermine")

    -- 取消删除好友按钮
    self:AddReleaseEvent(function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
        self:LeaveDeleteMode()
    end,"ButtonCancel")

    -- 关闭界面
    self:AddReleaseEvent(function()
         dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)   
        self:Close()
    end,"ButtonClose")

    self:AddReleaseEvent(function(sender)
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)   
        self:Close()
    end,
    "ButtonReturn") 

    -- 滚动层
    self.scroll_view = dxm.CScrollViewUI:Create(self:GetWidget("ScrollView"))
    if self.scroll_view ~= nil then
        self:AddChild(self.scroll_view)
        self.scroll_view.fix_tail = 580
    end

    -- 显示当前好友
    self:ShowFriends()

    -- 显示滚动层内容
    sFriendSystem:RequestGetFriends(function()

        if self.is_entered ~= true then
            return
        end

        player.player_modules.friend:MakeSureFriendExist(function(is_changed) 
            if is_changed == false then
                return
            end
            self:ShowFriends() 
        end)
    end)

    -- 监听好友移除
    sFriendSystem.add_friend_callback = function() self.is_friend_changed = true end
    sFriendSystem.remove_friend_callback = function() self.is_friend_changed = true end

    -- 显示按钮
    self:UpdateDeleteButton()

    -- 设置名字
    print(player.db.info.name)
    if not player.db.info.name or player.db.info.name == "" or player.db.info.name == "nickname" then    
        sUI:Open(true, "app.views.ui.name.name_ui", function()end)
    end

    self:ScheduleUpdate(function(dt) self:Update(dt) end)
end

function CFriendUI:onExit()

    if self.scroll_view ~= nil then
        self.scroll_view:RemoveFromParent()
        self.scroll_view = nil
    end
end

function CFriendUI:ShowFriends()

    if self.scroll_view ~= nil then
        self.scroll_view:RemoveAllCells()

        -- 获取上次停留的位置
        --[[
        local old_height = self.scroll_view.scroll_view:getInnerContainerSize().height
        local old_pos = cc.p(self.scroll_view.scroll_view:getInnerContainerPosition())
        ]]--

        -- 显示当前加载到的好友
        for _,friend in pairs(sFriendSystem.friends) do
            local friend_cell_ui = require("app.views.ui.friend.friend_cell_ui"):Create(friend)
            if friend_cell_ui ~= nil then
                self.scroll_view:AddCell(friend_cell_ui)
            end
        end

        self.scroll_view:InitPosition()

        -- 判断当前是否存在好友
        self:SetWidgetEnableAndVisible(self.scroll_view.cell_ui_list.size == 0, "PanelNPC")

        -- 恢复到之前的位置
        --[[
        local height = self.scroll_view.scroll_view:getInnerContainerSize().height
        self.scroll_view.scroll_view:setInnerContainerPosition(cc.p(old_pos.x, old_pos.y + (height - old_height)))
        self.scroll_view:Update(0)
        ]]--
    end
end

function CFriendUI:EnterDeleteMode()

    if self.is_delete_mode then
        return
    end
    self.is_delete_mode = true

    -- 所有cell条都进入选择状态
    if self.scroll_view ~= nil then

        local itor = self.scroll_view.cell_ui_list:Begin()
        while true do
            local node = itor()
            if node == nil then break end
            local cell = node.value
            if cell ~= nil then
                cell:EnterSelectMode()
            end
        end
    end

    -- 按钮显示调整
    self:UpdateDeleteButton()
end

function CFriendUI:ConfirmDelete()

    if not self.is_delete_mode then
        return
    end

    -- 批量删除好友
    local itor = self.scroll_view.cell_ui_list:Begin()
    while true do
        local node = itor()
        if node == nil then break end
        local cell = node.value
        if cell ~= nil and cell.is_selected then
            sFriendSystem:RequestRemoveFriend(cell.friend.user_id, nil)
        end
    end

    -- 离开删除模式
    self:LeaveDeleteMode()

    -- 刷新内容
    self:ShowFriends()
end

function CFriendUI:LeaveDeleteMode()

    if self.is_delete_mode == false then
        return
    end
    self.is_delete_mode = false

    -- 所有cell条都离开选择状态
    if self.scroll_view ~= nil then

        local itor = self.scroll_view.cell_ui_list:Begin()
        while true do
            local node = itor()
            if node == nil then break end
            local cell = node.value
            if cell ~= nil then
                cell:LeaveSelectMode()
            end
        end
    end

    -- 按钮显示调整
    self:UpdateDeleteButton()
end

function CFriendUI:UpdateDeleteButton()
    self:SetWidgetEnableAndVisible(not self.is_delete_mode, "ButtonAddFriends")
    self:SetWidgetEnableAndVisible(not self.is_delete_mode, "ButtonDelete")
    self:SetWidgetEnableAndVisible(self.is_delete_mode, "ButtonDetermine")
    self:SetWidgetEnableAndVisible(self.is_delete_mode, "ButtonCancel")
end

function CFriendUI:Update(dt)

    if self.is_friend_changed then
        self.is_friend_changed = false
        self:ShowFriends()
    end
end

return CFriendUI
--endregion
