--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CGameRecommenderRewardUI = class("game.CGameRecommenderRewardUI",dxm.CDialogUI)

local CGameRecommenderRewardUI = game.CGameRecommenderRewardUI

function CGameRecommenderRewardUI:ctor()
    CGameRecommenderRewardUI.super.ctor(self)
end

function CGameRecommenderRewardUI:Init(recommender_id, close_callback)
    self.recommender_id = recommender_id
    self:InitWithFile("csd/Additional/AdditionalTurntablePop")
    if close_callback then
        self.close_callback = close_callback
    end
    return true
end

function CGameRecommenderRewardUI:Create(...)
    local ui = CGameRecommenderRewardUI.new()
    if ui and ui:Init(...) then
        return ui
    end

    return nil
end

function CGameRecommenderRewardUI:onEnter()
    
    local close_callback = self.close_callback
    self:AddReleaseEvent(function()

        local reward_string = sGameRecommender:GetReward()
        player.player_modules.reward:TakeRewardString(reward_string)
        sGameRecommender:CompleteTask(self.recommender_id)
        sPlayer.player_modules.game_recommender:CompleteTask(self.recommender_id)

        -- local center_pos = dxm.VisibleRect:center()
        -- game.CRewardPopUI:Show(center_pos, reward_string)

        self:Close()
        if close_callback then 
            close_callback()
        end
    end,"Panel_5")  

    print("", sGameRecommender:GetGameName(self.recommender_id))
    self:SetLabelText(sStringUtils:GetString("@game_recommender_reward_tip", {game_name=sGameRecommender:GetGameName(self.recommender_id)}),"TextTip_0")

    local label = self:GetWidget("TextTip_0")
    if label then
        label:setFontSize(32)
    end

    local image_file = sGameRecommender:GetImageFile(self.recommender_id)
    local ui = dxm.CNodeUI:Create( cc.Sprite:create(image_file) )
    if ui then self:AddChild("ImageAdvertising", ui) end

    local reward_string = sGameRecommender:GetReward()
    local reward_list = game.sRewardHelper:ParseFromString(reward_string)
    if reward_list then
        for i = 1, 99 do
            local widget = self:GetWidget("ImageReward" .. i)
            if not widget then break end
            widget:setVisible(false)
        end

        local show_count = 1
        for k, v in pairs(reward_list.list) do
            local widget = self:GetWidget("ImageIconGoods")
            if not widget then break end
            widget:setVisible(true)
            show_count = show_count + 1
            self:SetImageViewPicture(sPathHelper:GetRewardIconPath(v), widget)
            self:SetLabelText("x" .. v.count, "TextTip")
        end
    end
end


function CGameRecommenderRewardUI:onExit()

end

return CGameRecommenderRewardUI

--endregion
