--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CGameRecommenderUI = class("game.CGameRecommenderUI",dxm.CDialogUI)

local CGameRecommenderUI = game.CGameRecommenderUI

function CGameRecommenderUI:ctor()
    CGameRecommenderUI.super.ctor(self)
end

function CGameRecommenderUI:Init(ads_id, close_callback)
    self.ads_id = ads_id
    self:InitWithFile("csd/Main/MainAdvertising")
    if close_callback then
        self.close_callback = close_callback
    end
    return true
end

function CGameRecommenderUI:Create(...)
    local ui = CGameRecommenderUI.new()
    if ui and ui:Init(...) then
        return ui
    end

    return nil
end

function CGameRecommenderUI:onEnter()
    self:SetLabelText(sStrings:GetString("game_tip"),"TextInformation")
    
    local close_callback = self.close_callback
    self:AddReleaseEvent(function()
        self:Close()
        if close_callback then 
            close_callback()
        end
    end,"ButtonClose")  

    self:AddReleaseEvent(function()
        sGameRecommender:DownloadGame(self.ads_id)
        sGameRecommender:AcceptTask()
        self:Close()
        if close_callback then 
            close_callback()
        end
    end,"PaneAdvertisingTouch")

    local image_file = sGameRecommender:GetImageFile(self.ads_id)
    local ui = dxm.CNodeUI:Create( cc.Sprite:create(image_file) )
    if ui then self:AddChild("ImageAdvertising", ui) end

    local reward_string = sGameRecommender:GetReward()
    local reward_list = game.sRewardHelper:ParseFromString(reward_string)
    if reward_list then
        for i = 1, 99 do
            local widget = self:GetWidget("ImageReward" .. i)
            if not widget then break end
            widget:setVisible(false)
        end

        local show_count = 1
        for k, v in pairs(reward_list.list) do
            local widget = self:GetWidget("ImageReward" .. show_count)
            if not widget then break end
            widget:setVisible(true)
            show_count = show_count + 1

            self:SetImageViewPicture(sPathHelper:GetRewardIconPath(v), widget)
            self:SetLabelText("x" .. v.count, widget, "TextNumber")
        end
    end
end


function CGameRecommenderUI:onExit()

end

return CGameRecommenderUI

--endregion
