--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CMailRewardCellUI = class("game.CMailRewardCellUI",dxm.CBaseUI)

local CMailRewardCellUI = game.CMailRewardCellUI

function CMailRewardCellUI:ctor()
    CMailRewardCellUI.super.ctor(self)

    self.message = nil
end

function CMailRewardCellUI:Init(message)
    if self:InitWithFile("csd/Mail/MailStrip") == false then
        return false
    end
    self.message = message
    return true
end

function CMailRewardCellUI:Create(...)
    local ui = CMailRewardCellUI.new()
    if ui and ui:Init(...) then
        return ui
    end
    return nil
end

function CMailRewardCellUI:onEnter()

    -- 奖励内容
    local reward = nil
    if self.message.content.action_type == "give_action_point" then
        reward = assets.const.friend_action_point_reward
    else
        reward = self.message.content.action_data.reward
    end
    if reward == nil then
        reward = ""
    end

    -- 领取按钮
    self:AddReleaseEvent(function() 
        dxm.audio:playSound(assets.sound.config.sound.ui_button_release)
        local center_pos = dxm.VisibleRect:center()        
        require("app.views.ui.reward_pop.reward_pop_ui"):Show(center_pos, reward)
        sMessageSystem:ConfirmPlayerMessage(self.message.message_id)
    end,"ButtonReceive")

    local reward_list = game.sRewardHelper:ParseFromString(reward)
    if #reward_list.list > 0 then
        self:SetWidgetEnableAndVisible(true, "PanelReceiveGoods1")
        self:SetImageViewPicture(sPathHelper:GetRewardIconPath(reward_list.list[1]), "PanelReceiveGoods1", "ImageReceiveIcon")
        self:SetLabelText("+"..reward_list.list[1].count, "PanelReceiveGoods1", "TextReceive")
    else
        self:SetWidgetEnableAndVisible(false, "PanelReceiveGoods1")
    end

    -- 显示发起者名称
    self:SetLabelText(self.message.sender.user_name or "ID:"..tonumber(self.message.sender.user_id)+assets.const.min_user_id, "TextPlayerName")

    -- 隐藏系统标识
    self:SetWidgetEnableAndVisible(false, "ImageSystem")
end

function CMailRewardCellUI:onExit()
end

return CMailRewardCellUI

--endregion
