--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CMedalIcon2UI = class("game.CMedalIcon2UI", dxm.CBaseUI)

local CMedalIcon2UI = game.CMedalIcon2UI

function CMedalIcon2UI:ctor()
    CMedalIcon2UI.super.ctor(self)
end

function CMedalIcon2UI:Init(group_id,level,click_callback)
    self.group_id = group_id
    self.level = level
    self.click_callback = click_callback

    return self:InitWithFile("csd/Medal/MedalStrip2")
end

function CMedalIcon2UI:Create(...)
    local ui = CMedalIcon2UI.new()
    if ui and ui:Init(...) then
        return ui
    end
    return nil
end

function CMedalIcon2UI:onEnter()
    for i = 1 , 5 do
        self:SetWidgetVisible(self.level >= i,"ImageStar"..i)
    end

    if self.level == 0 then
        sShaderUtils:AddGray(self:GetWidget("ImageMedalIcon"))
    end
    
    --勋章名字
    self:SetLabelText(sStrings:GetString("medal_name_"..self.group_id),"TextMedalName")

    --设置勋章图标
    local icon_path = assets.medal_icon_path.config[self.group_id]
    if icon_path then
        self:SetImageViewPicture(icon_path,"ImageMedalIcon")
    end

    self:AddReleaseEvent(function()
        dxm.audio:playSound(assets.sound.config.sound.ui_button_release)
        if self.click_callback then
            self.click_callback()
        end
    end,"PanelTouch")
end

function CMedalIcon2UI:onExit()
    if self.level == 0 then
        sShaderUtils:RemoveGray(self:GetWidget("ImageMedalIcon"))
    end
end

return CMedalIcon2UI

--endregion
