--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CMedalInfoUI = class("game.CMedalInfoUI",dxm.CDialogUI)

local CMedalInfoUI = game.CMedalInfoUI

function CMedalInfoUI:ctor()
    CMedalInfoUI.super.ctor(self)
end

function CMedalInfoUI:Init(group_id,task_list)
    self.group_id = group_id
    self.task_list = task_list
    self.current_task = self.task_list[player.player_modules.medal_task:GetGroupStatus(group_id)]
    if not self.current_task then
        return false
    end
    return self:InitWithFile("csd/Medal/MedalPop")
end

function CMedalInfoUI:Create(...)
    local ui = CMedalInfoUI.new()
    if ui and ui:Init(...) then
        return ui
    end

    return nil
end

function CMedalInfoUI:onEnter()
    self:SetLabelText(sStrings:GetString("medal_name_" .. self.group_id), "TextMedalName")
    self:SetLabelText(sStrings:GetString("medal_desc_" .. self.group_id), "TextDescribe")
    local complete_count = player.player_modules.medal_task:GetMedalProgress(self.group_id)
    if complete_count < #self.task_list then
        -- 当前条件
        self:SetLabelText(sStrings:GetString(self.current_task.entry.desc), "TextCondition")
    else
        self:SetLabelText(sStrings:GetString("medal_task_all_complete"), "TextCondition")
    end

    for i = 1, 5 do
        self:SetWidgetVisible(complete_count >= i, "ImageStar" .. i)
    end

    -- 设置勋章图标
    local icon_path = assets.medal_icon_path.config[self.group_id]
    if icon_path then
        self:SetImageViewPicture(icon_path, "ImageMedalIcon")
    end

    -- 当前任务进度
    local loading_bar = self:GetWidget("LoadingBar")
    if loading_bar then
        loading_bar:setPercent((self.current_task.progress / self.current_task.entry.complete_times) * 100)
    end
    self:SetLabelText(self.current_task.progress .. "/" .. self.current_task.entry.complete_times, "PanelPop", "TextNumber2")

    self:AddReleaseEvent( function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
        self:Close()
    end , "ButtonClose")

end

function CMedalInfoUI:onExit()

end


return CMedalInfoUI

--endregion
