-- region *.lua
-- Date
-- 此文件由[BabeLua]插件自动生成

require "app.views.ui.medal.medal_icon_ui"
require "app.views.ui.medal.medal_cell_ui"

game.CMedalUI = class("game.CMedalUI", dxm.CStackUI)

local CMedalUI = game.CMedalUI

function CMedalUI:ctor()
    CMedalUI.super.ctor(self)
    self.icon_list = {}
end

function CMedalUI:Init()
    return self:InitWithFile("csd/Medal/Medal")
end

function CMedalUI:Create()
    local ui = CMedalUI.new()
    if ui and ui:Init() then
        return ui
    end
end

function CMedalUI:onEnter()

    sShortcutHelper:OpenTop()
    sShortcutHelper:OpenBottom()

    self.scroll_view = dxm.CScrollViewUI:Create(self:GetWidget("ScrollView"))

    local medal_list = player.player_modules.medal_task:GetMedalList()

    local complete_count = 0
    local cell = game.CMedalCellUI:Create()
    for group_id, medal in pairs(medal_list) do

        local progress = player.player_modules.medal_task:GetMedalProgress(group_id)
        complete_count = complete_count + progress
        if cell and cell:IsFull() then

            self.scroll_view:AddCell(cell)
            cell = game.CMedalCellUI:Create()
        end
        cell:Push(game.CMedalIconUI:Create(group_id, progress, function()
            sUI:Open("app.views.ui.medal.medal_info_ui", group_id, medal)
        end ))
    end

    if cell and not cell:Empty() then
        self.scroll_view:AddCell(cell)
    end
    
    self:AddChild(self.scroll_view)
    self.scroll_view.fix_tail = 380
    self.scroll_view:InitPosition()

    self:SetLabelText("x" .. complete_count, "TextHaveStar")

    self:ShowTitle()

    self:ShowRewardUI()

    self:AddReleaseEvent( function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
        sUI:Open("app.views.ui.medal.title_reward_ui")
    end , "ButtonReward")

    self:AddReleaseEvent( function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
        self:Close()
    end , "ButtonClose")
end

function CMedalUI:onExit()
    if self.title_name_icon then
        self.title_name_icon:removeFromParent()
    end

    for _, icon in pairs(self.icon_list) do
        if icon then
            icon:removeFromParent()
        end
    end
end

function CMedalUI:ShowTitle()
    local current_title_id = player.player_modules.title:GetCurrentTitle()

    if current_title_id then
        local title_entry = assets.title.config[current_title_id]
        if title_entry then
            local icon_pos = self:GetWidget("ImageMedalName")
            if icon_pos then
                self.title_name_icon = cc.Sprite:create(title_entry.name_path)
                if self.title_name_icon then
                    icon_pos:addChild(self.title_name_icon)
                end
            end
            self:SetLabelText(sStrings:GetString(title_entry.attribute_desc), "TextAttribute")
        end
    else
        self:SetLabelText("", "TextAttribute")
    end
end

function CMedalUI:ShowRewardUI()
    local current_title_id = player.player_modules.title:GetCurrentTitle()
    if current_title_id then
        -- 显示奖励
        local title_entry = assets.title.config[current_title_id]
        local reward_list = game.sRewardHelper:ParseFromString(title_entry.reward)

        for i = 1, 3 do
            local reward = reward_list.list[i]
            if reward then
                local icon_pos = self:GetWidget("PanelRewardGoods" .. i, "ImageGoodsIcon")
                self.icon_list[i] = cc.Sprite:create(sPathHelper:GetRewardIconPath(reward))
                if self.icon_list[i] then
                    icon_pos:addChild(self.icon_list[i])
                end

                self:SetLabelText("x" .. reward.count, "PanelRewardGoods" .. i, "TextNumber")
                self:SetWidgetVisible(true, "PanelRewardGoods" .. i)
            else
                self:SetWidgetVisible(false, "PanelRewardGoods" .. i)
            end
        end
    end
end

return CMedalUI

-- endregion
