--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CTitleRewardUI = class("game.CTileRewardUI",dxm.CDialogUI)

local CTitleRewareUI = game.CTitleRewardUI

function CTitleRewareUI:ctor()
    CTitleRewareUI.super.ctor(self)
    self.icon_list = {}
end

function CTitleRewareUI:Init()
    return self:InitWithFile("csd/Medal/MedalReward")
end

function CTitleRewareUI:Create()
    local ui = CTitleRewareUI.new()
    if ui and ui:Init() then
        return ui
    end

    return nil
end

function CTitleRewareUI:onEnter()
    local current_title_id = player.player_modules.title:GetCurrentTitle()
    if current_title_id then
        -- 显示奖励
        local title_entry = assets.title.config[current_title_id]
        local reward_list = game.sRewardHelper:ParseFromString(title_entry.reward)
        
        for i = 1, 3 do
            local reward = reward_list.list[i]
            if reward then
                local icon_pos = self:GetWidget("PanelRewardGoods" .. i,"ImageGoodsIcon")
                self.icon_list[i] = cc.Sprite:create(sPathHelper:GetRewardIconPath(reward))
                if self.icon_list[i] then
                    icon_pos:addChild(self.icon_list[i])
                end

                self:SetLabelText("x" .. reward.count,"PanelRewardGoods" .. i, "TextNumber")
                self:SetWidgetVisible(true, "PanelRewardGoods" .. i)
            else
                self:SetWidgetVisible(false, "PanelRewardGoods" .. i)
            end
        end
    end

    self:AddReleaseEvent( function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
        self:Close()
    end , "ButtonClose")
end

function CTitleRewareUI:onExit()
    for _,icon in pairs(self.icon_list) do
        if icon then
            icon:removeFromParent()
        end
    end
end

return CTitleRewareUI


--endregion
