-- region *.lua
-- Date
-- 此文件由[BabeLua]插件自动生成

game.CCreateRoleUI = class("game.CCreateRoleUI", dxm.CDialogUI)

local CCreateRoleUI = game.CCreateRoleUI

function CCreateRoleUI:ctor()
    CCreateRoleUI.super.ctor(self)
end

function CCreateRoleUI:Init(callback)
    self.callback = callback
    return self:InitWithFile("csd/Land/CreateRole")
end

function CCreateRoleUI:Create(...)

    local ui = CCreateRoleUI.new()
    if ui == nil or ui:Init(...) == false then
        return nil
    end
    
    return ui
end

function CCreateRoleUI:onEnter()
    
    self:SetLabelText("", "TextFieldName")
    self:AddReleaseEvent(function() 
        
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)  
        local text_field = self:GetWidget("TextFieldName")
        if text_field then 
            local text = text_field:getString()
            if sIllegalStrings:Check(text) then
                sUI:Open("dxm.ui.prefab.message_box_ok_ui", sStrings:GetString("has_illegal_word"))
                return 
            end

            if string.len(text) == 0 then text = "nickname" end

            player.player_modules.info:SetName(text)
            player.player_modules.info:SetSex(self.sex)
            sPlayer.player_modules.skins:SetActiveSkin(2-self.sex)
            player.player_modules.info:SetHeadIcon(2-self.sex)

            sCtrlMainMenu:WelcomeBack()
            if self.callback then self.callback() end
            self:Close()
        end
    end, "ButtonOK")

    self:SetLabelText(assets.names:Get(), "TextFieldName")
    self:AddReleaseEvent(function()   
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)       
        self:SetLabelText(assets.names:Get(), "TextFieldName")
    end, "ButtonRandom")

    self:AddReleaseEvent( function(sender)
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)   
        self:Close()
    end , "ButtonClose")

    self:AddReleaseEvent(function() self:SelectSex(1) end,  "PanelHeadPortraitBottom1", "PanelTouch")
    self:AddReleaseEvent(function() self:SelectSex(0) end,  "PanelHeadPortraitBottom2", "PanelTouch")

    self:SetImageViewPicture(sPathHelper:GetPlayerIconPath(1), "PanelHeadPortraitBottom1", "ImageHeadPortrait")
    self:SetImageViewPicture(sPathHelper:GetPlayerIconPath(2), "PanelHeadPortraitBottom2", "ImageHeadPortrait")
    self:SelectSex(1)
end

function CCreateRoleUI:onExit()
    if self.sex == 0 then
        sShaderUtils:RemoveGray(self:GetWidget("PanelHeadPortraitBottom1", "ImageHeadPortrait"))
    else
        sShaderUtils:RemoveGray(self:GetWidget("PanelHeadPortraitBottom2", "ImageHeadPortrait"))
    end
end

function CCreateRoleUI:SelectSex(sex)

    if self.sex == sex then
        return
    end

    if self.sex == 0 then
        sShaderUtils:RemoveGray(self:GetWidget("PanelHeadPortraitBottom1", "ImageHeadPortrait"))
    elseif self.sex == 1 then
        sShaderUtils:RemoveGray(self:GetWidget("PanelHeadPortraitBottom2", "ImageHeadPortrait"))
    end

    if sex == 0 then
        self.sex = 0
        self:SetWidgetVisible(false, "PanelHeadPortraitBottom1", "ImageSelectedIcon")
        self:SetWidgetVisible(true, "PanelHeadPortraitBottom2", "ImageSelectedIcon")
        sShaderUtils:AddGray(self:GetWidget("PanelHeadPortraitBottom1", "ImageHeadPortrait"))
    else
        self.sex = 1
        self:SetWidgetVisible(true, "PanelHeadPortraitBottom1", "ImageSelectedIcon")
        self:SetWidgetVisible(false, "PanelHeadPortraitBottom2", "ImageSelectedIcon")
        sShaderUtils:AddGray(self:GetWidget("PanelHeadPortraitBottom2", "ImageHeadPortrait"))
    end

    self:RefreshSkin(2-self.sex)
end


function CCreateRoleUI:RefreshSkin(skin_id)

    if skin_id == nil then
        skin_id = player.db.skins.active_skin_id
    end

    local skin = sPlayer.player_modules.skins:GetSkin(skin_id)
    self:SetWidgetVisible(skin.buyed, "TextSkinLvName")
    self:SetLabelText(skin.level, "TextSkinLv")
    if self.skin_id == skin_id then
        return
    end
    self.skin_id = skin_id
    local skin_entry = assets.skins:GetEntry(skin_id)
    if skin_entry then
        self:RemoveAllChildren("PanelManAnimationRoot")
        local spine_ui = dxm.CSpineUI:Create(skin_entry.Spine, "idle1") 
        if spine_ui then
            self:AddChild("PanelManAnimationRoot", spine_ui)
        end
    end
end

return CCreateRoleUI
-- endregion
