-- region *.lua
-- Date
-- 此文件由[BabeLua]插件自动生成

game.COnlinePackageUI = class("game.COnlinePakcage", dxm.CDialogUI)

local COnlinePackageUI = game.COnlinePackageUI

function COnlinePackageUI:ctor()
    COnlinePackageUI.super.ctor(self)
end

function COnlinePackageUI:Init()
    self.icon_ui_list = { }
    return self:InitWithFile("csd/Main/MainOnLineBox")
end

function COnlinePackageUI:Create()
    local ui = COnlinePackageUI.new()
    if ui and ui:Init() then
        return ui
    end
end

function COnlinePackageUI:onEnter()
    local reward_list = game.sRewardHelper:ParseFromString(player.player_modules.online_gift_package:GetRewardString())
    local index = 1
    for _, reward in pairs(reward_list.list) do
        self.icon_ui_list[index] = cc.Sprite:create(sPathHelper:GetRewardIconPath(reward))
        local icon_pos = self:GetWidget("PanelReceiveIcon" .. index)
        if self.icon_ui_list[index] and icon_pos then
            icon_pos:addChild(self.icon_ui_list[index])
        end
        self:SetWidgetVisible(true,"PanelReceiveIcon" .. index)
        self:SetLabelText("x" .. reward.count, "PanelReceiveIcon" .. index, "TextNumber")
        index = index + 1
    end

    for i = index , 3 do
        self:SetWidgetVisible(false,"PanelReceiveIcon" .. i)
    end

    self:SetLabelText(sStrings:GetString(player.player_modules.online_gift_package:GetPackageName()), "TextStage")

    self:SetWidgetVisible(player.player_modules.online_gift_package:CanFetchReward() == "no_error", "ButtonReceive")

    self:AddReleaseEvent( function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)  
        local center_pos = dxm.VisibleRect:center()
        require("app.views.ui.reward_pop.reward_pop_ui"):Show(center_pos, player.player_modules.online_gift_package:GetRewardString())

        player.player_modules.online_gift_package:FetchReward()
        dxm.CMessageTipUI:Show(sStrings:GetString("received"))
        self:Close()
    end , "ButtonReceive")

    self:AddReleaseEvent( function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)  
        self:Close()
    end , "ButtonClose")
    self:ScheduleUpdate(function(dt) self:Update(dt) end)
end

function COnlinePackageUI:Update()
    local time = player.player_modules.online_gift_package:GetNextRewardTime()
    if time < 0 then
        time = 0
    end

    local message = dxm.CStringCombiner.new()
    message:Init(sStrings:GetString("online_package_time"))
    message:SetValue("time", sTimeUtils:ToTimeSpanString(time))
    self:SetLabelText(message:Combine(), "TextTime")

    self:SetWidgetVisible(time~=0, "TextTime")
end

function COnlinePackageUI:onExit()
    for _, icon_ui in pairs(self.icon_ui_list) do
        if icon_ui then
            icon_ui:removeFromParent()
        end
    end
end

return COnlinePackageUI

-- endregion
