--region *.lua
--Date
--此文件由[BabeLua]插件自动生成
game.CItemIconUI = class("CItemIconUI",dxm.CBaseUI)
local CItemIconUI = game.CItemIconUI

function CItemIconUI:Init(item_id, click_callback)
    self.entity = assets.items.config[item_id]
    self.item_id = item_id
    self.click_callback = click_callback
    if not self.entity then
        return false
    end

    if self:InitWithFile("csd/IconStrip/IconGoods") == false then
        return false
    end
    
    return true
end

function CItemIconUI:Create(...)
    local ui = CItemIconUI.new()
    if ui and ui:Init(...) then
        return ui
    end
end

function CItemIconUI:onEnter()
    self:SetLabelText(tostring(game.CPlayerModulePackage:GetItemCount(self.item_id)),"ImageBottom","AtlasLabelNumber")
    self.icon_widget = self:GetWidget("ImageIcon")
    local icon_path = assets.items.config[self.item_id].icon_path
    if icon_path then
        local icon = cc.Sprite:create(icon_path)
        if icon then
            icon:setPosition(self.icon_widget:getAnchorPointInPoints())
            self.icon_widget:addChild(icon)
            if self.entity.spine_path and self.entity.animation_name then
                local spine = sSpineUtils:CreateWidgetAnimation(self.entity.spine_path)
                if spine then
                    spine:setAnimation(0,self.entity.animation_name,true)
                    spine:setAnchorPoint(cc.p(0.5,0.5))
                    local pos = cc.p(icon:getContentSize().width / 2,icon:getContentSize().height / 2)
                    spine:setPosition(pos)
                    icon:addChild(spine)
                end
            end
        end
    end

   self:AddReleaseEvent(function() 
    dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
    if self.click_callback then self.click_callback() end
   end, "PanelTouch")

end

function CItemIconUI:onExit()
    self.icon_widget:removeAllChildren()
end

function CItemIconUI:Refresh()
    self:SetLabelText(tostring(game.CPlayerModulePackage:GetItemCount(self.item_id)),"ImageBottom","AtlasLabelNumber")
end

return CItemIconUI

--endregion
