--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local CItemIconUI = require("app.views.ui.package.item_icon_ui")


local CPackageCellUI = class("CPackageCellUI",dxm.CBaseUI)

function CPackageCellUI:ctor()
    CPackageCellUI.super.ctor(self)
end

function CPackageCellUI:Init(item_id,callback)
    self.item_id = item_id
    self.callback = callback
    self.item_entry = assets.items.config[item_id]
    self.item_count = player.player_modules.package:GetItemCount(self.item_id)
    if self:InitWithFile("csd/IconStrip/PackageStrip") == false then
       return false
    end

    return true
end

function CPackageCellUI:Create(item_id,callback)
    local ui = CPackageCellUI.new()
    if ui and ui:Init(item_id,callback) then
        return ui
    end
end

function CPackageCellUI:onEnter()
    local icon_widget = self:GetWidget("ImageIcon")    
    if icon_widget then
        self.icon = cc.Sprite:create(self.item_entry.icon_path)
        if self.icon then
            icon_widget:addChild(self.icon)
        end
    end

    self:SetLabelText("x"..self.item_count,"AtlasLabelNumber")
    self:SetLabelText(sStrings:GetString(self.item_entry.name),"TextGoodsName")
    self:SetLabelText(sStrings:GetString(self.item_entry.desc),"TextExplain")

    --设置按钮状态
    self:Refresh()

    self:AddReleaseEvent(function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 

        if self.item_entry.item_type == assets.items.ItemType.kTypeActionPointBox and player.player_modules.action_point:IsFull() then
            sUI:Open("dxm.ui.prefab.message_box_ok_ui", sStrings:GetString("action_point_is_full"))
            return
        end

        if game.CCtrlItem:UseItem(self.item_id, 1) == false then
            return false
        end
        self.item_count = player.player_modules.package:GetItemCount(self.item_id)
        if self.item_count == nil or self.item_count == 0 then
            --移除自己
            if self.callback then
                self.callback(self)
            end
        end

        self:SetLabelText("x"..self.item_count,"AtlasLabelNumber")

        --播放动画
        if self.item_entry.item_type == assets.items.ItemType.kTypeBox then            
            dxm.audio:playEffect(assets.sound.config.sound.item_use_normal)  
            local parent = self:GetWidget("ImageIcon")
            if parent then
                local pos = parent:convertToWorldSpace(cc.p(parent:getPositionX(),parent:getPositionY()))
                require("app.views.ui.reward_pop.reward_pop_ui"):Show(pos,self.item_entry.value)
                dxm.CMessageTipUI:Show(sStrings:GetString("box_received"))
            end
        elseif self.item_entry.item_type == assets.items.ItemType.kTypeActionPointBox then
            dxm.audio:playEffect(assets.sound.config.sound.item_use_action_point)
            game.CActionHelper:ActionPointHeartAdd()
        end

        --体力满了刷新cell_list按钮
        if player.player_modules.action_point:IsFull() then
            if self.callback then
                self.callback()
            end
        end
    end,"ButtonBse")
end

function CPackageCellUI:Refresh()
    self:SetWidgetVisible(false,"ButtonBse")
    if self.item_entry.item_type == assets.items.ItemType.kTypeBox then
        self:SetWidgetVisible(true,"ButtonBse")
    elseif self.item_entry.item_type == assets.items.ItemType.kTypeActionPointBox then
        self:SetWidgetVisible(true,"ButtonBse")
    end
end

function CPackageCellUI:onExit()
    if self.icon then
        self.icon:removeFromParent()
        self.icon = nil
    end
end

return CPackageCellUI

--endregion
