--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local CPackageCellUI = require("app.views.ui.package.package_cell_ui")

game.CPackageUI = class("game.CPackageUI",dxm.CStackUI)

local CPackageUI = game.CPackageUI

function CPackageUI:ctor()
    CPackageUI.super.ctor(self)
    self.cell_list = {}
end

function CPackageUI:Init()
    if not self:InitWithFile("csd/Main/Package") then
        return false
    end
    
   
    return true
end

function CPackageUI:Create()
    local ui = CPackageUI.new()
    if ui and ui:Init() then
        return ui
    end
end

function CPackageUI:onEnter()

    sShortcutHelper:OpenTop()
    sShortcutHelper:OpenBottom()

    local scroll_widget = self:GetWidget("ScrollView")
    self.scroll_view = dxm.CScrollViewUI:Create(scroll_widget)
    self.scroll_view.fix_tail = 380
    self.scroll_view.fix_head = 20

    local package_item_list = player.player_modules.package:GetItemList()
    for k , v in pairs(package_item_list) do
        local cell = CPackageCellUI:Create(tonumber(k),function(cell) 
            if cell then
                self:RemoveCell(cell) 
            end
            self:RefreshCellList()
        end)
        if cell then 
            self.scroll_view:AddCell(cell) 
            self.cell_list[cell] = cell
        end
    end

    self.scroll_view:InitPosition()
    self:AddChild(self.scroll_view)

    self:AddReleaseEvent(function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
        self:Close()
    end,"ButtonClose")
end

function CPackageUI:RemoveCell(cell)
    self.cell_list[cell] = nil
    local action = cc.Sequence:create(
        cc.MoveBy:create(0.3,cc.p(700,0)),
        cc.CallFunc:create(function()
            self.scroll_view:RemoveCell(cell)
            for k , v in pairs(self.cell_list) do
                sActionUtils:Shake(v:GetWidget("ImageRankingStrip"))
            end
        end)
    )

    cell.widget:runAction(action)
end

function CPackageUI:RefreshCellList()
    for k ,v in pairs(self.cell_list) do
        v:Refresh()
    end
end

return CPackageUI

--endregion
