-- region *.lua
-- Date
-- 此文件由[BabeLua]插件自动生成

game.CRankCellUI = class("game.CRankCellUI", dxm.CStackUI)

local CRankCellUI = game.CRankCellUI

function CRankCellUI:ctor()
    CRankCellUI.super.ctor(self)

    self.rank_number = 0
    self.rank_name = 0
    self.rank_value = 0
end

function CRankCellUI:Init(rank_player)
    self.rank_user_id = rank_player.user_id or 0
    self.rank_number = rank_player.pos or 100

    if player.db.info.user_id and self.rank_user_id == player.db.info.user_id then
        self.rank_name = player.db.info.name or "nickname"
    else
        self.rank_name = rank_player.user_name or "nickname"
    end
    self.rank_value = rank_player.value or 0
    self.rank_player = rank_player
    return self:InitWithFile("csd/IconStrip/RankingStrip")
end

function CRankCellUI:Create(...)

    local ui = CRankCellUI.new()
    if ui == nil or ui:Init(...) == false then
        return nil
    end
    
    return ui
end

function CRankCellUI:onEnter()

    self:SetWidgetVisible(false, "AtlasLabelRanking")
    self:SetWidgetVisible(false, "ImageRanking1")
    self:SetWidgetVisible(false, "ImageRanking2")
    self:SetWidgetVisible(false, "ImageRanking3")
    self:SetWidgetVisible(false,"ImageRankingGai1")
    self:SetWidgetVisible(false,"ImageRankingGai2")
    self:SetWidgetVisible(false,"ImageRankingGai3")
    self:SetWidgetVisible(false,"ImageRankingGai4")

    if self.rank_number == 1 then 
        self:SetWidgetVisible(true, "ImageRanking1")
        self:SetWidgetVisible(true,"ImageRankingGai1")
        self:SetWidgetVisible(true,"ImageBottom1")
        self:SetWidgetVisible(false,"ImageBottom2")
    elseif self.rank_number == 2 then 
        self:SetWidgetVisible(true, "ImageRanking2")
        self:SetWidgetVisible(true,"ImageRankingGai2")
        self:SetWidgetVisible(true,"ImageBottom1")
        self:SetWidgetVisible(false,"ImageBottom2")
    elseif self.rank_number == 3 then 
        self:SetWidgetVisible(true, "ImageRanking3")
        self:SetWidgetVisible(true,"ImageRankingGai3")
        self:SetWidgetVisible(true,"ImageBottom1")
        self:SetWidgetVisible(false,"ImageBottom2")
    else
        self:SetWidgetVisible(true,"ImageRankingGai4")
        self:SetWidgetVisible(true, "AtlasLabelRanking")
        self:SetWidgetVisible(false,"ImageBottom1")
        self:SetWidgetVisible(true,"ImageBottom2")
    end

    self:SetAtlasLabelText(tostring(self.rank_number), "AtlasLabelRanking")
    if self.rank_name then 
        self:SetLabelText(self.rank_name, "TextName") 
    else
       self:SetLabelText("nickname", "TextName")
    end

    self:SetAtlasLabelText(tostring(self.rank_value), "TextFraction")

    self:SetIcon()
end

function CRankCellUI:onExit()
end

function CRankCellUI:SetIcon()

    local head_icon = 1
    if player.db.user_id and self.rank_user_id == player.db.user_id then
        head_icon = player.db.head_icon
        self:SetWidgetVisible(true, "ImageMyRank")
    else
        if self.rank_player.user_info then self.rank_player.user_info.head_icon = tonumber(self.rank_player.user_info.head_icon) end
        if self.rank_player.user_info and self.rank_player.user_info.head_icon then
            head_icon = self.rank_player.user_info.head_icon
        end
        self:SetWidgetVisible(false, "ImageMyRank")
    end
    self:SetImageViewPicture(sPathHelper:GetPlayerIconPath(head_icon), "ImageHeadPortrait")
end


return CRankCellUI

-- endregion
