-- region *.lua
-- Date
-- 此文件由[BabeLua]插件自动生成

game.CStageScoreRankUI = class("game.CStageScoreRankUI", dxm.CBaseUI)

local CStageScoreRankUI = game.CStageScoreRankUI

function CStageScoreRankUI:ctor()
    CStageScoreRankUI.super.ctor(self)
end

function CStageScoreRankUI:Init(rank_name)
    self.rank_name = rank_name
    return self:InitWithFile("csd/Battle/BattleRanking")
end

function CStageScoreRankUI:Show(ui, stage_id)
    
    if assets.version.app_test then
        return
    end
    
    local rank_name = "stage_score_"..stage_id
    player.player_modules.rank:RequestGetRank(rank_name, 1, function() 
        local rank_top = player.player_modules.rank:GetRankTop(rank_name)
        if rank_top and #rank_top>0 then
            ui:AddChild("PanelRank", CStageScoreRankUI:Create(rank_name))
        end
    end)  
end

function CStageScoreRankUI:Create(...)

    local ui = CStageScoreRankUI.new()
    if ui == nil or ui:Init(...) == false then
        return nil
    end    
    return ui
end

function CStageScoreRankUI:onEnter()
    self:Refresh()
end

function CStageScoreRankUI:onExit()

end

function CStageScoreRankUI:Refresh()

    for i=1, 10 do
        local widget = self:GetWidget("ImagePlayer"..i)            
        if not widget then
            break
        end
        widget:setVisible(false)
    end

    local rank_top = player.player_modules.rank:GetRankTop(self.rank_name)
    if rank_top then
        table.sort(rank_top, function(a, b) return a.pos < b.pos end)
        for i=1, #rank_top do
            local widget = self:GetWidget("ImagePlayer"..i)            
            if not widget then
                break
            end
            local rank_player = rank_top[i]
            if rank_player then
                widget:setVisible(true)
                self:SetLabelText(rank_player.user_name, widget, "TextName")
                self:SetLabelText(tostring(rank_player.value), widget, "TextFraction")
                self:SetIcon(widget, rank_player)
            else
                widget:setVisible(false)
            end
        end
    end
end


function CStageScoreRankUI:SetIcon(widget, rank_player)

    local icon_paths = {}
    for i=1, 4 do
        icon_paths[i] = "images/head/role"..i..".png" 
    end

    local icon_path
    if player.db.user_id and rank_player.rank_user_id == player.db.user_id then
        icon_path = icon_paths[player.db.head_icon]
    elseif rank_player then
        if rank_player.user_info then rank_player.user_info.head_icon=tonumber(rank_player.user_info.head_icon) end
        if rank_player.user_info and rank_player.user_info.head_icon and rank_player.user_info.head_icon <= 4 and rank_player.user_info.head_icon >= 1 then
            icon_path = icon_paths[rank_player.user_info.head_icon]
        else
            icon_path = icon_paths[math.random(1, #icon_paths)]
        end
    end
    self:SetImageViewPicture(icon_path, widget, "ImagePhoto")
end

return CStageScoreRankUI

-- endregion
