--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CRewardRechargeUI = class("game.CRewardRechargeUI",dxm.CDialogUI)

local CRewardRechargeUI = game.CRewardRechargeUI

function CRewardRechargeUI:ctor()
    CRewardRechargeUI.super.ctor(self)
end

function CRewardRechargeUI:Init(close_callback)

    self.close_callback = close_callback
    self:InitWithFile("csd/Additional/AdditionalPackageReceive")
    return true
end

function CRewardRechargeUI:Create(...)
    local ui = CRewardRechargeUI.new()
    if ui and ui:Init(...) then
        return ui
    end
    return nil
end

function CRewardRechargeUI:onEnter()

    self:AddReleaseEvent( function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)  
        game.CCtrlMainMenu:OpenShopUI()
        self:Close()
    end , "ButtonRecharge")

    self:AddReleaseEvent( function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)  
        if not player.player_modules.recharge:IsRechargeRewardEnable() then

            local current = player.player_modules.recharge:GetRechargeMoneyTotal()
            local max = player.player_modules.recharge:GetRechargeRewardCondition()
            local string = ""
            local string_combiner = dios.util.CStringCombiner:new()
            if string_combiner ~= nil then    
                string_combiner:Init(sStrings:GetString("recharge_reward_money_is_not_enough"))
                string_combiner:SetVar("point", max-current)
                string = string_combiner:Combine()
                string_combiner:delete()
            end
            game.CMessageOkCancelUI:Show(string, function(ok)
                if ok then 
                    game.CCtrlMainMenu:OpenShopUI()
                end
            end)
            return
        end
        local center_pos = dxm.VisibleRect:center()
        local reward_string = player.player_modules.recharge:GetRechargeRewardString()
        require("app.views.ui.reward_pop.reward_pop_ui"):Show(center_pos, reward_string)
        player.player_modules.recharge:FetchRechargeReward()
        dxm.CMessageTipUI:Show(sStrings:GetString("fetch_reward_successful"), 35)
    end , "ButtonReceive")

    self:AddListener("recharge_reward_fetched", function()
        local next_reward_times = player.player_modules.recharge:GetRechargeRewardTimes()+1
        self:Close()
        if next_reward_times <= 4 then             
            sUI:Open("app.views.ui.recharge.reward_recharge_ui")
        end   
    end)

    self:AddReleaseEvent( function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)  
        local close_callback = self.close_callback
        self:Close()
        if close_callback then close_callback() end
    end , "ButtonClose")

    self:Refresh()
end

function CRewardRechargeUI:onExit()

end

function CRewardRechargeUI:Refresh()
    -- local enable = player.player_modules.shop:IsRechargeRewardEnable()
    -- self:SetWidgetVisible(enable, "ButtonReceive")
    -- self:SetWidgetVisible(not enable, "ButtonRecharge")

    local current = player.player_modules.recharge:GetRechargeMoneyTotal()
    local max = player.player_modules.recharge:GetRechargeRewardCondition()
    if current > max then
        self:SetLoadingbarPercent(100, "ImageLoadingBar", "LoadingBar")
    else
        self:SetLoadingbarPercent(current / max * 100, "ImageLoadingBar", "LoadingBar")
    end
    self:SetLabelText("" .. current .. "/" .. max, "TextNumber")

    local next_reward_times = player.player_modules.recharge:GetRechargeRewardTimes()+1
    for i = 1, 4 do
        self:SetWidgetVisible(next_reward_times == i, "PanelStage" .. i)
    end
end

return CRewardRechargeUI
--endregion
