--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CReviveUI = class("game.CReviveUI", dxm.CDialogUI)

local CReviveUI = game.CReviveUI

function CReviveUI:ctor()
    CReviveUI.super.ctor(self)
end

function CReviveUI:Init(callback)
    self.callback = callback
    return self:InitWithFile("csd/Battle/BattleDeath")
end

function CReviveUI:Create(...)
    local ui = CReviveUI.new()
    if ui and ui:Init(...) then
        return ui
    end
    return nil
end

function CReviveUI:onEnter()

    self:AddReleaseEvent(function()
        dxm.audio:playSound(assets.sound.config.sound.ui_button_release)  
        self:PayForRevive()
    end, "ButtonDetermine")

    self:AddReleaseEvent(function()
        dxm.audio:playSound(assets.sound.config.sound.ui_button_release)  
        if self.callback then self.callback(false) end
        self:Close()
    end, "ButtonCancel")

    self:SetLabelText(sStringUtils:GetCombinedStringByID("pay_for_revive", { price=game.CAssetGame.revive_price }), "TextInformation")

    self:_RefreshAd()
end

function CReviveUI:_RefreshAd()

    local panel_name = "ButtonAdvertisement"
    self:SetWidgetVisible(sPlayer.player_modules.ad:IsPop(3), panel_name)
    self:AddReleaseEvent(function() 
        sPlayer.player_modules.ad:Pop(3, function(is_ok, reward_type, reward_param) 
            if is_ok then
                if self.callback then self.callback(true) end
                
                self:SetWidgetVisible(false, panel_name)
                self:Close()
            end
        end)
    end, panel_name)
end

function CReviveUI:PayForRevive()

    --[[
    sCtrlRecharge:Pay(game.CAssetGame.revive_price, game.CAssetGame.revive_payid, "pay_for_revive", function(is_successful)
        if is_successful then
            if self.callback then self.callback(true) end
            self:Close()
        end
    end)
    ]]--
    sPlayer.player_modules.point:SubPoint(game.CAssetGame.revive_price, function(is_successful) 

        if is_successful then
            if self.callback then self.callback(true) end
            self:Close()
        else
            sCtrlItem:PointIsNotEnough()
        end
    end)
end

return CReviveUI

--endregion
