--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CStageReviveUI = class("game.CStageReviveUI", dxm.CDialogUI)

local CStageReviveUI = game.CStageReviveUI

function CStageReviveUI:ctor()
    CStageReviveUI.super.ctor(self)
end

function CStageReviveUI:Init(callback, stage_type, stage_id, child_stage_id)
    self.callback = callback    
    self.stage_type = stage_type
    self.stage_id = stage_id
    self.child_stage_id = child_stage_id
    self.child_stage_entry = sPlayer.player_modules.stage:GetChildStageEntry(stage_type, stage_id, child_stage_id)
    if not self.child_stage_entry then
        return false
    end
    return self:InitWithFile("csd/Battle/Failed")
end

function CStageReviveUI:Create(...)
    local ui = CStageReviveUI.new()
    if ui and ui:Init(...) then
        return ui
    end
    return nil
end

function CStageReviveUI:onEnter()

    sPlayer.player_modules.stage.failed_times = sPlayer.player_modules.stage.failed_times + 1
    self:SetWidgetVisible(true, "PanelState1")
    self:SetWidgetVisible(false, "PanelState2")

    -- 返回按钮
    self:AddReleaseEvent(function() 
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
        local callback = self.callback
        self:OpenStageListUI()
        if callback then callback(false) end
    end, "ButtonOK")

    -- 再次挑战按钮
    self:AddReleaseEvent(function()
        local callback = self.callback
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)  
        self:OpenStageReadyUI()
        if callback then callback(false) end
    end, "PanelState1", "ButtonGoOn")

    -- 复活按钮
    self:AddReleaseEvent(function()
        dxm.audio:playSound(assets.sound.config.sound.ui_button_release)  
        self:PayForRevive()
    end, "PanelState1", "ButtonResurrection")

    self:SetLabelText(sStringUtils:GetCombinedStringByID("pay_for_revive", { price=game.CAssetGame.revive_price }), "TextInformation")
    self:SetLabelText(self.stage_id.."-"..self.child_stage_id.." "..sStrings:GetString(self.child_stage_entry.name), "TextNowCheckpointName")
    
    self:_RefreshAd()
end

function CStageReviveUI:_RefreshAd()

    local panel_name = "ButtonAdvertisement"
    self:SetWidgetVisible(sPlayer.player_modules.ad:IsPop(3), panel_name)
    self:AddReleaseEvent(function() 
        sPlayer.player_modules.ad:Pop(3, function(is_ok, reward_type, reward_param) 
            if is_ok then
                if self.callback then self.callback(true) end
                
                self:SetWidgetVisible(false, panel_name)
                self:Close()
            end
        end)
    end, panel_name)
end

function CStageReviveUI:PayForRevive()

    --[[
    sCtrlRecharge:Pay(game.CAssetGame.revive_price, game.CAssetGame.revive_payid, "pay_for_revive", function(is_successful)
        if is_successful then
            if self.callback then self.callback(true) end
            self:Close()
        end
    end)
    ]]--
    sPlayer.player_modules.point:SubPoint(game.CAssetGame.revive_price, function(is_successful) 

        if is_successful then
            if self.callback then self.callback(true) end
            self:Close()
        else
            sCtrlItem:PointIsNotEnough()
        end
    end)
end


function CStageReviveUI:OpenStageListUI()

    -- 关闭界面
    self:Close()

    -- 进入下一关的界面
    sUI:Open("app.views.ui.stage.stage_list_ui", self.stage_type, self.stage_id, self.child_stage_id)
end

function CStageReviveUI:OpenStageReadyUI()

    -- 关闭界面
    self:Close()

    -- 创建游戏场景
    require("app.views.game.game_ui"):Show(self.stage_type, self.stage_id, self.child_stage_id)

    -- 进入下一关的界面
    sUI:OpenWithClearStack("app.views.ui.stage.stage_ready_ui", self.stage_type, self.stage_id, self.child_stage_id)

    if sPlayer.player_modules.stage.failed_times>=3 then

        sUI:Open("dxm.ui.prefab.message_box_ok_cancel_ui", sStringUtils:GetString("@goto_level_up"), function(ok)
            if ok then
                local skin = sPlayer.player_modules.skins:GetActiveSkin()
                if skin then
                    sUI:Open("app.views.ui.skin_and_mount.skin_upgrade_ui", skin)
                end
            end
        end)
        sPlayer.player_modules.stage.failed_times = 0
    end
end


return CStageReviveUI

--endregion
