--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CRewardPopUI = class("game.CRewardPopUI", dxm.CNoticeUI)

local CRewardPopUI = game.CRewardPopUI

CRewardPopUI.pop_number = 0

function CRewardPopUI:ctor()
    CRewardPopUI.super.ctor(self)
end

function CRewardPopUI:Init()
    self:InitWithFile("csd/Main/MainShopFunction")
    self.is_package_show = false
    return true
end

function CRewardPopUI:Create()
    local ui = CRewardPopUI.new()
    if ui and ui:Init() then
        return ui
    end

    return nil
end

CRewardPopUI.g_reward_pop_ui = nil
function CRewardPopUI:Show(pos,reward_string,jump_distance)
    if not CRewardPopUI.g_reward_pop_ui then
        CRewardPopUI.g_reward_pop_ui = CRewardPopUI:Create()
    end

    if CRewardPopUI.g_reward_pop_ui then
        if not CRewardPopUI.g_reward_pop_ui.is_entered then
            dxm.CUIManager:GetInstancePtr():OpenUI( CRewardPopUI.g_reward_pop_ui, dxm.UIOrder.kUIOrderNotice, open_animation)  
        end
        CRewardPopUI.g_reward_pop_ui:Play(pos,reward_string,jump_distance) 
    end

end

function CRewardPopUI:ShowToUI(ui, pos, reward_string, jump_distance)

    if not CRewardPopUI.g_reward_pop_ui then
        CRewardPopUI.g_reward_pop_ui = CRewardPopUI:Create()
    end

    if CRewardPopUI.g_reward_pop_ui then
        if not CRewardPopUI.g_reward_pop_ui.is_entered then
            dxm.CUIManager:GetInstancePtr():OpenUI( CRewardPopUI.g_reward_pop_ui, dxm.UIOrder.kUIOrderNotice, open_animation)  
        end
        CRewardPopUI.g_reward_pop_ui:Play(pos,reward_string,jump_distance) 
    end
    
    if ui then
        ui.event_exit:Connect(function() 
            dxm.CUIManager:GetInstancePtr():CloseUI( CRewardPopUI.g_reward_pop_ui)
        end)
    end
end

function CRewardPopUI:onEnter()
    local widget = self:GetWidget("PanelBottomLayer","TextNumberTip")
    self.old_pos = cc.p(widget:getPositionX(),widget:getPositionY())
end

function CRewardPopUI:onExit()
end 

function CRewardPopUI:Play(show_pos,reward_string,jump_distance)

    self.package_widget = self:GetWidget("PanelBottomLayer","ImagePackageIcon")
    

    local x , y = self.package_widget:getPositionX(),self.package_widget:getPositionY()
    local package_pos = self.package_widget:getParent():convertToWorldSpace(cc.p(x,y))

    local diamond_widget = self:GetWidget("PanelTopLayer","ImageBottom","ImageDiamonds","AtlasLabelNumber")
    local diamond_pos = diamond_widget:convertToWorldSpace(cc.p(diamond_widget:getPositionX(),diamond_widget:getPositionY()))

    local gamebill_widget = self:GetWidget("PanelTopLayer","ImageBottom","ImageDiamonds","AtlasLabelNumber")
    local gamebill_pos = gamebill_widget:convertToWorldSpace(cc.p(gamebill_widget:getPositionX(),gamebill_widget:getPositionY()))

    local reward_list = game.sRewardHelper:ParseFromString(reward_string)
    local delay_time = 0
    if reward_list then
       for k,v in pairs (reward_list.list) do

			local actions = {}
			actions[#actions + 1] = cc.ScaleTo:create(0.21, 0.8, 1.2)
			actions[#actions + 1] = cc.ScaleTo:create(0.1, 1, 1.05)
			actions[#actions + 1] = cc.ScaleTo:create(0.06, 1.2, 0.85)
			actions[#actions + 1] = cc.ScaleTo:create(0.21, 0.8, 1.2)
			actions[#actions + 1] = cc.ScaleTo:create(0.1, 1, 1.05)
			actions[#actions + 1] = cc.ScaleTo:create(0.06, 1.2, 0.85)
			actions[#actions + 1] = cc.ScaleTo:create(0.06, 1, 1)
			local shake_action = cc.Sequence:create(actions)
            if v.reward_type == game.RewardType.kTypeItem then
                
                self.package_widget:setOpacity(255)
                self:SetWidgetVisible(false,"PanelBottomLayer","ImagePackageIcon")
                local icon = cc.Sprite:create(sPathHelper:GetRewardIconPath(v))
                if icon then
                    icon:setVisible(false)
                    local parent = self:GetWidget("Panel_5")
                    parent:addChild(icon)
                    local pos = parent:convertToNodeSpace(show_pos)
                    icon:setPosition(pos)
                    local speed =(pos.y - package_pos.y) / 2000
                    local action = cc.Sequence:create(
                    cc.DelayTime:create(delay_time),
                    cc.CallFunc:create( function() icon:setVisible(true) end),
                    cc.Spawn:create(
                    cc.JumpBy:create(1, jump_distance or cc.p(150, -100), 120, 3),
                    shake_action
                    ),
                    cc.Spawn:create(
                    cc.MoveTo:create(speed, package_pos),
                    cc.ScaleTo:create(speed, 0.3)
                    ),
                    cc.RemoveSelf:create(),
                    cc.CallFunc:create( function()
                        local ui = sShortcutHelper:GetBottom()
                        if ui then
                            ui:PlayPackageShake()
                            self.package_widget:setOpacity(0)
                            self:SetWidgetVisible(false, "PanelBottomLayer", "ImagePackageIcon")
                        else
                            self:PlayPackageShake()
                        end

                    end )
                    )
                    icon:runAction(action)
                end
            elseif v.reward_type == game.RewardType.kTypeActionPoint then
                game.CActionHelper:ActionPointHeartAdd()
            elseif v.reward_type == game.RewardType.kTypePoint then
                local icon = cc.Sprite:create(sPathHelper:GetRewardIconPath(v))
                if icon then
                    local parent = self:GetWidget("Panel_5")
                    parent:addChild(icon)
                    local pos = parent:convertToNodeSpace(show_pos)
                    icon:setPosition(pos)
                    local speed =(diamond_pos.y - pos.y) / 1400
                    local action = cc.Sequence:create(
                    cc.DelayTime:create(delay_time),
                    cc.CallFunc:create( function() icon:setVisible(true) end),
                    cc.Spawn:create(
                    cc.JumpBy:create(1, self.jump_distance or cc.p(150, -100), 120, 3),
                    shake_action
                    ),

                    cc.Spawn:create(
                    cc.MoveTo:create(speed, diamond_pos),
                    cc.ScaleTo:create(speed, 0.3)
                    ),
                    cc.RemoveSelf:create(),
                    cc.CallFunc:create( function()
                        local ui = sShortcutHelper:GetTop()
                        if ui then
                            ui:PlayDiamondShake()
                        end
                    end )
                    )
                    icon:runAction(action)
                end
            elseif v.reward_type == game.RewardType.kTypeGamebill then
                local icon = cc.Sprite:create(sPathHelper:GetRewardIconPath(v))
                if icon then
                    local parent = self:GetWidget("Panel_5")
                    parent:addChild(icon)
                    local pos = parent:convertToNodeSpace(show_pos)
                    icon:setPosition(pos)
                    local speed =(gamebill_pos.y - pos.y) / 1400
                    local action = cc.Sequence:create(
                    cc.DelayTime:create(delay_time),
                    cc.CallFunc:create( function() icon:setVisible(true) end),
                    cc.Spawn:create(
                    cc.JumpBy:create(1, self.jump_distance or cc.p(150, -100), 120, 3),
                    shake_action
                    ),

                    cc.Spawn:create(
                    cc.MoveTo:create(speed, gamebill_pos),
                    cc.ScaleTo:create(speed, 0.3)
                    ),
                    cc.RemoveSelf:create(),
                    cc.CallFunc:create( function()
                        local ui = sShortcutHelper:GetTop()
                        if ui then
                            ui:PlayDiamondShake()
                        end
                    end )
                    )
                    icon:runAction(action)
                end
            end
            delay_time = delay_time + 1
       end

    end
end

function CRewardPopUI:PlayPackageShake()
    sActionUtils:Shake(self.package_widget,function()
        
            self.package_widget:runAction(
                cc.Sequence:create(
                    cc.FadeOut:create(0.2),
                    cc.CallFunc:create(function() 
                        self.package_widget:setVisible(false)
                        self.package_widget:setOpacity(0)
                    end)
                )
            )
        if player.player_modules.package.reward_item_count == 0 then
            return
        end

        self:SetLabelText("+"..player.player_modules.package.reward_item_count,"PanelBottomLayer","TextNumberTip")
        self:SetWidgetVisible(true,"PanelBottomLayer","TextNumberTip")
        local widget = self:GetWidget("PanelBottomLayer","TextNumberTip")
        widget:setPosition(self.old_pos)
        widget:setOpacity(255)
        local pos = cc.p(widget:getPositionX(),widget:getPositionY())
        
        game.CActionHelper:PopAndMoveText(self:GetWidget("PanelBottomLayer","TextNumberTip"),function()
            self:SetWidgetVisible(false,"PanelBottomLayer","TextNumberTip")
        end)
        player.player_modules.package.reward_item_count = 0
    end)
end

return CRewardPopUI

--endregion
