--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CDiamondShopCellUI = class("game.CDiamondShopCellUI",dxm.CBaseUI)

local CDiamondShopCellUI = game.CDiamondShopCellUI

function CDiamondShopCellUI:ctor()
    CDiamondShopCellUI.super.ctor(self)
end

function CDiamondShopCellUI:Init(entity, remove_callback)

    if assets.opened.is_yys then
        if self:InitWithFile("csd/IconStrip/IconStripShopStripYYS") == false then        
            return false
        end
    else
        if self:InitWithFile("csd/IconStrip/IconStripShopStrip") == false then        
            return false
        end
    end
    self.entity = entity
    self.remove_callback = remove_callback

    return true
end

function CDiamondShopCellUI:Create(entity, remove_callback)
    if not entity then
        return nil
    end

    local ui = CDiamondShopCellUI.new()
    if ui and ui:Init(entity, remove_callback) then
        return ui
    end
    return nil
end

function CDiamondShopCellUI:onEnter()

    self:SetWidgetVisible(assets.version.branch == "yijie", "TextPhoneNumber")

    local gift = player.player_modules.recharge:GetGiftPoint(self.entity.id)
    if gift ~= 0 then
        local message = dxm.CStringCombiner.new()        
        if not player.player_modules.recharge:IsRecharged(self.entity.id) then
            message:Init(sStrings:GetString("first_recharge_gift_desc"))  
        else
            message:Init(sStrings:GetString("other_recharge_gift_desc"))
        end 
        message:SetValue("point", gift)
        print(message:Combine())
        self:SetLabelText(message:Combine(),"TextExtraGiftName")   
        self:SetWidgetVisible(true,"TextExtraGiftName")
    else
        self:SetWidgetVisible(false,"TextExtraGiftName")
    end
    
    local message = dxm.CStringCombiner.new()
    message:Init(sStrings:GetString(self.entity.title))
    message:SetValue("point",self.entity.point)
    self:SetLabelText(message:Combine(),"TextNumber")
    
    local icon_widget = self:GetWidget("ImageIconBottom","ImageIcon")
    if icon_widget then
        self.icon = cc.Sprite:create(self.entity.icon_path)
        if self.icon then
            icon_widget:addChild(self.icon)
        end
    end

    if assets.opened.is_yys then

        local text_money = self:GetWidget("TextMoney")
        if text_money then
            text_money:setString(sStrings:GetString("rmb")..self.entity.money)
        end
    elseif assets.version.branch=="google" then
        local button = self:GetWidget("ButtonBuy")
        if button then
            button:setTitleText(sStrings:GetString("dollar")..self.entity.money)
        end      
    else
        local button = self:GetWidget("TextBuy")
        if button then
            button:setString(sStrings:GetString("rmb")..self.entity.money)
        end
    end

    self:AddReleaseEvent(function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
        -- player.player_modules.recharge:Recharge(self.entity.id)
        sCtrlRecharge:Pay(self.entity.money, self.entity.id, self.entity.desc, function(is_successful)
            if is_successful then
                sHttpUser:RequestSavePayinfo(self.entity.money, assets.version.branch)
                player.player_modules.recharge:Recharge(self.entity.id)
                local gift = player.player_modules.recharge:GetGiftPoint(self.entity.id)
                if gift ~= 0 then
                    local message = dxm.CStringCombiner.new()        
                    if not player.player_modules.recharge:IsRecharged(self.entity.id) then
                        message:Init(sStrings:GetString("first_recharge_gift_desc"))  
                    else
                        message:Init(sStrings:GetString("other_recharge_gift_desc"))
                    end 
                    message:SetValue("point", gift)
                    print(message:Combine())
                    self:SetLabelText(message:Combine(),"TextExtraGiftName")   
                    self:SetWidgetVisible(true,"TextExtraGiftName")
                else
                    self:SetWidgetVisible(false,"TextExtraGiftName")
                end
                local widget = self:GetWidget("ImageIcon")
                local x ,y = widget:getPositionX(),widget:getPositionX()
                local pos = widget:convertToWorldSpace(cc.p(x,y))
                require("app.views.ui.reward_pop.reward_pop_ui"):Show(pos,"point")
                dxm.CMessageTipUI:Show(sStrings:GetString("buy_successful"))

                if  self.remove_callback and not player.player_modules.recharge:IsShowRecharge(self.entity.id) then  self.remove_callback(self) end
            else
                -- sUI:Open("dxm.ui.prefab.message_box_ok_ui", sStrings:GetString("recharge_failed"))
                return
            end
        end )
    end,"ButtonBuy")
end

function CDiamondShopCellUI:onExit()
    if self.icon then
        self.icon:removeFromParent()
        self.icon = nil
    end
end

return CDiamondShopCellUI

--endregion
