--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CGamebillShopCellUI = class("game.CGamebillShopCellUI",dxm.CBaseUI)

local CGamebillShopCellUI = game.CGamebillShopCellUI

function CGamebillShopCellUI:ctor()

    CGamebillShopCellUI.super.ctor(self)
end

function CGamebillShopCellUI:Init(entity, remove_callback)

    if self:InitWithFile("csd/IconStrip/IconStripShopGoldStrip") == false then        
        return false
    end
    self.entity = entity
    self.remove_callback = remove_callback
    return true
end

function CGamebillShopCellUI:Create(entity, remove_callback)

    if not entity then
        return nil
    end

    local ui = CGamebillShopCellUI.new()
    if ui and ui:Init(entity, remove_callback) then
        return ui
    end
    return nil
end

function CGamebillShopCellUI:onEnter()

    local gift = player.player_modules.shop:GetGiftGamebill(self.entity.id)
    if gift ~= 0 then
        local message = dxm.CStringCombiner.new()
        if not player.player_modules.shop:IsGamebillBuyed(self.entity.id) then
            message:Init(sStrings:GetString("first_buy_gamebill_gift_desc"))
        else
            message:Init(sStrings:GetString("other_buy_gamebill_gift_desc"))
        end
        message:SetValue(enum.NumberType.kTypeGamebill, gift)
        print(message:Combine())
        self:SetLabelText(message:Combine(), "TextExtraGiftName")
        self:SetWidgetVisible(true, "TextExtraGiftName")
    else
        self:SetWidgetVisible(false, "TextExtraGiftName")
    end

    local message = dxm.CStringCombiner.new()
    message:Init(sStrings:GetString(self.entity.title))
    message:SetValue(enum.NumberType.kTypeGamebill, self.entity.gamebill)
    self:SetLabelText(message:Combine(), "TextNumber")

    local icon_widget = self:GetWidget("ImageIconBottom", "ImageIcon")
    if icon_widget then
        self.icon = cc.Sprite:create(self.entity.icon_path)
        if self.icon then
            icon_widget:addChild(self.icon)
        end
    end

    self:SetLabelText(tostring(self.entity.price), "TextBuy")

    self:AddReleaseEvent( function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
        if player.player_modules.point:GetPoint() >= self.entity.price then
            player.player_modules.point:SubPoint(self.entity.price, function(is_successful)
                if is_successful then
                    sThirdPlatformUtils:LogEvent("item_purchase", '{"item":"gamebill_'..self.entity.gamebill..'", "item_count":1, "price":'..self.entity.price.."}")
                    local reward = "gamebill/" .. player.player_modules.shop:GetGiftGamebill(self.entity.id) + self.entity.gamebill
                    player.player_modules.reward:TakeRewardString(reward)
                    dxm.CMessageTipUI:Show(sStrings:GetString("buy_successful"))
                    local widget = self:GetWidget("ImageIcon")
                    local x, y = widget:getPositionX(), widget:getPositionX()
                    local pos = widget:convertToWorldSpace(cc.p(x, y))
                    require("app.views.ui.reward_pop.reward_pop_ui"):Show(pos, reward)
                else
                    game.CCtrlItem:PointIsNotEnough()
                end
            end )
        else
            game.CCtrlItem:PointIsNotEnough()
        end
    end , "ButtonBuy")
end

function CGamebillShopCellUI:onExit()
    if self.icon then
        self.icon:removeFromParent()
        self.icon = nil
    end
end

return CGamebillShopCellUI

--endregion
