--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CGiftPackageV2UI = class("game.CGiftPackageV2UI",dxm.CDialogUI)

local CGiftPackageV2UI = game.CGiftPackageV2UI

function CGiftPackageV2UI:ctor()
    CGiftPackageV2UI.super.ctor(self)
end

function CGiftPackageV2UI:Init(id, close_callback)

    self.close_callback = close_callback
    
    self.id = id
    self.entry = assets.shop_gift_package.config[self.id]

    if not self.entry or not self.entry.ui_name then
        return
    end

    return self:InitWithFile(self.entry.ui_name)
end

function CGiftPackageV2UI:Create(...)

    local ui = CGiftPackageV2UI.new()
    if ui and ui:Init(...) then
        return ui
    end
    return nil
end

function CGiftPackageV2UI:onEnter()

    self:SetWidgetVisible(assets.version.branch == "yijie", "TextPhoneNumber")

    self:AddReleaseEvent(function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)  
        player.player_modules.recharge:BuyGiftPackage(self.id, function(is_successful)
            if is_successful then
                local center_pos = dxm.VisibleRect:center()
                require("app.views.ui.reward_pop.reward_pop_ui"):Show(center_pos, assets.shop_gift_package.config[self.id].reward)
            end
            local close_callback = self.close_callback
            self:Close()
            if close_callback then 
                close_callback()
            end
        end)
    end,"ButtonReceive")

    self:AddReleaseEvent(function() 
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
        player.player_modules.recharge:BuyGiftPackage(self.id, function(is_successful)
            if is_successful then
                local center_pos = dxm.VisibleRect:center()
                require("app.views.ui.reward_pop.reward_pop_ui"):Show(center_pos,assets.shop_gift_package.config[self.id].reward)
            end
            local close_callback = self.close_callback
            self:Close()                
            if close_callback then 
                close_callback() 
            end
        end)
    end,"ButtonBuy")

    self:AddReleaseEvent(function()     
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)    
        player.player_modules.recharge:BuyGiftPackage(self.id, function(is_successful)
            if is_successful then
                local center_pos = dxm.VisibleRect:center()
                require("app.views.ui.reward_pop.reward_pop_ui"):Show(center_pos,assets.shop_gift_package.config[self.id].reward)           
            end
            local close_callback = self.close_callback
            self:Close()
            if close_callback then 
                close_callback() 
            end
        end)
    end,"ButtonRecharge")

    if self.entry.is_bad_guy=="true" then       
        self:AddReleaseEvent(function()
            dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
            player.player_modules.recharge:BuyGiftPackage(self.id, function(is_successful)
                if is_successful then
                    local center_pos = dxm.VisibleRect:center()
                    require("app.views.ui.reward_pop.reward_pop_ui"):Show(center_pos,assets.shop_gift_package.config[self.id].reward)
                end
                local close_callback = self.close_callback
                self:Close()  
                if close_callback then 
                    close_callback() 
                end
            end)
        end,"Panel_5")
    end

    self:SetWidgetVisible(false, "ButtonReceive")

    self:AddReleaseEvent(function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)         
        if self.id == 6 or self.id == 7 then              
            sPlayer.player_modules.stat:Chg(enum.StatType.kTypeBadGuyCloseTimes, 1)   
        end   
        local close_callback = self.close_callback
        self:Close()
        if close_callback then close_callback() end

    end,"ButtonClose")
    

    for i=1, 100 do
        local widget = self:GetWidget("PanelIconGoodsRoot"..i)
        if not widget then
            break
        end
        widget:setVisible(false)
    end
    local count = 1
    local reward_list = game.CRewardList:ParseFromString(self.entry.reward)
    for _,reward in pairs(reward_list.list) do
        local widget = self:GetWidget("PanelIconGoodsRoot"..count)
        if not widget then
            break
        end
        widget:setVisible(true)
        self:SetImageViewPicture(sPathHelper:GetRewardIconPath(reward), widget, "Image_9")
        self:SetLabelText("x"..reward.count, widget, "TextName")
        count = count + 1
    end
end

function CGiftPackageV2UI:onExit()

end

return CGiftPackageV2UI
--endregion
