--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CPropShopCellUI = class("game.CShopCellUI",dxm.CBaseUI)

local CPropShopCellUI = game.CPropShopCellUI

function CPropShopCellUI:ctor()
    CPropShopCellUI.super.ctor(self)
end

function CPropShopCellUI:Init(entity)
    if self:InitWithFile("csd/IconStrip/IconStripShopPropStrip") == false then
        return false
    end

    self.entity = entity

    return true
end

function CPropShopCellUI:Create(entity)
    if not entity then
        return
    end

    local ui = CPropShopCellUI.new()
    if ui and ui:Init(entity) then
        return ui
    end
end

function CPropShopCellUI:onEnter()
    self:SetLabelText(assets.shop_item:GetName(self.entity.id),"ImageRankingStrip","TextPropName")
    self:SetLabelText(assets.shop_item:GetDesc(self.entity.id),"ImageRankingStrip","TextExplain")

    self:SetLabelText(tostring(self.entity.price), "TextBuy")

    local icon_widget = self:GetWidget("ImageIconBottom","ImageIcon")
    if icon_widget then
        self.icon = cc.Sprite:create(self.entity.icon_path)
        if self.icon then
            icon_widget:addChild(self.icon)
        end
    end

    --显示道具数量
    local reward = game.CReward:Create(self.entity.reward)
    self:SetLabelText("x"..reward.count,"AtlasLabelNumber")

    self:AddReleaseEvent(function() 
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
        sUI:Open("app.views.ui.package.item_tip_ui", self.entity.id, function()                 
            end)       
    end, "ImageIconBottom")

    self:AddReleaseEvent(function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
        if player.player_modules.point:GetPoint() >= self.entity.price then
            player.player_modules.point:SubPoint(self.entity.price,function(is_successful)
                if is_successful then
                    local reward_list = game.sRewardHelper:ParseFromString(self.entity.reward)
                    local delay_time = 0
                    if reward_list then
                        for k,v in pairs (reward_list.list) do  
                            if v.reward_type == "item" then
                                sThirdPlatformUtils:LogEvent("item_purchase", "{\"item\":\""..v.reward_type.."_"..v.id.."\", \"item_count\":"..v.count..", \"price\":"..self.entity.price.."}")
                            else
                                sThirdPlatformUtils:LogEvent("item_purchase", "{\"item\":\""..v.reward_type.."\", \"item_count\":"..v.count..", \"price\":"..self.entity.price.."}")
                            end
                        end    
                    end
                    player.player_modules.reward:TakeRewardString(self.entity.reward)
                    dxm.CMessageTipUI:Show(sStrings:GetString("buy_successful"))
                    local widget = self:GetWidget("ImageIcon")
                    local x ,y = widget:getPositionX(),widget:getPositionX()
                    local pos = widget:convertToWorldSpace(cc.p(x,y))
                    require("app.views.ui.reward_pop.reward_pop_ui"):Show(pos,self.entity.reward)
                else
                    sUI:Open("dxm.ui.prefab.message_box_ok_ui", sStrings:GetString("buy_failed"))
                end
            end)
        else
            -- 点券不足则弹出重置快链;
             sUI:Open("dxm.ui.prefab.message_box_ok_ui", sStrings:GetString("buy_failed"))
        end
    end,"ButtonBuy")
end

function CPropShopCellUI:onExit()
    if self.icon then
        self.icon:removeFromParent()
        self.icon = nil
    end
end

return CPropShopCellUI

--endregion
