--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local CDiamondShopCellUI = require("app.views.ui.shop.diamond_shop_cell_ui")
local CPropShopCellUI = require("app.views.ui.shop.prop_shop_cell_ui")
local CGamebillCellUI = require("app.views.ui.shop.gamebill_shop_cell_ui")
local CActionPointCellUI = require("app.views.ui.shop.action_point_shop_cell_ui")
local CFirstRechargeCell = class("CFristRechargeCell",dxm.CBaseUI)

function CFirstRechargeCell:ctor()
    CFirstRechargeCell.super.ctor(self)
end

function CFirstRechargeCell:Init()
    return self:InitWithFile("csd/IconStrip/IconStripShopAdvertisement")
end

function CFirstRechargeCell:Create()
    local ui = CFirstRechargeCell.new()
    if ui and ui:Init() then
        return ui
    end

    return nil
end


game.CShopDialogUI  = class("game.CShopDialogUI",dxm.CGameDialogUI)

local CShopDialogUI = game.CShopDialogUI

function CShopDialogUI:ctor()
    CShopDialogUI.super.ctor(self)
end

function CShopDialogUI:Init(shop_tap, show_bottom)
    local file_name
    local default_shop_tap
    if assets.version.branch == "baidu" then
        file_name = "csd/Checkpoint/CheckpointShopPopBaidu"
        default_shop_tap = "action_point"
    else
        file_name = "csd/Checkpoint/CheckpointShopPop"
        default_shop_tap = "diamon"
    end
    if self:InitWithFile(file_name) == false then
        return false
    end
    self.point_list = nil
    self.prop_list = nil
    self.shop_tap = shop_tap or default_shop_tap
    self.show_bottom = show_bottom or true
    return true
end

function CShopDialogUI:Create(...)
    local ui = CShopDialogUI.new()
    if ui and ui:Init(...) then
        print("debug print : return ui")
        return ui
    end
end

function CShopDialogUI:onEnter()
  
    CShopDialogUI.ui = self

    self.scroll_view = dxm.CScrollViewUI:Create(self:GetWidget("ScrollView"))
    self:AddChild(self.scroll_view)
    self.scroll_view.fix_tail = 0

    if self.shop_tap == "item" then
        self:ShowPropShop()
    elseif self.shop_tap == "action_point" then
        self:ShowActionPointShop()
    elseif self.shop_tap == enum.NumberType.kTypeGamebill then
        self:ShowGamebillShop()
    else
        self:ShowDiamondsShop()
    end

    self:AddReleaseEvent(function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
        self:ShowDiamondsShop()
    end,"ButtonDiamonds")
       
    self:AddReleaseEvent(function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
        -- self:ShowPropShop()
        self:ShowActionPointShop()
    end,"ButtonProp")

    self:AddReleaseEvent(function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
        self:ShowGamebillShop()
    end,"ButtonGold")

    self:AddReleaseEvent(function(sender)
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)   
        self:Close()
    end,
    "ButtonReturn") 

    self:AddReleaseEvent(function(sender)
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)   
        self:Close()
    end,
    "ButtonClose") 

    self:AddListener("first_recharge", function() 
        sUI:Open("app.views.ui.recharge.first_recharge_ui")
    end)
end

function CShopDialogUI:onExit()

    -- if self.top_ui then self.top_ui:CloseUI() end
end

function CShopDialogUI:RemoveCell(cell)
    local action = cc.Sequence:create(
        cc.MoveBy:create(0.3,cc.p(700,0)),
        cc.CallFunc:create(function()
            self.scroll_view:RemoveCell(cell)
        end)
    )
    cell.widget:runAction(action)
end

function CShopDialogUI:ShowDiamondsShop()
     self:SetWidgetEnable(false, "ButtonDiamonds" )
     self:SetWidgetEnable(true, "ButtonProp" )
     self:SetWidgetEnable(true, "ButtonGold" )

    self.scroll_view:RemoveAllCells()

--    local cell = nil
--    if not player.player_modules.recharge:IsFirstRechargeRewarded() then
--        cell = CFirstRechargeCell:Create()
--        self.scroll_view:AddCell(cell)
--    end

    if not self.point_list then
        self.point_list = {}
        for k ,v in pairs(assets.shop_point.config) do
            table.insert(self.point_list,k)
        end
        table.sort(self.point_list)
    end
    
    for k ,v in pairs(self.point_list) do
        local cell = CDiamondShopCellUI:Create(assets.shop_point.config[v], function(cell) self:RemoveCell(cell) end)
        
        if cell and player.player_modules.recharge:IsShowRecharge(v) then
            self.scroll_view:AddCell(cell)
        end
    end

    self.scroll_view:InitPosition()
end

function CShopDialogUI:ShowPropShop()
     self:SetWidgetEnable(true, "ButtonDiamonds" )
     self:SetWidgetEnable(false, "ButtonProp" )
     self:SetWidgetEnable(true, "ButtonGold" )
     self.scroll_view:RemoveAllCells()
     
     if not self.prop_list then
        self.prop_list = {}
        for k ,v in pairs(assets.shop_item.config) do
            table.insert(self.prop_list,k)
        end
        table.sort(self.prop_list)
    end
    
     for k , v in pairs(self.prop_list) do
        local cell = CPropShopCellUI:Create(assets.shop_item.config[v])
        if cell then
            self.scroll_view:AddCell(cell)
        end
    end

    self.scroll_view:InitPosition()
end

function CShopDialogUI:ShowGamebillShop()
     self:SetWidgetEnable(true, "ButtonDiamonds" )
     self:SetWidgetEnable(true, "ButtonProp" )
     self:SetWidgetEnable(false, "ButtonGold" )
     self.scroll_view:RemoveAllCells()
     
    self.scroll_view:RemoveAllCells()

    if not self.gamebill_list then
        self.gamebill_list = {}
        for k ,v in pairs(assets.shop_gamebill.config) do
            table.insert(self.gamebill_list, k)
        end
        table.sort(self.gamebill_list)
    end
    
    for k ,v in pairs(self.gamebill_list) do
        local cell = CGamebillCellUI:Create(assets.shop_gamebill.config[v], function(cell) self:RemoveCell(cell) end)
        if cell then
            self.scroll_view:AddCell(cell)
        end
    end

    self.scroll_view:InitPosition()
end

function CShopDialogUI:ShowActionPointShop()

     self:SetWidgetEnable(true, "ButtonDiamonds" )
     self:SetWidgetEnable(false, "ButtonProp" )
     self:SetWidgetEnable(true, "ButtonGold" )
     self.scroll_view:RemoveAllCells()
     
    self.scroll_view:RemoveAllCells()

    if not self.action_point_list then
        self.action_point_list = {}
        for k ,v in pairs(assets.shop_action_point.config) do
            table.insert(self.action_point_list, k)
        end
        table.sort(self.action_point_list)
    end
    
    for k ,v in pairs(self.action_point_list) do
        local cell = CActionPointCellUI:Create(assets.shop_action_point.config[v], function(cell) self:RemoveCell(cell) end)
        if cell then
            self.scroll_view:AddCell(cell)
        end
    end

    self.scroll_view:InitPosition()
end

return CShopDialogUI


--endregion
