-- region *.lua
-- Date
-- 此文件由[BabeLua]插件自动生成

game.CShopGoodsInfoUI = class("game.CShopGoodsInfoUI", dxm.CDialogUI)
local CShopGoodsInfoUI = game.CShopGoodsInfoUI

function CShopGoodsInfoUI:ctor()
    CShopGoodsInfoUI.super.ctor(self)
end

function CShopGoodsInfoUI:Init(entry)
    self.entry = entry
    return self:InitWithFile("csd/Additional/ShopGoodsPop")
end

function CShopGoodsInfoUI:Create(...)
    local ui = CShopGoodsInfoUI.new()
    if ui and ui:Init(...) then
        return ui
    end

    return nil
end


function CShopGoodsInfoUI:onEnter()
    self:SetLabelText("", "TextGoodsName_0")
    if self.entry.coin_type == "point" then
        self:SetLabelText("x" .. self.entry.price, "TextBuy")
        self:SetWidgetVisible(true, "ImageDiamonds")
        self:SetWidgetVisible(false, "ImageGold")
        self:SetWidgetVisible(false, "TextRMBName")
        if self.entry.shop_type == "prop" then
            -- 道具
            local reward = game.CReward:Create(self.entry.reward)
            self:SetLabelText("x" .. reward.count, "TextNumber")
            self:SetLabelText(sStrings:GetString(self.entry.desc), "TextGoodsName_0")
        else
            -- 金币
            self:SetLabelText("x" .. self.entry.gamebill, "TextNumber")
        end

    elseif self.entry.coin_type == "rmb" then
        self:SetWidgetVisible(false, "ImageDiamonds")
        self:SetWidgetVisible(false, "ImageGold")
        self:SetWidgetVisible(true, "TextRMBName")
        self:SetLabelText("x" .. self.entry.money, "TextRMB")
    end

    local icon_pos = self:GetWidget("ImageGoodsIcon")
    if icon_pos then
        self.icon = cc.Sprite:create(self.entry.icon_path)
        if self.icon then
            icon_pos:addChild(self.icon)
        end
    end

    -- 名字和介绍
    if self.entry.shop_type == "prop" then
        self:SetLabelText(sStrings:GetString(self.entry.name), "TextGoodsName")
    elseif self.entry.title then
        local message = dxm.CStringCombiner.new()
        message:Init(sStrings:GetString(self.entry.title))
        if self.entry.shop_type == "point" then
            message:SetValue("point", self.entry.point)
        else
            message:SetValue(enum.NumberType.kTypeGamebill, self.entry.gamebill)
        end
        self:SetLabelText(message:Combine(), "TextGoodsName")
    end

    self:AddReleaseEvent( function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
        self:Close()
    end , "ButtonClose")

    if self.entry.shop_type == "prop" then
        self:AddReleaseEvent( function()
            dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
            if player.player_modules.point:GetPoint() >= self.entry.price then
                player.player_modules.point:SubPoint(self.entry.price, function(is_successful)
                    if is_successful then
                        local reward_list = game.sRewardHelper:ParseFromString(self.entry.reward)
                        local delay_time = 0
                        if reward_list then
                            for k, v in pairs(reward_list.list) do
                                if v.reward_type == "item" then
                                    sThirdPlatformUtils:LogEvent("item_purchase", "{\"item\":\"" .. v.reward_type .. "_" .. v.id .. "\", \"item_count\":" .. v.count .. ", \"price\":" .. self.entry.price .. "}")
                                else
                                    sThirdPlatformUtils:LogEvent("item_purchase", "{\"item\":\"" .. v.reward_type .. "\", \"item_count\":" .. v.count .. ", \"price\":" .. self.entry.price .. "}")
                                end
                            end
                        end
                        player.player_modules.reward:TakeRewardString(self.entry.reward)
                        dxm.CMessageTipUI:Show(sStrings:GetString("buy_successful"))
--                        local widget = self:GetWidget("ImageIcon")
--                        local x, y = widget:getPositionX(), widget:getPositionX()
--                        local pos = widget:convertToWorldSpace(cc.p(x, y))
--                        require("app.views.ui.reward_pop.reward_pop_ui"):Show(pos, self.entry.reward)
                    else
                        sUI:Open("dxm.ui.prefab.message_box_ok_ui", sStrings:GetString("buy_failed"))
                    end
                end )
            else
                -- 点券不足则弹出重置快链;
                sUI:Open("dxm.ui.prefab.message_box_ok_ui", sStrings:GetString("buy_failed"))
            end
        end , "ButtonBuy")
    end

    if self.entry.shop_type == enum.NumberType.kTypeGamebill then
        self:AddReleaseEvent( function()
            dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
            if player.player_modules.point:GetPoint() >= self.entry.price then
                player.player_modules.point:SubPoint(self.entry.price, function(is_successful)
                    if is_successful then
                        sThirdPlatformUtils:LogEvent("item_purchase", '{"item":"gamebill_' .. self.entry.gamebill .. '", "item_count":1, "price":' .. self.entry.price .. "}")
                        local reward = "gamebill/" .. player.player_modules.shop:GetGiftGamebill(self.entry.id) + self.entry.gamebill
                        player.player_modules.reward:TakeRewardString(reward)
                        dxm.CMessageTipUI:Show(sStrings:GetString("buy_successful"))
--                        local widget = self:GetWidget("ImageIcon")
--                        local x, y = widget:getPositionX(), widget:getPositionX()
--                        local pos = widget:convertToWorldSpace(cc.p(x, y))
--                        require("app.views.ui.reward_pop.reward_pop_ui"):Show(pos, reward)
                    else
                        sUI:Open("dxm.ui.prefab.message_box_ok_ui", sStrings:GetString("buy_failed"))
                    end
                end )
            else
                -- 点券不足则弹出重置快链;
                sUI:Open("dxm.ui.prefab.message_box_ok_ui", sStrings:GetString("buy_failed"))
            end
        end , "ButtonBuy")
    end

    if self.entry.shop_type == "point" then
        self:AddReleaseEvent( function()
            dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
            -- player.player_modules.shop:Recharge(self.entry.id)
            sCtrlRecharge:Pay(self.entry.money, self.entry.id, self.entry.desc, function(is_successful)
                if is_successful then
                    sHttpUser:RequestSavePayinfo(self.entry.money, assets.version.branch)
                    player.player_modules.shop:Recharge(self.entry.id)
                    local gift = player.player_modules.shop:GetGiftPoint(self.entry.id)
                    if gift ~= 0 then
                        local message = dxm.CStringCombiner.new()
                        if not player.player_modules.shop:IsRecharged(self.entry.id) then
                            message:Init(sStrings:GetString("first_recharge_gift_desc"))
                        else
                            message:Init(sStrings:GetString("other_recharge_gift_desc"))
                        end
                        message:SetValue("point", gift)
                        print(message:Combine())
                        self:SetLabelText(message:Combine(), "TextExtraGiftName")
                        self:SetWidgetVisible(true, "TextExtraGiftName")
                    else
                        self:SetWidgetVisible(false, "TextExtraGiftName")
                    end
--                    local widget = self:GetWidget("ImageIcon")
--                    local x, y = widget:getPositionX(), widget:getPositionX()
--                    local pos = widget:convertToWorldSpace(cc.p(x, y))
--                    require("app.views.ui.reward_pop.reward_pop_ui"):Show(pos, "point")
                    dxm.CMessageTipUI:Show(sStrings:GetString("buy_successful"))

                    if self.remove_callback and not player.player_modules.shop:IsShowRecharge(self.entry.id) then self.remove_callback(self) end
                else
                    -- sUI:Open("dxm.ui.prefab.message_box_ok_ui", sStrings:GetString("recharge_failed"))
                    return
                end
            end )
        end , "ButtonBuy")
    end
end

function CShopGoodsInfoUI:onExit()
    if self.icon then
        self.icon:removeFromParent()
    end
end

return CShopGoodsInfoUI

-- endregion
