--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CSignIconUI = class("game.CSignIconUI",dxm.CBaseUI)

local CSignIconUI = game.CSignIconUI

function CSignIconUI:ctor()
    CSignIconUI.super.ctor(self)
end

function CSignIconUI:Init(day_)
    self.day = day_
    self.entry = assets.sign_reward.config[self.day]
    if not self:InitWithFile("csd/IconStrip/IconStripSignIcon") then return false end

    return true
end

function CSignIconUI:Create(day)
    local ui = CSignIconUI.new()

    if ui and ui:Init(day) then
        return ui
    end

    return nil
end

function CSignIconUI:onEnter()

    self:RefreshReceiveStatus()
    -- 获取奖励信息并显示
    local reward_string = self.entry.reward
    local reward = game.CReward:Create(reward_string)
    if reward then

        self:SetImageViewPicture(sPathHelper:GetRewardIconPath(reward), "ImageIconGoods")
        self:SetLabelText("x" .. reward.count, "TextNumber")
    end

    self:SetLabelText(sStrings:GetString(self.entry.name),"TextDay")
end


function CSignIconUI:onExit()
    if self.spine then
        self.spine:removeFromParent()
        self.spine = nil
    end
end

function CSignIconUI:RefreshReceiveStatus()
    if self.day > player.player_modules.sign:GetCurrentSignDay() or (self.day == player.player_modules.sign:GetCurrentSignDay() and not player.player_modules.sign:CheckTodaySigned()) then
        --未签到
        self:SetWidgetVisible(true,"ImageBottom1")
        self:SetWidgetVisible(false,"ImageBottom2")
        self:SetWidgetVisible(false,"ImageTag")
        self:SetWidgetVisible(true,"TextDay")
        self:SetWidgetVisible(false,"TextTag")
    else
        --已签到
        self:SetWidgetVisible(false,"ImageBottom1")
        self:SetWidgetVisible(true,"ImageBottom2")
        self:SetWidgetVisible(true,"ImageTag")
        self:SetWidgetVisible(false,"TextDay")
        self:SetWidgetVisible(true,"TextTag")
    end
end

return CSignIconUI

--endregion
