--region *.lua
--Date
--此文件由[BabeLua]插件自动生成
require("app.views.ui.sign.sign_cell_ui")

game.CSignUI = class("game.CSignUI",dxm.CDialogUI)

local CSignUI = game.CSignUI

function CSignUI:ctor()
    CSignUI.super.ctor(self)
    self.icon_list = {}
end

function CSignUI:Init(close_callback)

    self.close_callback = close_callback
    self:InitWithFile("csd/Additional/AdditionalSign")
    return true
end

function CSignUI:Create(...)
    local ui = CSignUI.new()
    if ui and ui:Init(...) then
        return ui
    end

    return nil
end

function CSignUI:onEnter()

    -- sShortcutHelper:OpenTop()
    self:Refresh()

    self:AddReleaseEvent( function()
        local close_callback = self.close_callback
        self:Close()
        if close_callback then close_callback() end
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
    end , "ButtonClose")

    self:AddReleaseEvent(function()
        local close_callback = self.close_callback 
        self:Close()
        if close_callback then close_callback() end
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
    end,"ButtonClose")
    
    self:SetWidgetVisible(not player.player_modules.sign:CheckTodaySigned(),"ButtonSign")
    self:SetWidgetVisible(player.player_modules.sign:CheckTodaySigned(),"ButtonClose")

    self:AddReleaseEvent( function()
        if not player.player_modules.sign:CheckTodaySigned() then
            player.player_modules.sign:Sign()
            local day = player.player_modules.sign:GetCurrentSignDay()
            if day == 8 then
                self:RefreshReceiveStatus()
            else
                local icon_ui = self.icon_list[day-1]
                if icon_ui then
                    icon_ui:RefreshReceiveStatus()
                end
            end
            dxm.CMessageTipUI:Show(sStrings:GetString("sign_ok"))

            -- dxm.audio:playSound(assets.const.sound_sign)
        else
            dxm.CMessageTipUI:Show(sStrings:GetString("already_sign_in"))
        end

        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
        self:SetWidgetVisible(not player.player_modules.sign:CheckTodaySigned(),"ButtonSign")
        self:SetWidgetVisible(player.player_modules.sign:CheckTodaySigned(),"ButtonClose")
        local close_callback = self.close_callback 
        self:Close()
        if close_callback then close_callback() end
    end , "ButtonSign")


    self:AddListener("sign_daily_clear", function()
        print("----------- sign_daily_clear") 
        self:Refresh()
    end)

    self:ScheduleUpdate(function() 
    end)
end

function CSignUI:Refresh()

    for i = 1, 6 do
        local icon = game.CSignIconUI:Create(i)
        self:RemoveAllChildren("PanelRewardRoot" .. i)
        self:AddChildWithWidgetName("PanelRewardRoot" .. i, icon)
        self.icon_list[i] = icon
    end

    local reward_list = game.sRewardHelper:ParseFromString(assets.sign_reward.config[7].reward)
    local count = 1
    for _, reward in pairs(reward_list.list) do

        self:SetImageViewPicture(sPathHelper:GetRewardIconPath(reward), "PanelRewardIcon"..count, "ImageIconGoods")
        self:SetLabelText("x"..reward.count,"PanelRewardIcon"..count,"TextNumber")
        count = count + 1
    end

    self:RefreshReceiveStatus()

    self:SetWidgetVisible(not player.player_modules.sign:CheckTodaySigned(),"ButtonSign")
    self:SetWidgetVisible(player.player_modules.sign:CheckTodaySigned(),"ButtonClose")
end

function CSignUI:RefreshReceiveStatus()
    -- 第七天的大奖励;
    if player.player_modules.sign:GetCurrentSignDay()<7 or not player.player_modules.sign:CheckSigned(player.player_modules.sign:GetCurrentSignDay()) then
        self:SetWidgetVisible(false,"ImageBottom","ImageTag1")
        self:SetWidgetVisible(false,"ImageDayBottom11","TextTag")
        self:SetWidgetVisible(true,"ImageDayBottom11","TextTip")
        self:SetWidgetVisible(false, "ImageBottom11")
    else
        self:SetWidgetVisible(true,"ImageBottom","ImageTag1")
        self:SetWidgetVisible(true,"ImageDayBottom11","TextTag")
        self:SetWidgetVisible(false,"ImageDayBottom11","TextTip")
        self:SetWidgetVisible(true, "ImageBottom11")
    end
end

return CSignUI

--endregion
