--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CMountCellUI = class("game.CMountCellUI",dxm.CBaseUI)

local CMountCellUI = game.CMountCellUI

function CMountCellUI:ctor()

    CMountCellUI.super.ctor(self)

    self.gray = false
end

function CMountCellUI:Init(mount, select_changed_callback)

    if not mount then
        return false
    end

    local entry = assets.mounts:GetEntry(mount.id)
    if not entry then
        return false
    end
    
    self.mount = mount
    self.entry = entry
    self.select_changed_callback = select_changed_callback
    self:InitWithFile("csd/IconStrip/IconStripShopMountStrip")
    return true
end

function CMountCellUI:Create(...)

    local ui = CMountCellUI.new()
    if ui and ui:Init(...) then
        return ui
    end
    return nil
end

function CMountCellUI:Refresh()

    local buyed = player.player_modules.mounts:IsBuyed(self.mount.id)
    local unlocked = player.player_modules.mounts:IsUnlock(self.mount.id)
    local actived = player.player_modules.mounts:IsActiveMount(self.mount.id)

    -- 名字;
    self:SetLabelText(sStrings:GetString(self.entry.Name), "TextMountName")
    -- 描述;
    self:SetLabelText(sStrings:GetString(self.entry.Desc), "TextExplain")
    -- 头像;
    self:SetImageViewPicture(self.entry.Icon, "ImageHeadPortrait")
    if buyed then
        if self.gray then
            sShaderUtils:RemoveGray(self:GetWidget("ImageHeadPortrait"))
            self.gray = false
        end
    else
        sShaderUtils:AddGray(self:GetWidget("ImageHeadPortrait"))
        self.gray = true
    end

    -- 技能
    --[[
    local key = 0
    for _, skill_id in pairs(self.mount.skill_list) do

        key = key + 1
        local entry = assets.skills:GetEntry(skill_id)
        local widget = self:GetWidget("PanelSkill"..key) 
        if entry and widget then   
            self:SetWidgetVisible(true, widget)  
            self:SetImageViewPicture(entry.Icon, widget, "ImageSkillIcon")
            self:AddReleaseEvent(function() 
                dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)  
                sUI:Open("app.views.ui.mounts.mount_skill_ui", self.mount, skill_id) 
            end, widget, "ButtonTip")
            self:SetLabelText(sStringUtils:GetString("@"..entry.Name), widget, "TextSkillName")
            self:SetLabelText(sStringUtils:GetString("@"..entry.Desc, {value=player.player_modules.mounts:GetMountSkillValue(self.mount.id, skill_id)}), widget, "TextExplain")
        end
    end
    ]]--
      
    self:SetWidgetVisible(not buyed, "ButtonPreview")

    if buyed==true then
        self:SetWidgetVisible(actived, "ImageCurrent")
        self:SetWidgetVisible(not actived, "ButtonReplace") 
        self:SetWidgetVisible(actived, "PanelDismount") 

        self:SetWidgetVisible(true, "TextLvName")
        self:SetWidgetVisible(false, "TextLvName2")
        self:SetLabelText(self.mount.level.."/"..self.entry.MaxLevel, "TextLvName", "TextLv")
        if player.player_modules.mounts:IsFullLevel(self.mount.id)==true then           
            self:SetWidgetVisible(false, "ButtonUpgrade")
            self:SetWidgetVisible(false, "ButtonBuy")
            self:SetWidgetVisible(true, "ImageMax")
            self:SetWidgetVisible(false, "ImageLock")
        else
            self:SetWidgetVisible(true, "ButtonUpgrade")
            self:SetWidgetVisible(false, "ButtonBuy")
            self:SetWidgetVisible(false, "ImageMax")
            self:SetWidgetVisible(false, "ImageLock")
        end

        self:AddReleaseEvent(function() 
            dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)  
            sUI:Open("app.views.ui.skin_and_mount.mount_upgrade_ui", self.mount, function(mount)
            end)
        end, "ButtonUpgrade")

        self:AddReleaseEvent(function() 
            dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)  
            sUI:Open("app.views.ui.skin_and_mount.mount_upgrade_ui", self.mount, function(mount)
            end)
        end, "ImageMax")

        self:AddReleaseEvent(function() 
            dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)  

            local top_ui = sShortcutHelper:GetTop()
            if top_ui then
                top_ui:RefreshMount(self.entry.ID)
            end
            self:_SetSelected(self.mount)
        end, "ButtonReplace", "PanelTouch")

        self:AddReleaseEvent(function() 
            dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)  
            local top_ui = sShortcutHelper:GetTop()
            if top_ui and top_ui.mount_id==self.entry.ID then
                top_ui:RefreshMount(0)
                self:_SetSelected(self.mount)
            else
                top_ui:RefreshMount(self.entry.ID)
            end
        end, "PanelDismount")
    else

        self:SetWidgetVisible(false, "ImageCurrent")
        self:SetWidgetVisible(false, "ButtonReplace")  
        self:SetWidgetVisible(false, "TextLvName")
        self:SetWidgetVisible(true, "TextLvName2")
        self:SetWidgetVisible(false, "PanelDismount")
        self:SetLabelText(""..self.entry.MaxLevel, "TextLvName2", "TextLv")
        if not unlocked then
            self:SetWidgetVisible(false, "ButtonUpgrade")
            self:SetWidgetVisible(false, "ButtonBuy")
            self:SetWidgetVisible(false, "ImageMax")
            self:SetWidgetVisible(true, "ImageLock")    
            if self.entry.LockConditionType == "stage" then  
                self:SetLabelText(sStringUtils:GetString("@mount_lock_stage", {stage=self.entry.LockConditionValue}), "TextLock")
            elseif self.entry.LockConditionType == "level" then  
                self:SetLabelText(sStringUtils:GetString("@mount_lock_level", {stage=self.entry.LockConditionValue}), "TextLock")
            end
        elseif not buyed then
            self:SetWidgetVisible(false, "ButtonUpgrade")
            self:SetWidgetVisible(true, "ButtonBuy")
            self:SetWidgetVisible(false, "ImageMax")
            self:SetWidgetVisible(false, "ImageLock")
            self:SetLabelText("x"..self.entry.BuyValue, "TextBuy")
            self:SetWidgetVisible(self.entry.BuyType=="point", "ImageDiamonds")
            self:SetWidgetVisible(self.entry.BuyType=="gamebill", "ImageGold")
        end

        self:AddReleaseEvent(function() 
            dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)  
            local error_string = player.player_modules.mounts:Buy(self.mount.id)
            if error_string~=nil then
                if error_string == "mount_buyed" then
                    dxm.CMessageTipUI:Show(sStringUtils:GetString("@mount_buyed"), 35)
                elseif error_string == "mount_lock" then
                    dxm.CMessageTipUI:Show(sStringUtils:GetString("@mount_lock"), 35)
                elseif error_string == "not_enough_gamebill" then
                    sCtrlItem:GamebillIsNotEnough()
                elseif error_string == "not_enough_point" then
                    game.CCtrlItem:PointIsNotEnough()
                end
                return
            end
            dxm.CMessageTipUI:Show(sStringUtils:GetString("@buy_successful"), 35)
        end, "ButtonBuy")

        self:AddReleaseEvent(function() 
            dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)  
            local top_ui = sShortcutHelper:GetTop()
            if top_ui then
                top_ui:RefreshMount(self.entry.ID)
            end
        end, "ButtonPreview", "PanelTouch")
    end
end

function CMountCellUI:_SetSelected()
    if self.select_changed_callback then
        self.select_changed_callback(self.mount)
    end
end

function CMountCellUI:onEnter()   
   self:Refresh()
   self:AddListener("buy_mount_ok", function(mount_id)
        if self.mount.id == mount_id then
            self:Refresh()
        end
   end)
   self:AddListener("upgrade_mount_ok", function(mount_id)
        if self.mount.id == mount_id then
            self:Refresh()
        end
   end)
end

function CMountCellUI:onExit()
    if self.gray then
        sShaderUtils:RemoveGray(self:GetWidget("ImageHeadPortrait"))
        self.gray = false
    end
end

function CMountCellUI:SetActived(actived)

    if self.gray and player.player_modules.mounts:IsBuyed(self.entry.ID) then
        sShaderUtils:RemoveGray(self:GetWidget("ImageIcon"))
    end

    local actived = player.player_modules.mounts:IsActiveMount(self.mount.id)
    local buyed = player.player_modules.mounts:IsBuyed(self.mount.id)

    if buyed then
        self:SetWidgetVisible(actived, "ImageCurrent")
        self:SetWidgetVisible(not actived, "ButtonReplace")  
        self:SetWidgetVisible(actived, "PanelDismount") 
    else
        self:SetWidgetVisible(false, "ImageCurrent")
        self:SetWidgetVisible(false, "ButtonReplace")  
        self:SetWidgetVisible(false, "PanelDismount") 
    end
end

return CMountCellUI
--endregion
