--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CSkinAndMountUI = class("game.CSkinAndMountUI",dxm.CStackUI)
local CSkinAndMountUI = game.CSkinAndMountUI

function CSkinAndMountUI:ctor()

    CSkinAndMountUI.super.ctor(self)
    self.cell_list = {}
end

function CSkinAndMountUI:Init(tab_name)

    self.tab_name = tab_name or "skin"
    return self:InitWithFile("csd/Main/MainSkinMount")
end

function CSkinAndMountUI:Create(...)

    local ui = CSkinAndMountUI.new()
    if ui and ui:Init(...) then
        return ui
    end

    return nil
end

function CSkinAndMountUI:onEnter()

    sShortcutHelper:OpenTop()
    sShortcutHelper:OpenTask()
    sShortcutHelper:OpenBottom()

    CSkinAndMountUI.ui = self

    self.scroll_view = dxm.CScrollViewUI:Create(self:GetWidget("ScrollView"))
    self.scroll_view.fix_tail = 380
    self.scroll_view.fix_head = 0
    self:AddChild(self.scroll_view)
    
    self:AddReleaseEvent(function() 
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)  
        self:ShowSkin()
    end, "ButtonSkin")

    self:AddReleaseEvent(function() 
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)  
        self:ShowMount()
    end, "ButtonMount")

    if self.tab_name=="skin" then        
        self:ShowSkin()
    elseif self.tab_name=="mount" then     
        self:ShowMount()
    end 

    self:AddReleaseEvent(function(sender)
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)   
        self:Close()
    end, "ButtonReturn") 

end

function CSkinAndMountUI:onExit()

    if self.icon_spine then
        self.icon_spine:removeFromParent()
        self.icon_spine = nil
    end

    local top_ui = sShortcutHelper:GetTop()
    if top_ui then
        top_ui:RefreshMount()
        top_ui:RefreshSkin()
    end
end

function CSkinAndMountUI:ShowSkin()

    self:SetWidgetEnable(false, "ButtonSkin" )
    self:SetWidgetEnable(true, "ButtonMount" )

    self.scroll_view:RemoveAllCells()

     local skins = {}
     for key, role in pairs(player.db.skins.skin_list) do
        skins[#skins+1] = role
     end
     table.sort(skins, function(a,b) return a.id < b.id end)

     self.cell_list = {}
     for key, skin in pairs(skins) do
        local cell = require("app.views.ui.skin_and_mount.skin_cell_ui"):Create(skin, function(mount) 
                self:_SetSkinSelected(mount)
            end)
        if cell then
            self.scroll_view:AddCell(cell)
            self.cell_list[cell] = cell
        end
    end
    self.scroll_view:InitPosition()
end

function CSkinAndMountUI:ShowMount()

    self:SetWidgetEnable(true, "ButtonSkin" )
    self:SetWidgetEnable(false, "ButtonMount" )

    self.scroll_view:RemoveAllCells()

     local mounts = {}
     for key, mount in pairs(player.db.mounts.mount_list) do
        mounts[#mounts+1] = mount
     end
     table.sort(mounts, function(a,b) return a.id < b.id end)

     self.cell_list = {}
     for key, mount in pairs(mounts) do
        local cell = require("app.views.ui.skin_and_mount.mount_cell_ui"):Create(mount, function(mount) 
                self:_SetMountSelected(mount)
            end)
        if cell then
            self.scroll_view:AddCell(cell)
            self.cell_list[cell] = cell
        end
    end
    self.scroll_view:InitPosition()
end


function CSkinAndMountUI:_SetMountSelected(mount)

    local actived = player.player_modules.mounts:IsActiveMount(mount.id)

    if actived then
        player.player_modules.mounts:SetActiveMount(0)
    else
        player.player_modules.mounts:SetActiveMount(mount.id)
    end

    for _, cell in pairs(self.cell_list) do
        cell:SetActived(player.player_modules.mounts:IsActiveMount(cell.mount.id))
    end
end

function CSkinAndMountUI:_SetSkinSelected(skin)

    player.player_modules.skins:SetActiveSkin(skin.id)
    for _, cell in pairs(self.cell_list) do
        cell:SetActived(player.player_modules.skins:IsActiveSkin(cell.skin.id))
    end
end

return CSkinAndMountUI

--endregion
