--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CSkinCellUI = class("game.CSkinCellUI",dxm.CBaseUI)

local CSkinCellUI = game.CSkinCellUI

function CSkinCellUI:ctor()

    CSkinCellUI.super.ctor(self)

    self.gray = false
end

function CSkinCellUI:Init(skin, select_changed_callback)

    if not skin then
        return false
    end

    local entry = assets.skins:GetEntry(skin.id)
    if not entry then
        return false
    end
    
    self.skin = skin
    self.entry = entry
    self.select_changed_callback = select_changed_callback
    self:InitWithFile("csd/IconStrip/IconStripShopSkinStrip")
    return true
end

function CSkinCellUI:Create(...)

    local ui = CSkinCellUI.new()
    if ui and ui:Init(...) then
        return ui
    end
    return nil
end

function CSkinCellUI:Refresh()

    local buyed = player.player_modules.skins:IsBuyed(self.skin.id)
    local unlocked = player.player_modules.skins:IsUnlock(self.skin.id)
    local actived = player.player_modules.skins:IsActiveSkin(self.skin.id)

    -- 名字;
    self:SetLabelText(sStrings:GetString(self.entry.Name), "TextMountName")
    -- 描述;
    self:SetLabelText(sStrings:GetString(self.entry.Desc), "TextExplain")
    -- 头像;
    self:SetImageViewPicture(self.entry.Icon, "ImageHeadPortrait")
    if buyed then
        if self.gray then
            sShaderUtils:RemoveGray(self:GetWidget("ImageHeadPortrait"))
            self.gray = false
        end
    else
        sShaderUtils:AddGray(self:GetWidget("ImageHeadPortrait"))
        self.gray = true
    end

    -- 技能
    --[[
    local key = 0
    for _, skill_id in pairs(self.skin.skill_list) do

        key = key + 1
        local entry = assets.skills:GetEntry(skill_id)
        local widget = self:GetWidget("PanelSkill"..key) 
        if entry and widget then   
            self:SetWidgetVisible(true, widget)  
            self:SetImageViewPicture(entry.Icon, widget, "ImageSkillIcon")
            self:AddReleaseEvent(function() 
                dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)  
                sUI:Open("app.views.ui.skins.skin_skill_ui", self.skin, skill_id) 
            end, widget, "ButtonTip")
            self:SetLabelText(sStringUtils:GetString("@"..entry.Name), widget, "TextSkillName")
            self:SetLabelText(sStringUtils:GetString("@"..entry.Desc, {value=player.player_modules.skins:GetSkinSkillValue(self.skin.id, skill_id)}), widget, "TextExplain")
        end
    end
    ]]--
      
    self:SetWidgetVisible(not buyed, "ButtonPreview")

    if buyed==true then

        self:SetWidgetVisible(actived, "ImageCurrent")
        self:SetWidgetVisible(not actived, "ButtonReplace")  
        self:SetWidgetVisible(actived, "PanelDismount") 

        self:SetWidgetVisible(true, "TextLvName")
        self:SetWidgetVisible(false, "TextLvName2")
        self:SetLabelText(self.skin.level.."/"..self.entry.MaxLevel, "TextLvName", "TextLv")
        if player.player_modules.skins:IsFullLevel(self.skin.id)==true then           
            self:SetWidgetVisible(false, "ButtonUpgrade")
            self:SetWidgetVisible(false, "ButtonBuy")
            self:SetWidgetVisible(true, "ImageMax")
            self:SetWidgetVisible(false, "ImageLock")
        else
            self:SetWidgetVisible(true, "ButtonUpgrade")
            self:SetWidgetVisible(false, "ButtonBuy")
            self:SetWidgetVisible(false, "ImageMax")
            self:SetWidgetVisible(false, "ImageLock")
        end

        self:AddReleaseEvent(function() 
            dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)  
            sUI:Open("app.views.ui.skin_and_mount.skin_upgrade_ui", self.skin)
        end, "ButtonUpgrade")

        self:AddReleaseEvent(function() 
            dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)  
            sUI:Open("app.views.ui.skin_and_mount.skin_upgrade_ui", self.skin)
        end, "ImageMax")

        self:AddReleaseEvent(function() 
            dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)  
            self:_SetSelected(self.skin)
            local top_ui = sShortcutHelper:GetTop()
            if top_ui then
                top_ui:RefreshSkin(self.entry.ID)
            end
        end, "ButtonReplace", "PanelTouch")

        self:AddReleaseEvent(function() 
            dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)  
            local top_ui = sShortcutHelper:GetTop()
            if top_ui then
                top_ui:RefreshSkin(self.entry.ID)
            end
        end, "PanelDismount")
    else
        self:SetWidgetVisible(false, "ImageCurrent")
        self:SetWidgetVisible(false, "ButtonReplace")  
        self:SetWidgetVisible(false, "TextLvName")
        self:SetWidgetVisible(true, "TextLvName2")
        self:SetWidgetVisible(false, "PanelDismount")
        self:SetLabelText(""..self.entry.MaxLevel, "TextLvName2", "TextLv")
        if not unlocked then
            self:SetWidgetVisible(false, "ButtonUpgrade")
            self:SetWidgetVisible(false, "ButtonBuy")
            self:SetWidgetVisible(false, "ImageMax")
            self:SetWidgetVisible(true, "ImageLock")      
            if self.entry.LockConditionType == "stage" then  
                self:SetLabelText(sStringUtils:GetString("@mount_lock_stage", {stage=self.entry.LockConditionValue}), "TextLock")
            elseif self.entry.LockConditionType == "level" then  
                self:SetLabelText(sStringUtils:GetString("@mount_lock_level", {level=self.entry.LockConditionValue}), "TextLock")
            end
        elseif not buyed then
            self:SetWidgetVisible(false, "ButtonUpgrade")
            self:SetWidgetVisible(true, "ButtonBuy")
            self:SetWidgetVisible(false, "ImageMax")
            self:SetWidgetVisible(false, "ImageLock")
            self:SetLabelText("x"..self.entry.BuyValue, "TextBuy")
            self:SetWidgetVisible(self.entry.BuyType=="point", "ImageDiamonds")
            self:SetWidgetVisible(self.entry.BuyType=="gamebill", "ImageGold")
        end

        self:AddReleaseEvent(function() 
            dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)  
            local error_string = player.player_modules.skins:Buy(self.skin.id)
            if error_string~=nil then
                if error_string == "skin_buyed" then
                    dxm.CMessageTipUI:Show(sStringUtils:GetString("@skin_buyed"), 35)
                elseif error_string == "skin_lock" then
                    dxm.CMessageTipUI:Show(sStringUtils:GetString("@skin_lock"), 35)
                elseif error_string == "not_enough_gamebill" then
                    sCtrlItem:GamebillIsNotEnough()
                elseif error_string == "not_enough_point" then
                    game.CCtrlItem:PointIsNotEnough()
                end
                return
            end
            dxm.CMessageTipUI:Show(sStringUtils:GetString("@buy_successful"), 35)
        end, "ButtonBuy")

        self:AddReleaseEvent(function() 
            dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)  
            local top_ui = sShortcutHelper:GetTop()
            if top_ui then
                top_ui:RefreshSkin(self.entry.ID)
            end
        end, "ButtonPreview", "PanelTouch")
    end
end

function CSkinCellUI:_SetSelected()
    if self.select_changed_callback then
        self.select_changed_callback(self.skin)
    end
end

function CSkinCellUI:onEnter()   
   self:Refresh()
   self:AddListener("buy_skin_ok", function(skin_id)
        if self.skin.id == skin_id then
            self:Refresh()
        end
   end)
   self:AddListener("upgrade_skin_ok", function(skin_id)
        if self.skin.id == skin_id then
            self:Refresh()
        end
   end)
end

function CSkinCellUI:onExit()
    if self.gray then
        sShaderUtils:RemoveGray(self:GetWidget("ImageHeadPortrait"))
        self.gray = false
    end
end

function CSkinCellUI:SetActived(actived)

    if self.gray and player.player_modules.skins:IsBuyed(self.entry.ID) then
        sShaderUtils:RemoveGray(self:GetWidget("ImageIcon"))
    end

    local actived = player.player_modules.skins:IsActiveSkin(self.skin.id)
    local buyed = player.player_modules.skins:IsBuyed(self.skin.id)

    if buyed then
        self:SetWidgetVisible(actived, "ImageCurrent")
        self:SetWidgetVisible(not actived, "ButtonReplace")  
        self:SetWidgetVisible(actived, "PanelDismount") 
    else
        self:SetWidgetVisible(false, "ImageCurrent")
        self:SetWidgetVisible(false, "ButtonReplace")  
        self:SetWidgetVisible(false, "PanelDismount") 
    end
end

return CSkinCellUI
--endregion
