-- region *.lua
-- Date
-- 此文件由[BabeLua]插件自动生成

game.CSkinUpgradeUI = class("game.CSkinUpgradeUI", dxm.CGameDialogUI)

local CSkinUpgradeUI = game.CSkinUpgradeUI

function CSkinUpgradeUI:ctor()
    CSkinUpgradeUI.super.ctor(self)
end

function CSkinUpgradeUI:Init(skin)
    if not skin then
        return false
    end
    local entry = assets.skins:GetEntry(skin.id)
    if not entry then
        return false
    end
    self.skin = skin
    self.entry = entry
    self:InitWithFile("csd/Main/MainUiSkinUpgrade")
    return true
end

function CSkinUpgradeUI:Create(...)
    local ui = CSkinUpgradeUI.new()
    if ui and ui:Init(...) then
        return ui
    end

    return nil
end

function CSkinUpgradeUI:onEnter()

    self:SetImageViewPicture(self.entry.Icon, "ImageHeadPortrait")
    self:SetLabelText(sStrings:GetString(self.entry.Name), "TextPetName")

    self:AddReleaseEvent(function()   
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)       
        self:Close()  
    end, "ButtonClose")

   self:AddReleaseEvent(
       function()   
            dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)  

            local error_string = player.player_modules.skins:Upgrade(self.skin.id)
            if error_string ~= nil then
                if error_string == "not_enough_gamebill" then
                    sCtrlItem:GamebillIsNotEnough()
                end
                return
            end
            dxm.audio:playEffect(assets.sound.config.sound.skin_upgrade_successful)
            dxm.CMessageTipUI:Show(sStringUtils:GetString("@upgrade_successful"), 35)
            self:RefreshUI()     
        end, "ButtonDetermine")

   self:AddReleaseEvent(function()   
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)  
        player.player_modules.skins:OneKeyUpgrade(self.skin.id, function(is_successful)    
            if is_successful then     
                dxm.audio:playEffect(assets.sound.config.sound.skin_upgrade_successful)
                dxm.CMessageTipUI:Show(sStringUtils:GetString("@upgrade_successful"), 35)
            end
            self:RefreshUI()     
        end)
    end, "ButtonOneKeyFull")

    self:RefreshUI()

    self:SetActionPointText(sPlayer.player_modules.action_point:GetActionPoint())
    self:SetPointText(sPlayer.player_modules.point:GetPoint())
    self:SetGamebillText(sPlayer.player_modules.numbers:Get(enum.NumberType.kTypeGamebill))

    self:AddListener("action_point_changed", function()
        self:SetActionPointText(sPlayer.player_modules.action_point:GetActionPoint(),true)
        local full = sPlayer.player_modules.action_point:IsFull()
        self:SetWidgetEnableAndVisible( not full, "ImageTL","ButtonAdd")
    end)

    self:AddListener("point_changed", function()
        self:SetPointText(sPlayer.player_modules.point:GetPoint(),true)
    end)
    
    self:AddListener("player_number_changed", function(number_name, delta)
        if number_name == enum.NumberType.kTypeGamebill then
            self:SetGamebillText(sPlayer.player_modules.numbers:Get(enum.NumberType.kTypeGamebill), true)
            self:PlayGamebillShake(delta)
        end
    end)

    self:AddReleaseEvent(function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)  
        game.CCtrlMainMenu:OpenShopUI("action_point")
    end,"ImageTL","ButtonAdd")

    self:AddReleaseEvent(function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)  
        game.CCtrlMainMenu:OpenShopUI("diamon")
    end,"ImageDiamonds","ButtonAdd")

    self:AddReleaseEvent(function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)  
        game.CCtrlMainMenu:OpenShopUI(enum.NumberType.kTypeGamebill)
    end,"ImageGold","ButtonAdd")
    
    self:SetWidgetVisible(false, "ImageTL", "TextTime")
    self:SetWidgetVisible(false,"ImageGold","TextNumberTip")
    self:SetWidgetVisible(false,"ImageTL","TextNumberTip")
    self:SetWidgetVisible(false,"ImageDiamonds","TextNumberTip")
    self:SetWidgetVisible(false,"ImageGold","ButtonAdd")
    self:SetWidgetVisible(false,"ImageTL","ButtonAdd")
    self:SetWidgetVisible(false,"ImageDiamonds","ButtonAdd")
end

function CSkinUpgradeUI:onExit()

end

function CSkinUpgradeUI:RefreshUI()

    for i=1, 99 do        
        local widget = self:GetWidget("PanelSkill"..i) 
        if not widget then break end
        self:SetWidgetVisible(false, widget)  
    end  

    local key = 0
    for _, skill_id in pairs(self.skin.skill_list) do

        key = key + 1
        local entry = assets.skills:GetEntry(skill_id)
        local widget = self:GetWidget("PanelSkill" .. key)
        if widget then
            self:SetWidgetVisible(true, widget)  
            self:SetImageViewPicture(entry.Icon, widget, "ImageSkillIcon")
            self:AddReleaseEvent( function() 
                dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)  
                sUI:Open("app.views.ui.skins.skin_skill_ui", cell.skin, skill_id) 
            end, widget, "ButtonTip")
            self:SetLabelText(sStringUtils:GetString("@" .. entry.Name), widget, "TextSkillName")
            self:SetLabelText(sStringUtils:GetString("@" .. entry.Desc), widget, "TextSkillExplain")
            self:SetLabelText(sStringUtils:GetString("@" .. entry.EffectDesc, { value = player.player_modules.skins:GetSkinSkillValue(self.skin.id, skill_id, self.skin.level) }), widget, "TextSkillNow")
            self:SetLabelText(sStringUtils:GetString("@" .. entry.EffectSimpleDesc, { value = player.player_modules.skins:GetSkinSkillValue(self.skin.id, skill_id, self.skin.level + 1) }), widget, "TextSkillNext")
            self:SetWidgetVisible(self.skin.level~=self.entry.MaxLevel, widget, "TextSkillNow_0")
            self:SetWidgetVisible(self.skin.level~=self.entry.MaxLevel, widget, "TextSkillNext")   
            self:SetWidgetVisible(self.skin.level~=self.entry.MaxLevel, widget, "TextSkillNext_0")    
        end        
    end

    self:SetLabelText("X" .. player.player_modules.skins:GetLevelUpGamebill(self.skin.id), "TextGold")
    self:SetLabelText(self.skin.level.."/"..self.entry.MaxLevel,"ImageHeadBottom", "TextLv")
    self:SetWidgetVisible(self.skin.level~=self.entry.MaxLevel, "TextSkillNext")

    -- 能否一键;
    local cannot_one_key_full = (assets.version.branch == "baidu")

    self:SetWidgetVisible(not player.player_modules.skins:IsFullLevel(self.skin.id), "ButtonDetermine")    
    self:SetWidgetVisible(not player.player_modules.skins:IsFullLevel(self.skin.id) and not cannot_one_key_full, "ButtonOneKeyFull")

    self:SetWidgetVisible(assets.version.branch == "yijie" and not player.player_modules.skins:IsFullLevel(self.skin.id), "TextPhoneNumber")
    --self:SetWidgetVisible(false, "ButtonOneKeyFull")

    self:SetLabelText(sStringUtils:GetString("@rmb"), "TextMoneyName")
    self:SetLabelText(self.entry.OneKeyUpgradePayMoney, "TextMoney")
    self:SetLabelText(sStringUtils:GetString("@level_desc", {level=self.entry.MaxLevel}), "TextLV")
end

function CSkinUpgradeUI:SetActionPointText(action_point, play_action)
    
    local label = self:GetWidget("ImageTL","AtlasLabelNumber")
    -- if not play_action then
        if label then label:setString(action_point.."/"..assets.const.player_max_action_point) end
    -- else
    --     game.CActionHelper:NumberChange(label, action_point)    
    -- end
    
end

function CSkinUpgradeUI:SetPointText(point,play_action)

    local label = self:GetWidget("ImageDiamonds","AtlasLabelNumber")
    if not play_action then
        if label then label:setString(tostring(point)) end
    else
        game.CActionHelper:NumberChange(label,point)    
    end
end

function CSkinUpgradeUI:SetGamebillText(gamebill, play_action)

    local label = self:GetWidget("ImageGold","AtlasLabelNumber")
    if not play_action then
        if label then label:setString(tostring(gamebill)) end
    else
        game.CActionHelper:NumberChange(label, gamebill)
    end
end

function CSkinUpgradeUI:PlayGamebillShake(delta)

    sActionUtils:Shake(self:GetWidget("ImageGold","ImageIcon2"))
    local number = delta
    if number > 0 then        
        local label = self:GetWidget("ImageGold","TextNumberTip")
        self:SetWidgetVisible(true,"ImageGold","TextNumberTip")
        self:SetLabelText("+"..number,"ImageGold","TextNumberTip")
        label:setOpacity(200)
        game.CActionHelper:PopText(label,function()
            self:SetWidgetVisible(false,"ImageGold","TextNumberTip")
        end)
    end
end

function CSkinUpgradeUI:PlayDiamondShake()

    sActionUtils:Shake(self:GetWidget("ImageDiamonds","ImageIcon2"))
    local number = sPlayer.player_modules.point.add_point
    sPlayer.player_modules.point.add_point = 0
    if number > 0 then
        
        local label = self:GetWidget("ImageDiamonds","TextNumberTip")
        self:SetWidgetVisible(true,"ImageDiamonds","TextNumberTip")
        self:SetLabelText("+"..number,"ImageDiamonds","TextNumberTip")
        label:setOpacity(200)
        game.CActionHelper:PopText(label,function()
            self:SetWidgetVisible(false,"ImageDiamonds","TextNumberTip")
        end)
    end
end

function CSkinUpgradeUI:PlayHeartShake()

    sActionUtils:Shake(self:GetWidget("ImageTL","ImageIcon2"))
    local number = sPlayer.player_modules.action_point.add_action_point
    sPlayer.player_modules.action_point.add_action_point = 0
    if number > 0 then
        
        local label = self:GetWidget("ImageTL","TextNumberTip")
        self:SetWidgetVisible(true,"ImageTL","TextNumberTip")
        self:SetLabelText("+"..number,"ImageTL","TextNumberTip")
        label:setOpacity(200)
        game.CActionHelper:PopText(label,function()
            self:SetWidgetVisible(false,"ImageTL","TextNumberTip")
        end)
    end
end


return CSkinUpgradeUI
-- endregion
