--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CStageIconUI =  class("game.CStageIconUI",dxm.CBaseUI)

local CStageIconUI = game.CStageIconUI

function CStageIconUI:ctor()
    CStageIconUI.super.ctor(self)

    self.is_selected = false
end

function CStageIconUI:Init(stage_type,stage_id,child_stage_id,callback)
    self.stage_type = stage_type
    self.stage_id = stage_id
    self.child_stage_id = child_stage_id
    self.entry = sPlayer.player_modules.stage:GetChildStageEntry(self.stage_type,self.stage_id,self.child_stage_id)
    self.callback = callback
    self.default_arrow_pos = nil
    if not self.entry then
        return false
    end

    if self:InitWithFile("csd/Checkpoint/CheckpointInformationIcon") == false then
        return false
    end
    return true
end

function CStageIconUI:Create(...)
    local ui = CStageIconUI.new()

    if ui and ui:Init(...) then
        return ui
    end

    return nil
end

function CStageIconUI:onEnter()

    self:SetWidgetVisible(false,"ImageArrow")
    self:SetWidgetVisible(self.entry.is_boss or false, "ImageBoss")

    if not self.default_arrow_pos then
        local image_arrow = self:GetWidget("ImageArrow")
        if image_arrow then
            self.default_arrow_pos = cc.p(image_arrow:getPosition())
        end
    else
        local image_arrow = self:GetWidget("ImageArrow")
        if image_arrow then
            image_arrow:setPosition(self.default_arrow_pos)
        end
    end

    local stage_info = sPlayer.player_modules.stage:GetStageInfo(self.stage_type,self.stage_id,self.child_stage_id)

    -- 获得关卡信息

    -- 显示关卡星级
    for i = 1, 3 do
        local is_visible = stage_info and i <= stage_info.best_star
        self:SetWidgetVisible(is_visible,"ImageStar"..i ,"ImageStarHave")
    end

    -- 显示关卡
    self:SetLabelText(self.child_stage_id,"TextCheckpoint")

    -- 默认选择关卡
    local top_stage_info = sPlayer.player_modules.stage:GetTopStageInfo(self.stage_type)

    -- 是否最新关卡
    self:SetWidgetVisible(top_stage_info.top_stage_id == self.stage_id and top_stage_info.top_child_stage_id == self.child_stage_id, "ImageNew")

    -- 关卡是否锁着
    self:SetWidgetVisible(self.stage_id > top_stage_info.top_stage_id or (self.stage_id == top_stage_info.top_stage_id and self.child_stage_id > top_stage_info.top_child_stage_id), "ButtonCheckpoint2")

    -- 显示选中箭头
    if self.is_selected then
        self:ShowSelected()
    else
        self:ShowUnselected()
    end

    -- 点击按钮
    self:AddReleaseEvent(function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)  
        if self.callback then
            self.callback(self.child_stage_id)
        end
    end,"ButtonCheckpoint")
end

function CStageIconUI:onExit()
    
end

function CStageIconUI:Selected()

    if self.is_selected == true then
        return
    end
    self.is_selected = true
    self:ShowSelected()
end

function CStageIconUI:ShowSelected()


    self:SetWidgetVisible(true, "ImageArrow")

    local image_arrow = self:GetWidget("ImageArrow")
    if image_arrow then
        self.image_arrow_pos = cc.p(image_arrow:getPosition())
        self.image_arrow_action = image_arrow:runAction(cc.RepeatForever:create(cc.Sequence:create(cc.MoveBy:create(0.2, cc.p(0, 20)), 
        cc.DelayTime:create(1), 
        cc.MoveBy:create(0.2, cc.p(0, -20)))))
    end
end

function CStageIconUI:Unselected()
    if self.is_selected == false then
        return
    end
    self.is_selected = false
    self:ShowUnselected()
end

function CStageIconUI:ShowUnselected()

    self:SetWidgetVisible(false, "ImageArrow")

    local image_arrow = self:GetWidget("ImageArrow")
    if image_arrow then

        if self.image_arrow_pos then
            image_arrow:setPosition(self.image_arrow_pos)
            self.image_arrow_pos = nil
        end

        if self.image_arrow_action then
            image_arrow:stopAction(self.image_arrow_action)
            self.image_arrow_action = nil
        end
    end
end

return CStageIconUI

--endregion
