--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

dxm.CStageItemFullUI = class("dxm.CStageItemFullUI",dxm.CDialogUI)

local CStageItemFullUI = dxm.CStageItemFullUI

function CStageItemFullUI:ctor()
    CStageItemFullUI.super.ctor(self)
end

function CStageItemFullUI:Init(entry, point, callback)
    local string_id = "@full_to_open_box_with_point"
    if point == 0 then
        string_id = "@full_to_open_box_without_point"
    end

    self.point = point
    self.entry = entry
    self.message = sStringUtils:GetString(string_id, { point=point })
    self.callback = callback
    return self:InitWithFile("csd/Checkpoint/CheckpointPackageMessageBox")
end

function CStageItemFullUI:Create(...)
    local ui = CStageItemFullUI.new()
    if ui and ui:Init(...) then
        return ui
    end

    return nil
end

function CStageItemFullUI:onEnter()
    self:SetWidgetVisible(false,"PanelBottom2")
    self:SetWidgetVisible(true,"PanelBottom1")
        
    self:AddReleaseEvent(function()
        dxm.audio:playSound(assets.sound.config.sound.ui_button_release)
        if self.callback then self.callback(false) end
        self:Close()
    end,"PanelBottom1","ButtonCancel")

    self:AddReleaseEvent(function()
        dxm.audio:playSound(assets.sound.config.sound.ui_button_release)
        if self.callback then self.callback(true) end
        self:Close()
    end,"PanelBottom1","ButtonConfirm") 

    self:SetLabelText(self.message,"TextMessage")

    self:_RefreshAd()

    self.spine_ui = dxm.CSpineUI:Create(self.entry.path, "idle") 
    if self.spine_ui then
        self:RemoveAllChildren(self:GetWidget("PanelPackageRoot"))
        self:AddChild(self:GetWidget("PanelPackageRoot"), self.spine_ui)
    end
end

function CStageItemFullUI:onExit()
end


function CStageItemFullUI:_RefreshAd()

    local panel_name = "ButtonAdvertisement"
    if self.point == 0 then
        self:SetWidgetVisible(false, panel_name)
        return
    end
    self:SetWidgetVisible(sPlayer.player_modules.ad:IsPop(5), panel_name)
    self:AddReleaseEvent(function() 
        sPlayer.player_modules.ad:Pop(5, function(is_ok, reward_type, reward_param) 
            if is_ok then
                sCtrlReward:AdReward(reward_type, reward_param)
                
                self:SetWidgetVisible(false, panel_name)
                self:Close()
            end
        end)
    end, panel_name)
end

return CStageItemFullUI
--endregion
