-- region *.lua
-- Date
-- 此文件由[BabeLua]插件自动生成

game.CStageItemBoxUI = class("game.CStageItemBoxUI", dxm.CGameDialogUI)


local CStageItemBoxUI = game.CStageItemBoxUI

function CStageItemBoxUI:ctor()
    CStageItemBoxUI.super.ctor(self)
end

function CStageItemBoxUI:Init(slot_pos)

    
    self.slot_pos = slot_pos
    self.item_box = sPlayer.player_modules.item_box:GetBox(slot_pos)
    if self.item_box == nil then
        
        return false
    end

    self.entry = assets.item_boxes:GetEntry(self.item_box.id)   
    if self.entry == nil then
        return false
    end

    self.slot_pos = slot_pos
    self.state = 0
    if self:InitWithFile("csd/Checkpoint/CheckpointPackagePop") == false then
        return false
    end
    return true
end

function CStageItemBoxUI:Create(...)
    local ui = CStageItemBoxUI.new()
    if ui and ui:Init(...) then
        return ui
    end
end

function CStageItemBoxUI:onEnter()

    self:Refresh()

    self.update_listener = sSchedulerSystem:AddSecondly(function()
        self:_RefreshLastUnlockTime()
    end)

    self:AddReleaseEvent(function() self:Close() end, "Panel_5")

    self:AddListener("item_box_unlocked", function() self:Refresh() end)
    self:AddListener("item_box_opened", function() self:Refresh() end)
    self:AddListener("item_box_added", function() self:Refresh() end)
end

function CStageItemBoxUI:onExit()
    self.update_listener:Disconnect()
    self.update_listener = nil
end

function CStageItemBoxUI:Refresh()

    -- 箭头
    for i=1, 4 do
        self:SetWidgetVisible(self.slot_pos==i, "ImageArrow"..i)
    end

    self:_RefreshReward()

    -- 更新各个状态;
    -- 1: 可开锁
    -- 2: 开锁中, 当前箱子
    -- 3: 开锁中, 非当前箱子
    -- 4: 已开锁
    local last_unlock_seconds = sPlayer.player_modules.item_box:GetLastUnlockSeconds(self.slot_pos)
    local unlock_slot_pos = sPlayer.player_modules.item_box:GetUnlockSlotPos()
    if unlock_slot_pos == 0 then                
        if last_unlock_seconds < 0 then            
            -- 可解锁的宝箱, 解锁&&立即开箱;
            self:_RefreshState1(unlock_slot_pos, last_unlock_seconds)
        elseif last_unlock_seconds == 0 then
            -- 可开启的宝箱, 开箱; 
            self:_RefreshState4(unlock_slot_pos, last_unlock_seconds)
        else
            -- assert(false, "not this state")
            self:_RefreshState3(unlock_slot_pos, last_unlock_seconds)
        end
    elseif self.slot_pos == unlock_slot_pos then
        if last_unlock_seconds > 0 then            
            -- 解锁中的当前宝箱, 解锁剩余时间&&立即打开;
            self:_RefreshState2(unlock_slot_pos, last_unlock_seconds)
        elseif last_unlock_seconds == 0 then
            -- 可开启的宝箱, 开箱; 
            self:_RefreshState4(unlock_slot_pos, last_unlock_seconds)
        else
            -- assert(false, "not this state")
            self:_RefreshState3(unlock_slot_pos, last_unlock_seconds)
        end
    else
        -- 解锁中的非当前宝箱, 其他宝箱正在解锁&&立即打开;
        if last_unlock_seconds == 0 then
            self:_RefreshState4(unlock_slot_pos, last_unlock_seconds)
        else
            self:_RefreshState3(unlock_slot_pos, last_unlock_seconds)
        end
    end

    local spine_names = {}
    spine_names[1] = "idle"
    spine_names[2] = "idle"
    spine_names[3] = "idle"
    spine_names[4] = "shake"
    self.spine_ui = dxm.CSpineUI:Create(self.entry.path, spine_names[self.state]) 
    if self.spine_ui then
        self:RemoveAllChildren(self:GetWidget("PanelPackageRoot"))
        self:AddChild(self:GetWidget("PanelPackageRoot"), self.spine_ui)
        self.spine_ui:Play({"exhibition", spine_names[self.state]}, true)
    end
end

function CStageItemBoxUI:_OpenWithPoint()

    sPlayer.player_modules.item_box:OpenBoxWithPoint(self.slot_pos, function(is_successful)
        if not is_successful then
            sCtrlItem:PointIsNotEnough()
        else
            -- 播放开箱界面;
            sUI:Open("app.views.ui.stage.stage_item_box_reward_ui", self.entry)
            self:Close()
        end
    end)
end


function CStageItemBoxUI:_RefreshState1(unlock_slot_pos, last_unlock_seconds)

    self.state = 1
    for i=1, 4 do
        self:SetWidgetVisible(false, "PanelState"..i)
    end
    self:SetWidgetVisible(true, "PanelState1")

    local widget = self:GetWidget("PanelState1")
    self:AddReleaseEvent(function()
        sPlayer.player_modules.item_box:UnlockBox(self.slot_pos)
        self:Close()
    end, widget, "ButtonOpen")

    self:AddReleaseEvent(function() 
        self:_OpenWithPoint(is_successful)
    end, widget, "ButtonDiamondsOpen")


    self:SetLabelText(math.floor(self.entry.unlock_seconds/60)..""..sStringUtils:GetString("@min"), widget, "TextTime")
    self:SetLabelText("x"..sPlayer.player_modules.item_box:GetUnlockPoint(self.slot_pos), widget, "ButtonDiamondsOpen", "TextTime")
end

function CStageItemBoxUI:_RefreshState2(last_unlock_seconds, last_unlock_seconds)

    self.state = 2
    for i=1, 4 do
        self:SetWidgetVisible(false, "PanelState"..i)
    end
    self:SetWidgetVisible(true, "PanelState2")

    local widget = self:GetWidget("PanelState2")
    self:AddReleaseEvent(function() 
        self:_OpenWithPoint(is_successful)
    end, widget, "ButtonDiamondsOpen")

    self:SetLabelText(sTimeUtils:ToTimeSpanString(last_unlock_seconds), widget, "ImageOpenIng", "TextTime")
    self:SetLabelText("x"..sPlayer.player_modules.item_box:GetUnlockPoint(self.slot_pos), widget, "ButtonDiamondsOpen", "TextTime")
end

function CStageItemBoxUI:_RefreshState3(last_unlock_seconds, last_unlock_seconds)

    self.state = 3
    for i=1, 4 do
        self:SetWidgetVisible(false, "PanelState"..i)
    end
    self:SetWidgetVisible(true, "PanelState3")

    local widget = self:GetWidget("PanelState3")
    self:AddReleaseEvent(function() 
        self:_OpenWithPoint(is_successful)
    end, widget, "ButtonDiamondsOpen")

    self:SetLabelText("x"..sPlayer.player_modules.item_box:GetUnlockPoint(self.slot_pos), widget, "ButtonDiamondsOpen", "TextTime")
end

function CStageItemBoxUI:_RefreshState4(last_unlock_seconds, last_unlock_seconds)

    self.state = 4
    for i=1, 4 do
        self:SetWidgetVisible(false, "PanelState"..i)
    end
    self:SetWidgetVisible(true, "PanelState4")

    local widget = self:GetWidget("PanelState4")
    self:AddReleaseEvent(function() 
        sPlayer.player_modules.item_box:OpenBox(self.slot_pos)
        -- 播放开箱界面;
        sUI:Open("app.views.ui.stage.stage_item_box_reward_ui", self.entry)
        self:Close()
    end, widget, "ButtonOpen")
end

function CStageItemBoxUI:_RefreshReward()

    local count = 1
    -- 解析奖励
    local reward_list = game.CRewardList:ParseFromString(self.entry.reward)
    for _,reward in pairs(reward_list.list) do

        self:SetWidgetVisible(true, "PanelReward"..count)
        self:SetImageViewPicture(sPathHelper:GetRewardIconPath(reward), "PanelReward"..count, "ImageIcon")
        self:SetLabelText("x"..reward.count, "PanelReward"..count, "TextNumber")
        count = count + 1
    end

    for i=count,3 do
        self:SetWidgetVisible(false, "PanelReward"..i)
    end
end

function CStageItemBoxUI:_RefreshLastUnlockTime()

    local last_unlock_seconds = sPlayer.player_modules.item_box:GetLastUnlockSeconds(self.slot_pos)
    local unlock_slot_pos = sPlayer.player_modules.item_box:GetUnlockSlotPos()
    if self.state == 2 then
        local widget = self:GetWidget("PanelState2")
        self:AddReleaseEvent(function() 
            self:_OpenWithPoint(is_successful)
        end, widget, "ButtonDiamondsOpen")

        self:SetLabelText(sTimeUtils:ToTimeSpanString(last_unlock_seconds), widget, "ImageOpenIng", "TextTime")
        self:SetLabelText("x"..sPlayer.player_modules.item_box:GetUnlockPoint(self.slot_pos), widget, "ButtonDiamondsOpen", "TextTime")
    end
end
return CStageItemBoxUI
-- endregion
