-- region *.lua
-- Date
-- 此文件由[BabeLua]插件自动生成

game.CStageListUI = class("game.CStageListUI", dxm.CStackUI)

local CStageListUI = game.CStageListUI

function CStageListUI:Init(stage_type, stage_id, default_child_stage_id)
    self.stage_type = stage_type
    self.stage_id = stage_id
    self.stage_entry = sPlayer.player_modules.stage:GetStageEntry(self.stage_type, self.stage_id)
    self.default_child_stage_id = default_child_stage_id
    self.child_stage_id = nil
    if self:InitWithFile("csd/Checkpoint/CheckpointInformation") == false then
        return false
    end
    self.icon_ui_list = {}
    return true
end

function CStageListUI:Create(...)

    local ui = CStageListUI.new()
    if ui and ui:Init(...) then
        return ui
    end
end

function CStageListUI:onEnter()

    self:SetActionPointText(sPlayer.player_modules.action_point:GetActionPoint())
    self:SetPointText(sPlayer.player_modules.point:GetPoint())
    self:SetGamebillText(sPlayer.player_modules.numbers:Get(enum.NumberType.kTypeGamebill))

    self:AddListener("action_point_changed", function()
        self:SetActionPointText(sPlayer.player_modules.action_point:GetActionPoint(),true)
        local full = sPlayer.player_modules.action_point:IsFull()
        self:SetWidgetEnableAndVisible(not full, "ImageTL", "ButtonAdd")
    end)

    self:AddListener("point_changed", function()
        self:SetPointText(sPlayer.player_modules.point:GetPoint(),true)
    end)
    
    self:AddListener("player_number_changed", function(number_name, delta)
        if number_name == enum.NumberType.kTypeGamebill then
            self:SetGamebillText(sPlayer.player_modules.numbers:Get(enum.NumberType.kTypeGamebill), true)
            self:PlayGamebillShake(delta)
        end
    end)

    self:AddReleaseEvent(function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)  
        game.CCtrlMainMenu:OpenShopDialogUI("action_point")
    end,"ImageTL","ButtonAdd")

    self:AddReleaseEvent(function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)  
        game.CCtrlMainMenu:OpenShopDialogUI("diamon")
    end,"ImageDiamonds","ButtonAdd")

    self:AddReleaseEvent(function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)  
        game.CCtrlMainMenu:OpenShopDialogUI("gamebill")
    end,"ImageGold","ButtonAdd")

    -- 滚动层
    self.scroll_view = dxm.CScrollViewUI:Create(self:GetWidget("ScrollView"))
    if self.scroll_view ~= nil then
        self:AddChild(self.scroll_view)
    end

    -- 关闭按钮
    self:AddReleaseEvent(function()  
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)        
        sCtrlMainMenu:BackGame()
    end, "ButtonClose")

    -- 开始按钮
    self:AddReleaseEvent(function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)  
        self:JoinStage()
    end, "ButtonStart")

    -- 世界地图
    self:AddReleaseEvent(function()
        dxm.audio:playSound(assets.sound.config.sound.ui_button_release)
        sUI:Open("app.views.ui.stage.stage_map_ui", self.stage_type)
    end, "ButtonMap")

    -- 左右大地图切换按钮
    self:AddReleaseEvent(function() 
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)
        self:PreStage()
    end, "PanelLeftLayer", "PanelTouch")
    
    self:AddReleaseEvent(function() 
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)
        self:NextStage()
    end, "PanelRightLayer", "PanelTouch")

    -- 显示关卡
    self:_ShowStage()

    --dxm.UIHelper:Open("app.views.game_story.game_story_ui", 1)

    self:RefreshItemBoxes()

    for i=1, 4 do
        self:AddReleaseEvent(function() 
            dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)
            local item_box = sPlayer.player_modules.item_box:GetBox(i)
            if item_box then
                local last_unlock_seconds = sPlayer.player_modules.item_box:GetLastUnlockSeconds(i)
                if last_unlock_seconds ~= 0 then
                    sUI:Open("app.views.ui.stage.stage_item_box_ui", i)
                else
                    sPlayer.player_modules.item_box:OpenBox(i)
                    -- 播放开箱界面;
                    local entry = assets.item_boxes:GetEntry(item_box.id)   
                    sUI:Open("app.views.ui.stage.stage_item_box_reward_ui", entry)
                end
            end
        end, "PanelPackageRoot"..i, "PanelTouch")    
    end

    self:AddListener("item_box_unlocked", function() self:RefreshItemBoxes() end)
    self:AddListener("item_box_opened", function() self:RefreshItemBoxes() end)
    self:AddListener("item_box_added", function() self:RefreshItemBoxes() end)
    self:AddListener("upgrade_skin_ok", function() self:ShowSkinLevel() end)
    self.update_listener = sSchedulerSystem:AddSecondly(function()
        self:RefreshItemBoxesTime()
        self:RefreshScrollviewArrow()
    end)

end

function CStageListUI:onExit()
    if self.update_listener then
        self.update_listener:Disconnect()
        self.update_listener = nil
    end
end

function CStageListUI:RefreshScrollviewArrow()

    if self.scroll_view then
        self:SetWidgetEnableAndVisible(self.scroll_view:HasCellOutsideInFront(), "ImageArrow2")
        self:SetWidgetEnableAndVisible(self.scroll_view:HasCellOutsideInBack(), "ImageArrow1")
    end
end

function CStageListUI:JoinStage(ignore_level_condition)

    ignore_level_condition = ignore_level_condition or false

    -- 先判断皮肤等级是否足够
    if not ignore_level_condition then
        if self.child_stage_entry.level_condition then
            local skin = sPlayer.player_modules.skins:GetActiveSkin()
            if skin and skin.level < self.child_stage_entry.level_condition then
                sUI:Open("app.views.ui.stage.stage_level_condition_warning_ui", function(ok)
                    if ok then
                        self:JoinStage(true)
                    end
                end)
                return
            end
        end
    end

    -- 判断宝箱相关内容
    if sPlayer.player_modules.item_box.full_tip ~= true or not sPlayer.player_modules.item_box:IsFull() then
        if assets.opened.is_dev then
            sPlayer.player_modules.item_box:AddBox(math.random(1,3))
        end
        sUI:OpenWithClearStack("app.views.ui.stage.stage_ready_ui", self.stage_type, self.stage_id, self.child_stage_id)
    else
        local module_item_box = sPlayer.player_modules.item_box
        local pos = module_item_box:GetFullOpenSlotPos()
        local point = sPlayer.player_modules.item_box:GetUnlockPoint(pos)
        local item_box = sPlayer.player_modules.item_box:GetBox(pos)
        local entry = assets.item_boxes:GetEntry(item_box.id)   
        
        sUI:Open("app.views.ui.stage.stage_item_box_full_ui", entry, point,
            function(ok)
                if ok then
                    sPlayer.player_modules.item_box:OpenBoxWithPoint(pos, function(is_successful)
                        if not is_successful then
                            sCtrlItem:PointIsNotEnough()
                        else
                            -- 播放开箱界面;
                            sUI:Open("app.views.ui.stage.stage_item_box_reward_ui", entry)
                        end
                    end)    
                else
                    sUI:OpenWithClearStack("app.views.ui.stage.stage_ready_ui", self.stage_type, self.stage_id, self.child_stage_id)                
                end
            end )
        sPlayer.player_modules.item_box.full_tip = false
    end
end

function CStageListUI:PreStage()

    if self.stage_id <= 1 then
        return
    end
    --sUI:OpenWithClearStack("app.views.ui.stage.stage_list_ui", self.stage_type, self.stage_id - 1)
    self:SelectStage(self.stage_id - 1)
end

function CStageListUI:NextStage()

    if self.stage_id >= game.CAssetStage.normal.stage_count then
        return
    end
    --sUI:OpenWithClearStack("app.views.ui.stage.stage_list_ui", self.stage_type, self.stage_id + 1)
    self:SelectStage(self.stage_id + 1)
end

function CStageListUI:SelectStage(stage_id)

    -- 滚动层清理
    if self.scroll_view then
        self.scroll_view:RemoveAllCells()
    end

    -- 设置关卡
    self.stage_id = stage_id
    self.stage_entry = sPlayer.player_modules.stage:GetStageEntry(self.stage_type, self.stage_id)
    self.default_child_stage_id = nil
    self.child_stage_id = nil

    -- 显示关卡
    self:_ShowStage()
end

function CStageListUI:_ShowStage()

    -- 左右按钮设置
    self:SetWidgetEnableAndVisible(self.stage_id > 1, "PanelLeftLayer")
    self:SetWidgetEnableAndVisible(self.stage_id < game.CAssetStage.normal.stage_count, "PanelRightLayer")

    -- 添加关卡内容
    if self.scroll_view then
        local cell_ui = nil
        for i = 1,self.stage_entry.child_stage_count do
            local icon_ui = require("app.views.ui.stage.stage_icon_ui"):Create(self.stage_type, self.stage_id, i, function(child_stage_id) self:SelectChildStage(child_stage_id) end)
            if not cell_ui then
                cell_ui = require("app.views.ui.stage.stage_cell_ui"):Create()
                self.scroll_view:AddCell(cell_ui)
            end
            cell_ui:Push(icon_ui)
            self.icon_ui_list[i] = icon_ui
            icon_ui.cell_ui = cell_ui

            if cell_ui:IsFull() then
                cell_ui = nil
            end
        end
        self.scroll_view:InitPosition()
    end

    -- 默认选择关卡
    local top_stage_info = sPlayer.player_modules.stage:GetTopStageInfo(self.stage_type)
    print(self.default_child_stage_id)
    if self.default_child_stage_id and (top_stage_info.top_stage_id > self.stage_id or 
    (top_stage_info.top_stage_id == self.stage_id and self.default_child_stage_id <= top_stage_info.top_child_stage_id)) then
        self:SelectChildStage(self.default_child_stage_id, true)
    else

        if top_stage_info.top_stage_id > self.stage_id then
            self:SelectChildStage(self.stage_entry.child_stage_count, true)
        elseif top_stage_info.top_stage_id == self.stage_id then

            local child_stage_id = top_stage_info.top_child_stage_id
            if child_stage_id > self.stage_entry.child_stage_count then
                child_stage_id = self.stage_entry.child_stage_count
            end
            self:SelectChildStage(child_stage_id, true)
        else
            self:SelectChildStage(1, true)
        end
    end

    -- 设置名称
    self:SetLabelText(sStrings:GetString(self.stage_entry.name), "ImageBottom", "TextBT")
end

function CStageListUI:SelectChildStage(child_stage_id, scrollview_move_focus)

    if scrollview_move_focus then
        self.scroll_view:FocusCenter(self.icon_ui_list[child_stage_id].cell_ui)
        self:RefreshScrollviewArrow()
    end

    if self.child_stage_id == child_stage_id then
        return false
    end

    -- 之前选中的界面撤销选中状态
    if self.child_stage_id and self.icon_ui_list[self.child_stage_id] then
        self.icon_ui_list[self.child_stage_id]:Unselected()
    end

    -- 设置新的关卡
    self.child_stage_id = child_stage_id
    self.child_stage_entry = sPlayer.player_modules.stage:GetChildStageEntry(self.stage_type, self.stage_id, self.child_stage_id)
    if not self.child_stage_entry then
        return false
    end
   
    -- 选中状态
    if self.child_stage_id and self.icon_ui_list[self.child_stage_id] then
        self.icon_ui_list[self.child_stage_id]:Selected()
    end

    -- 显示等级
    self:ShowSkinLevel()

    -- 关卡名字
    self:SetLabelText(sStrings:GetString(self.child_stage_entry.name), "ImageBottom2", "TextBT")

    -- 关卡数
    self:SetLabelText(child_stage_id, "TextCheckpointNumber")

    -- 关卡描述
    self:SetLabelText(sStrings:GetString(self.child_stage_entry.desc or "desc"), "TextInformation")

    -- 获取三星通关信息
    self:ShowStarInfo()

    -- 显示关卡奖励
    self:ShowReward()

    -- 创建游戏场景
    require("app.views.game.game_ui"):Show(self.stage_type, self.stage_id, self.child_stage_id)

    -- 关卡排行
    self:ShowStageRankInfo()
end

function CStageListUI:ShowSkinLevel()

    -- 判断是否配置了推荐等级
    if self.child_stage_entry.level_condition then

        local current_level = sPlayer.player_modules.skins:GetActiveSkin().level
        self:SetWidgetVisible(true, "TextCheckpointTipName")
        self:SetLabelText(sStrings:GetString("condition_level")..self.child_stage_entry.level_condition, "TextCheckpointTipName")
        self:SetLabelText(sStrings:GetString("current_level")..current_level, "TextCheckpointTip")

        local label = self:GetWidget("TextCheckpointTip")
        if label then
            local color = nil
            if current_level < self.child_stage_entry.level_condition then
                color = cc.c3b(255, 0, 0)
                self:SetWidgetVisible(false, "TextCheckpointTip", "Image_1")
            else
                color = cc.c3b(0, 255, 0)
                self:SetWidgetVisible(true, "TextCheckpointTip", "Image_1")
            end
            label:setColor(color)
        end
    else
        self:SetWidgetVisible(false, "TextCheckpointTipName")
    end
end

function CStageListUI:ShowStageRankInfo()
    self.rank_name = "stage_score_"..self.stage_type..self.stage_id..self.child_stage_id
    player.player_modules.rank:RequestGetRank(self.rank_name, 1, function() 
        local rank_top = player.player_modules.rank:GetRankTop(self.rank_name)
        if rank_top then           
            self:SetWidgetVisible(true,"PanelRank")
            self:_ShowStageRankInfo()
        else
            self:SetWidgetVisible(false,"PanelRank")
        end

    end)  
end

function CStageListUI:_ShowStageRankInfo()    
    local rank_top = player.player_modules.rank:GetRankTop(self.rank_name)
    if rank_top then
        table.sort(rank_top, function(a, b) return a.pos < b.pos end)
        for i = 1,50 do
            local widget = self:GetWidget("PanelRank"..i)            
            if not widget then
                break
            end
            local rank_player = rank_top[i]
            if rank_player then
                widget:setVisible(true)
                self:SetLabelText(rank_player.user_name, widget, "TextName")
                self:SetLabelText(tostring(rank_player.value), widget, "TextFraction")
                self:SetLabelText(rank_player.pos,widget,"AtlasLabelRanking")
                self:SetWidgetVisible(rank_player.pos == 1,widget,"ImageRanking1")
                self:SetWidgetVisible(rank_player.pos == 2,widget,"ImageRanking2")
                self:SetWidgetVisible(rank_player.pos == 3,widget,"ImageRanking3")
                self:SetWidgetVisible(true,widget,"ImageRanking4")
                self:SetIcon(widget, rank_player)
            else
                widget:setVisible(false)
            end
        end
    end
end

function CStageListUI:SetIcon(widget, rank_player)

    local head_icon = 1
    if player.db.user_id and rank_player.rank_user_id == player.db.user_id then
        head_icon = player.db.head_icon
    elseif rank_player then
        if rank_player.user_info then rank_player.user_info.head_icon=tonumber(rank_player.user_info.head_icon) end
        if rank_player.user_info and rank_player.user_info.head_icon and rank_player.user_info.head_icon <= 4 and rank_player.user_info.head_icon >= 1 then
            head_icon = rank_player.user_info.head_icon
        end
    end
    self:SetImageViewPicture(sPathHelper:GetPlayerIconPath(head_icon), widget, "ImageHeadPortrait")
end

function CStageListUI:ShowStarInfo()
    local stage_entry = sPlayer.player_modules.stage:GetChildStageEntry(self.stage_type, self.stage_id, self.child_stage_id)
    local stage_info = sPlayer.player_modules.stage:GetStageInfo(self.stage_type, self.stage_id, self.child_stage_id).star_info
    for i = 1, 3 do
        stage_entry.star_condition = stage_entry.star_condition or {}
        local condition = stage_entry.star_condition[i]
        if condition then
            local widget = self:GetWidget("Panel" .. i .. "Star")
            if widget then
                self:SetWidgetVisible(true, widget)

                -- 根据条件来创建文本描述
                local message = ""
                if condition.type == game.CAssetGameCondition.win then
                    message = sStrings:GetString(condition.type.desc)
                elseif condition.type == game.CAssetGameCondition.item_collect then
                    message = sStringUtils:GetCombinedStringByID(condition.type.desc, 
                        {param=sStrings:GetString(game.CAssetGameObject[condition.param].name), value=condition.value})
                elseif condition.type == game.CAssetGameCondition.score or condition.type == game.CAssetGameCondition.time then
                    message = sStringUtils:GetCombinedStringByID(condition.type.desc, 
                        {value=condition.value})
                end
                self:SetLabelText(message, widget, "TextCondition")
                self:SetWidgetVisible(stage_info[i] or false, widget, "ImageState1")
                self:SetWidgetVisible(not(stage_info[i] or false), widget, "ImageState2")
            end
        else
            self:SetWidgetVisible(false, "Panel" .. i .. "Star")
        end
    end
end


function CStageListUI:SetActionPointText(action_point, play_action)
    
    local label = self:GetWidget("ImageTL","AtlasLabelNumber")
    -- if not play_action then
        if label then label:setString(action_point.."/"..assets.const.player_max_action_point) end
    -- else
    --     game.CActionHelper:NumberChange(label, action_point)    
    -- end
    
end

function CStageListUI:SetPointText(point,play_action)

    local label = self:GetWidget("ImageDiamonds","AtlasLabelNumber")
    if not play_action then
        if label then label:setString(tostring(point)) end
    else
        game.CActionHelper:NumberChange(label,point)    
    end
end

function CStageListUI:SetGamebillText(gamebill, play_action)

    local label = self:GetWidget("ImageGold","AtlasLabelNumber")
    if not play_action then
        if label then label:setString(tostring(gamebill)) end
    else
        game.CActionHelper:NumberChange(label, gamebill)
    end
end

function CStageListUI:PlayGamebillShake(delta)

    sActionUtils:Shake(self:GetWidget("ImageGold","ImageIcon2"))
    local number = delta
    if number > 0 then        
        local label = self:GetWidget("ImageGold","TextNumberTip")
        self:SetWidgetVisible(true,"ImageGold","TextNumberTip")
        self:SetLabelText("+"..number,"ImageGold","TextNumberTip")
        label:setOpacity(200)
        game.CActionHelper:PopText(label,function()
            self:SetWidgetVisible(false,"ImageGold","TextNumberTip")
        end)
    end
end

function CStageListUI:PlayDiamondShake()

    sActionUtils:Shake(self:GetWidget("ImageDiamonds","ImageIcon2"))
    local number = sPlayer.player_modules.point.add_point
    sPlayer.player_modules.point.add_point = 0
    if number > 0 then
        
        local label = self:GetWidget("ImageDiamonds","TextNumberTip")
        self:SetWidgetVisible(true,"ImageDiamonds","TextNumberTip")
        self:SetLabelText("+"..number,"ImageDiamonds","TextNumberTip")
        label:setOpacity(200)
        game.CActionHelper:PopText(label,function()
            self:SetWidgetVisible(false,"ImageDiamonds","TextNumberTip")
        end)
    end
end

function CStageListUI:PlayHeartShake()

    sActionUtils:Shake(self:GetWidget("ImageTL","ImageIcon2"))
    local number = sPlayer.player_modules.action_point.add_action_point
    sPlayer.player_modules.action_point.add_action_point = 0
    if number > 0 then
        
        local label = self:GetWidget("ImageTL","TextNumberTip")
        self:SetWidgetVisible(true,"ImageTL","TextNumberTip")
        self:SetLabelText("+"..number,"ImageTL","TextNumberTip")
        label:setOpacity(200)
        game.CActionHelper:PopText(label,function()
            self:SetWidgetVisible(false,"ImageTL","TextNumberTip")
        end)
    end
end

function CStageListUI:ShowReward()

    local count = 1
    local reward_times = 1

    -- 首先判断该关卡是否为未过关的关卡
    local top_stage_info = sPlayer.player_modules.stage:GetTopStageInfo(self.stage_type)
    if not top_stage_info or self.stage_id == top_stage_info.top_stage_id and self.child_stage_id == top_stage_info.top_child_stage_id then
        reward_times = 2
    end

    local entry = sPlayer.player_modules.stage:GetChildStageEntry(self.stage_type, self.stage_id, self.child_stage_id)
    if entry and entry.reward then

        -- 解析奖励
        local reward_list = game.CRewardList:ParseFromString(entry.reward)
        for _,reward in pairs(reward_list.list) do

            self:SetWidgetVisible(true, "ImageRewardBottom"..count)

            self.icon = nil
            local icon_pos = self:GetWidget("ImageRewardBottom"..count, "ImageRewardIcon")
            self.icon = cc.Sprite:create(sPathHelper:GetRewardIconPath(reward))
            if self.icon then
                icon_pos:addChild(self.icon)
                --self.icon:setScale(0.5)
                self.icon:setPosition(cc.p(icon_pos:getContentSize().width / 2, icon_pos:getContentSize().height / 2))
            end

            self:SetLabelText("x"..reward.count*reward_times,"ImageRewardBottom"..count, "TextNumber")

            -- 增加奖励数量
            count = count + 1
        end
    end

    for i=count,3 do
        self:SetWidgetVisible(false, "ImageRewardBottom"..i)
    end
end

function CStageListUI:RefreshItemBoxes()

    local current_box_item_id = sPlayer.player_modules.item_box:GetUnlockSlotPos()
    for i=1, 100 do

        local widget = self:GetWidget("PanelPackageRoot"..i)
        if not widget then
            break
        end

        local item_box = sPlayer.player_modules.item_box:GetBox(i)
        if item_box then
            self:SetWidgetVisible(true, widget)

            local entry = assets.item_boxes:GetEntry(item_box.id)
            local spine_ui = nil
            if entry then
                spine_ui = dxm.CSpineUI:Create(entry.path, "idle") 
                if spine_ui then
                    self:RemoveAllChildren(self:GetWidget(widget, "PanelAnimationRoot"))
                    self:AddChild(self:GetWidget(widget, "PanelAnimationRoot"), spine_ui)
                end
            end

            local last_unlock_seconds = sPlayer.player_modules.item_box:GetLastUnlockSeconds(i)
            if last_unlock_seconds == -1 then
                if current_box_item_id == 0 then
                    self:SetWidgetVisible(true, widget, "TextTip")
                    self:SetWidgetVisible(false, widget, "TextTime")
                    self:SetLabelText(sStringUtils:GetString("@wait_open_box"), widget, "TextTip" )
                    if spine_ui and spine_ui.spine then spine_ui.spine:setAnimation(0, "idle", true) end
                else
                    self:SetWidgetVisible(false, widget, "TextTip")
                    self:SetWidgetVisible(false, widget, "TextTime")
                    if spine_ui and spine_ui.spine then spine_ui.spine:setAnimation(0, "idle", true) end                   
                end
            elseif last_unlock_seconds == 0 then
                self:SetWidgetVisible(true, widget, "TextTip")
                self:SetWidgetVisible(false, widget, "TextTime")
                self:SetLabelText(sStringUtils:GetString("@can_open_box"), widget, "TextTip" )
                if spine_ui and spine_ui.spine then spine_ui.spine:setAnimation(0, "shake", true) end
            else
                self:SetWidgetVisible(false, widget, "TextTip")
                self:SetWidgetVisible(true, widget, "TextTime")
                self:SetLabelText(sTimeUtils:ToTimeSpanString(last_unlock_seconds), widget, "TextTime" )
                if spine_ui and spine_ui.spine then spine_ui.spine:setAnimation(0, "idle", true) end
            end
        else
            self:SetWidgetVisible(false, widget)
        end
    end
end

function CStageListUI:RefreshItemBoxesTime()

    for i=1, 100 do
        local widget = self:GetWidget("PanelPackageRoot"..i)
        if not widget then
            break
        end

        local item_box = sPlayer.player_modules.item_box:GetBox(i)
        if item_box then
            local last_unlock_seconds = sPlayer.player_modules.item_box:GetLastUnlockSeconds(i)
            if last_unlock_seconds>0 then
                self:SetWidgetVisible(true, widget, "TextTime")
                self:SetLabelText(sTimeUtils:ToTimeSpanString(last_unlock_seconds), widget, "TextTime" )
            end
        else
            self:SetWidgetVisible(false, widget)
        end
    end
end
return CStageListUI
-- endregion
