--region *.lua
--Date
--此文件由[BabeLua]插件自动生成
--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CStageModeUI = class("game.CStageModeUI",dxm.CStackUI)

local CStageModeUI = game.CStageModeUI

function CStageModeUI:ctor()
    CStageModeUI.super.ctor(self)
    self.cell_list = {}
end

function CStageModeUI:Init(play_open_animation)
    if not self:InitWithFile("csd/Main/MainUi") then
        return false
    end

    self.play_open_animation_ = play_open_animation or false
    return true
end

function CStageModeUI:Create(...)
    local ui = CStageModeUI.new()
    if ui and ui:Init(...) then
        return ui
    end
end

function CStageModeUI:onEnter()

    -- 二次打开不执行主界面动画;
    -- self.play_open_animation = self.play_open_animation_
    -- self.play_open_animation_ = false

    sUI:Open("app.views.ui.shortcut.main_shortcut_ui")
    sUI:Open(true, "app.views.ui.main.main_bg_ui")

    -- 配置决定功能;
    self:SetWidgetVisible(assets.opened.turn_table, "ButtonTurntable")
    self:SetWidgetVisible(assets.version.branch == "telecom", "ButtonMoreGame")
    -- self:SetWidgetVisible(false, "ButtonMoreGame")

    -- 关卡;
    self:AddReleaseEvent(function() 

        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)
        --cc.Director:getInstance():replaceScene(cc.TransitionSlideInR:create(0.5,require("app.views.game.game_scene"):Create()))
        cc.Director:getInstance():replaceScene(require("app.views.game.game_scene"):Create())

        -- 判断是否为首次游戏
        if sCtrlGuide:Listen("join_stage") == false then
            game.CCtrlBattle:GotoStage()
        end
    end, "ButtonCheckpoint")

    -- 无尽;
    self:AddReleaseEvent(function() 
        cc.Director:getInstance():replaceScene(cc.TransitionSlideInR:create(0.5,require("app.views.game.game_scene"):Create()))
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 

        -- 创建游戏场景
        require("app.views.game.game_ui"):Show("infinite", 1, 1)
        sUI:Open("app.views.ui.stage.stage_ready_ui", "infinite", 1, 1)
        
    end, "ButtonEndless")

    -- 对战;
    self:AddReleaseEvent(function() 
        --cc.Director:getInstance():replaceScene(cc.TransitionSlideInR:create(0.5,require("app.views.game.game_scene"):Create()))
        cc.Director:getInstance():replaceScene(require("app.views.game.game_scene"):Create())
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 

        -- 创建游戏场景
        local game_ui = require("app.views.game.game_ui"):Show("compete", 1, 1)
        if game_ui then
            game_ui:Start()
        end
    end, "ButtonSports")

    -- 签到
    self:AddReleaseEvent(function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)  
        game.CCtrlMainMenu:OpenSignUI()
    end,"ButtonSign")

    -- 设置;
    self:AddReleaseEvent(function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)  
        game.CCtrlMainMenu:OpenSettingUpUI()
    end,"ButtonSetUp") 

    -- 更多游戏;
    self:AddReleaseEvent( function(sender)
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)   
        CThirdPlatformUtil:GetInstancePtr():MoreGame()
    end , "ButtonMoreGame")

    -- 大转盘;
    self:AddReleaseEvent( function(sender)
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)   
        game.CCtrlMainMenu:OpenTurnTableUI()
    end , "ButtonTurntable")

    -- 客服相关;
    if assets.opened.is_yys then

        self:AddReleaseEvent(function()
            dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
            dxm.UIHelper:Open("app.views.ui.game_tip_ui.game_service_ui")
        end,"ButtonCustomerService")

        -- self:AddReleaseEvent(function()
        --     dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
        --     dxm.UIHelper:Open("app.views.ui.shop.one_dime_gift_ui")
        -- end,"ButtonSmallPackage")
        -- self:SetWidgetVisible(not sPlayer.player_modules.recharge:IsGiftPackageBuyed(8),"ButtonSmallPackage")

        self:SetWidgetVisible(true,"ButtonCustomerService")
    else
        self:SetWidgetVisible(false,"ButtonCustomerService")
        -- self:SetWidgetVisible(false,"ButtonSmallPackage")
    end

    -- 首充;
    self:AddReleaseEvent(function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
        dxm.UIHelper:Open("app.views.ui.recharge.first_recharge_ui")
    end,"ButtonRechargePack")

    -- 礼包功能;
    if assets.opened.is_yys == true then
        local gift_package_id = sGiftPackage:GetAdvanceGiftPackageID()
        for i = 1, 4 do
            self:AddReleaseEvent(function()
                dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
                sGiftPackage:OpenAdvanceGiftPackageUI()
            end, "ButtonPackage" .. i)
            self:SetWidgetVisible(gift_package_id == i, "ButtonPackage" .. i)
        end
        self:SetWidgetVisible(false, "ButtonPackage5")  
        self:AddListener("buy_gift_package", function()
            local gift_package_id = sGiftPackage:GetAdvanceGiftPackageID()
            for i = 1, 4 do
                self:SetWidgetVisible(gift_package_id == i, "ButtonPackage" .. i)
            end
            self:SetWidgetVisible(false, "ButtonPackage5")        
        end)
    else
        local next_reward_times = player.player_modules.recharge:GetRechargeRewardTimes()+1
        for i = 1, 4 do
            self:AddReleaseEvent(function()
                dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
                dxm.UIHelper:Open("app.views.ui.recharge.reward_recharge_ui")
            end, "ButtonPackage" .. i)
            self:SetWidgetVisible(next_reward_times == i, "ButtonPackage" .. i)
        end
        self:SetWidgetVisible(false, "ButtonPackage5")

        self:AddListener("recharge_reward_fetched", function()
            local next_reward_times = player.player_modules.recharge:GetRechargeRewardTimes()+1
            for i = 1, 4 do
                self:SetWidgetVisible(next_reward_times == i, "ButtonPackage" .. i)
            end        
        end)
    end

    self:SetWidgetEnableAndVisible(false, "ButtonCheckpointsSpree")
    self:SetWidgetEnableAndVisible(false, "ButtonSpecialPackage")
    self:SetWidgetEnableAndVisible(false, "ButtonSmallPackage")

    for _, entry in pairs(assets.shop_gift_package.config) do
        if entry.button_name then
            if entry.is_bad_guy ~= "true" then
                self:SetWidgetEnableAndVisible(not sPlayer.player_modules.recharge:IsGiftPackageBuyed(entry.id), entry.button_name)
                self:AddReleaseEvent(function()
                    dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
                    sGiftPackage:OpenGiftPackageV2(entry.id)
                end, entry.button_name)
            else
                self:SetWidgetEnableAndVisible(false, entry.button_name)
            end
        end
    end

    self:AddListener("buy_gift_package", function(id)
        local entry = assets.shop_gift_package.config[id]
        if entry.button_name then
            if entry.is_bad_guy ~= "true" then
                self:SetWidgetVisible(not sPlayer.player_modules.recharge:IsGiftPackageBuyed(entry.id), entry.button_name)
            end  
        end
    end)

   self:AddListener("gift_package_daily_clear", function(id)
        local entry = assets.shop_gift_package.config[id]
        if entry.button_name then
            if entry.is_bad_guy ~= "true" then
                self:SetWidgetVisible(not sPlayer.player_modules.recharge:IsGiftPackageBuyed(entry.id), entry.button_name)
            end  
        end
    end)

    -- 首充礼包监听;
    self:AddListener("first_recharge_reward_fetched", function()
        self:SetWidgetVisible(not player.player_modules.shop:IsFirstRechargeRewarded(),"ButtonRechargePack")     
    end)


    self:SetWidgetEnableAndVisible(false, "ButtonPackage_0")
    self:SetWidgetEnableAndVisible(false, "ButtonActivityFB")

     
    self:SetWidgetEnableAndVisible(false, "ButtonUpdate")
    self:AddReleaseEvent( function(sender)
       dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
       sUI:Open("app.views.ui.update.update_tip_ui")
    end , "ButtonUpdate")

    self:AddReleaseEvent(function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
        if game.CAssetGame.all_open then
            dxm.UIHelper:OpenWithClearStack("app.views.ui.mail.mail_ui")
        else
            dxm.CMessageTipUI:Show(sStrings:GetString("system_is_not_open"))
        end
    end,"ButtonMail")

    self:AddReleaseEvent(function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
        sUI:Open("app.views.ui.friend.friend_info_ui", sHttpUser)
    end,"ButtonMy")

    self:AddReleaseEvent(function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
        sCtrlMainMenu:OpenSkinAndMountUI("mount")
    end,"ButtonPetRoom")

    self:AddReleaseEvent(function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
        sCtrlMainMenu:OpenSkinAndMountUI("skin")
    end,"ButtonSkin")

    -- 更新;
    self:ScheduleUpdate(function(dt) self:Update(dt) end)
    self:Update()

    -- 拉一次角色信息
    sMessageSystem:GetAllPlayerMessage()

    self:_RefreshAd()
end

function CStageModeUI:Update()

    self:RefreshMailHotPoint()
    self:RefreshUpdateButton()
    self:RefreshAdButton()
end

function CStageModeUI:onExit()

end

function CStageModeUI:RefreshUpdateButton()
    
    local show_update = sUpdateSystem:HasNewVersion()
    if show_update ~= self.show_update then
        self.show_update = show_update
        self:SetWidgetEnableAndVisible(self.show_update, "ButtonUpdate")
    end
end

function CStageModeUI:RefreshMailHotPoint()
    self:SetWidgetVisible(sMessageSystem:HasNewPlayerMessage(), "ButtonMail", "ImageRedDot")
end

function CStageModeUI:RefreshAdButton()

    -- 获取当前的CD
    local cd = sCtrlReward:GetAdPointCD()

    -- 显示CD
    self:SetWidgetVisible(cd > 0, "TextCdTime")
    self:SetLabelText(sTimeUtils:ToTimeSpanString(cd), "TextCdTime")
end

function CStageModeUI:_RefreshAd()

    self.is_pop = sPlayer.player_modules.ad:IsPop(1)
    self:SetWidgetEnableAndVisible(self.is_pop, "ButtonAdvertisement")

    self:AddReleaseEvent(function() 
        sCtrlReward:AdPoint(function() 

            if assets.version.branch == "baidu" then
                self.is_pop = sPlayer.player_modules.ad:IsPop(1)
                self:SetWidgetEnableAndVisible(self.is_pop, "ButtonAdvertisement")
            else
                self:SetWidgetEnableAndVisible(false, "ButtonAdvertisement")
            end
        end)
    end, "ButtonAdvertisement")
    self:RefreshAdButton()

    self:SetWidgetVisible(false, "PanelAdvertisementTouch")
    self:SetWidgetVisible(false, "ButtonAdvertisementReward")
    if assets.opened.game_recommender then 
        local task_game_id = sGameRecommender:GetCompleteTaskGameID()
        if not task_game_id then
            local old_recommender_id = sGameRecommender:GetCurrentGameID()
            sGameRecommender:RequestRecommendGame(function(recommender_id) 
                if not old_recommender_id and recommender_id then   
                    self:RefreshGameRecommender()
                end       
            end)
        end
        self:RefreshGameRecommender()
    end

    self:AddListener("app_enter_foreground", function()     
        if assets.opened.game_recommender then 
            self:RefreshGameRecommender()
        end
    end)
end


function CStageModeUI:RefreshGameRecommender() 

    local task_game_id = sGameRecommender:GetCompleteTaskGameID()
    self:SetWidgetVisible(false, "PanelAdvertisementTouch")
    self:SetWidgetVisible(false, "ButtonAdvertisementReward")
    if not task_game_id then
        if sGameRecommender:CanAcceptTask() then
            local recommender_id = sGameRecommender:GetCurrentGameID()
            if recommender_id then   
                self:SetWidgetVisible(true, "PanelAdvertisementTouch")
                local image_file = sGameRecommender:GetIconFile(recommender_id)
                local ui = dxm.CNodeUI:Create( cc.Sprite:create(image_file) )
                self:RemoveAllChildren("PanelAdvertisementRoot")
                if ui then self:AddChild("PanelAdvertisementRoot", ui) end
                self:AddReleaseEvent(function()       
                    local task_game_id = sGameRecommender:GetCompleteTaskGameID()   
                    if task_game_id then      
                        sUI:Open("app.views.ui.game_recommender.game_recommender_reward_ui", recommender_id, function() 
                            self:RefreshGameRecommender()
                        end)
                    else
                        sUI:Open("app.views.ui.game_recommender.game_recommender_ui", recommender_id, function()
                            self:RefreshGameRecommender()
                        end )
                    end
                end,            
                "PanelAdvertisementTouch")
            end
        end
    else
        self:RemoveAllChildren("PanelAdvertisementRoot")
        self:RefreshGameRecommenderReward()
    end
end

function CStageModeUI:RefreshGameRecommenderReward()

    self:SetWidgetVisible(false, "PanelAdvertisementTouch")
    self:SetWidgetVisible(false, "ButtonAdvertisementReward")
    local task_game_id = sGameRecommender:GetCompleteTaskGameID()
    if task_game_id then

        self:SetWidgetVisible(true, "ButtonAdvertisementReward")
        self:AddReleaseEvent( function()
            sUI:Open("app.views.ui.game_recommender.game_recommender_reward_ui", task_game_id, function()
                self:RefreshGameRecommender()
                self.task_game_id = nil
            end )
        end ,
        "ButtonAdvertisementReward")

        self.task_game_id = task_game_id
    end
end

return CStageModeUI

--endregion