--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CStageReadyCellUI = class("game.CStageReadyCellUI",dxm.CBaseUI)

local CStageReadyCellUI = game.CStageReadyCellUI

function CStageReadyCellUI:ctor()
    CStageReadyCellUI.super.ctor(self)

    self.icon = nil
    self.shop_item_entry = nil
    self.item_entry = nil
    self.reward = nil
end

function CStageReadyCellUI:Init(entry)

    self.shop_item_entry = entry
    if not self.shop_item_entry then 
        return false 
    end

    -- 将商品第一件的物品抽离出来
    local reward_list = game.sRewardHelper:ParseFromString(self.shop_item_entry.reward)
    if #reward_list.list > 0 then
        self.reward = reward_list.list[1]
        self.item_entry = assets.items:GetEntry(self.reward.id)
    end
    if not self.item_entry then
        return false
    end
    return self:InitWithFile("csd/Checkpoint/BattlePropStrip")
end

function CStageReadyCellUI:Create(...)

    local ui = CStageReadyCellUI.new()
    if ui and ui:Init(...) then
        return ui
    end
    return nil
end

function CStageReadyCellUI:onEnter()
    if not self.shop_item_entry then
        return
    end

    self:SetLabelText(sStrings:GetString(self.item_entry.name), "TextPropName")
    self:SetLabelText(sStrings:GetString(self.item_entry.desc), "TextPropExplain")
    self:SetLabelText("x"..tostring(self.shop_item_entry.price), "TextMoney")
    self:SetLabelText("x"..tostring(sPlayer.player_modules.package:GetItemCount(self.item_entry.id)), "TextPropNumber")
    
    self:Refresh()

    local panel_icon = self:GetWidget("PanelIcon")
    if panel_icon then
        self.icon = cc.Sprite:create(sPathHelper:GetRewardIconPath(self.reward))
        if self.icon then
            panel_icon:addChild(self.icon)
        end
    end

    self:AddReleaseEvent(function()
        dxm.audio:playSound(assets.sound.config.sound.ui_button_release)
        sPlayer.player_modules.shop:BuyItem(self.item_entry.id, function(is_successful)
            if is_successful == true then
                dxm.UIHelper:Open("dxm.ui.prefab.message_tip_ui", sStrings:GetString("buy_ok"))
                self:Refresh()
            else
                sCtrlItem:GamebillIsNotEnough()
            end
        end)
    end,"ButtonBuy")
end

function CStageReadyCellUI:onExit()

    if self.icon then
        self.icon:removeFromParent()
        self.icon = nil
    end
end

function CStageReadyCellUI:Refresh()

    --获取背包数量
    local count = sPlayer.player_modules.package:GetItemCount(self.item_entry.id)
    if count > 0 then
        self:SetWidgetEnableAndVisible(true, "TextPropNumber")
        self:SetLabelText("x"..count, "TextPropNumber")
    else
        self:SetWidgetEnableAndVisible(false, "TextPropNumber")
    end
end

return CStageReadyCellUI

--endregion
