--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

-- region *.lua
-- Date
-- 此文件由[BabeLua]插件自动生成

game.CStageResultCompeteUI = class("game.CStageResultCompeteUI", dxm.CStackUI)

local CStageResultCompeteUI = game.CStageResultCompeteUI

function CStageResultCompeteUI:Init(stage_type, stage_id, child_stage_id, record, is_win)
    self.stage_type = stage_type
    self.stage_id = stage_id
    self.child_stage_id = child_stage_id
    self.record = record
    self.is_win = is_win

    if self:InitWithFile("csd/Battle/Settlement3") == false then
        return false
    end
    return true
end

function CStageResultCompeteUI:Create(...)

    local ui = CStageResultCompeteUI.new()
    if ui and ui:Init(...) then
        return ui
    end
    return nil
end

function CStageResultCompeteUI:onEnter()

    -- 确认按钮
    self:AddReleaseEvent(function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)
        self:OpenMainMenu()
    end, "ButtonOK")

    -- 继续按钮
    self:AddReleaseEvent(function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)
        self:Restart()
    end, "ButtonGoOn")

    -- 排行内容显示
    local self_color = cc.c3b(0,255,0)
    local other_color = cc.c3b(103,67,32)
    for i=1,#self.record.rank do

        local rank_player = self.record.rank[i]
        if rank_player then

            -- 判断是否为自己
            if rank_player.is_self then
                self:SetLabelText("No."..i, "PanelInformation", "TextFraction")
            end

            -- 在对应的排行位置进行显示赋值
            local panel = self:GetWidget("PanelRank"..i)
            if panel then
                self:SetImageViewPicture(sPathHelper:GetPlayerIconPath(rank_player.icon_path), panel, "ImageHeadPortrait")

                local label = self:GetWidget(panel, "TextFraction")
                if label then
                    if rank_player.is_self then
                        label:setColor(self_color)
                    else
                        label:setColor(other_color)
                    end

                    if self.is_win or rank_player.is_self then
                        label:setString(math.floor(rank_player.score))
                        self:SetWidgetVisible(false, panel, "TextTip")
                    else
                        label:setString("")
                        self:SetWidgetVisible(true, panel, "TextTip")
                    end
                end

                label = self:GetWidget(panel, "TextPlayerName")
                if label then
                    if rank_player.is_self then
                        label:setColor(self_color)
                    else
                        label:setColor(other_color)
                    end
                    label:setString(rank_player.name)
                end
            end
        end
    end
end

function CStageResultCompeteUI:onExit()
    
    -- 音乐播放
    dxm.audio:playMusic(assets.sound.config.music.main)
end

function CStageResultCompeteUI:OpenMainMenu()

    -- 关闭界面
    self:Close()

    -- 进入下一关的界面
    sCtrlMainMenu:BackGame()
end

function CStageResultCompeteUI:Restart()

    self:Close()

    -- 创建游戏场景
    local game_ui = require("app.views.game.game_ui"):Show("compete", 1, 1)
    if game_ui then
        game_ui:Start()
    end
end

return CStageResultCompeteUI

-- endregion

