-- region *.lua
-- Date
-- 此文件由[BabeLua]插件自动生成

game.CStageResultFailUI = class("game.CStageResultFailUI", dxm.CStackUI)

local CStageResultFailUI = game.CStageResultFailUI

function CStageResultFailUI:Init(stage_type, stage_id, child_stage_id)
    self.stage_type = stage_type
    self.stage_id = stage_id
    self.child_stage_id = child_stage_id
    self.child_stage_entry = sPlayer.player_modules.stage:GetChildStageEntry(stage_type, stage_id, child_stage_id)
    if not self.child_stage_entry then
        return false
    end

    if self:InitWithFile("csd/Battle/Failed") == false then
        return false
    end
    return true
end

function CStageResultFailUI:Create(...)

    local ui = CStageResultFailUI.new()
    if ui and ui:Init(...) then
        return ui
    end
    return nil
end

function CStageResultFailUI:onEnter()

    sPlayer.player_modules.stage.failed_times = sPlayer.player_modules.stage.failed_times + 1
    self:SetWidgetVisible(false, "PanelState1")
    self:SetWidgetVisible(true, "PanelState2")

    -- 返回按钮
    self:AddReleaseEvent(function() 
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
        if self.stage_type == "infinite" then
            game.CCtrlBattle:GotoMain()
        else        
            self:OpenStageListUI()
        end
    end, "ButtonOK")

    -- 再次挑战按钮
    self:AddReleaseEvent(function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)  
        self:OpenStageReadyUI()
    end, "PanelState2", "ButtonGoOn")

    self:AddReleaseEvent(function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
        if self.stage_type == "infinite" then
            game.CCtrlBattle:GotoMain()
        else        
            self:OpenStageListUI()       
        end  
        local skin = sPlayer.player_modules.skins:GetActiveSkin()
        if skin then
            sUI:Open("app.views.ui.skin_and_mount.skin_upgrade_ui", skin)
        end
    end, "PanelState2", "ButtonUpgrade")

    -- 显示关卡名称
    self:SetLabelText(sStringUtils:GetString("@is_restart_game"), "TextInformation")
    self:SetLabelText(self.stage_id.."-"..self.child_stage_id.." "..sStrings:GetString(self.child_stage_entry.name), "TextNowCheckpointName")

    local stage_id = self.stage_id
    local child_stage_id = self.child_stage_id
    if stage_id > 1 or child_stage_id >= 10  then
        sPlayer.player_modules.ad:ForcePop(50)
    elseif stage_id > 1 or child_stage_id >= 3  then
        sPlayer.player_modules.ad:ForcePop(30)
    end
end

function CStageResultFailUI:onExit()

    -- 音乐播放
    dxm.audio:playMusic(assets.sound.config.music.main)
end

function CStageResultFailUI:OpenStageListUI()

    -- 关闭界面
    self:Close()

    -- 进入下一关的界面
    sUI:Open("app.views.ui.stage.stage_list_ui", self.stage_type, self.stage_id, self.child_stage_id)
end

function CStageResultFailUI:OpenStageReadyUI()

    -- 关闭界面
    self:Close()

    -- 创建游戏场景
    require("app.views.game.game_ui"):Show(self.stage_type, self.stage_id, self.child_stage_id)

    -- 进入下一关的界面
    sUI:OpenWithClearStack("app.views.ui.stage.stage_ready_ui", self.stage_type, self.stage_id, self.child_stage_id)


    if sPlayer.player_modules.stage.failed_times>=3 then

        sUI:Open("dxm.ui.prefab.message_box_ok_cancel_ui", sStringUtils:GetString("@goto_level_up"), function(ok)
            if ok then
                local skin = sPlayer.player_modules.skins:GetActiveSkin()
                if skin then
                    sUI:Open("app.views.ui.skin_and_mount.skin_upgrade_ui", skin)
                end
            end
        end)
        sPlayer.player_modules.stage.failed_times = 0
    end
end

return CStageResultFailUI

-- endregion
