--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CAchievementCellUI = class("game.CAchievementCellUI",dxm.CBaseUI)

local CAchievementCellUI = game.CAchievementCellUI

function CAchievementCellUI:ctor()
    CAchievementCellUI.super.ctor(self)
end

function CAchievementCellUI:Init(group_id, achievement_group, callback)

    self.group_id = group_id
    self.achievement = achievement_group
    self.task = nil
    self.callback = callback
    self:InitWithFile("csd/IconStrip/IconStripAchievement")
    return true
end

function CAchievementCellUI:RefreshAchievement()

    self.task = self.achievement[player.player_modules.achievement:GetGroupStatus(self.group_id)]
end

function CAchievementCellUI:Create(...)
    local ui = CAchievementCellUI.new()
    if ui and ui:Init(...) then
        return ui
    end

    return nil
end

function CAchievementCellUI:Refresh()

   --刷新一下当前成就
   self:RefreshAchievement()

   self:SetLabelText(sStrings:GetString(self.task.entry.desc),"ImageRankingStrip","TextAchievement") 

   local reward = game.CReward:Create(self.task.entry.reward)
   if reward then
        self:SetLabelText("+"..reward.count,"AtlasLabelNumber")
   end

   self:SetButton()

   local loading_bar = self:GetWidget("ImageLoadingBarBottom","LoadingBar")
   if loading_bar then
        loading_bar:setPercent((self.task.progress / self.task.entry.complete_times) * 100)
   end
   self:SetLabelText(self.task.progress.."/"..self.task.entry.complete_times,"ImageLoadingBarBottom","TextNumber")

   self:SetWidgetVisible(self.task.status == game.CTask.TaskStatus.kTypeReceived,"ImageFinish")

   self:SetWidgetVisible((self.task.status ~= game.CTask.TaskStatus.kTypeReceived) and (game.CCtrlLink:HasConditionLinkUI(self.task:GetCondition())), "ButtonGo")

end

function CAchievementCellUI:onEnter()
    self:Refresh()

   self:AddReleaseEvent(function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)  
        if self.task then
            game.CCtrlLink:OpenConditionLinkUI(self.task:GetCondition())    
        end
   end,"ButtonGo")

   self:AddReleaseEvent(function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)  
        if player.player_modules.achievement:CheckReceiveReward(self.task) then
            player.player_modules.achievement:ReceiveReward(self.task)
            local widget = self:GetWidget("ImageIcon")
            local x ,y = widget:getPositionX(),widget:getPositionX()
            local pos = widget:convertToWorldSpace(cc.p(x,y))
            require("app.views.ui.reward_pop.reward_pop_ui"):Show(pos,self.task.entry.reward)
            dxm.CMessageTipUI:Show(sStrings:GetString("received"))
            if self.callback and self.task.status == game.CTask.TaskStatus.kTypeReceived then
                self.callback()
            end
            self:Refresh()
        end
   end,"ButtonReceive")

   self:AddReleaseEvent(function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)  
        if self.task then
            local reward = game.CReward:Create(self.task.entry.reward)

            if reward and reward.reward_type == game.RewardType.kTypeItem then
                sUI:Open("app.views.ui.package.item_tip_ui",reward.id, function()                 
                end)  
            end
        end
    end,"ImageIconBottom")
    
   local icon_widget = self:GetWidget("ImageIcon")
   if icon_widget then
        self.icon = cc.Sprite:create(self.task.entry.reward_icon_path)
        if self.icon then
            icon_widget:addChild(self.icon)
        end
   end

end

function CAchievementCellUI:SetButton()
    if self.task.status == game.CTask.TaskStatus.kTypeNotComplete then
        self:SetWidgetVisible(false,"ButtonReceive")
        self:SetWidgetVisible(true,"ButtonGo")
    elseif self.task.status == game.CTask.TaskStatus.kTypeCompleted then
        self:SetWidgetVisible(true,"ButtonReceive")
        self:SetWidgetVisible(false,"ButtonGo")
    elseif self.task.status == game.CTask.TaskStatus.kTypeReceived then
        self:SetWidgetVisible(false,"ButtonReceive")
        self:SetWidgetVisible(false,"ButtonGo")
    end
end

function CAchievementCellUI:onExit()
    if self.icon then
        self.icon:removeFromParent()
    end
end

return CAchievementCellUI
--endregion
