--region *.lua
--Date
--此文件由[BabeLua]插件自动生成
require("app.views.ui.task.achievement_cell_ui")
game.CAchievementUI = class("game.CAchievementUI",dxm.CStackUI)

local CAchievementUI = game.CAchievementUI

function CAchievementUI:ctor()
    CAchievementUI.super.ctor(self)
end

function CAchievementUI:Init()
    self:InitWithFile("csd/Additional/AdditionalAchievement")
    self.list = player.player_modules.achievement:GetAchievementList()

    return true
end

function CAchievementUI:Create()
    local ui = CAchievementUI.new()
    if ui and ui:Init() then
        return ui
    end

    return nil
end

function CAchievementUI:onEnter()

    sShortcutHelper:OpenTop()
    sShortcutHelper:OpenTask()
    sShortcutHelper:OpenBottom()

    self.scroll_view = dxm.CScrollViewUI:Create(self:GetWidget("ScrollView"))
    self.scroll_view.fix_tail = 380
    self:AddChild(self.scroll_view)

    self.completed_count = 0
    for group_id, achievement_group in pairs(self.list) do
        for id, achievement in pairs(achievement_group) do
            if achievement.status == game.CTask.TaskStatus.kTypeCompleted or achievement.status == game.CTask.TaskStatus.kTypeReceived then
                self.completed_count = self.completed_count + 1
            end
        end

        local cell = game.CAchievementCellUI:Create(group_id, achievement_group, function() self:SetCompleteText() end)
        if cell then
            self.scroll_view:AddCell(cell)
        end
    end

    self.scroll_view:InitPosition()

    self:SetCompleteText()
end

function CAchievementUI:onExit()

end

function CAchievementUI:SetCompleteText()

    local count = 0
    for _,achievement_group in pairs(self.list) do
        for _,_ in pairs(achievement_group) do
            count = count + 1
        end
    end

    self:SetLabelText(self.completed_count.."/"..count,"TextCompleteNumber")
end

return CAchievementUI

--endregion
