--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CDailyTaskCellUI = class("game.CDailyTaskCellUI",dxm.CBaseUI)

local CDailyTaskCellUI = game.CDailyTaskCellUI

function CDailyTaskCellUI:ctor()
    CDailyTaskCellUI.super.ctor(self)
end

function CDailyTaskCellUI:Init(task,callback)
    self.task = task
    self.callback = callback
    print(self.callback)
    return self:InitWithFile("csd/IconStrip/IconStripDailyTask")
end

function CDailyTaskCellUI:Create(task,callback)
    if task then
        local ui = CDailyTaskCellUI.new()

        if ui and ui:Init(task,callback) then
            return ui
        end
    end

    return nil
end

function CDailyTaskCellUI:onEnter()
   self:SetLabelText(sStrings:GetString(self.task.entry.desc),"ImageRankingStrip","TextTaskDescribe") 
   self:SetLabelText("+"..self.task.entry.activity,"TextActiveName","TextActive")

   local reward = game.CReward:Create(self.task.entry.reward)
   if reward then
        self:SetLabelText("+"..reward.count,"AtlasLabelNumber")
   end

   self:SetButton()

   local loading_bar = self:GetWidget("ImageLoadingBarBottom","LoadingBar")
   if loading_bar then
        loading_bar:setPercent((self.task.progress / self.task.entry.complete_times) * 100)
   end
   self:SetLabelText(self.task.progress.."/"..self.task.entry.complete_times,"ImageLoadingBarBottom","TextNumber")

   self:AddReleaseEvent(function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
        if self.task then
            game.CCtrlLink:OpenConditionLinkUI(self.task:GetCondition())    
        end
   end,"ButtonGo")

   self:AddReleaseEvent(function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
        if player.player_modules.daily_task:CheckReceiveReward(self.task.entry.id) then
            player.player_modules.daily_task:ReceiveReward(self.task.entry.id)
            local widget = self:GetWidget("ImageIcon")
            local x ,y = widget:getPositionX(),widget:getPositionX()
            local pos = widget:convertToWorldSpace(cc.p(x,y))
            require("app.views.ui.reward_pop.reward_pop_ui"):Show(pos,self.task.entry.reward)
            self:SetButton()
            if self.callback then
                self.callback(self)
            end
            dxm.CMessageTipUI:Show(sStrings:GetString("received"))
        end
   end,"ButtonReceive")

   self:AddReleaseEvent(function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
        if self.task then
            local reward = game.CReward:Create(self.task.entry.reward)

            if reward and reward.reward_type == game.RewardType.kTypeItem then
                sUI:Open("app.views.ui.package.item_tip_ui",reward.id, function()                 
                end)  
            end
        end
    end,"ImageIconBottom")
    
   local icon_widget = self:GetWidget("ImageIcon")
   if icon_widget then
        self.icon = cc.Sprite:create(self.task.entry.reward_icon_path)
        if self.icon then
            icon_widget:addChild(self.icon)
        end
   end

end

function CDailyTaskCellUI:SetButton()
    if self.task.status == game.CTask.TaskStatus.kTypeNotComplete then
        self:SetWidgetVisible(false,"ButtonReceive")
        self:SetWidgetVisible(true,"ButtonGo")
    elseif self.task.status == game.CTask.TaskStatus.kTypeCompleted then
        self:SetWidgetVisible(true,"ButtonReceive")
        self:SetWidgetVisible(false,"ButtonGo")
    elseif self.task.status == game.CTask.TaskStatus.kTypeReceived then
        self:SetWidgetVisible(false,"ButtonReceive")
        self:SetWidgetVisible(false,"ButtonGo")
    end
end

function CDailyTaskCellUI:onExit()
    if self.icon then
        self.icon:removeFromParent()
    end
end

return CDailyTaskCellUI

--endregion
