--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CDailyTaskUI = class("game.CDailyTaskUI",dxm.CStackUI)

local CDailyTaskCellUI = require("app.views.ui.task.daily_task_cell_ui")
local CDailyTaskUI = game.CDailyTaskUI

function CDailyTaskUI:ctor()
    CDailyTaskUI.super.ctor(self)
    self.cell_list = {}
end

function CDailyTaskUI:Init()
    return self:InitWithFile("csd/Additional/AdditionalDailyTask")
end

function CDailyTaskUI:Create()
    local ui = CDailyTaskUI.new()

    if ui and ui:Init() then
        return ui
    end

    return nil
end

function CDailyTaskUI:onEnter()
    sShortcutHelper:OpenTop()

    sShortcutHelper:OpenTask()
    sShortcutHelper:OpenBottom()

    self.scroll_view = dxm.CScrollViewUI:Create(self:GetWidget("ScrollView"))
    self.scroll_view.fix_tail = 380
    self.scroll_view.fix_head = 20
    self:AddChild(self.scroll_view)

    local task_list = player.player_modules.daily_task:GetDailyTaskList()

    for k, v in pairs(task_list) do
        if v.status ~= game.CTask.TaskStatus.kTypeReceived then
            local cell = CDailyTaskCellUI:Create(v,function(cell) 
                self:RemoveCell(cell) 
                self:SetActiviy()
            end)
            if cell then
                self.scroll_view:AddCell(cell)
                self.cell_list[cell] = cell
            end
        end
    end
    self.scroll_view:InitPosition()

    self:SetLabelText(tostring(0),"TextActiveName","TextActive")
    local loadingbar = self:GetWidget("LoadingBar")
    if loadingbar then loadingbar:setPercent(0) end
    self:SetActiviy()

    self:AddReleaseEvent(function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
        local err = player.player_modules.daily_task:CheckOpenCopperBox()
        if err == game.CPlayerModuleDailyTask.OpenBoxError.kTypeOpenBoxErrorOk then
            player.player_modules.daily_task:OpenCopperBox()
            local widget = self:GetWidget("ImageBox1")
            widget:stopAllActions()
            widget:setRotation(0)
            local visible_rect = dxm.VisibleRect
            local center_pos = visible_rect:center()
            require("app.views.ui.reward_pop.reward_pop_ui"):Show(center_pos,assets.const.copper_box_reward,cc.p(0,-150))
            dxm.CMessageTipUI:Show(sStrings:GetString("received"))
        elseif err == game.CPlayerModuleDailyTask.OpenBoxError.kTypeOpenBoxErrorNotActivity then
            dxm.CMessageTipUI:Show(sStrings:GetString("not_open_daily_box"))
        elseif err == game.CPlayerModuleDailyTask.OpenBoxError.kTypeOpenBoxErrorReceived then
            dxm.CMessageTipUI:Show(sStrings:GetString("daily_box_received"))
        end
    end,"ImageBox1")

    self:AddReleaseEvent(function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
        local err = player.player_modules.daily_task:CheckOpenSilverBox()
        if err == game.CPlayerModuleDailyTask.OpenBoxError.kTypeOpenBoxErrorOk then
            player.player_modules.daily_task:OpenSilverBox()
            local widget = self:GetWidget("ImageBox2")
            widget:stopAllActions()
            widget:setRotation(0)
            local visible_rect = dxm.VisibleRect
            local center_pos = visible_rect:center()
            require("app.views.ui.reward_pop.reward_pop_ui"):Show(center_pos,assets.const.silver_box_reward,cc.p(0,-150))
            dxm.CMessageTipUI:Show(sStrings:GetString("received"))
        elseif err == game.CPlayerModuleDailyTask.OpenBoxError.kTypeOpenBoxErrorNotActivity then
            dxm.CMessageTipUI:Show(sStrings:GetString("not_open_daily_box"))
        elseif err == game.CPlayerModuleDailyTask.OpenBoxError.kTypeOpenBoxErrorReceived then
            dxm.CMessageTipUI:Show(sStrings:GetString("daily_box_received"))
        end
    end,"ImageBox2")

    self:AddReleaseEvent(function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
        local err = player.player_modules.daily_task:CheckOpenGlodBox()
        if err == game.CPlayerModuleDailyTask.OpenBoxError.kTypeOpenBoxErrorOk then
            player.player_modules.daily_task:OpenGlodBox()
            local widget = self:GetWidget("ImageBox3")
            widget:stopAllActions()
            widget:setRotation(0)
            local visible_rect = dxm.VisibleRect
            local center_pos = visible_rect:center()
            require("app.views.ui.reward_pop.reward_pop_ui"):Show(center_pos,assets.glod._box_reward,cc.p(0,-150))
            dxm.CMessageTipUI:Show(sStrings:GetString("received"))
        elseif err == game.CPlayerModuleDailyTask.OpenBoxError.kTypeOpenBoxErrorNotActivity then
            dxm.CMessageTipUI:Show(sStrings:GetString("not_open_daily_box"))
        elseif err == game.CPlayerModuleDailyTask.OpenBoxError.kTypeOpenBoxErrorReceived then
            dxm.CMessageTipUI:Show(sStrings:GetString("daily_box_received"))
        end
    end,"ImageBox3")


    self:AddReleaseEvent(function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
        self:Close()
    end,"ButtonClose")
end

function CDailyTaskUI:RemoveCell(cell)
    self.cell_list[cell] = nil
    local action = cc.Sequence:create(
        cc.MoveBy:create(0.3,cc.p(700,0)),
        cc.CallFunc:create(function()
            self.scroll_view:RemoveCell(cell)
            for k , v in pairs(self.cell_list) do
                sActionUtils:Shake(v:GetWidget("ImageRankingStrip"))
            end
        end)
    )

    cell.widget:runAction(action)
end

function CDailyTaskUI:onExit()
    if self.icon_spine then
        self.icon_spine:removeFromParent()
        self.icon_spine = nil
    end
end

function CDailyTaskUI:SetActiviy()
    print("2222222222222222222222222222222222222222")
    local label = self:GetWidget("PanelPop2","TextActiveName","TextActive")
    game.CActionHelper:NumberScrollChange(label,player.player_modules.daily_task:GetActivity())

    local loadingbar = self:GetWidget("Image_17","LoadingBar")
    if loadingbar then
        game.CActionHelper:LoadingTo(loadingbar,math.floor(player.player_modules.daily_task:GetActivity() / assets.const.daily_task_max_activity * 100))
    end

    if player.player_modules.daily_task:GetActivity() > 0 and self.icon_spine == nil then
        local icon_spine = sSpineUtils:CreateNodeAnimation("spine/battle/special_bubble", true, "line_remove")
        local parent = self:GetWidget("PanelLightAnimation")
        if parent then 
            self.icon_spine = icon_spine
            parent:addChild(self.icon_spine)
        end
    end

    self:SetLabelText(tostring(assets.const.copper_box_need_activity),"LoadingBar","TextNumber1")
    self:SetLabelText(tostring(assets.const.silver_box_need_activity),"LoadingBar","TextNumber2")
    self:SetLabelText(tostring(assets.const.glod_box_need_activity),"LoadingBar","TextNumber3")

    --是否播放宝箱动画
    self:PalyBoxShake()
end

function CDailyTaskUI:PalyBoxShake()
    if player.player_modules.daily_task:CheckOpenCopperBox() == game.CPlayerModuleDailyTask.OpenBoxError.kTypeOpenBoxErrorOk then
        game.CActionHelper:RockedLoop(self:GetWidget("ImageBox1"))
    end

    if player.player_modules.daily_task:CheckOpenSilverBox() == game.CPlayerModuleDailyTask.OpenBoxError.kTypeOpenBoxErrorOk then
        game.CActionHelper:RockedLoop(self:GetWidget("ImageBox2"))
    end

    if player.player_modules.daily_task:CheckOpenGlodBox() == game.CPlayerModuleDailyTask.OpenBoxError.kTypeOpenBoxErrorOk then
        game.CActionHelper:RockedLoop(self:GetWidget("ImageBox3"))
    end
end

return CDailyTaskUI

--endregion
