--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CMainTaskUI = class("game.CMainTaskUI",dxm.CStackUI)

local CMainTaskUI = game.CMainTaskUI

function CMainTaskUI:ctor()
    CMainTaskUI.super.ctor(self)
end

function CMainTaskUI:Init()
    self:InitWithFile("csd/Additional/AdditionalThreadTask")
    return true
end

function CMainTaskUI:Create()
    local ui = CMainTaskUI.new()

    if ui and ui:Init() then
        return ui
    end

    return nil
end

function CMainTaskUI:onEnter()
     sShortcutHelper:OpenTop()

     sShortcutHelper:OpenTask()
     sShortcutHelper:OpenBottom()

     self:InitMainTask()

    self:AddReleaseEvent(function()

        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)  
        game.CCtrlMainMenu:OpenHome()
    end,"ButtonClose")

    self:AddReleaseEvent(function()

        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
        local is_successful = player.player_modules.main_task:ReceiveMainTaskReward()
        --领取成功刷新界面;
        if is_successful then
            self:InitMainTask()
            local icon_widget = self:GetWidget("ImageRewardIconBottom","ImageRewardIcon")
            local pos = icon_widget:convertToWorldSpace(cc.p(icon_widget:getPositionX(),icon_widget:getPositionY()))
            require("app.views.ui.reward_pop.reward_pop_ui"):Show(pos,self.main_task.entry.reward,cc.p(0,-150))
            dxm.CMessageTipUI:Show(sStrings:GetString("received"))
        end    
    end,"ImageBottom","ButtonReceive")

    self:AddReleaseEvent(function()

        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
        if self.main_task then
            game.CCtrlLink:OpenConditionLinkUI(self.main_task:GetCondition())
        end
    end,"ImageBottom","ButtonGo")

    self:AddReleaseEvent(function()

        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
        if self.main_task then
            local reward = game.CReward:Create(self.main_task.entry.reward)
            if reward.reward_type == game.RewardType.kTypeItem then
                sUI:Open("app.views.ui.package.item_tip_ui",reward.id, function()                 
                end)  
            end
        end
    end,"ImageRewardIconBottom")

end

function CMainTaskUI:InitMainTask()
    if not player.player_modules.main_task:IsAllCompleted() then
        self.main_task = player.player_modules.main_task:GetCurrentTask()
        
        if not self.main_task then return end

        local entry = self.main_task.entry
        if entry then
            
            self:SetLabelText(sStrings:GetString(entry.name),"ImageExplainBottom","TextTaskName")
            self:SetLabelText(sStrings:GetString(entry.desc),"ImageExplainBottom","TextTaskExplain")
            
            --奖励icon
            local icon_widget = self:GetWidget("ImageRewardIconBottom","ImageRewardIcon")
            if icon_widget then
                if self.main_task_icon then 
                    self.main_task_icon:removeFromParent()
                    self.main_task_icon = nil
                end
                self.main_task_icon = cc.Sprite:create(entry.reward_icon_path)
                if self.main_task_icon then
                    self.main_task_icon:setPosition(cc.p(icon_widget:getContentSize().width / 2,icon_widget:getContentSize().height / 2))
                    icon_widget:addChild(self.main_task_icon)
                end
            end

            local token_list = dxm.CToken:Parse(self.main_task.entry.reward,"/")
            self:SetLabelText("x"..token_list[#token_list],"TextNumber")
        end

        --任务是否完成
        if self.main_task.status == game.CTask.TaskStatus.kTypeNotComplete then
            self:SetWidgetVisible(false,"ImageBottom","ButtonReceive")
            self:SetWidgetVisible(true,"ImageBottom","ButtonGo")
            local widget = self:GetWidget("ImageRewardIconBottom")
            if widget then widget:stopAllActions() end
            self:SetWidgetVisible(false,"ImageLight")
        elseif self.main_task.status == game.CTask.TaskStatus.kTypeCompleted then
            self:SetWidgetVisible(true,"ImageBottom","ButtonReceive")
            sActionUtils:ShakeLoop(self:GetWidget("ImageRewardIconBottom"))
            self:SetWidgetVisible(false,"ImageBottom","ButtonGo")
            self:PlayAnimation("LightAnimation",true)
        end

         if not self.icon_spine then
            self.icon_spine = sSpineUtils:CreateNodeAnimation("spine/battle/special_bubble", true, "line_remove")
            local parent = self:GetWidget("ImageRewardIconBottom")
            if parent then 
                parent:addChild(self.icon_spine)
            end
            self.icon_spine:setPosition(cc.p(parent:getContentSize().width / 2,parent:getContentSize().height / 2 + 5))
            self.icon_spine:setScale(1.2)
        else
            self.icon_spine:setVisible(true)
        end

        sActionUtils:ShakeLoop(self:GetWidget("ButtonGo"))
        sActionUtils:ShakeLoop(self:GetWidget("ButtonReceive"))
        
        self:SetWidgetVisible(false,"ImageRewardIconBottom","ImageQuestionMark")
        self:SetWidgetVisible(true,"ImageRewardIconBottom","TextNumber")
    else
        self.main_task = nil
        --全部完成
        if self.main_task_icon then
            self.main_task_icon:removeFromParent()
            self.main_task_icon = nil
        end

        local widget = self:GetWidget("ImageRewardIconBottom")
            if widget then widget:stopAllActions() end

        self:StopAnimation()

        if self.icon_spine then 
            self.icon_spine:setVisible(false)
        end

        self:SetWidgetVisible(false,"ImageLight")
        -- self:SetLabelText(sStrings:GetString("main_task_all_completed"),message:Combine(),"TextTaskExplain")
        self:SetLabelText("","ImageExplainBottom","TextTaskName")
        self:SetLabelText(sStrings:GetString("main_task_all_completed"),"ImageExplainBottom","TextTaskExplain")

        self:SetWidgetVisible(true,"ImageRewardIconBottom","ImageQuestionMark")
        self:SetWidgetVisible(false,"ImageRewardIconBottom","TextNumber")
        self:SetWidgetVisible(false,"ImageBottom","ButtonGo")
        self:SetWidgetVisible(false,"ImageBottom","ButtonReceive")
    end
    
    --任务进度
    local current_progress = player.db.current_main_task_id - 1
    if not self.loading_bar then
        self.loading_bar = cc.ProgressTimer:create(cc.Sprite:create("images/tupian20.png"))
        
        --设置进度条格式
        self.loading_bar:setType(cc.PROGRESS_TIMER_TYPE_BAR)
        self.loading_bar:setMidpoint(cc.p(0, 0))
        self.loading_bar:setBarChangeRate(cc.p(1,0))
        
        self.loading_bar:setAnchorPoint(cc.p(0,0))

        local parent = self:GetWidget("ImageLoadingBarBottom")
        if parent then
            parent:addChild(self.loading_bar)
        end
    end
    
    local current_loading = self.loading_bar:getPercentage()
    local next_loading = (current_progress / #assets.main_task.config) * 100
    local loading_time = (next_loading - current_loading) / 100
    local loading_action = cc.ProgressTo:create(loading_time, next_loading)
    self.loading_bar:runAction(loading_action)
    
    self:SetLabelText(current_progress.."/"..#assets.main_task.config,"TextLoadingBar")
    
end

function CMainTaskUI:onExit()
    if self.main_task_icon then
        self.main_task_icon:removeFromParent()
        self.main_task_icon = nil
    end

    if self.loading_bar then
        self.loading_bar:removeFromParent()
        self.loading_bar = nil
    end

    if self.icon_spine then
        self.icon_spine:removeFromParent()
        self.icon_spine = nil
    end

end

return CMainTaskUI
--endregion
