--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CTaskTabUI = class("game.CTaskTabUI",dxm.CStackUI)
local CTaskTabUI = game.CTaskTabUI

local CDailyTaskCellUI = require("app.views.ui.task.daily_task_cell_ui")
local CAchievementCellUI = require("app.views.ui.task.achievement_cell_ui")

function CTaskTabUI:ctor()

    CTaskTabUI.super.ctor(self)
    self.cell_list = {}
end

function CTaskTabUI:Init(tab_name)

    self.tab_name = tab_name or "daily_task"
    return self:InitWithFile("csd/Additional/AdditionalDailyTask")
end

function CTaskTabUI:Create(...)

    local ui = CTaskTabUI.new()
    if ui and ui:Init(...) then
        return ui
    end

    return nil
end

function CTaskTabUI:onEnter()

    sShortcutHelper:OpenTop()
    sShortcutHelper:OpenTask()
    sShortcutHelper:OpenBottom()

    self.scroll_view = dxm.CScrollViewUI:Create(self:GetWidget("ScrollView"))
    self.scroll_view.fix_tail = 480
    self:AddChild(self.scroll_view)
    
    self:AddReleaseEvent(function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)   
        self:ShowDailyTask()
    end, "ButtonDailyTask")

    self:AddReleaseEvent(function() 
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)  
        self:ShowAchievement()
    end, "ButtonAchievement")

    if self.tab_name=="daily_task" then
        
        self:ShowDailyTask()
    elseif self.tab_name=="achievement" then 
    
        self:ShowAchievement()
    end 

    self:AddReleaseEvent(function(sender)
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)   
        self:Close()
    end,
    "ButtonReturn") 

end

function CTaskTabUI:RemoveCell(cell)

    self.cell_list[cell] = nil
    local action = cc.Sequence:create(
        cc.MoveBy:create(0.3,cc.p(700,0)),
        cc.CallFunc:create(function()
            self.scroll_view:RemoveCell(cell)
            for k , v in pairs(self.cell_list) do
                -- sActionUtils:Shake(v:GetWidget("ImageRankingStrip"))
            end
        end)
    )
    cell.widget:runAction(action)
end

function CTaskTabUI:onExit()

    if self.icon_spine then
        self.icon_spine:removeFromParent()
        self.icon_spine = nil
    end
end

function CTaskTabUI:SetActiviy()

    local label = self:GetWidget("TextActiveName","TextActive")
    game.CActionHelper:NumberScrollChange(label,player.player_modules.daily_task:GetActivity())

    local loadingbar = self:GetWidget("LoadingBar")
    if loadingbar then
        game.CActionHelper:LoadingTo(loadingbar,math.floor(player.player_modules.daily_task:GetActivity() / assets.const.daily_task_max_activity * 100))
    end

    if player.player_modules.daily_task:GetActivity() > 0 and self.icon_spine == nil then
        self.icon_spine = sSpineUtils:CreateNodeAnimation("spine/battle/special_bubble", true, "line_remove")
        local parent = self:GetWidget("PanelLightAnimation")
        if parent then 
            parent:addChild(self.icon_spine)
        end
    end

    self:SetLabelText(tostring(assets.const.copper_box_need_activity),"LoadingBar","TextNumber1")
    self:SetLabelText(tostring(assets.const.silver_box_need_activity),"LoadingBar","TextNumber2")
    self:SetLabelText(tostring(assets.const.glod_box_need_activity),"LoadingBar","TextNumber3")

    --是否播放宝箱动画
    self:PalyBoxShake()
end

function CTaskTabUI:PalyBoxShake()

    if player.player_modules.daily_task:CheckOpenCopperBox() == game.CPlayerModuleDailyTask.OpenBoxError.kTypeOpenBoxErrorOk then
        game.CActionHelper:RockedLoop(self:GetWidget("ImageBox1"))
    end

    if player.player_modules.daily_task:CheckOpenSilverBox() == game.CPlayerModuleDailyTask.OpenBoxError.kTypeOpenBoxErrorOk then
        game.CActionHelper:RockedLoop(self:GetWidget("ImageBox2"))
    end

    if player.player_modules.daily_task:CheckOpenGlodBox() == game.CPlayerModuleDailyTask.OpenBoxError.kTypeOpenBoxErrorOk then
        game.CActionHelper:RockedLoop(self:GetWidget("ImageBox3"))
    end
end


function CTaskTabUI:ShowDailyTask()

    self:SetWidgetEnable(false, "ButtonDailyTask" )
    self:SetWidgetEnable(true, "ButtonAchievement" )
    self:SetWidgetVisible(true, "PanelDailyTask" )
    self:SetWidgetVisible(false, "PanelAchievement" )

    self.scroll_view:RemoveAllCells()
    local task_list = player.player_modules.daily_task:GetDailyTaskList()
    local sort_task_list = {}
    for _, v in pairs(task_list) do
        sort_task_list[#sort_task_list+1] = v
    end

    table.sort(sort_task_list, function(a,b) 
        if b.status == game.CTask.TaskStatus.kTypeCompleted then
            return false
        end
        if a.status == game.CTask.TaskStatus.kTypeCompleted then
            return true
        end
        if b.status == game.CTask.TaskStatus.kTypeNotComplete then
            return false
        end
        if a.status == game.CTask.TaskStatus.kTypeNotComplete then
            return true
        end
        if b.status == game.CTask.TaskStatus.kTypeReceived then
            return false
        end
        if a.status == game.CTask.TaskStatus.kTypeReceived then
            return true
        end
        return false
    end)
    for k, v in pairs(sort_task_list) do
        if v.status ~= game.CTask.TaskStatus.kTypeReceived then
            local cell = CDailyTaskCellUI:Create(v,function(cell) 
                self:RemoveCell(cell) 
                self:SetActiviy()
            end)
            if cell then
                self.scroll_view:AddCell(cell)
                self.cell_list[cell] = cell
            end
        end
    end
    self.scroll_view:InitPosition()

    self:SetLabelText(tostring(0),"PanelDailyTask","TextActive")
    local loadingbar = self:GetWidget("PanelDailyTask","LoadingBar")
    loadingbar:setPercent(0)
    self:SetActiviy()


    self:AddReleaseEvent(function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)  
        local err = player.player_modules.daily_task:CheckOpenCopperBox()
        if err == game.CPlayerModuleDailyTask.OpenBoxError.kTypeOpenBoxErrorOk then
            player.player_modules.daily_task:OpenCopperBox()
            local widget = self:GetWidget("ImageBox1")
            widget:stopAllActions()
            widget:setRotation(0)
            local center_pos = dxm.VisibleRect:center()
            game.CRewardPopUI:Show(center_pos,assets.const.copper_box_reward,cc.p(0,-150))
            dxm.CMessageTipUI:Show(sStrings:GetString("received"))
        elseif err == game.CPlayerModuleDailyTask.OpenBoxError.kTypeOpenBoxErrorNotActivity then
            dxm.CMessageTipUI:Show(sStrings:GetString("not_open_daily_box"))
        elseif err == game.CPlayerModuleDailyTask.OpenBoxError.kTypeOpenBoxErrorReceived then
            dxm.CMessageTipUI:Show(sStrings:GetString("daily_box_received"))
        end
    end,"ImageBox1")

    self:AddReleaseEvent(function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)  
        local err = player.player_modules.daily_task:CheckOpenSilverBox()
        if err == game.CPlayerModuleDailyTask.OpenBoxError.kTypeOpenBoxErrorOk then
            player.player_modules.daily_task:OpenSilverBox()
            local widget = self:GetWidget("ImageBox2")
            widget:stopAllActions()
            widget:setRotation(0)
            local center_pos = dxm.VisibleRect:center()
            game.CRewardPopUI:Show(center_pos,assets.const.silver_box_reward,cc.p(0,-150))
            dxm.CMessageTipUI:Show(sStrings:GetString("received"))
        elseif err == game.CPlayerModuleDailyTask.OpenBoxError.kTypeOpenBoxErrorNotActivity then
            dxm.CMessageTipUI:Show(sStrings:GetString("not_open_daily_box"))
        elseif err == game.CPlayerModuleDailyTask.OpenBoxError.kTypeOpenBoxErrorReceived then
            dxm.CMessageTipUI:Show(sStrings:GetString("daily_box_received"))
        end
    end,"ImageBox2")

    self:AddReleaseEvent(function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release)  
        local err = player.player_modules.daily_task:CheckOpenGlodBox()
        if err == game.CPlayerModuleDailyTask.OpenBoxError.kTypeOpenBoxErrorOk then
            player.player_modules.daily_task:OpenGlodBox()
            local widget = self:GetWidget("ImageBox3")
            widget:stopAllActions()
            widget:setRotation(0)

            local center_pos = dxm.VisibleRect:center()
            game.CRewardPopUI:Show(center_pos,assets.glod._box_reward,cc.p(0,-150))
            dxm.CMessageTipUI:Show(sStrings:GetString("received"))
        elseif err == game.CPlayerModuleDailyTask.OpenBoxError.kTypeOpenBoxErrorNotActivity then
            dxm.CMessageTipUI:Show(sStrings:GetString("not_open_daily_box"))
        elseif err == game.CPlayerModuleDailyTask.OpenBoxError.kTypeOpenBoxErrorReceived then
            dxm.CMessageTipUI:Show(sStrings:GetString("daily_box_received"))
        end
    end,"ImageBox3")
end

function CTaskTabUI:ShowAchievement()

    self:SetWidgetEnable(true, "ButtonDailyTask" )
    self:SetWidgetEnable(false, "ButtonAchievement" )
    self:SetWidgetVisible(false, "PanelDailyTask" )
    self:SetWidgetVisible(true, "PanelAchievement" )

    self.scroll_view:RemoveAllCells()
    local achievement_list = player.player_modules.achievement:GetAchievementList()

    local sort_task_list = {}
    for group_id, achievement in pairs(achievement_list) do
        sort_task_list[#sort_task_list+1] = player.player_modules.achievement:GetCurrentTask(group_id)
    end
    table.sort(sort_task_list, function(a,b) 
        if b.status == game.CTask.TaskStatus.kTypeCompleted then
            return false
        end
        if a.status == game.CTask.TaskStatus.kTypeCompleted then
            return true
        end
        if b.status == game.CTask.TaskStatus.kTypeNotComplete then
            return false
        end
        if a.status == game.CTask.TaskStatus.kTypeNotComplete then
            return true
        end
        if b.status == game.CTask.TaskStatus.kTypeReceived then
            return false
        end
        if a.status == game.CTask.TaskStatus.kTypeReceived then
            return true
        end
        return false
    end)

    self.completed_count = 0
    for _, task in pairs(sort_task_list) do
        local group_id = task.entry.group_id
        local task_list = achievement_list[group_id]
        for id, task in pairs(task_list) do
            if task.status == game.CTask.TaskStatus.kTypeComplete or task.status == game.CTask.TaskStatus.kTypeReceived then
                self.completed_count = self.completed_count + 1
            end
        end

        local cell = CAchievementCellUI:Create(group_id, task_list, function() 
                self.completed_count = self.completed_count + 1
                self:SetAchievementCompleteText() 
            end)
        if cell then
            self.scroll_view:AddCell(cell)
        end
    end
    self.scroll_view:InitPosition()
    self:SetAchievementCompleteText()
end

function CTaskTabUI:SetAchievementCompleteText()

    local count = 0
    local list = player.player_modules.achievement:GetAchievementList()
    for _,achievement_group in pairs(list) do
        for _,_ in pairs(achievement_group) do
            count = count + 1
        end
    end
    self:SetLabelText(self.completed_count.."/"..count,"TextCompleteNumber")
end


return CTaskTabUI

--endregion
