-- region *.lua
-- Date
-- 此文件由[BabeLua]插件自动生成

game.CTurnTableUI = class("game.CTurnTableUI", dxm.CStackUI)

local CTurnTableUI = game.CTurnTableUI

function CTurnTableUI:ctor()
    CTurnTableUI.super.ctor(self)
end

function CTurnTableUI:Init()
    self:InitWithFile("csd/Additional/AdditionalTurntable")
    return true
end

function CTurnTableUI:Create(...)
    local ui = CTurnTableUI.new()
    if ui and ui:Init(...) then
        return ui
    end

    return nil
end

function CTurnTableUI:Show(...)
    local ui = self:Create(...)
    return ui
end

function CTurnTableUI:onEnter()
    sShortcutHelper:OpenTop()
    -- sShortcutHelper:OpenBottom()
    self:AddReleaseEvent( function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
        self:Close()
    end , "ButtonClose")

    self:AddReleaseEvent( function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
        self:Run()
    end , "ButtonStart")

    self:AddReleaseEvent( function()
        dxm.audio:playEffect(assets.sound.config.sound.ui_button_release) 
        self:Run()
    end , "ButtonFree")

    local image_light = self:GetWidget("ImageLight")
    if image_light then
        image_light:runAction(cc.RepeatForever:create(cc.Blink:create(3, 10)))
    end

    self:Refresh()

    self:AddListener("turn_table_fetch_reward", function() 
    
        -- player.player_modules.turn_table.random_id
        local center_pos = dxm.VisibleRect:center()
        local entry = assets.turn_table:GetEntry(player.player_modules.turn_table.random_id) 
        if entry then
            -- require("app.views.ui.reward_pop.reward_pop_ui"):Show(center_pos, entry.reward)
        end
    end)

    for i=1, 8 do
        local entry = assets.turn_table:GetEntry(i) 
        if entry then
            self:SetImageViewPicture(entry.icon_path, "PanelIconGoods"..i, "ImageIconRoot")
            local reward = game.CReward:Create(entry.reward)
            self:SetLabelText("x"..reward.count, "PanelIconGoods"..i, "TextPackage")
        end
    end
end

function CTurnTableUI:onExit()

end

function CTurnTableUI:Run()

    local err = player.player_modules.turn_table:Run()
    if err then
        if err == "not_enough_point" then
            game.CCtrlItem:PointIsNotEnough()
            return
        end
    end

    local random_id = player.player_modules.turn_table.random_id
    local target_rotation = (random_id-1)*45 + 22.5
    -- 准备转到 player.player_modules.turn_table.random_id 并锁屏;
    local actions = {}
    actions[#actions+1] = cc.EaseIn:create(cc.RotateTo:create(2, 360*5), 2)
    actions[#actions+1] = cc.EaseOut:create(cc.RotateTo:create(4, 360*8+target_rotation), 10)
    actions[#actions+1] = cc.DelayTime:create(1)
    sUI:LockTouch()
    actions[#actions+1] = cc.CallFunc:create(function() 
        sUI:UnlockTouch()
        self:Refresh()
        sUI:Open("app.views.ui.turn_table.turn_table_pop_ui", random_id)
    end)
    
    local image_bottom = self:GetWidget("ImageTurntableBottom")
    if image_bottom then
        image_bottom:setRotation(math.floor(image_bottom:getRotation())%360)
        image_bottom:runAction(cc.Sequence:create(actions))
    end
    player.player_modules.turn_table:FetchReward()
end

function CTurnTableUI:Refresh()

    local free_time = player.player_modules.turn_table:GetFreeTimes()
    self:SetWidgetVisible(free_time==0, "ButtonStart")
    self:SetWidgetVisible(free_time~=0, "ButtonFree")
    self:SetLabelText(""..free_time, "TextNumber")
    self:SetLabelText("x"..assets.turn_table.point_per_once, "TextDiamonds")

end

return CTurnTableUI
-- endregion
