--region *.lua
--Date
--此文件由[BabeLua]插件自动生成


dxm.CLocale = {}
cc.exports.sLocale = dxm.CLocale
local CLocale = dxm.CLocale

function CLocale:GetBranchName()
    local branch = sJsonUtils:Load("branches/branch.json")
    return branch.name
end

function CLocale:GetLocaleName(name)
    
    local locale_name = name
    if self.locale_name then
        locale_name = locale_name.."_" ..self.locale_name
    end
    return locale_name
end

function CLocale:SetLocale(locale_name)

    if not locale_name then
        local current_locale = sDeviceUtils:GetState("locale")
        local lang = string.sub(current_locale, 1, 2)
        local contry = string.sub(current_locale, 4, 5)
        if lang == zh then
            if contry and (contry == "TW" or contry =="Hant" or contry =="HK") then
                -- chf
                self.locale_name = "chs"
            else
                -- chs
                self.locale_name = "chs"
            end
        else
            -- en
            self.locale_name = "chs"
        end
    else
        self.locale_name = locale_name
    end

    local branch = sJsonUtils:Load("branches/branch.json")
    self.branch_name = branch.name

    local search_paths = {}
    -- ""
    search_paths[#search_paths+1] = device.writablePath.."patch/" 
    if self.branch_name then search_paths[#search_paths+1] = "branches/"..self.branch_name.."/" end
    -- search_paths[#search_paths+1] = ""

    -- "src/"
    search_paths[#search_paths+1] = device.writablePath.."patch/src/" 
    if self.branch_name then search_paths[#search_paths+1] = "branches/"..self.branch_name.."/src/" end
    search_paths[#search_paths+1] = "src/" 

    -- "res/res-"..self.locale_name
    search_paths[#search_paths+1] = device.writablePath.."patch/res/res-"..self.locale_name.."/"
    if self.branch_name then search_paths[#search_paths+1] = "branches/"..self.branch_name.."/res/res-"..self.locale_name.."/" end
    search_paths[#search_paths+1] = "res/res-"..self.locale_name.."/"

    -- "ccs/ccs-"..self.locale_name
    search_paths[#search_paths+1] = device.writablePath.."patch/ccs/ccs-"..self.locale_name.."/"
    if self.branch_name then search_paths[#search_paths+1] = "branches/"..self.branch_name.."/ccs/ccs-"..self.locale_name.."/" end
    search_paths[#search_paths+1] = "ccs/ccs-"..self.locale_name.."/"

    -- "res"
    search_paths[#search_paths+1] = device.writablePath.."patch/res/"
    if self.branch_name then search_paths[#search_paths+1] = "branches/"..self.branch_name.."/res/" end
    search_paths[#search_paths+1] = "res/"

    -- "ccs"
    search_paths[#search_paths+1] = device.writablePath.."patch/ccs/"
    if self.branch_name then search_paths[#search_paths+1] = "branches/"..self.branch_name.."/ccs/" end
    search_paths[#search_paths+1] = "ccs/"

    cc.FileUtils:getInstance():setSearchPaths(search_paths)
    self:Load()
end

function CLocale:Load()
   
   assets.strings:Load()
   assets.names:Load()
   assets.scripts:Load()
   assets.tips:Load()
end

function CLocale:LoadStrings()   
   self:Load()
end

function CLocale:GetUIFile(config)

    local csb_file = "ccs/"..config..".csb"
    if self.locale_name then
        local locale_csb_file = "ccs/ccs-" ..self.locale_name.."/"..config..".csb"	
        local fullpath = cc.FileUtils:getInstance():fullPathForFilename(locale_csb_file)
        if cc.FileUtils:getInstance():isFileExist(fullpath) then
             csb_file = locale_csb_file
        end
    end
    return csb_file
end

return CLocale

--endregion
