-- region *.lua
-- Date
-- 此文件由[BabeLua]插件自动生成

dxm.CPeroidTasks = class("dxm.CPeroidTasks")

local CPeroidTasks = dxm.CPeroidTasks

-- 持续型任务, 运行中的任务为0时会执行后备系统的任务
-- 注意保证一个 ParallelDo 对应一个 ParallelDone

function CPeroidTasks:ctor()
    self.running_count = 0
    self.wait_run_list = dxm.CList:new()
end

-- 纯执行, 不参与并行任务逻辑
function CPeroidTasks:AsyncDo( task_callback )
    if task_callback==nil then return end
    task_callback(0)
end

function CPeroidTasks:ParallelDo( task_callback )
    if task_callback==nil then return end

    -- 为什么+2? 保证同一帧调用 Done 直接执行后续任务的
    self.running_count = self.running_count + 2
    task_callback()
    self.running_count = self.running_count - 1
end

function CPeroidTasks:ParallelDone()
    
     -- print("task done".. aiid)
     if self.running_count == 0 then 
        return 
     end

     self.running_count = self.running_count - 1
     self:_CheckNext()
end

function CPeroidTasks:SequenceDo( task_callback )
    if self.running_count==0 then
        -- print("task next do")
        if task_callback then task_callback() end
        self:_CheckNext()
    else
        -- print("task next wait")
        self.wait_run_list:PushBack(task_callback)
    end
end

function CPeroidTasks:_CheckNext()
    if self.running_count==0 then
        -- print("task next do 2")
        local task_callback = self.wait_run_list:PopFront()
        if task_callback then
            if task_callback then task_callback() end
            self:_CheckNext()
        end
    end
end

return CPeroidTasks

-- endregion
