-- region *.lua
-- Date
-- 此文件由[BabeLua]插件自动生成

dxm.CTasks = class("dxm.CTasks")

local CTasks = dxm.CTasks

-- 任务需要手动执行和关闭; 任务执行完毕以后执行下一组任务;
function CTasks:ctor()
    self.running_count = 0
    self.task_group_list = dxm.CList:new()
end

-- 任务开始;
function CTasks:Add2AsyncGroup( task_callback )
    if task_callback then task_callback() end
end

-- 任务开始;
function CTasks:Add2CurGroup( task_callback )
    if task_callback==nil then return end

    self:_Run(task_callback)
    self:_RunNextTaskGroup()
end

-- 任务结束;
function CTasks:Done()
    
     if self.running_count == 0 then 
        return 
     end

     self.running_count = self.running_count - 1
     -- print("tasks:task done", self.running_count, self.task_group_list.size)
     self:_RunNextTaskGroup()
end

-- 添加任务到组;
function CTasks:Add2Group(task_callback)

    if not task_callback or type(task_callback) ~= "function" then return end

    local task_group = self.task_group_list:Back()
    if not task_group then
        self:Add2CurGroup(task_callback)
    else
        task_group.list[#task_group.list+1] = task_callback
        -- print("tasks:task add", self.running_count, self.task_group_list.size)
    end
end

-- 添加任务组;
function CTasks:Add2NewGroup(task_callback)

    -- 没有任务就直接加入运行组;
    if self.running_count==0 then         
        self:Add2Group(task_callback) 
        return
    end

    if not task_callback or type(task_callback) ~= "function" then return end
    local task_group = {}
    task_group.list = {}
    self.task_group_list:PushBack(task_group)
    -- print("tasks:task group add", self.running_count, self.task_group_list.size)
    self:Add2Group(task_callback)   
end

-- 执行任务;
function CTasks:_Run( task_callback )
    if task_callback==nil then return end

    -- 为什么+2? 任务结束需要调用 Done, 函数 Done 检测引用计数为 0 则执行下一组任务。
    -- 如果+1的话, 回调中直接调用 Done, 本组还没有执行完成就执行下一组任务了, 逻辑就出问题了。
    self.running_count = self.running_count + 2
    -- print("tasks:task run", self.running_count-1, self.task_group_list.size)
    task_callback()
    -- print("tasks:task run", self.running_count, self.task_group_list.size)
    self.running_count = self.running_count - 1
    -- print("tasks:task run done", self.running_count, self.task_group_list.size)
end

-- 检查下一组;
function CTasks:_RunNextTaskGroup()

    if self.running_count==0 then
        local task_group = self.task_group_list:PopFront()
        if not task_group then return end

        for _, task_callback in pairs(task_group.list) do
            self:_Run(task_callback)
        end

        -- 如果没有持续型的任务, 就直接结束;
        self:_RunNextTaskGroup()
    end
end

return CTasks

-- endregion
