--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

dxm.CTimePointTask = class("dxm.CTimePointTask")

local CTimePointTask = dxm.CTimePointTask

function CTimePointTask:ctor()
    self.period = nil
    self.start_time = nil
    self.current_time = nil
    self.callback = nil
end

function CTimePointTask:Init(preiod,start_time,callback)
    self.preiod = preiod or 1
    self.start_time = start_time
    self.callback = callback
    
    return true
end

function CTimePointTask:Create(...)
    local task = CTimePointTask.new()
    if task and task:Init(...) then
        return task
    end

    return nil
end

function CTimePointTask:Update(dt)
    local current_time = os.time()
    local start_time = self.start_time
    local times = 0
    if current_time >= start_time then
        times = math.floor((current_time - start_time) / self.preiod) + 1
        start_time = start_time + times * self.preiod
    end
    
    if self.start_time ~= start_time then
        self.start_time = start_time
        if self.callback then
            self.callback(times)
        end
    end
end

dxm.CTimeScheduler = class("dxm.CTimeScheduler")

local CTimeScheduler = dxm.CTimeScheduler

function CTimeScheduler:ctor()
    self.update_list = {}
    self.handler = 0
    self.frequency_dt = 0
    self.frequency = 1
end

function CTimeScheduler:Update(dt)

    self.frequency_dt = self.frequency_dt + dt
    if self.frequency_dt > self.frequency then
        self.frequency_dt = self.frequency_dt - self.frequency
        for k,v in pairs (self.update_list) do
            v:Update(self.frequency)
        end
    end
end

function CTimeScheduler:AddUpdate(...)
    local time_task = dxm.CTimePointTask:Create(...)
    self.handler = self.handler + 1
    self.update_list[self.handler] = time_task
    return self.handler
end

function CTimeScheduler:RemoveUpdate(handler)
    self.update_list[handler] = nil
end

return CTimeScheduler

--endregion
