--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

dxm.audio = class("audio")

local engine = cc.SimpleAudioEngine:getInstance()

local DEBUG_LEVEL = 3

function dxm.audio:preloadEffect(name)    
    self:preloadSound(name)
end

function dxm.audio:playEffect(name, loop)
    self:playSound(name, loop)  
end

function dxm.audio:playMusic(name, loop)
    
	if assets.opened.open_sound then return end
    if self.current_music ~= name then
        self.current_music = name
        self:_playMusic(name, loop)  
    elseif self.current_music and not self:isMusicPlaying() then
        self:resumeMusic()
    end    
end

function dxm.audio:stopMusic(isReleaseData)
    self.current_music = ""
    self:_stopMusic(isReleaseData)
end

function dxm.audio:getMusicVolume()
    local volume = engine:getMusicVolume()
    if DEBUG >= DEBUG_LEVEL then
        printf("[audio] getMusicVolume() - volume: %0.2f", volume)
    end
    return volume
end

function dxm.audio:setMusicVolume(volume)
    volume = checknumber(volume)
    if DEBUG >= DEBUG_LEVEL then
        printf("[audio] setMusicVolume() - volume: %0.2f", volume)
    end
    engine:setMusicVolume(volume)
end

function dxm.audio:preloadMusic(filename)
    assert(filename, "audio.preloadMusic() - invalid filename")
    if DEBUG >= DEBUG_LEVEL then
        printf("[audio] preloadMusic() - filename: %s", tostring(filename))
    end
    engine:preloadMusic(filename)
end

function dxm.audio:_playMusic(filename, isLoop)
    assert(filename, "audio.playMusic() - invalid filename")
    if type(isLoop) ~= "boolean" then isLoop = true end

    if DEBUG >= DEBUG_LEVEL then
        printf("[audio] playMusic() - filename: %s, isLoop: %s", tostring(filename), tostring(isLoop))
    end
    engine:playMusic(filename, isLoop)
end

function dxm.audio:_stopMusic(isReleaseData)
    isReleaseData = checkbool(isReleaseData)
    if DEBUG >= DEBUG_LEVEL then
        printf("[audio] stopMusic() - isReleaseData: %s", tostring(isReleaseData))
    end
    engine:stopMusic(isReleaseData)
end

function dxm.audio:pauseMusic()
    if DEBUG >= DEBUG_LEVEL then
        printf("[audio] pauseMusic()")
    end
    engine:pauseMusic()
end

function dxm.audio:resumeMusic()
    if DEBUG >= DEBUG_LEVEL then
        printf("[audio] resumeMusic()")
    end
    engine:resumeMusic()
end

function dxm.audio:rewindMusic()
    if DEBUG >= DEBUG_LEVEL then
        printf("[audio] rewindMusic()")
    end
    engine:rewindMusic()
end

function dxm.audio:isMusicPlaying()
    local ret = engine:isMusicPlaying()
    if DEBUG >= DEBUG_LEVEL then
        printf("[audio] isMusicPlaying() - ret: %s", tostring(ret))
    end
    return ret
end

function dxm.audio:getSoundsVolume()
    local volume = engine:getEffectsVolume()
    if DEBUG >= DEBUG_LEVEL then
        printf("[audio] getSoundsVolume() - volume: %0.1f", volume)
    end
    return volume
end

function dxm.audio:setSoundsVolume(volume)
    volume = checknumber(volume)
    if DEBUG >= DEBUG_LEVEL then
        printf("[audio] setSoundsVolume() - volume: %0.1f", volume)
    end
    engine:setEffectsVolume(volume)
end

function dxm.audio:playSound(filename, isLoop)
    if assets.opened.open_sound then return end
    if not filename then
        printError("audio.playSound() - invalid filename")
        return
    end
    if type(isLoop) ~= "boolean" then isLoop = false end
    if DEBUG >= DEBUG_LEVEL then
        printf("[audio] playSound() - filename: %s, isLoop: %s", tostring(filename), tostring(isLoop))
    end
    return engine:playEffect(filename, isLoop)
end

function dxm.audio:pauseSound(handle)
    if not handle then
        printError("audio.pauseSound() - invalid handle")
        return
    end
    if DEBUG >= DEBUG_LEVEL then
        printf("[audio] pauseSound() - handle: %s", tostring(handle))
    end
    engine:pauseEffect(handle)
end

function dxm.audio:pauseAllSounds()
    if DEBUG >= DEBUG_LEVEL then
        printf("[audio] pauseAllSounds()")
    end
    engine:pauseAllEffects()
end

function dxm.audio:resumeSound(handle)
    if not handle then
        printError("audio.resumeSound() - invalid handle")
        return
    end
    if DEBUG >= DEBUG_LEVEL then
        printf("[audio] resumeSound() - handle: %s", tostring(handle))
    end
    engine:resumeEffect(handle)
end

function dxm.audio:resumeAllSounds()
    if DEBUG >= DEBUG_LEVEL then
        printf("[audio] resumeAllSounds()")
    end
    engine:resumeAllEffects()
end

function dxm.audio:stopSound(handle)
    if not handle then
        printError("audio.stopSound() - invalid handle")
        return
    end
    if DEBUG >= DEBUG_LEVEL then
        printf("[audio] stopSound() - handle: %s", tostring(handle))
    end
    engine:stopEffect(handle)
end

function dxm.audio:stopAllSounds()
    if DEBUG >= DEBUG_LEVEL then
        printf("[audio] stopAllSounds()")
    end
    engine:stopAllEffects()
end
audio.stopAllEffects = audio.stopAllSounds

function dxm.audio:preloadSound(filename)
    if not filename then
        printError("audio.preloadSound() - invalid filename")
        return
    end
    if DEBUG >= DEBUG_LEVEL then
        printf("[audio] preloadSound() - filename: %s", tostring(filename))
    end
    engine:preloadEffect(filename)
end

function dxm.audio:unloadSound(filename)
    if not filename then
        printError("audio.unloadSound() - invalid filename")
        return
    end
    if DEBUG >= DEBUG_LEVEL then
        printf("[audio] unloadSound() - filename: %s", tostring(filename))
    end
    engine:unloadEffect(filename)
end

return dxm.audio

--endregion
