-- region *.lua
-- Date
-- 此文件由[BabeLua]插件自动生成

dxm.CClickClippingNode = class("dxm.CClickClippingNode", cc.ClippingNode)
local CClickClippingNode = dxm.CClickClippingNode

function CClickClippingNode:ctor()
   
end

-- click_callback(click_clip)
function CClickClippingNode:Init(opacity, click_callback)

    local points = { cc.p(0,0), cc.p(720, 0), cc.p(720,1160), cc.p(0, 1160) } 
    local white = cc.c4f(1, 1, 1, 1) 
    local stencil = cc.DrawNode:create()
    stencil:drawPolygon(points, 4, white, 0, white)      
    self:setInverted(true)
    self:setAnchorPoint(cc.p(0,0))  
    self:setStencil(stencil)
    self:setCascadeOpacityEnabled(true)
    self:setCascadeColorEnabled(true)

    opacity = opacity or 128
	self.panel = cc.LayerColor:create(cc.c3b(0,0,0))  
    self.panel:setOpacity(opacity)  
    self.panel:setCascadeOpacityEnabled(true)
    self.panel:setCascadeColorEnabled(true)
    self:addChild(self.panel)

    local function onTouchBegan(touch, event)  
      
        local location = touch:getLocation()  
        location = self:convertToNodeSpace(location)
        self.touch_listener:setSwallowTouches(false)   
        if cc.rectContainsPoint(self.rect, location) then
            if self.click_callback then self.click_callback(true) end
            return false  
        end
        if self.click_callback then self.click_callback(false) end
        self.touch_listener:setSwallowTouches(true)  
        return true  
    end 
    self.touch_listener = cc.EventListenerTouchOneByOne:create()  
    self.touch_listener:registerScriptHandler(onTouchBegan,cc.Handler.EVENT_TOUCH_BEGAN)  
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithSceneGraphPriority(self.touch_listener, self.panel) 
    
    self.click_callback = click_callback 
    return true
end

function CClickClippingNode:Create(...)

    local ui = CClickClippingNode.new()
    if ui == nil or ui:Init(...) == false then
        return nil
    end
    return ui
end

function CClickClippingNode:SetNode(node)

    local position = cc.p(node:getPosition())
    position = node:convertToWorldSpace(cc.p(0,0))
    local top_right = dxm.VisibleRect:rightTop()
    position = self:convertToNodeSpace(position)
    self:SetRect(node:getContentSize(), position, node:getAnchorPoint())
end

function CClickClippingNode:SetRect(size, offset, anchor_point)

    anchor_point = anchor_point or cc.p(0,0)
    offset = offset or cc.p(0,0)
    local points = { cc.p(0,0), cc.p(0 + size.width, 0), cc.p(0 + size.width, 0 + size.height ), cc.p(0, 0 + size.height) } 
    local white = cc.c4f(1, 1, 1, 1) 
    local stencil = cc.DrawNode:create()
    stencil:setAnchorPoint(anchor_point)  
    stencil:drawPolygon(points, 4, white, 0, white)  
    stencil:setPosition(offset)

    self.rect = cc.rect(offset.x, offset.y, size.width, size.height)

    self:setStencil(stencil)
end

return CClickClippingNode

--endregion