--region NewFile_1.lua
--Author : IBM
--Date   : 2015/4/28
--此文件由[BabeLua]插件自动生成


dxm = dxm or {}

dxm.CBaseB2Scene = class("dxm.CBaseB2Scene", function()
    return display.newScene("dxm.CBaseScene")
end )
local CBaseB2Scene = dxm.CBaseB2Scene

-- 构造函数
function CBaseB2Scene:ctor()

end

-- 创建函数
function CBaseB2Scene:Create()
    local base_scene = CBaseB2Scene.new()
    if base_scene == nil or base_scene:Init() == false then
        return nil
    end
    return base_scene
end

-- 初始化函数
function CBaseB2Scene:Init()
	-- UI管理器初始化;
    if not layer_ui then
        self._layer_ui = dxm.CLayerUI:Create()
        self._layer_ui_is_auto_create = true
    else
        self._layer_ui = layer_ui
        self._layer_ui_is_auto_create = false
    end
    
    self._layer_ui:AttachParent(self)

    -- 监听事件;
    self:registerScriptHandler( function(state)
        if state == "enter" then
            self:onEnter()
        elseif state == "exit" then
            self:onExit()
        elseif state == "enterTransitionFinish" then
            self:onEnterTransitionFinish()
        elseif state == "exitTransitionStart" then
            self:onExitTransitionStart()
        elseif state == "cleanup" then
            self:onCleanup()
        end
    end )

    -- 物理世界;
    local gravity = b2Vec2:new()
    gravity:Set(0, -100)
    self.physics_world = b2World:new(gravity)

    -- 允许睡眠, 可以提高物体的处理效率, 只有在收到物理效果影响时才会唤醒对象
    self.physics_world:SetAllowSleeping(true)

    -- 开启连续物理测试
    --[[
    连续物理测试会使物理模拟时间间隔缩短，提高模拟精度，避免速度较快的两个物体直接穿透
    但该方法同样会降低引擎的运行效率
    ]]--
	self.physics_world:SetContinuousPhysics(true)

    --[[
    local debug_draw = GLESDebugDraw:new(32)
    debug_draw:SetFlags(7)
    self.physics_world:SetDebugDraw(debug_draw)
    ]]--

    -- 设置监听器
    --[[
    self.contact_listener = CLuab2ContactListener:new()
    self.contact_listener:RegisterBeginContact(function(contact)
        self:BodyBeginContact(contact)
    end)
    self.contact_listener:RegisterEndContact(function(contact)
        self:BodyEndContact(contact)
    end)
    self.physics_world:SetContactListener(self.contact_listener)
    ]]--
	return
end

-- 进入与离开事件
function CBaseB2Scene:onEnter()
    if assets and assets.opened and assets.opened.is_dev then
        local points = { cc.p(0,0), cc.p(200, 0), cc.p(200, 100), cc.p(0, 100) } 
        local black = cc.c4f(0, 0, 0, 0.5) 
        local draw_node = cc.DrawNode:create()
        draw_node:drawPolygon(points, 4, black, 0, black)
        self:addChild(draw_node, 9999)
    end    
    self.update_entry = cc.Director:getInstance():getScheduler():scheduleScriptFunc( function(dt)
    
        local velocityIterations = 8
	    local positionIterations = 1
	    self.physics_world:Step(1/60, velocityIterations, positionIterations);
    end, 0, false)

    -- local debug_b2 = true
    if debug_b2 then
        local debug_layer = CB2DebugLayer:Create()
        debug_layer:SetWorld(self.physics_world)
        debug_layer:SetFlags(1)
        self:addChild(debug_layer, 10000)
    end
end

function CBaseB2Scene:onExit()
    self._layer_ui:DetachParent()
    if self._layer_ui_is_auto_create then
	    self._layer_ui:Dispose()
    end
    cc.Director:getInstance():getTextureCache():removeUnusedTextures()
    trace(cc.Director:getInstance():getTextureCache():getCachedTextureInfo())
    cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.update_entry)
end

function CBaseB2Scene:onEnterTransitionFinish()
end

function CBaseB2Scene:onExitTransitionStart()
end

function CBaseB2Scene:onCleanup()
end

-- 替换界面
function CBaseB2Scene:ReplaceScene(scene)
    cc.Director:getInstance():getTouchDispatcher():removeAllDelegates()
	cc.Director:getInstance():replaceScene(scene)
end

return CBaseB2Scene

--endregion
