--region NewFile_1.lua
--Author : IBM
--Date   : 2015/4/28
--此文件由[BabeLua]插件自动生成


dxm = dxm or {}

dxm.CBasePhysicsScene = class("dxm.CBasePhysicsScene", function()
    return cc.Scene:createWithPhysics()
end )
local CBasePhysicsScene = dxm.CBasePhysicsScene

-- 构造函数
function CBasePhysicsScene:ctor()

end

-- 创建函数
function CBasePhysicsScene:Create()
    local base_scene = CBasePhysicsScene.new()
    if base_scene == nil or base_scene:Init() == false then
        return nil
    end
    return base_scene
end

-- 初始化函数
function CBasePhysicsScene:Init()
	-- UI管理器初始化;
    if not layer_ui then
        self._layer_ui = dxm.CLayerUI:Create()
        self._layer_ui_is_auto_create = true
    else
        self._layer_ui = layer_ui
        self._layer_ui_is_auto_create = false
    end
    
    self._layer_ui:AttachParent(self)

    -- 监听事件;
    self:registerScriptHandler( function(state)
        if state == "enter" then
            self:onEnter()
        elseif state == "exit" then
            self:onExit()
        elseif state == "enterTransitionFinish" then
            self:onEnterTransitionFinish()
        elseif state == "exitTransitionStart" then
            self:onExitTransitionStart()
        elseif state == "cleanup" then
            self:onCleanup()
        end
    end )
	return true;
end

-- 进入与离开事件
function CBasePhysicsScene:onEnter()
    if assets and assets.opened and assets.opened.is_dev then
        local points = { cc.p(0,0), cc.p(200, 0), cc.p(200, 100), cc.p(0, 100) } 
        local black = cc.c4f(0, 0, 0, 0.5) 
        local draw_node = cc.DrawNode:create()
        draw_node:drawPolygon(points, 4, black, 0, black)
        self:addChild(draw_node, 9999)
    end    
end

function CBasePhysicsScene:onExit()
    self._layer_ui:DetachParent()
    if self._layer_ui_is_auto_create then
	    self._layer_ui:Dispose()
    end
    cc.Director:getInstance():getTextureCache():removeUnusedTextures()
    trace(cc.Director:getInstance():getTextureCache():getCachedTextureInfo())
end

function CBasePhysicsScene:onEnterTransitionFinish()
end

function CBasePhysicsScene:onExitTransitionStart()
end

function CBasePhysicsScene:onCleanup()
end

-- 替换界面
function CBasePhysicsScene:ReplaceScene(scene)
    cc.Director:getInstance():getTouchDispatcher():removeAllDelegates()
	cc.Director:getInstance():replaceScene(scene)
end

return CBasePhysicsScene

--endregion
