-- region *.lua
-- Date
-- 此文件由[BabeLua]插件自动生成

cc.exports.dxm = cc.exports.dxm or { }
dxm.CDebugScene = class("dxm.CDebugScene", dxm.CBaseScene)

local CDebugScene = dxm.CDebugScene

-- 唯一请求
CDebugScene.http_request = dxm.CHttpRequest.new()
CDebugScene.is_debug = false

CDebugScene.touch_size = 200

function CDebugScene:ctor()
    CDebugScene.super.ctor(self)
    print("CDebugScene ctor")
end

function CDebugScene:dispose()
    
end

function CDebugScene:Init()
    if CDebugScene.super.Init(self) == false then
        return false
    end

    -- 测试层
    local debug_layer = display.newLayer()
    if debug_layer ~= nil then

        -- 监听点击
        local touch_listener = cc.EventListenerTouchOneByOne:create()
        self.debug_touch_time = 0 
        self.debug_left_count = 0
        self.debug_right_count = 0

        local function touch_began(touch, event)

            -- 判断是否超时
            local current_time = sTimeUtils:Now()
            if current_time - self.debug_touch_time > 5 then
                self.debug_touch_time = current_time
                self.debug_left_count = 0
                self.debug_right_count = 0
            end
            
            -- 左右指定区域内点击可增加次数
            local pos = touch:getStartLocation()
            if pos.x < CDebugScene.touch_size and pos.y > self._layer_ui.layer:getContentSize().height - CDebugScene.touch_size then
                self.debug_left_count = self.debug_left_count + 1
            elseif pos.x > self._layer_ui.layer:getContentSize().width - CDebugScene.touch_size and pos.y > self._layer_ui.widget:getContentSize().height - CDebugScene.touch_size then
                self.debug_right_count = self.debug_right_count + 1
            end

            -- 判断点击次数是否达标
            if self.debug_left_count == 3 and self.debug_right_count == 3 then

                if CDebugScene.is_debug == true then
                    CThirdPlatformUtil:GetInstancePtr():Debug()
                else

                    local panel_debug = ccui.Layout:create()
                    if panel_debug ~= nil then

                        -- 创建输入框
                        local inputtext = ccui.TextField:create("?????", "", 30)
                        if inputtext ~= nil then
                            inputtext:setAnchorPoint(cc.p(0.5,0))

                            print(self._layer_ui.layer:getContentSize().width/2)
                            print(self._layer_ui.layer:getContentSize().height - CDebugScene.touch_size - 100)
                            inputtext:setPosition(cc.p(self._layer_ui.layer:getContentSize().width/2, 
                                self._layer_ui.layer:getContentSize().height - CDebugScene.touch_size - 100))
                            panel_debug:addChild(inputtext)
                        end

                        -- 
                        panel_debug:setSize(self._layer_ui.layer:getContentSize().width, self._layer_ui.layer:getContentSize().height)
                        self._layer_ui:AddReleaseEventFromWidget(function() 

                                local password = ""
                                if inputtext ~= nil then
                                    password = inputtext:getString()
                                end

                                if  CDebugScene.http_request ~= nil then
                                        CDebugScene.http_request:Request(assets.config.http_url.."/Sdk/", 
                                            "Verify", 
                                            "password="..password, 
                                            function(code)

                                                if code == 1 then
                                                    CDebugScene.is_debug = true
                                                    CThirdPlatformUtil:GetInstancePtr():Debug()
                                                end
                                                panel_debug:removeFromParent()
                                            end)
                                end
                            end, 
                            panel_debug)

                        self._layer_ui.widget:addChild(panel_debug, 1000)
                    end
                end
                self.debug_touch_time = current_time - 5
            end
            return false
        end
        touch_listener:setSwallowTouches(true)  
        touch_listener:registerScriptHandler(touch_began, cc.Handler.EVENT_TOUCH_BEGAN)

        debug_layer:getEventDispatcher():addEventListenerWithSceneGraphPriority(touch_listener, debug_layer)

        self._layer_ui.layer:addChild(debug_layer)
    end

    return true
end

return CDebugScene

-- endregion
