--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

dxm.CPhysicsWorld = class("dxm.CPhysicsWorld")

cc.exports.sPhysicsWorld = dxm.CPhysicsWorld

local CPhysicsWorld = dxm.CPhysicsWorld

function CPhysicsWorld:Init()
   -- 物理世界;
    local gravity = b2Vec2:new()
    gravity:Set(0, -100)
    self.physics_world = b2World:new(gravity)

    -- 允许睡眠, 可以提高物体的处理效率, 只有在收到物理效果影响时才会唤醒对象
    self.physics_world:SetAllowSleeping(true)

    -- 开启连续物理测试
    --[[
    连续物理测试会使物理模拟时间间隔缩短，提高模拟精度，避免速度较快的两个物体直接穿透
    但该方法同样会降低引擎的运行效率
    ]]--
	self.physics_world:SetContinuousPhysics(true)

    local debug_draw = GLESDebugDraw:new(32)
    self.physics_world:SetDebugDraw(debug_draw)

    -- 设置监听器
    --[[
    ]]--
    self.contact_listener = CLuab2ContactListener:new()
    self.contact_listener:RegisterBeginContact(function(contact)
        self:BodyBeginContact(contact)
    end)
    self.contact_listener:RegisterEndContact(function(contact)
        self:BodyEndContact(contact)
    end)
    self.physics_world:SetContactListener(self.contact_listener)
end

function CPhysicWorld:Enter()

end

function CPhysicWorld:Exit()

end

function CPhysicsWorld:SetGravity(gravity_x, gravity_y)

    self.physics_world:SetGravity(b2Vec:new_local(gravity_x, gravity_y))
end

function CPhysicsWorld:setDebugDrawMask(mask)

    local debug_draw = GLESDebugDraw:new(32)
    debug_draw:SetFlags(mask)
    self.physics_world:SetDebugDraw(debug_draw)
end

function CPhysicsWorld:BodyBeginContact(contact)

end

function CPhysicsWorld:BodyEndContact(contact)
    
end


return CPhysicsWorld

--endregion
