

dxm.CDatabase = { }

local CDatabase = dxm.CDatabase
cc.exports.sDatabase = CDatabase


--[[
    1. ݶȡ
        1. [ok] memory_value = sDatabase.data.dbtable.value (Ǳݶȡ)
        1. [ok] db_proxy_table = sDatabase.data.dbtable (ݶȡ)
        1. [ok] memory_table = sDatabase.data.dbtable:Clone() (ݶȡ)
        1. [ok] memory_table = sDatabase.data.dbtable() (ݶȡ)
    1. ݸ
        1. [ok] sDatabase.data.dbtable.value = 1  (Ǳд)
        1. [ok] sDatabase.data.dbtable = db_proxy_table (д)
        1. [ok] sDatabase.data.dbtable = deep_table (д)
    1. ݱ
        1. [ok] for key, value in pairs(sDatabase.data.dbtable) do ()
        1. [ok] for key, value in pairs(memory_table) do (ڴ)
    1. ɾ
        1. [ok] sDatabase.data.dbtable = nil
    1. ݱ(ʱͿ)
        1. [ok] sDatabase:Save() (1뱣һ, ͱ)
]]--

--  pairs ֧ݿݵı;
local g_pairs = pairs
cc.exports.dbpairs = function(data_table)

    if data_table and data_table._is_db_proxy then
        local key = nil
        return function()     
            key = next(data_table._db_fields, key)
            return key, data_table[key]
        end
    else
        return g_pairs(data_table)
    end
end
pairs = dbpairs


function CDatabase:SetEncryptInt(db_table, a_key, value)
    local random_int = math.random(111111, 999999)
    local evalue = value + math.floor((random_int + 123456)/2)
    db_table[a_key] = evalue
    db_table[CDatabase.prefix_enumber..a_key] = random_int
end

function CDatabase:GetEncryptInt(db_table, a_key)
    local value = db_table[a_key]
    local random_int = db_table[CDatabase.prefix_enumber..a_key]        
    if random_int then
        return value - math.floor((random_int + 123456)/2)
    end
    return value
end

function CDatabase:SetNotEncryptInt(db_table, a_key, value)
    db_table[a_key] = value
    db_table[CDatabase.prefix_enumber..a_key] = nil
end

function CDatabase:GetNotEncryptInt(db_table, a_key)
    local random_int = db_table[CDatabase.prefix_enumber..a_key]        
    if random_int then
        db_table[CDatabase.prefix_enumber..a_key] = nil
        db_table[a_key] = db_table[a_key] - math.floor((random_int + 123456)/2)
    end
    return db_table[a_key]
end

-- ݳʼ;
function CDatabase:Init(encrypt)

    -- ݿ;
    if encrypt == nil then encrypt = false end
    self.encrypt = encrypt
    sDatabaseUtils:EnableEncrypt(self.encrypt)

    if self.encrypt then
        self.SetInt = self.SetEncryptInt
        self.GetInt = self.GetEncryptInt
    else
        self.SetInt = self.SetNotEncryptInt
        self.GetInt = self.GetNotEncryptInt
    end

    -- ݿ;
    self.db = {}
    -- ݱ; 
    self._db_table_dirty = {}
    -- ӿ, ܴ;
    self.data = self:_CreateDBProxy(self.db)
    -- ֵֶμֶǰ׺;
    self.prefix_enumber = "__enumber_random_" 
end

-- ݼ;
function CDatabase:_Load(table_name)
    -- ݱ
    local db_string = sDatabaseUtils:Get(table_name)
    if db_string then
        local db_table = sJsonUtils:Decode(db_string)
        self:_SetDBRootTable(table_name, db_table)
    else
        self:_SetDBRootTable(table_name, {})
    end
    return self:_GetValue(self.data, self.db, table_name)
end

-- ݱ;
function CDatabase:Save()

    -- ݱ
    for table_name, value in pairs(self._db_table_dirty) do 
        local contents = sJsonUtils:Encode(self.db[table_name])
        sDatabaseUtils:Set(table_name, contents)
    end
    self._db_table_dirty = {}
end

-- DB ½, ڵnilҪݿ
function CDatabase:_CreateDBProxy(db_table, root_table_name)

    if type(db_table) ~= "table" then
        return nil
    end

    -- root_table_name==nil Ϊݿ
    -- root_table_name~=nil Ϊݱӱ 
    if root_table_name ~= nil and type(root_table_name)~="string" then
        return nil
    end

    -- ĬϹ
    -- ¡: Clone
    -- ʶ: _is_db_proxy
    local data_table = {}
    local mt = { }
    mt.__index = function(table, a_key)

        if a_key == nil then
            return nil
        end

        if a_key == "Clone" then
            return mt.Clone
        end

        if a_key == "_is_db_proxy" then
            return mt._is_db_proxy
        end

        if root_table_name==nil and not db_table[a_key] then
            -- root_table_name==nil Ϊݿ
            -- ݱ򴴽
            return self:_Load(a_key)
        end

        return CDatabase:_GetValue(data_table, db_table, a_key)
    end

    mt.__newindex = function(table, a_key, a_value)

        if a_key == nil then
            return nil
        end

        -- ݿⱣֶ;
        if a_key == "Clone" or a_key == "_is_db_proxy" then
            return
        end

        if root_table_name==nil then    
            -- root_table_name==nil Ϊݿ,ÿձʾɾ;   
            if a_value == nil then
                if db_table[a_key] then
                    db_table[a_key] = nil
                    rawset(data_table, "."..a_key, nil)
                    CDatabase._db_table_dirty[a_key] = nil
                    sDatabaseUtils:Remove(a_key)
                end
                return
            end
            
            -- ݿ lua  table 
            if type(a_value) ~= "table" then
                print(debug.traceback("[ERROR] DB Table "..a_key.." Value Type Need lua-table But Its " .. type(a_value), 2))
                return
            end
        end
        local table_name = root_table_name or a_key
        CDatabase:_SetValue(data_table, db_table, a_key, a_value, table_name)
    end

    mt.__call = function()
        return CDatabase:_DeepCopy(db_table)
    end

    mt.Clone = function()
        return CDatabase:_DeepCopy(db_table)
    end

    mt._is_db_proxy = true    
    
    data_table._db_fields = {}
    setmetatable(data_table, mt)
    return data_table
end

-- db ΰ󶨵 data ;
function CDatabase:_SetDBRootTable(table_name, value)
    
    --  db 
    self.db[table_name] = value
    
    -- ݹ鴴ݴ;
    local function _RecursiveCreateDBProxy(data_table, db_table, a_key, table_name)     
         
        data_table._db_fields[a_key] = true
        local db_proxy = CDatabase:_CreateDBProxy(db_table[a_key], table_name)        
        rawset(data_table, "."..a_key, db_proxy)
        for db_key, db_value in pairs(db_table[a_key]) do
            if type(db_value) == "table" then
                _RecursiveCreateDBProxy(rawget(data_table, "."..a_key), db_table[a_key], db_key, table_name)
            end
        end       
    end

    -- ݴ;
    _RecursiveCreateDBProxy(self.data, self.db, table_name, table_name)
end

-- ȿ;
function CDatabase:_DeepCopy(object)

    local lookup_table = {}
    local function _copy(object)
        if type(object) ~= "table" then
            return object
        elseif lookup_table[object] then
            return lookup_table[object]
        end
        local new_table = {}
        lookup_table[object] = new_table
        for key, value in pairs(object) do                          
            if type(value) == "number" and type(key) == "string" then
                if string.find(key, CDatabase.prefix_enumber) == nil then        
                    if object[CDatabase.prefix_enumber..key] then
                        new_table[_copy(key)] = self:GetInt(object, key)
                    else
                        new_table[_copy(key)] = value
                    end
                end
            else
                new_table[_copy(key)] = _copy(value)
            end
        end
        return setmetatable(new_table, getmetatable(object))
    end
    return _copy(object)
end


-- ȡ(ֵǼܵ);
function CDatabase:_GetValue(data_table, db_table, a_key)

    if type(a_key) == "number" then
        a_key = tostring(a_key)
    end

    local value = db_table[a_key]
    if type(value) == "number" then
        return self:GetInt(db_table, a_key)
    elseif type(value) == "table" then
        return rawget(data_table, "."..a_key)
    end
    return value       
end

-- (ֵǼܵ);
function CDatabase:_SetValue(data_table, db_table, a_key, value, table_name)

    if type(a_key) == "number" then
        a_key = tostring(a_key)
    end

    if not (type(a_key) == "string") then
        print("[ERROR] DB table Key Type Need string or number But Its "..type(a_key), a_key)
        return
    end

    if value==nil then
        data_table._db_fields[a_key] = nil
    else        
        data_table._db_fields[a_key] = true
    end

    CDatabase._db_table_dirty[table_name] = true
    if type(value) == "number" then        

        self:SetInt(db_table, a_key, value)
    elseif type(value) == "table" then
        
        if value._is_db_proxy then
            value = value:Clone()
        end

        db_table[a_key] = {}
        local db_proxy = CDatabase:_CreateDBProxy(db_table[a_key], table_name) 
        rawset(data_table, "."..a_key, db_proxy)        
        for sub_key, sub_value in pairs(value) do
            db_proxy[sub_key] = sub_value
        end 
    else         
        db_table[a_key] = value
    end
end


return CDatabase
