--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

dxm.DownloadSystem = {}
local DownloadSystem = dxm.DownloadSystem
cc.exports.sDownloadSystem = DownloadSystem

function DownloadSystem:Init()

    self.download_path = string.gsub(device.writablePath, "[\\\\/]+$", "") .. device.directorySeparator

    -- 本地数据
    sDatabase.data.download_system.download_cache = sDatabase.data.download_system.download_cache or {}
end

-- 远程获取文件
-- callback(file_name)
function DownloadSystem:GetURLFile(url, path, callback)

    local file_path = sDatabase.data.download_system.download_cache[url]

    -- 判断文件是否存在
    if file_path == nil or io.exists(file_path) == false then
        
        -- 下载文件
        CAxel:GetInstancePtr():Download(url, 
            self.download_path..path,
            function(state, result)
                if state == kDownloadFinish then
                    print("download file "..result.file_path.." done")

                    -- 加载完成
                    sDatabase.data.download_system.download_cache[url] = result.file_path

                    -- 完成加载
                    if callback ~= nil then
                        callback(result.file_path)
                    end
                end
            end
        )
    else

        -- 完成加载
        if callback ~= nil then
            callback(file_path)
        end
    end
end

return DownloadSystem

--endregion
