

dxm.CHttpRequest = class("game.CHttpRequest")
local CHttpRequest = dxm.CHttpRequest

--[[
    request:
        url .. action ..".php?" .. param
    response:
        {
            "code":1,
            "data":{},
        }
]]--

function CHttpRequest:ctor(user)
    self.requesting = false;
    self.event_request_waiting = dxm.CEvent.new()
    self.event_request_done = dxm.CEvent.new()
    self.backup_list = dxm.CList.new()
end

function CHttpRequest:Request(url, action, param, response_callback, data)

    if self.requesting == true then
        -- print("", url .. action .. "?" .. param)
        self.backup_list:PushBack({url=url, action=action, param=param, response_callback=response_callback, data=data})
        return
    end

    -- ½һXMLHttpRequest
    local xhr = cc.XMLHttpRequest:new()
    -- json
    xhr.responseType = cc.XMLHTTPREQUEST_RESPONSE_JSON
    -- GETʽ
    local open_url = url .. action .. "?" .. param
    -- open_url = sStringUtils:EncodeURL(open_url)
    xhr:open("POST", open_url)

    local function onReadyStateChange()

        -- ;
        self.requesting = false
        self.event_request_done:Fire()       
  
        local request_pop = self.backup_list:PopFront()
        if request_pop then
            self:Request(request_pop.url, request_pop.action, request_pop.param, request_pop.response_callback, request_pop.data)
        end      
        -- ʾ״̬,ɹʾ200
        if xhr.status == 200 then
            local response = xhr.response
            -- print("---- url:", open_url)
            -- print("---- response:", response)

            -- Ӧ
            local response_json = json.decode(response)
            -- print("---- url:", open_url)
            -- dump(response_json, "response:", 10)

            -- 
            if response_json == nil then
                -- 
                if response_callback then
                    response_callback(-1)
                end
                return
            end

            -- Ӧ
            local action_data = response_json["data"] or { }
            if response_callback then
                response_callback(response_json.code, action_data)
            end
        elseif xhr.status==0 then
            if response_callback then
                response_callback(-999)
            end
        else
            -- print("---- url:", open_url)
            -- print("response: error", xhr.status)
            -- ״̬Ϊ200
            -- self:_OpenRewardPanel("status is error code[" .. xhr.status .. "]")
            if response_callback then
                response_callback(- xhr.status)
            end
        end
    end

    -- עűص
    xhr:registerScriptHandler(onReadyStateChange)

    -- 
    xhr:send(data)

    self.event_request_waiting:Fire()
    self.requesting = true
end

return CHttpRequest