--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

dxm.CHttpUser = {}

local CHttpUser = dxm.CHttpUser
cc.exports.sHttpUser = CHttpUser

-- code: 1为正常返回;
function CHttpUser:Init(game_id)

    self.http_request = dxm.CHttpRequest.new()
    self.device_id = CDeviceUtil:GetInstancePtr():GetDeviceId()
    self.game_id = game_id
    self.url = assets.config.http_url.."/Sdk/index/"
    self.community_url = assets.config.http_url.."/index/index".."?DeviceID="..self.device_id.."&GameID="..self.game_id
    self.qr_code_url = assets.config.http_url.."/index/index".."?DeviceID="..self.device_id.."&GameID="..self.game_id

    -- bast data;
    self.token = nil
    self.seq_id = nil

    -- user_name: "xxx",
    -- user_value: user_name, score
    self.user_name = nil 
    self.user_info = {}
    self.user_data = {}
    self.user_rank_info = {}
    self.user_rank_top = {}
    self.user_rank_less_me = {}
    self.user_rank_large_me = {}
    self.user_rank_top_with_friend = {}
    self.achievement_statistics = {}
    self.achievement_completed = {}
    self.achievement_players = {}
    self.function_list = {}
    self.total_player = 1
    self.friends = {}
    self.users_nearby = {}
    self.player_message = {}
    self.world_message = {}
end

function CHttpUser:_RequestUserToken(callback)

    local session = self:_GetDeviceSession();
    self.http_request:Request(self.url, "GetUserToken", session, function(code, data) 
        if data and data.token then
            self.token = data.token or nil
            self.seq_id = data.seq_id or 1
            self.seq_id = self.seq_id + 1
        end
        if callback then 
            callback(code, data)
        end
    end)
end

function CHttpUser:RequestUserInfo(callback)

    self:_CheckToken(function(code)
        if code~=0 then 
            if callback then 
                callback(code, {})
            end
            return
        else

        local session = self:_GetUserSession()
        self.http_request:Request(self.url, "GetUserInfo", session, function(code, data) 
                self:_SyncData(data)
                if callback then 
                    callback(code, data)
                end
            end)
        end
    end)
end

function CHttpUser:RequestSetUserName(name, callback)

    self:_CheckToken(function(code)
        if code~=0 then 
            if callback then 
                callback(code)
            end
        else
            local session = self:_GetUserSession();
            self.http_request:Request(self.url, "SetUserName", session.."&UserName="..sStringUtils:EncodeURL(name), function(code, data) 
                self:_SyncData(data)
                if callback then 
                    callback(code, data)
                end
            end)
        end
    end)
end

function CHttpUser:RequestCommitUserData(var_name, value, callback)

    self:_CheckToken(function(code)
        if code~=0 then 
            if callback then 
                callback(code)
            end
        else
            local session = self:_GetUserSession();
            self.http_request:Request(self.url, "CommitUserData", session.."&VarName="..var_name.."&VarValue="..value, 
                function(code, data) 
                    self:_SyncData(data)
                    if callback then 
                        callback(code, data)
                    end
                end)
        end
    end)
end


function CHttpUser:RequestCommitUserInfo(var_name, value, callback)

    self:_CheckToken(function(code)

        if code~=0 then 
            if callback then 
                callback(code)
            end
        else
            local session = self:_GetUserSession();
            self.http_request:Request(self.url, "CommitUserInfo", session, 
                function(code, data) 
                    self:_SyncData(data)
                    if callback then 
                        callback(code, data)
                    end
                end,
                "VarName="..var_name.."&VarValue="..value
            )
        end
    end)
end


-- value: 表示数值
-- rank_order: 0表示倒序，1表示正序
function CHttpUser:RequestCommitUserRankValue(rank_name, value, sub_value, rank_order, callback)

    self:_CheckToken(function(code)
        if code~=0 then 
            if callback then 
                callback(code)
            end
        else
            local session = self:_GetUserSession();
            self.http_request:Request(self.url, "CommitUserRankValue", session.."&RankName="..rank_name.."&Value="..value.."&SubValue="..sub_value.."&RankOrder="..rank_order, 
                function(code, data) 
                    self:_SyncData(data)
                    if callback then 
                        callback(code, data)
                    end
                end)
        end
    end)
end


-- rank_name: 排行名字
-- rank_order: 0表示倒序，1表示正序
function CHttpUser:RequestGetRankInfo(rank_name, rank_order, callback)

    self:_CheckToken(function(code)
        if code~=0 then 
            if callback then 
                callback(code)
            end
        else
            local session = self:_GetUserSession();
            self.http_request:Request(self.url, "GetRankInfo", session.."&RankName="..rank_name.."&RankOrder="..rank_order, 
                function(code, data)                          
                    self:_SyncData(data)
                    if callback then 
                        callback(code, data)
                    end
                end)
        end
    end)
end

function CHttpUser:RequestCommitAchievementComplete(achievement_name, callback)

    if self.achievement_completed[achievement_name] then
        if callback then 
            callback(0)
        end  
        return
    end

    self:_CheckToken(function(code)
        if code~=0 then 
            if callback then 
                callback(code)
            end
        else
            local session = self:_GetUserSession();
            self.http_request:Request(self.url, "CommitAchievementComplete", session.."&AchievementName="..achievement_name,
                function(code, data)  
                    self:_SyncData(data)
                    if callback then 
                        callback(code, data)
                    end
                end)
        end
    end)
end

function CHttpUser:RequestGetAchievementPlayerList(achievement_name, callback)

    self:_CheckToken(function(code)
        if code~=0 then 
            if callback then 
                callback(code)
            end
        else
            local session = self:_GetUserSession();
            self.http_request:Request(self.url, "GetAchievementPlayerList", session.."&AchievementName="..achievement_name,
                function(code, data)  
                    self:_SyncData(data)
                    if callback then 
                        callback(code, data)
                    end
                end)
        end
    end)
end

function CHttpUser:RequestSavePayinfo(pay_fee, platform)

    self:_CheckToken(function(code)
        if code==0 then 
            local session = self:_GetUserSession();
            self.http_request:Request(self.url, "SavePayinfo", session.."&pay_fee="..pay_fee.."&platform="..platform,
                function(code, data)  
                    if callback then 
                        callback(code, data)
                    end
                end)
        end
    end)
end

function CHttpUser:RequestGetFunctionList(platform, callback)

    self:_CheckToken(function(code)
        
        if code==0 then 
            local session = self:_GetUserSession()
            local gps = sJsonUtils:Decode(sDeviceUtils:GetJsonState("GPS"))
            local province = ""
            if gps and gps.province then
                province = sStringUtils:EncodeURL(gps.province)
            end
            local city = ""
            if gps and gps.city then
                city = sStringUtils:EncodeURL(gps.city)
            end
            local version_name = sDeviceUtils:GetVersionName()
            local version_code = sDeviceUtils:GetVersionCode()
            self.http_request:Request(self.url, "GetFunctionListV2", 
                session.."&platform="..platform.."&province="..province.."&city="..city.."&version_name="..version_name.."&version_code="..version_code,
                function(code, data)  
                    self:_SyncData(data)
                    if callback then 
                        callback(code, data)
                    end
                end)
        end
    end)
end

function CHttpUser:RequestCreateOrder(pay_fee, platform, callback)

    print("CHttpUser:RequestCreateOrder", pay_fee, platform)
    self:_CheckToken(function(code)
        if code==0 then 
            local session = self:_GetUserSession();
            self.http_request:Request(self.url, "CreateOrder", session.."&pay_fee="..pay_fee.."&platform="..platform,
                function(code, data)  
                    if callback then 
                        callback(code, data)
                    end
                end)
        end
    end)
end

function CHttpUser:RequestCheckOrder(order_id, callback)

    print("CHttpUser:RequestCheckOrder", order_id)
    self:_CheckToken(function(code)
        if code==0 then 
            local session = self:_GetUserSession();
            self.http_request:Request(self.url, "CheckOrder", session.."&order_id="..order_id,
                function(code, data)  
                    if callback then 
                        callback(code, data)
                    end
                end)
        end
    end)
end

function CHttpUser:PopCommunity()  
     CThirdPlatformUtil:GetInstancePtr():PopCommunity(self.community_url) 
end

-- callback: 回调函数
function CHttpUser:GetFriends(callback)  
    print("CHttpUser:GetFriends")
    self:_CheckToken(function(code)
        if code==0 then 
            local session = self:_GetUserSession();
            self.http_request:Request(self.url, "GetFriends", session,
                function(code, data)  
                    self:_SyncData(data)
                    if callback then 
                        callback(code, data)
                    end
                end)
        end
    end)
end

-- user_id: 用户编号
-- callback: 回调函数
function CHttpUser:AddFriend(user_id, two_way, callback)  
    print("CHttpUser:AddFriend", user_id)
    self:_CheckToken(function(code)
        if code==0 then 
            local session = self:_GetUserSession();
            self.http_request:Request(self.url, "AddFriend", session.."&user_id="..user_id.."&two_way="..tostring(two_way),
                function(code, data)  
                    self:_SyncData(data)
                    if callback then 
                        callback(code, data)
                    end
                end)
        end
    end)
end

-- user_id: 用户编号
-- callback: 回调函数
function CHttpUser:RemoveFriend(user_id, two_way, callback)  
    print("CHttpUser:RemoveFriend", user_id)
    self:_CheckToken(function(code)
        if code==0 then 
            local session = self:_GetUserSession();
            self.http_request:Request(self.url, "RemoveFriend", session.."&user_id="..user_id.."&two_way="..tostring(two_way),
                function(code, data)  
                    if callback then 
                        callback(code, data)
                    end
                end)
        end
    end)
end

-- user_id: 用户编号
-- callback: 回调函数
function CHttpUser:SearchPlayerByID(user_id, callback)  
    print("CHttpUser:SearchPlayerByID", user_id)
    self:_CheckToken(function(code)
        if code==0 then 
            local session = self:_GetUserSession();
            self.http_request:Request(self.url, "SearchPlayerByID", session.."&user_id="..user_id,
                function(code, data)  
                    if callback then 
                        callback(code, data)
                    end
                end)
        end
    end)
end

-- user_name: 用户名称
-- callback: 回调函数
function CHttpUser:SearchPlayersByName(user_name, callback)  
    print("CHttpUser:SearchPlayerByID", user_id)
    self:_CheckToken(function(code)
        if code==0 then 
            local session = self:_GetUserSession();
            self.http_request:Request(self.url, "SearchPlayersByName", session.."&user_name="..user_name,
                function(code, data)  
                    if callback then 
                        callback(code, data)
                    end
                end)
        end
    end)
end

-- longitude: 经度
-- latitude: 纬度
-- callback: 回调函数
function CHttpUser:CommitLocation(longitude, latitude, callback)
    -- print("CHttpUser:CommitLocation", longitude, latitude)
    -- self:_CheckToken(function(code)
        -- if code==0 then 
            -- local session = self:_GetUserSession();
            -- self.http_request:Request(self.url, "CommitLocation", session.."&longitude="..longitude.."&latitude="..latitude,
                -- function(code, data)  
                    -- print("CHttpUser:CommitLocation response", code)
                    -- if callback then 
                        -- callback(code, data)
                    -- end
                -- end)
        -- end
    -- end)
end

-- callback: 回调函数
function CHttpUser:SearchPlayersNearBy(min_distance, max_distance, user_count, callback)
    print("CHttpUser:SearchPlayersNearBy")
    self:_CheckToken(function(code)
        if code==0 then 
            local session = self:_GetUserSession();
            self.http_request:Request(self.url, "SearchPlayersNearBy", session.."&min_distance="..min_distance.."&max_distance="..max_distance.."&user_count="..user_count,
                function(code, data)  
                    self:_SyncData(data)
                    if callback then 
                        callback(code, data)
                    end
                end)
        end
    end)
end

-- last_message_id：当前保存的最后一条消息编号
-- message_count：获取消息数量
-- callback：回调函数
function CHttpUser:GetPlayerMessage(last_message_id, message_count, callback)
    print("CHttpUser:GetPlayerMessage", last_message_id, message_count)
    self:_CheckToken(function(code)
        if code==0 then 
            local session = self:_GetUserSession();
            self.http_request:Request(self.url, "GetPlayerMessage", session.."&last_message_id="..last_message_id.."&message_count="..message_count,
                function(code, data)  
                    self:_SyncData(data)
                    if callback then 
                        callback(code, data)
                    end
                end)
        end
    end)
end

-- message：自定义json字符串
-- callback：回调函数
function CHttpUser:SendPlayerMessage(user_id, message, callback)
    print("CHttpUser:SendPlayerMessage")

    self:_CheckToken(function(code)
        if code==0 then 
            local session = self:_GetUserSession();
            self.http_request:Request(self.url, "SendPlayerMessage", session.."&target_user_id="..user_id,
                function(code, data)  
                    if callback then 
                        callback(code, data)
                    end
                end,
                "data="..message
            )
        end
    end)
end

-- message_count：获取消息数量
-- callback：回调函数
function CHttpUser:GetWorldMessage(last_message_id, message_count, callback)
    print("CHttpUser:GetWorldMessage")
    self:_CheckToken(function(code)
        if code==0 then 
            local session = self:_GetUserSession();
            self.http_request:Request(self.url, "GetWorldMessage", session.."&last_message_id="..last_message_id.."&message_count="..message_count,
                function(code, data)  
                    if callback then 
                        self:_SyncData(data)
                        callback(code, data)
                    end
                end)
        end
    end)
end

-- data：自定义json字符串
-- callback：回调函数
function CHttpUser:SendWorldMessage(data, callback)
    print("CHttpUser:SendWorldMessage")
    self:_CheckToken(function(code)
        if code==0 then 
            local session = self:_GetUserSession();
            self.http_request:Request(self.url, "SendWorldMessage", session,
                function(code, data)  
                    if callback then 
                        callback(code, data)
                    end
                end,
                data
            )
        end
    end)
end

function CHttpUser:_GetDeviceSession()    
    local timestam = sTimeUtils:Now()
    local pwd = dios.util.CCrypto:Md5(self.device_id..timestam.."zhangdongkeji")
    local session = "DeviceID="..self.device_id.."&Password="..pwd.."&Timestam="..timestam.."&GameID="..self.game_id
    session = session.."&Password="..pwd
    return session
end

function CHttpUser:_GetUserSession()  
    
    if self.token==nil then return self:_GetDeviceSession() end
        
    local timestam = sTimeUtils:Now()
    local pwd = dios.util.CCrypto:Md5(self.token..self.seq_id .."zhangdongkeji")
    local session = "DeviceID="..self.device_id.."&Password="..pwd.."&Timestam="..timestam.."&GameID="..self.game_id
    session = session.."&Token="..self.token.."&Seqid="..self.seq_id     
    session = session.."&Password="..pwd
    self.seq_id = self.seq_id + 1 
    return session
end

function CHttpUser:_SyncData(data)    

    if data == nil then
        return
    end

    if data.user_name then                 
        self.user_name = data.user_name
    end 
     
    if data.user_id then                 
        self.user_id = data.user_id
    end  
    if data.user_info then 
        for key, value in pairs(data.user_info) do        
            self.user_info[key] = value
        end
    end

    if data.user_data then 
        for key, value in pairs(data.user_data) do        
           self.user_data[key] = value
        end
    end

    if data.user_rank_info then 
        for _, value in pairs(data.user_rank_info) do        
            self.user_rank_info[value.rank_name] = value
        end
    end

    if data.user_rank_top then 
        for _, value in pairs(data.user_rank_top) do        
            self.user_rank_top[value.rank_name] = value.rank_data
        end
    end

    if data.user_rank_less_me then 
        for _, value in pairs(data.user_rank_less_me) do        
            self.user_rank_less_me[value.rank_name] = value.rank_data
        end
    end

    if data.user_rank_large_me then 
        for _, value in pairs(data.user_rank_large_me) do        
            self.user_rank_large_me[value.rank_name] = value.rank_data
        end
    end

    if data.user_rank_top_with_friend then 
        for _, value in pairs(data.user_rank_top_with_friend) do        
            self.user_rank_top_with_friend[value.rank_name] = value.rank_data
        end
    end

    if data.achievement_statistics then 
        for _, value in pairs(data.achievement_statistics) do        
            self.achievement_statistics[value.achievement_name] = value.total
        end
    end

    if data.achievement_completed then 
        for _, value in pairs(data.achievement_completed) do        
            self.achievement_completed[value] = 1
        end
    end

    if data.function_list then 
        self.function_list = {}
        for _, value in pairs(data.function_list) do        
            self.function_list[tonumber(value.id)] = value.value
        end
    end
    if data.achievement_players then 
        for _, value in pairs(data.achievement_players) do        
            self.achievement_players[value.achievement_name] = value.users
        end
    end

    if data.total_player then                 
        self.total_player = data.total_player
    end

    if data.friends then
        self.friends = {}
        for _, value in pairs(data.friends) do        
            self.friends[value.user_id] = value
        end
    end

    if data.users_nearby then
        self.users_nearby = {}
        for _, value in pairs(data.users_nearby) do        
            self.users_nearby[value.user_id] = value
        end
    end

    if data.player_message then
        self.player_message = {}
        for key, value in pairs(data.player_message) do        
            self.player_message[value.message_id] = value
        end
    end

    if data.world_message then
        self.world_message = {}
        for key, value in pairs(data.world_message) do        
            self.world_message[value.message_id] = value
        end
    end
end

function CHttpUser:_CheckToken(callback)
    if callback==nil then return end

    if self.token~=nil then 
        callback(0)
        return 
    end

    if self.token_requesting ~= true then
        self.token_requesting = true

        self.callback_wait_list = {}
        self:_RequestUserToken(function(code, data) 

            for _,callback in ipairs(self.callback_wait_list) do
                callback(code)
            end
            self.callback_wait_list = {}
            self.token_requesting = false
        end)
    end
    self.callback_wait_list[#self.callback_wait_list+1] = callback
end

return CHttpUser

--endregion

