--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

dxm.CLocationSystem = {}

local CLocationSystem = dxm.CLocationSystem
cc.exports.sLocationSystem = CLocationSystem

local default_cd = 60

function CLocationSystem:Init()

    -- 提交一次本地信息
    self:Upload()

    self.upload_cd = default_cd

    cc.Director:getInstance():getScheduler():scheduleScriptFunc(function(dt) self:Update(dt) end, 1, false)
end

-- callback 回调函数
function CLocationSystem:Upload(callback)

    -- 获取当前的定位信息
    local json_state = sDeviceUtils:GetJsonState("GPS")
    -- json文本转换
    local state = json.decode(json_state)
    if state ~= nil then

        -- 默认为0,0
        state.longitude = state.longitude or 0
        state.latitude = state.latitude or 0

        -- 上传当前自己的位置
        sHttpUser:CommitLocation(state.longitude, state.latitude, callback)
    end
end

function CLocationSystem:Update(dt)

    self.upload_cd = self.upload_cd - dt
    if self.upload_cd < 0 then
        self.upload_cd = default_cd

        self:Upload()
    end
end

return CLocationSystem

--endregion
