-- region *.lua
-- Date
-- 此文件由[BabeLua]插件自动生成

dxm.CMessageDispatcher = { }

local CMessageDispatcher = dxm.CMessageDispatcher
cc.exports.sMessageDispatcher = CMessageDispatcher

CMessageDispatcher.handler_list = { }
CMessageDispatcher.group_list = { }
CMessageDispatcher.message_list = { }
CMessageDispatcher.handler = 0

function CMessageDispatcher:GetInstancePtr()
    return self
end

function CMessageDispatcher:Register(message_type, callback)

    self.handler = self.handler + 1
    self.handler_list[self.handler] = { message_type = message_type, callback = callback }
    if not self.message_list[message_type] then
        self.message_list[message_type] = { }
    end
    self.message_list[message_type][self.handler] = callback
    return self.handler
end

function CMessageDispatcher:RegisterGroup(group, message_type, callback)

    self.handler = self.handler + 1
    if not self.group_list[group] then
        self.group_list[group] = { }
    end
    if not self.message_list[message_type] then
        self.message_list[message_type] = { }
    end
    self.group_list[group][self.handler] = self.handler
    self.handler_list[self.handler] = { message_type = message_type, callback = callback, group = group }
    self.message_list[message_type][self.handler] = callback
    return self.handler
end

function CMessageDispatcher:Remove(handler)
    local info = self.handler_list[handler]
    if info then
        if info.group then
            self.group_list[info.group][handler] = nil
        end
        self.message_list[info.message_type][handler] = nil
    end
end

function CMessageDispatcher:RemoveGroup(group)

    if self.group_list[group] then
        local group_handler_list = { }
        for k, handler in pairs(self.group_list[group]) do
            group_handler_list[#group_handler_list + 1] = handler
        end

        for _, handler in pairs(group_handler_list) do
            self:Remove(handler)
        end
    end
end

function CMessageDispatcher:Dispatch(message_type, ...)
    
    local message_callback_list = self.message_list[message_type]
    if message_callback_list then
        for _, callback in pairs(message_callback_list) do
            if callback then callback(...) end
        end
    end

end

return CMessageDispatcher

-- endregion
