--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

dxm.CPaySystem = {}

local CPaySystem = dxm.CPaySystem
cc.exports.sPaySystem = CPaySystem

function CPaySystem:Pay(money, pay_type, pay_desc, callback, pay_with_order)

    -- 获取支付平台
    local platform = sThirdPlatformUtils:GetState("platform")
    print("CHttpUser:Pay", money, pay_type, pay_desc, platform)

    -- 服务器支付验证
    if pay_with_order==true then
        pay_with_order = true
    else
        pay_with_order = false
    end

    local pay_callback = function(is_ok, pay_type, order_id)    
        -- 成功日志
        order_id = order_id or ""
        if is_ok then
            sThirdPlatformUtils:LogEvent("pay_success", '{"order_id":"'..order_id..'"}') 
        end
        if callback then callback(is_ok, pay_trype) end
    end

    -- 判断当前支付是否支持订单验证
    if sThirdPlatformUtils:HasPayWithOrderID() then
    
        local dummy_order_id = nil
        self.dummy_order_pay_info = self.dummy_order_pay_info or {}
        if not pay_with_order then
            -- 调用第三方的接口
            dummy_order_id = ""..os.time()
            local string_count = #dummy_order_id
            for i=string_count+1, 16 do 
                dummy_order_id = dummy_order_id..math.random(1, 9)
            end
            self.dummy_order_pay_info[dummy_order_id] = self.dummy_order_pay_info[dummy_order_id] or {}
            self.dummy_order_pay_info[dummy_order_id].http_order_id = nil
            self.dummy_order_pay_info[dummy_order_id].pay_result = nil

            sThirdPlatformUtils:LogEvent("pay_request", '{"money":'..money..',"type":"'..pay_type..'","desc":"'..pay_desc..'","order_id":"'..dummy_order_id..'"}') 
        end

        -- 请求订单号
        sHttpUser:RequestCreateOrder(money, platform, function(code, data) 

            if code ~= 0 then
                if pay_with_order then
                    pay_callback(false)
                end
                if self.dummy_order_pay_info[dummy_order_id] then
                    self.dummy_order_pay_info[dummy_order_id] = nil
                end
            else
                -- 支付请求
                if pay_with_order then
                    sThirdPlatformUtils:LogEvent("pay_request", '{"money":'..money..',"type":"'..pay_type..'","desc":"'..pay_desc..'","order_id":"'..data.order_id..'"}') 
                    -- 调用第三方的接口
                    sThirdPlatformUtils:PayWithOrderID(money, pay_type, pay_desc, data.order_id, function(is_ok, pay_type) 
                        pay_type = pay_type or ""
                        if is_ok == false then
                            pay_callback(false, pay_type)
                        else
                            -- 请求验证订单号
                            self:RetryRequestCheckOrder(data.order_id, 0, pay_callback, pay_type)
                        end
                    end)
                else
                    -- 纯粹验证订单                    
                    if self.dummy_order_pay_info[dummy_order_id] then 
                        self.dummy_order_pay_info[dummy_order_id].http_order_id = data.order_id
                        if self.dummy_order_pay_info[dummy_order_id].pay_result ~= nil then
                            if self.dummy_order_pay_info[dummy_order_id].pay_result == true then          
                                self:RetryRequestCheckOrder(self.dummy_order_pay_info[dummy_order_id].http_order_id, 0)
                                self.dummy_order_pay_info[dummy_order_id] = nil      
                            end                     
                        end
                    end
                end
            end
        end)

        -- 不需要验证直接给予支付反馈, 但是还是会往服务器发送订单请求与验证的.
        if not pay_with_order then
            -- 调用第三方的接口
            sThirdPlatformUtils:PayWithOrderID(money, pay_type, pay_desc, dummy_order_id, function(is_ok, pay_type) 

                pay_type = pay_type or ""
                pay_callback(is_ok, pay_type, dummy_order_id)
                -- 纯粹验证订单
                if self.dummy_order_pay_info[dummy_order_id] then 
                    self.dummy_order_pay_info[dummy_order_id].pay_result = is_ok
                    if self.dummy_order_pay_info[dummy_order_id].http_order_id ~= nil then
                        if self.dummy_order_pay_info[dummy_order_id].pay_result == true then
                            self:RetryRequestCheckOrder(self.dummy_order_pay_info[dummy_order_id].http_order_id, 0)
                            self.dummy_order_pay_info[dummy_order_id] = nil   
                        end                        
                    end
                end
            end)
        end
    else

        -- 调用第三方的接口
        sThirdPlatformUtils:Pay(money, pay_type, pay_desc, function(is_ok, pay_type) 
            pay_callback(is_ok, pay_type, "")
        end)
    end
end

function CPaySystem:RetryRequestCheckOrder(order_id, try_count, callback, pay_type)

    sHttpUser:RequestCheckOrder(order_id, function(code, data) 

        local is_successful = false
        if code == 0 then

            -- MD5验证该结果
            if c.Crypto:MD5(sHttpUser.game_id..order_id) == data.sign then
                is_successful = true
            end
        else

            -- 增加判断次数并确认是否要重试
            try_count = try_count + 1
            if try_count < 5 then
                self:RetryRequestCheckOrder(order_id, try_count, callback)
                return
            end
        end

        print("CPaySystem:RetryRequestCheckOrder", is_successful)

        if callback ~= nil then
            callback(is_successful, pay_type, order_id)
        end
    end)
end

return CPaySystem

--endregion
