--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game.CProfileSystem = {}

cc.exports.sProfileSystem = game.CProfileSystem
local CProfileSystem = game.CProfileSystem

-- 构造;
function CProfileSystem:Init()

    self.data_map = {}
    self.timer_map = {}
    self.timer_cache = dxm.CList.new() 
end

-- 获取值;
function CProfileSystem:Get(profile_name)

    return self.data_map[profile_name] or nil
end

function CProfileSystem:Reset()

    for _, timer in pairs(self.timer_map) do

        self.timer_cache:PushBack(timer)
    end

    self.data_map = {}
    self.timer_map = {}
end

-- 
function CProfileSystem:AddSampling(profile_name, value, ratio)

    local data = self.data_map[profile_name]
    if not data then
        data = {}
        data.times = 0
        data.fmin = 0
        data.fmax = 0
        data.favg = 0
        data.fcur_max = 0
        self.data_map[profile_name] = data
    end

    data.times = data.times + 1

    local new_ratio = ratio or 0.01
    local old_ratio = 1 - new_ratio
	if data.avg == 0 then
		data.favg = value
		data.fmin = value
		data.fmax = value
        data.fcur_max = value
	else
		data.favg = data.favg*old_ratio + value*new_ratio
        if value <= data.fmin then
            data.fmin = value
        else
            data.fmin = data.fmin*old_ratio + value*new_ratio
        end

        if value >= data.fmax then
            data.fmax = value
        else
            data.fmax = data.fmax*old_ratio + value*new_ratio
        end

        if value > data.fcur_max then
            data.fcur_max = value
        end
	end
end

function CProfileSystem:StartSampling(profile_name)

    local timer = self.timer_map[profile_name]
    if not timer then
        timer = self.timer_cache:PopFront()
        if not timer then
            timer = dios.util.CElapsedTimer:new_local()
        end
        self.timer_map[profile_name] = timer
    end
    timer:Reset()
end


function CProfileSystem:StopSampling(profile_name)
    local timer = self.timer_map[profile_name]
    if not timer then  
        return
    end

    local value = timer:GetElapsed()
    self:AddSampling(profile_name, value*10000, value/10)
    self.timer_map[profile_name] = nil
    self.timer_cache:PushBack(timer)
end

function CProfileSystem:GetString()

    local str = ""
    local count = 0
    if self.data_map then
        for key, data in pairs(self.data_map) do

            if count>0 then
                str = str.."\n"
            end
            str = str..key..":"
            str = str.."("
            str = str..math.ceil(data.fcur_max)..","
            str = str..math.ceil(data.favg)..","
            str = str..math.ceil(data.fmin)..","
            str = str..math.ceil(data.fmax)..")"

            data.fcur_max = 0
            count = count + 1
        end 
    end
    return str
end

return CProfileSystem

--endregion
