--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

dxm.CQRCodeSystem = {}

local CQRCodeSystem = dxm.CQRCodeSystem
cc.exports.sQRCodeSystem = CQRCodeSystem

function CQRCodeSystem:Init()

    self.http_request = dxm.CHttpRequest.new()
    self.request_url = assets.config.http_url.."/sdk/qrcode/"

    sDatabase.data.qr_code_system.qr_code_file_url = sDatabase.data.qr_code_system.qr_code_file_url or nil
end

function CQRCodeSystem:GetQRCodeFile(callback)

    self:RequestQRCodeFileURL(function(url) 

        if url ~= nil then
            sDatabase.data.qr_code_system.qr_code_file_url = url

            self:DownloadQRCodeFile(callback)
        else
            if callback then
                callback(nil)
            end
        end
    end)
end

function CQRCodeSystem:RequestQRCodeFileURL(callback)

    print("CQRCodeSystem:RequestQRCodeFileURL", sHttpUser.user_id, sHttpUser.game_id)

    -- 判断角色的基本数据是否已得到
    if sHttpUser.user_id == nil or sHttpUser.game_id == nil then

        if callback ~= nil then
            callback(nil)
        end
        return
    end 

    -- 请求获取下载链接
    self.http_request:Request(self.request_url, "GetQRCode", "user_id=" .. sHttpUser.user_id .. "&game_id=" .. sHttpUser.game_id,
    function(code, data)

        -- 尝试获取下载链接
        local url = nil
        if code == 0 then
            url = data.url
        end

        -- 执行回调函数
        if callback then
            callback(url)
        end
    end )
end

function CQRCodeSystem:DownloadQRCodeFile(callback)
    print("CQRCodeSystem:DownloadQRCodeFile", sDatabase.data.qr_code_system.qr_code_file_url)

    sDownloadSystem:GetURLFile(sDatabase.data.qr_code_system.qr_code_file_url, "QRCode", callback)
end

return CQRCodeSystem

--endregion
