--region *.lua
--Date
--此文件由[BabeLua]插件自动生成


-- 定时系统, 每日, 每周;

game.CSchedulerSystem = {}

cc.exports.sSchedulerSystem = game.CSchedulerSystem

local CSchedulerSystem = game.CSchedulerSystem

function CSchedulerSystem:Init()

    self.secondly = dxm.CEvent.new()
    self.update_event = dxm.CEvent.new()
    self.late_update_event = dxm.CEvent.new()

    self.time_scheduler = dxm.CTimeScheduler.new()
    self.time_scheduler:AddUpdate(1, os.time(), function(times)
            self.secondly:Fire()
        end)

    cc.Director:getInstance():getScheduler():scheduleScriptFunc(function(dt)
        --sProfileSystem:StartSampling("CSchedulerSystem:Update")
		self.update_event:Fire(dt)
        self.late_update_event:Fire(dt)
        --sProfileSystem:StopSampling("CSchedulerSystem:Update")
	end, 0, false)

    -- 每秒更新;
    self:AddUpdate(1, function(dt) 
        self.time_scheduler:Update(dt)
    end)
end

-- 添加每秒事件;
function CSchedulerSystem:AddSecondly(callback)
    -- 该函数每秒检测一次;
    if callback then
        return self.secondly:Connect(function()
            if callback then callback() end
        end)   
    end
    return nil
end

-- 添加每次更新事件;
function CSchedulerSystem:AddUpdate(frequency, callback)

    if callback then
        local frequency_dt = 0
        return self.update_event:Connect(function(dt)
            frequency_dt = frequency_dt + dt
            if frequency_dt>frequency then
                if callback then callback(frequency_dt) end
                frequency_dt = 0
            end
        end)   
    end
    return nil
end

-- 添加每次更新事件;
function CSchedulerSystem:AddLateUpdate(frequency, callback)

    if callback then
        local frequency_dt = 0
        return self.late_update_event:Connect(function(dt)
            frequency_dt = frequency_dt + dt
            if frequency_dt>frequency then
                if callback then callback(frequency_dt) end
                frequency_dt = 0
            end
        end)   
    end
    return nil
end

return CSchedulerSystem

--endregion
