-- region *.lua
-- Date
-- 此文件由[BabeLua]插件自动生成


-- CDialogUI 是初期设计留下来的类。
-- 在想他留下来的必要的问题的时候想到一个界面我就留下了他, 对话框界面, 游戏提示确认框与系统提示确认框基本一致，这里需要保存两份界面么。
-- 出于我的程序员懒，觉得没有必要存在两个界面吧，于是乎手软留下了 CDialogUI 。 


dxm.CDialogUI = class("dxm.CDialogUI", dxm.CBaseUI)
local CDialogUI = dxm.CDialogUI

function CDialogUI:ctor(void)
    CDialogUI.super.ctor(self)

    self.close_event = dxm.CEvent.new()
    self.dont_play_action = false
    self.closing = false
end

function CDialogUI:Init()
    return true
end

function CDialogUI:Create()
    local ui = CDialogUI.new()
    if ui == nil or ui:Init() == false then
        return nil
    end
    return ui
end

function CDialogUI:Open(play_action)
    dxm.CUIManager:GetInstancePtr():OpenGameDialog(self)

    if play_action then
       -- self:_DoAction()
    end
end

function CDialogUI:OpenByGame(play_action)
    dxm.CUIManager:GetInstancePtr():OpenGameDialog(self)
    if play_action then
       -- self:_DoAction()
    end
end

function CDialogUI:OpenBySystem(play_action)
    dxm.CUIManager:GetInstancePtr():OpenSystemDialog(self)
    if play_action then
       -- self:_DoAction()
    end
end

function CDialogUI:Close()

    if self.closing == true then 
        return
    end
    self.closing = true
    if self.dont_play_action then
        dxm.CUIManager:GetInstancePtr():CloseUI(self)
        self.closing = false
    else
        self:LockTouch()
        self:PlayAnimation("CloseAnimation", function(ok)  
            if ok then
                self:UnlockTouch()
                self:RemoveFromParent()
                self.closing = false
            else
                -- self:_CloseAction(self.widget, function() 
                --     sUI:UnlockTouch()
                --     self:RemoveFromParent()
                --     self.closing = false
                -- end)
                self:UnlockTouch()
                self:RemoveFromParent()
                self.closing = false
            end
        end)
    end
    self.close_event:Fire()
end

function CDialogUI:_CloseAction(node, end_callback)

    if not node then
        return
    end

    node:stopAllActions()

    local actions = {}
    actions[#actions + 1] = cc.EaseOut:create(cc.MoveBy:create(0.1, cc.p(0, -100)), 2)
    actions[#actions + 1] = cc.Spawn:create(cc.EaseIn:create(cc.MoveBy:create(0.3, cc.p(0, 1160)), 2))

    if begin_callback then begin_callback() end
    
    actions[#actions + 1] = cc.CallFunc:create( function()
        if end_callback then end_callback() end
    end )

    local action = cc.Sequence:create(actions)
    node:runAction(action)
end


return CDialogUI
-- endregion
