--region NewFile_1.lua
--Author : IBM
--Date   : 2015/4/27
--此文件由[BabeLua]插件自动生成


dxm = dxm or {}
dxm.CLayerUI = class("CLayerUI", dxm.CBaseUI)

local CLayerUI = dxm.CLayerUI

-- 自定义回调
CLayerUI.quit_callback = nil

dxm.UIOrder = {
	kUIOrderBackground = 1,
	kUIOrderStack = 2,
	kUIOrderShortcut = 3,
	kUIOrderGameDialog = 4,
	kUIOrderGuide = 5,
	kUIOrderNotice = 6,
    kUIOrderTip = 7,
	kUIOrderSystemDialog = 8,
	kUIOrderTopMask = 9,
	kUIOrderMax = 10,
};

function CLayerUI:ctor()
    CLayerUI.super.ctor(self)

    self._shortcut_ui_opened_list = self._shortcut_ui_opened_list or {}
    self._notice_ui_opened_list = self._notice_ui_opened_list or {}
    self._game_dialog_ui_opened_list = self._game_dialog_ui_opened_list or {}
    self._system_dialog_ui_opened_list = self._system_dialog_ui_opened_list or {}
    self._tip_ui_opened_list = self._tip_ui_opened_list or {}
end

function CLayerUI:Dispose()
    self:_ClearUI()

    if self.layer ~= nil then
        self.layer:release()
    end
end

function CLayerUI:Init()
    if CLayerUI.super.Init(self) == false then
        return false
    end
    self.layer = display.newLayer()
    if self.layer ~= nil then
        self.layer:retain()
        self.layer:addChild(self.widget)

        -- 监听返回键
        local key_listener = cc.EventListenerKeyboard:create()
        local function key_return(keycode)
            if keycode ~= cc.KeyCode.KEY_ESCAPE and keycode ~= cc.KeyCode.KEY_MENU then
				return
            end
			
			if CLayerUI.quit_callback == nil then
                CThirdPlatformUtil:GetInstancePtr():Quit(function(is_ok) cc.Director:getInstance():endToLua() end)
            else
                CLayerUI.quit_callback()
            end
        end
        key_listener:registerScriptHandler(key_return, cc.Handler.EVENT_KEYBOARD_PRESSED)
        self.layer:getEventDispatcher():addEventListenerWithSceneGraphPriority(key_listener, self.layer)
    end
    return true
end

-- 成员函数
function CLayerUI:Create()
    local layer_ui = CLayerUI.new()
    layer_ui:Init()
    return layer_ui
end

function CLayerUI:AttachParent(parent)

    dxm.CUIManager:GetInstancePtr():InitLayerUI(self)

    parent:addChild(self.layer)
	self:_Enter()

    self._top_touch_mask_ui = dxm.CTopTouchMaskUI:Create(0)
    if not self.default_stack_ui then self.default_stack_ui = dxm.CStackUI:Create() end    

    -- 恢复背景;
    self:OpenUI(self._background, dxm.UIOrder.kUIOrderBackground, true)
   
    for _, ui in pairs(self._game_dialog_ui_opened_list) do
        self:OpenUI(ui, dxm.UIOrder.kUIOrderGameDialog)
    end  
    for _, ui in pairs(self._system_dialog_ui_opened_list) do
        self:OpenUI(ui, dxm.UIOrder.kUIOrderSystemDialog)
    end

    -- 打开栈界面;
    self:_OpenStackUI()
end

function CLayerUI:DetachParent()

    self:_Exit()
    self.layer:removeFromParent()

    self._shortcut_ui_opened_list = {}
    self._notice_ui_opened_list = {}
    self._tip_ui_opened_list = {}
end

-- 打开关闭界面
function CLayerUI:OpenUI(ui, ui_order, play_open_animation)

    if not ui then return end

    if play_open_animation == nil then
        ui.play_open_animation = true
    else
        ui.play_open_animation = play_open_animation
    end
    self:AddChild(ui, ui_order)
end

function CLayerUI:CloseUI(ui, callback)

    if not ui then 
        if callback then callback(false) end
        return 
    end

    if callback then
        ui:LockTouch()
        ui:PlayAnimation("CloseAnimation", function(ok)  
            ui:UnlockTouch()
            ui:RemoveFromParent()
            callback(ok)
        end)
    else
        ui:RemoveFromParent()
    end
end

-- 替换背景UI
function CLayerUI:OpenBackgroundUI(ui)

    self:CloseUI(self._background)
    self._background = ui
    self:OpenUI(self._background, dxm.UIOrder.kUIOrderBackground, true)
end

-- 堆栈界面
function CLayerUI:OpenStackUIWithReplaceTop(ui)

    if ui == nil then
        return nil
    end

    local old_stack_top_ui = self._stack_top_ui
    if old_stack_top_ui then 
        ui._pre_stack_ui = old_stack_top_ui._pre_stack_ui
        old_stack_top_ui._pre_stack_ui = nil
    else
        ui._pre_stack_ui = nil
    end

    self._stack_top_ui = ui
    self:_OpenStackUI(old_stack_top_ui)
end

function CLayerUI:OpenStackUIWithPushTop(ui)

    if ui == nil then
        return nil
    end
            
    local old_stack_top_ui = self._stack_top_ui
    ui._pre_stack_ui = old_stack_top_ui
    self._stack_top_ui = ui
    self:_OpenStackUI(old_stack_top_ui)
end

function CLayerUI:OpenStackUIWithPopTop()

    local old_stack_top_ui = nil
    if self._stack_top_ui then
        old_stack_top_ui = self._stack_top_ui
        self._stack_top_ui = old_stack_top_ui._pre_stack_ui
        old_stack_top_ui._pre_stack_ui = nil
    end    
    
    self:_OpenStackUI(old_stack_top_ui)
end

function CLayerUI:OpenStackUIWithClear(ui)

    local old_stack_top_ui =  self._stack_top_ui
    local pop_stack_top_ui = old_stack_top_ui
    while pop_stack_top_ui ~= nil do
        self._stack_top_ui = pop_stack_top_ui._pre_stack_ui
        pop_stack_top_ui._pre_stack_ui = nil
        pop_stack_top_ui = self._stack_top_ui
    end
    self._stack_top_ui = ui
    self:_OpenStackUI(old_stack_top_ui)
end

function CLayerUI:SetDefaultStackUI(ui)
    self.default_stack_ui = ui
end

function CLayerUI:_OpenStackUI(old_top_ui)

    if old_top_ui and old_top_ui.dialog_list then
        for k, v in ipairs(old_top_ui.dialog_list) do
            v:Close()
        end
    end

    self:CloseUI(old_top_ui, function()    

        if self._stack_top_ui == nil then
            self._stack_top_ui = self.default_stack_ui
        end

        self:CloseAllShotcut()
        self:CloseAllNotice()

	    local stack_ui = self._stack_top_ui
        self:OpenUI(stack_ui, dxm.UIOrder.kUIOrderStack, true)
        if stack_ui ~= nil and stack_ui.dialog_list ~= nil then
            for k, v in ipairs(stack_ui.dialog_list) do
                v.play_open_animation = false
                self:OpenGameDialog(v)
            end
        end    
    end)
end

-- 打开置顶触摸界面
function CLayerUI:LockTouch()

    self._top_touch_mask_ui = self._top_touch_mask_ui or dxm.CTopTouchMaskUI:Create(0)
    self._top_touch_mask_ui:Open(dxm.UIOrder.kUIOrderTopMask) 
end

function CLayerUI:UnlockTouch()

    if self._top_touch_mask_ui then
        self._top_touch_mask_ui:Close()
        if self._top_touch_mask_ui:GetOpenRef() == 0 then self._top_touch_mask_ui = nil end
    end
end

-- 打开对话框
function CLayerUI:OpenGameDialog(ui)

    if not ui or ui.is_entered then return end
    
    local top_touch_mask_ui = dxm.CTopTouchMaskUI:Create(80)
    top_touch_mask_ui:Open(dxm.UIOrder.kUIOrderGameDialog)
    top_touch_mask_ui:AddChild(ui)

    -- 退出监听;
    local exit_listener
    exit_listener = ui.event_exit:Connect(
    function()
        top_touch_mask_ui:Close()
        exit_listener:Disconnect()
    end
    )

    -- 关闭监听;
    if not ui.close_listener then
        local stack_ui = self._stack_top_ui
        if stack_ui then
            stack_ui.dialog_list = stack_ui.dialog_list or { }
            table.insert(stack_ui.dialog_list, ui)
        else
            self._game_dialog_ui_opened_list[ui] = ui
        end

        ui.close_listener = ui.close_event:Connect(
        function()
            if stack_ui and stack_ui.dialog_list then
                for k, v in ipairs(stack_ui.dialog_list) do
                    if v == ui then
                        table.remove(stack_ui.dialog_list, k)
                        break
                    end
                end
            else
                self._game_dialog_ui_opened_list[ui] = nil
            end
            ui.close_listener:Disconnect()
        end
        )
    end
end

function CLayerUI:CloseAllGameDialog()
    local close_ui_list = {}

    local stack_ui = self._stack_top_ui
    if stack_ui then
        for _, ui in pairs(stack_ui.dialog_list) do
            close_ui_list[#close_ui_list+1] = ui
        end
    else
        for _, ui in pairs(self._game_dialog_ui_opened_list) do
            close_ui_list[#close_ui_list+1] = ui
        end
    end

    for _, ui in pairs(close_ui_list) do
        ui:Close()
    end
end

function CLayerUI:OpenSystemDialog(ui)

    if not ui or ui.is_entered then return end

    local top_touch_mask_ui = dxm.CTopTouchMaskUI:Create(80)
    top_touch_mask_ui:Open(dxm.UIOrder.kUIOrderSystemDialog)

    top_touch_mask_ui:AddChild(ui)

    self._system_dialog_ui_opened_list[ui] = ui
    
    local exit_listener
    exit_listener = ui.event_exit:Connect(
        function()
            self._system_dialog_ui_opened_list[ui] = nil
            top_touch_mask_ui:Close()
            exit_listener:Disconnect()
        end
    )
end

-- 打开快捷栏
function CLayerUI:OpenShortcut(ui)

    if not ui then  return end

    local open_animation = true
    local temp_ui = self._shortcut_ui_opened_list[ui.cname]
    if temp_ui then
        open_animation = false
    else
        self._shortcut_ui_opened_list[ui.cname] = ui
        temp_ui = ui
    end

    if not temp_ui.is_entered then 
        self:OpenUI(temp_ui, dxm.UIOrder.kUIOrderShortcut, open_animation, true)         
    end
    temp_ui.widget:setVisible(true) 
end

function CLayerUI:CloseShortcut(ui_class)

    local ui = self._shortcut_ui_opened_list[ui_class.cname]
    if ui and ui.is_entered then 
        -- self:CloseUI(ui)
        ui.widget:setVisible(false)
        -- 延迟一帧清理, 如果再次被打开则不清理;
        local entry        
	    entry = cc.Director:getInstance():getScheduler():scheduleScriptFunc(function()
		    cc.Director:getInstance():getScheduler():unscheduleScriptEntry(entry)
            local ui = self._shortcut_ui_opened_list[ui_class.cname]
            if not ui.widget:isVisible() then
		        self._shortcut_ui_opened_list[ui.cname] = nil
                ui.widget:setVisible(true) 
                self:CloseUI(ui)
            end
	    end, 0, false)
    end
end

function CLayerUI:GetShortcut(ui_class)
    return self._shortcut_ui_opened_list[ui_class.cname]
end

function CLayerUI:CloseAllShotcut()
    for k, ui in pairs(self._shortcut_ui_opened_list) do
        self:CloseShortcut(ui)
    end
end

-- 打开通知快捷栏
function CLayerUI:OpenNotice(ui)

    if not ui then  return end

    local open_animation = true
    local temp_ui = self._notice_ui_opened_list[ui.cname]
    if temp_ui then
        open_animation = false
    else
        self._notice_ui_opened_list[ui.cname] = ui
        temp_ui = ui
    end

    if not ui.is_entered then 
        self:OpenUI(ui, dxm.UIOrder.kUIOrderNotice, open_animation, true)         
    end
    temp_ui.widget:setVisible(true) 
end

function CLayerUI:CloseNotice(ui_class)

    local ui = self._notice_ui_opened_list[ui_class.cname]
    if ui and ui.is_entered then 
        -- self:CloseUI(ui)
        ui.widget:setVisible(false) 
        -- 延迟一帧清理, 如果再次被打开则不清理;
        local entry        
	    entry = cc.Director:getInstance():getScheduler():scheduleScriptFunc(function()
		    cc.Director:getInstance():getScheduler():unscheduleScriptEntry(entry)
            local ui = self._notice_ui_opened_list[ui_class.cname]
            if not ui.widget:isVisible() then
		        self._notice_ui_opened_list[ui.cname] = nil
                ui.widget:setVisible(true) 
                self:CloseUI(ui)
            end
	    end, 0, false)
    end
end

function CLayerUI:CloseAllNotice()
    
    for k, ui in pairs(self._notice_ui_opened_list) do
        self:CloseNotice(ui)
    end
end

-- guide 
function CLayerUI:OpenGuide(ui)
    self:OpenUI(ui, dxm.UIOrder.kUIOrderGuide, true)
end

-- tip
function CLayerUI:OpenTip(ui)
    if not ui or ui.is_entered then return end

    self:OpenUI(ui, dxm.UIOrder.kUIOrderTip)
    self._tip_ui_opened_list[ui] = ui

    local exit_listener
    exit_listener = ui.event_exit:Connect(
        function()
            self._tip_ui_opened_list[ui] = nil
            exit_listener:Disconnect()
        end
    )
end

function CLayerUI:CloseTip(ui)
    local ui = self._tip_ui_opened_list[ui]
    if ui and ui.is_entered then 
        self:CloseUI(ui)
        self._tip_ui_opened_list[ui] = nil
    end
end

function CLayerUI:CloseAllTip()
    for k, ui in pairs(self._tip_ui_opened_list) do
        self:CloseTip(ui)
    end
end

-----------------

return CLayerUI

--endregion
