--region *.lua
--Date
--此文件由[BabeLua]插件自动生成
require("dxm.ui.prefab.card_ui")

dxm = dxm or {}

local CCardSelector = class("CCardSelector")

function CCardSelector:ctor()
    self.card_list = {}
    self.current_select_index = 1
    self.max_index = #self.card_list
    self.min_index = 10000000000
end

function CCardSelector:AddCard(card)
    self.max_index = self.max_index + 1
    self.card_list[self.max_index] = card
end

function CCardSelector:GetCurrentSelectIndex()
   return self.current_select_index 
end

function CCardSelector:SetCurrentSelectIndex(index)
    if index<= self:GetMaxIndex() and index>=self:GetMinIndex() then
		self.current_select_index = index
		return true;
	end
	return false;
end

function CCardSelector:GetMinIndex()
    if self.min_index == 10000000000 then
        for k , v in pairs(self.card_list) do
            if k < self.min_index then
                self.min_index = k
            end
        end
    end

    return self.min_index
end

function CCardSelector:GetMaxIndex()
    if self.max_index == 0 then
        for k ,v in pairs(self.card_list) do
            if k > self.max_index then
                self.max_index = k
            end
        end
    end

    return self.max_index
end

function CCardSelector:GetCard(index)
    return self.card_list[index]
end

function CCardSelector:RemoveCards()
    for k ,v in pairs(self.card_list) do
        v:SetShow(false)
    end

    self.card_list = {}
    self.curret_select_index = 1
    self.min_index = 10000000000
    self.max_index = 0
end



dxm.CCardSelectorUI = class("dxm.CCardSelectorUI",dxm.CBaseUI)

local CCardSelectorUI = dxm.CCardSelectorUI

function CCardSelectorUI:ctor()
    CCardSelectorUI.super.ctor(self)
   
    self.card_selector = CCardSelector.new()

    self.rotation_angel_max = nil
    self.manual_set_card_interval_x = nil
    self.manual_set_center_card_x = nil
    self.current_x = nil
    self.card_width = nil
    self.card_height = nil
    self.card_interval_x = nil
    self.center_card_x = nil
    self.center_card_y = nil
    self.current_select_index = nil
    self.adjust_select_index = nil
    self.old_show_select_index = nil

    --关于点击
    self.touch_move_start_pos = nil
    self.touch_move_began_pos = nil
    self.touch_end_pos = nil

    self.touched = nil
    self.auto_scroll = nil
    self.current_auto_scroll_speed = nil
    self.auto_scroll_acceleration = nil
    self.auto_scroll_speed_max = nil
    self.manual_scroll = nil
    self.manual_scroll_left = nil
    self.touch_action_time = nil
    self.adjust_move_speed = nil

    --底部后百分比
    self.border_radio_x = nil

    self.side_card_number = nil
    self.touch_moved = nil

    --由中心往两边缩放值
    self.scale_inverval_step_1 = nil
    self.opacity_inverval_step_1 = nil

    --边缘到消失的缩放值
    self.scale_interval_step_2 = nil
    self.opacity_inverval_step_2 = nil

    --是否循环
    self.loop = nil
    
    --是否旋转
    self.is_rotation = nil

    --代理触摸节点
    self.touch_delegate_widget = nil

    self.current_select_index = 1
    self.adjust_select_index = 1
    self.manual_scroll_left = false
    self.auto_scroll = false
    self.current_scroll_speed = 0.0
    self.manual_scroll = false
    self.touch_action_time = 0.0
    self.current_x = 0.0
    self.auto_scroll_acceleration = 0.0
    self.card_interval_x = 0.0
    self.manual_set_card_interval_x = false
    self.manual_set_center_card_x = false
    self.touched = false
    self.center_card_x = 0.0
    self.center_card_y = 0.0
    self.side_card_number = 1
    self.touch_moved = false
    self.scale_inverval_step_1 = 0.1
    self.scale_interval_step_2 = 0.1
    self.opacity_inverval_step_1 = 127
    self.opacity_inverval_step_2 = 128
    self.old_show_select_index = -1
    self.loop = false    
end


function CCardSelectorUI:Init(widget,card_width,card_height)
    if widget == nil or card_width == nil or card_height == nil then
        return false
    end
    
    self:InitWithWidget(widget)

	self.side_card_number = 1
	self.border_radio_x = 0.5
    self.adjust_move_speed = 600.0
	self.rotation_angel_max = 60
	self.card_width = card_width
	self.card_height = card_height	

	self.card_interval_x  = (self.widget:getContentSize().width/2 - self.card_width/2)/(self.side_card_number);
	self.center_card_x = self.widget:getContentSize().width/2 - self.card_width/2;
	self.auto_scroll_speed_max = self.card_width*10;
	self.auto_scroll_acceleration = self.auto_scroll_speed_max;

	self:SetTouchEnabled(true);

    return true
end

function CCardSelectorUI:Create(widget,card_width,card_height)
    local ui = CCardSelectorUI.new()

    if ui and ui:Init(widget,card_width,card_height) then
        return ui
    end
    
    return nil
end

function CCardSelectorUI:AddCard(base_ui)
    local card = dxm.CCardUI:Create(base_ui)
    if card then
        self.card_selector:AddCard(card)
    end
end

function CCardSelectorUI:RemoveCards()
    for i = self.card_selector:GetMinIndex() , self.card_selector:GetMaxIndex() do
        local card = self.card_selector:GetCard(i)
        if card then
            self:RemoveChild(card)
        end
    end

    self.card_selector:RemoveCards()
end

function CCardSelectorUI:onEnter()
    self.widget:addTouchEventListener(function(...) self:TouchEventCallback(...) end)
    self.update_handler = cc.Director:getInstance():getScheduler():scheduleScriptFunc(function(dt) self:Update(dt) end, 0, false)
end

function CCardSelectorUI:onExit()
    cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.update_handler)
end

function CCardSelectorUI:GetCard(index)
    return self.card_selector:GetCard(index)
end

function CCardSelectorUI:GetCurrentIndex()
    return self.card_selector:GetCurrentSelectIndex()
end

function CCardSelectorUI:Update(dt)
    self:_AutoScroll(dt)
    self:_RecordTouchActionTime(dt)
end

function CCardSelectorUI:TouchEventCallback(_,event_type)
--    if not self.touched then
--        return
--    end
    if event_type == ccui.TouchEventType.began then
        local x,y = self.widget:getTouchBeganPosition()
        self:_TouchesBegan(cc.p(x,y))
    elseif event_type == ccui.TouchEventType.moved then
        local x, y =self.widget:getTouchMovePosition()
        self:_TouchesMoved(cc.p(x,y))
    elseif event_type == ccui.TouchEventType.ended then
        local x,y = self.widget:getTouchEndPosition()
        self:_TouchesEnded(cc.p(x,y))
    elseif event_type == ccui.TouchEventType.canceled then
        local x, y =self.widget:getTouchMovePosition()
        self:_TouchesCancelled(cc.p(x,y))
    end
end

function CCardSelectorUI:_TouchesBegan(touch_location)
    if not self.touch_enabled then
        return
    end 
    self.touch_moved = false
    self.touched = true
    self.touch_move_start_pos = touch_location
    self.touch_began_pos = touch_location
    self:_StartRecordTouchAction()
end


CCardSelectorUI.TOUCH_DELTA = 5;  
function CCardSelectorUI:_TouchesMoved(touch_location)
    if not self.touch_enabled then
		return
	end

	if not self.touched then
		return
	end
	
    local offset = (touch_location.x - self.touch_move_start_pos.x)* (touch_location.x - self.touch_move_start_pos.x)
		+ ( touch_location.y - self.touch_move_start_pos.y)* (touch_location.y -self.touch_move_start_pos.y);

	--距离小于5个像素表示点击;
	if(offset<CCardSelectorUI.TOUCH_DELTA*CCardSelectorUI.TOUCH_DELTA) then
		return
	end

	local delta = touch_location.x - self.touch_move_start_pos.x
	self.manual_scroll_left = (delta<0)
	self.touch_moved = true
	self:ScrollMove(delta)

	self.touch_move_start_pos = touch_location
end

function CCardSelectorUI:_TouchesEnded(touch_location)
    if not self.touch_enabled then
		return
	end

	if not self.touched then
		return
	end

    --触发点击监听
    if self.touch_moved == false then
        local card = self.card_selector:GetCard(self.current_select_index)
        if card and card.ClickCallback then
            card:ClickCallback()
        end

--        for i = self.card_selector:GetMinIndex(),self.card_selector:GetMaxIndex() do
--            local card = self.card_selector:GetCard(i)
--            if card then
--                card:ClickEvent(touch_location)
--            end
--        end
	end

	self.touched = false
	self.touch_end_pos = touch_location
	self:_EndRecordTouchAction()
end

function CCardSelectorUI:_TouchesCancelled(touch_location)
    if not self.touch_enabled then
        return
    end

    if not  self.touched then
        return
    end

    self.touched = false
    self.touch_end_pos = touch_location
    self:_EndRecordTouchAction()
end

--开始记录滑动动作，如果自动滚动则停止，并开始计时;
function CCardSelectorUI:_StartRecordTouchAction()

	if  self.auto_scroll then
		self:_StopAutoScroll(false)
	end
	self.manual_scroll = true
	self.touch_action_time = 0.0
end

--记录滑动动作期间统计时间;
function CCardSelectorUI:_EndRecordTouchAction()
    --运动结束设置调整位置;
	self.adjust_select_index = self.card_selector:GetCurrentSelectIndex()
	self.manual_scroll = false

	if self.touch_action_time <= 0.016 then
		return
	end

	local totalDis = 0
	totalDis = self.touch_end_pos.x - self.touch_began_pos.x
	local orSpeed = math.abs(totalDis)/(self.touch_action_time)
	if(orSpeed>self.auto_scroll_speed_max) then
		orSpeed = self.auto_scroll_speed_max
	end
	self:_StartAutoScroll(orSpeed)
	self.touch_action_time = 0.0
end


--获取当前自动滚动速度;
--参数：时间;
--成员变量：加速度(m_fAutoScrollAcceleration), 当前速度(m_fAutoScrollOriginalSpeed);
function CCardSelectorUI:_RecordTouchActionTime(dt)
    if self.manual_scroll then
        self.touch_action_time = self.touch_action_time + dt
    end
end

function CCardSelectorUI:_GetCurAutoScrollDistance(time)
    local dt = time

    self.current_auto_scroll_speed = self.current_auto_scroll_speed - self.auto_scroll_acceleration * dt
    return self.current_auto_scroll_speed * dt
end

--开始自动滚动;
function CCardSelectorUI:_StartAutoScroll(v)
    self.current_auto_scroll_speed = v;
	self.auto_scroll = true
end

function CCardSelectorUI:_StopAutoScroll(real_stop)
    --自动滚动结束，设置调整位置;
    self.adjust_select_index = self.card_selector:GetCurrentSelectIndex();
	self.auto_scroll = false;
	self.current_auto_scroll_speed = 0.0
end

--自动滚动，速度为0则停止;
--参数：时间;
--成员变量：方向(m_eMoveDirection);
function CCardSelectorUI:_AutoScroll(dt)
    if not self.auto_scroll then
        self:_Adjust2Selected(dt)
        return
    end

    if self.manual_scroll_left then
        local curDis = self:_GetCurAutoScrollDistance(dt)
        if curDis <= 0 then
            curDis = 0
            self:_StopAutoScroll(true)
        end

        if not self:ScrollMove(-curDis) then
            self:_StopAutoScroll(true)
        end
    else
        local curDis = self:_GetCurAutoScrollDistance(dt)
        if curDis <= 0 then
            curDis = 0
            self:_StopAutoScroll(true)
        end

        if not self:ScrollMove(curDis) then
            self:_StopAutoScroll(true)
        end
    end
end

function CCardSelectorUI:_Adjust2Selected(dt)
    if not self.manual_scroll then
        local delta = self.adjust_move_speed * dt
        local need_adjust_select_index = false

        --todo:
        --if self.current_select_index ~= 

        if self.current_select_index == self.adjust_select_index then
            if self.current_x > 0.0 then
                self.current_x = self.current_x - delta
                if self.current_x < 0.0 then
                    self.current_x = 0.0
                end
            end

            self:_ResetCards()
        elseif self.loop == false and self.current_select_index > self.adjust_select_index then
            self:_MoveRight(delta)
            self:_ResetCards()
        elseif self.loop == true and self.current_select_index > self.adjust_select_index and 
               self.current_select_index - self.adjust_select_index <=(self.card_selector:GetMaxIndex() - self.card_selector:GetMinIndex() + 1) / 2 then
            self:_MoveRight(delta)
            self:_ResetCards()
        elseif self.loop == true and self.current_select_index < self.adjust_select_index and
               self.current_select_index - self.adjust_select_index > (self.card_selector:GetMaxIndex() - self.card_selector:GetMinIndex()) / 2 then
            self:_MoveRight(delta)
            self:_ResetCards()
        else
            self:_MoveLeft(delta)
            self:_ResetCards()
        end
        
        self:_UpdateCurrentSelectIndex()
    end
end

function CCardSelectorUI:_MoveLeft(x)
    self.current_x = self.current_x - x

    if self.loop == false and self.current_select_index >= self.card_selector:GetMaxIndex() + 1 then
        local border_x = self.card_interval_x * (1.0 - self.border_radio_x)
        if self.current_x < border_x then
            self.current_x = border_x
            return false
        end
    else
        if self.current_x < 0 then
            self.current_x = self.card_interval_x
            self.current_select_index = self.current_select_index + 1
            self.current_select_index = self:_FixIndexForLoop(self.current_select_index)
        end
    end
    return true
end

function CCardSelectorUI:_MoveRight(x)
    self.current_x = self.current_x + x
    if self.loop == false and self.current_select_index <= self.card_selector:GetMinIndex() then
        local border_x = self.card_interval_x * self.border_radio_x
        if self.current_x > border_x then
            self.current_x = border_x
            return false
        end
    else
        if self.current_x > self.card_interval_x then
            self.current_x = 0.1
            self.current_select_index = self.current_select_index - 1
            self.current_select_index = self:_FixIndexForLoop(self.current_select_index)
        end
    end
end

function CCardSelectorUI:ScrollMove(x)
    local rlt = nil
    if x > 0 then 
        rlt = self:_MoveRight(x)
    else
        rlt = self:_MoveLeft(-x)
    end

    self:_UpdateCurrentSelectIndex();
    self:_ResetCards()

    return rlt
end

function CCardSelectorUI:_FixIndexForLoop(index)
    if self.loop then
        if index < self.card_selector:GetMinIndex() then
            index = self.card_selector:GetMaxIndex()
        elseif index > self.card_selector:GetMaxIndex() then
            index = self.card_selector:GetMinIndex()
        end       
    else
--        if index < self.card_selector:GetMinIndex() then
--            index = self.card_selector:GetMinIndex()
--        elseif index > self.card_selector:GetMaxIndex() then
--            index = self.card_selector:GetMaxIndex()
--        end   
    end

    return index
end

function CCardSelectorUI:_SetCurrentSelectIndex(index)
    index = self:_FixIndexForLoop(index)
    local old_select_index = self.card_selector:GetCurrentSelectIndex()

    self.card_selector:SetCurrentSelectIndex(index)

    --选中card发生改变
    if old_select_index ~= index then
       if self.select_change_event then
            self.select_change_event()
       end
    end
end


function CCardSelectorUI:_UpdateCurrentSelectIndex(index)
    
    if self.current_x > self.card_interval_x / 2.0 then
        self:_SetCurrentSelectIndex(self.current_select_index -1)
    else
        self:_SetCurrentSelectIndex(self.current_select_index)
    end
end

function CCardSelectorUI:SetMoveToIndex(index,scroll_change)
    scroll_change = scroll_change or true

    self:_FixIndexForLoop(index)
    if index <= self.card_selector:GetMaxIndex() and index >= self.card_selector:GetMinIndex() then
        
        self.adjust_select_index = index
        if not scroll_change then
            self.current_select_index = index
        end
    end
    self:_Adjust2Selected(0)
end

function CCardSelectorUI:_ResetCard0X1()
    local index = self.current_select_index - self.side_card_number - 1
    index = self:_FixIndexForLoop(index)
    local card = self.card_selector:GetCard(index)
    if not card or card:GetContainer() == nil or card:GetRootNode() == nil then
        return
    end

    card:GetRootNode():setLocalZOrder(-self.side_card_number - 1)
    self:_HighlightSelected(card,index)

    card:GetContainer():setAnchorPoint(0,0)
    card:GetContainer():setPositionX(0)
    card:GetRootNode():setAnchorPoint(0,0.5)

    --设置平滑系数,先快后慢，先小后大
    local radio = (self.current_x * self.current_x) / (self.card_interval_x * self.card_interval_x)

    --平滑移动
    card:GetRootNode():setPositionX(self.current_x + self.center_card_x - (self.side_card_number + 1) * self.card_interval_x)
    card:GetRootNode():setPositionY(card:GetRootNode():getContentSize().height / 2 + self.center_card_y)

    --平滑变浓,0~128
    local opacity = radio * self.opacity_inverval_step_2
    card:GetRootNode():setOpacity(opacity)

    --平滑放大,0.8~0.91.0
    card:GetRootNode():setScale(1.0-self.scale_inverval_step_1-self.scale_interval_step_2+radio*self.scale_interval_step_2)

    --固定3D旋转角度
    local angle = self.rotation_angel_max
    card:SetRotation3D(angle)

    --根据角度设置zorder,角度越大zorder越大
    card:GetRootNode():setLocalZOrder(self.rotation_angel_max - angle)
end

function CCardSelectorUI:_ResetCard0X(reset_index)
    local index = self.current_select_index - reset_index
    index = self:_FixIndexForLoop(index)
    local card = self.card_selector:GetCard(index)
    if not card or card:GetContainer() == nil or card:GetRootNode() == nil then
        return
    end

    card:GetRootNode():setLocalZOrder(-reset_index)
    self:_HighlightSelected(card,index)
    
    card:GetContainer():setAnchorPoint(0,0)
    card:GetContainer():setPositionX(0)
    card:GetRootNode() :setAnchorPoint(0,0.5)

    local radio = (self.current_x * self.current_x) /(self.card_interval_x * self.card_interval_x)

    card:GetRootNode():setPositionX(self.current_x + self.center_card_x - reset_index)
    card:GetRootNode():setPositionY(card:GetRootNode():getContentSize().height / 2 + self.center_card_y)

    local opacity = self.opacity_inverval_step_2
    card:GetRootNode():setOpacity(opacity)

    card:GetRootNode():setScale(1.0 - self.scale_inverval_step_1)

    local angle = self.rotation_angel_max
    card:SetRotation3D(angle)

    card:GetRootNode():setLocalZOrder(self.rotation_angel_max - angle)
end

function CCardSelectorUI:_ResetCard0()
    local index = self.current_select_index - 1
    index = self:_FixIndexForLoop(index)
    local card = self.card_selector:GetCard(index)
    if not card or card:GetContainer() == nil or card:GetRootNode() == nil then
        return
    end

    card:GetRootNode():setLocalZOrder(-1)
    self:_HighlightSelected(card,index)

    local radio = (self.current_x * self.current_x) / (self.card_interval_x * self.card_interval_x)
    
    card:GetContainer():setAnchorPoint(0,0)
    card:GetContainer():setPositionX(0)
    card:GetRootNode():setAnchorPoint(0,0.5)

    --平滑移动
    
    card:GetRootNode():setPositionX(self.current_x + self.center_card_x - self.card_interval_x)
    card:GetRootNode():setPositionY(card:GetRootNode():getContentSize().height / 2 + self.center_card_y)

    local opacity = self.opacity_inverval_step_2 + radio * self.opacity_inverval_step_1
    card:GetRootNode():setOpacity(opacity)

    card:GetRootNode():setScale(1.0-self.scale_inverval_step_1+radio*self.scale_inverval_step_1)
    
    local angle = self.rotation_angel_max - radio * self.rotation_angel_max
    card:SetRotation3D(angle)

    card:GetRootNode():setLocalZOrder(self.rotation_angel_max - angle)
end

function CCardSelectorUI:_ResetdCard1()
    local index = self.current_select_index
    index = self:_FixIndexForLoop(index)
    local card = self.card_selector:GetCard(index)
    if not card or card:GetContainer() == nil or card:GetRootNode() == nil then
        return
    end

    card:GetRootNode():setLocalZOrder(0)
    self:_HighlightSelected(card,index)

    local radio = ((self.card_interval_x-self.current_x) * (self.card_interval_x-self.current_x)) / (self.card_interval_x * self.card_interval_x)
    
    card:GetContainer():setAnchorPoint(1,0)
    card:GetContainer():setPositionX(card:GetContainer():getContentSize().width)
    card:GetRootNode():setAnchorPoint(1,0.5)

    --平滑移动
    card:GetRootNode():setPositionX(self.current_x + self.center_card_x + 0)
    card:GetRootNode():setPositionY(card:GetRootNode():getContentSize().height / 2 + self.center_card_y)

    local opacity = 255 - (1.0 - radio) * self.opacity_inverval_step_1
    card:GetRootNode():setOpacity(opacity)

    card:GetRootNode():setScale(1.0 - self.scale_inverval_step_1 + radio * self.scale_inverval_step_1)
    
    local angle = (1.0 - radio) * self.rotation_angel_max
    card:SetRotation3D(angle)

    card:GetRootNode():setLocalZOrder(self.rotation_angel_max + angle)
end

function CCardSelectorUI:_ResetCard1X1()
    
    local index = self.current_select_index + self.side_card_number
    index = self:_FixIndexForLoop(index)
    local card = self.card_selector:GetCard(index)
    if not card or card:GetContainer() == nil or card:GetRootNode() == nil then
        return
    end

    card:GetRootNode():setLocalZOrder(self.side_card_number - self.side_card_number + 1)
    self:_HighlightSelected(card,index)

    local radio = ((self.card_interval_x - self.current_x) * (self.card_interval_x - self.current_x)) / (self.card_interval_x * self.card_interval_x)
    
    card:GetContainer():setAnchorPoint(1,0)
    card:GetContainer():setPositionX(card:GetContainer():getContentSize().width)
    card:GetRootNode():setAnchorPoint(1,0.5)

    --平滑移动
    card:GetRootNode():setPositionX(self.current_x + self.center_card_x + 0 + self.side_card_number * self.card_interval_x);
	card:GetRootNode():setPositionY( card:GetRootNode():getContentSize().height/2 + self.center_card_y)

    

    local opacity = 255- self.opacity_inverval_step_1-(1.0-radio)* self.opacity_inverval_step_2;
    card:GetRootNode():setOpacity(opacity)

    card:GetRootNode():setScale(1.0-self.scale_inverval_step_1-self.scale_interval_step_2+radio*self.scale_interval_step_2)
    
    local angle = -self.rotation_angel_max
    card:SetRotation3D(angle)

    card:GetRootNode():setLocalZOrder(self.rotation_angel_max + angle)
end

function CCardSelectorUI:_ResetCards()
    if self.old_show_select_index ~= self.current_select_index then
        if self.old_show_select_index ~= -1 then
            
            for i = self.old_show_select_index -(self.side_card_number + 1), self.old_show_select_index + self.side_card_number do
                local index = i
                index = self:_FixIndexForLoop(index)
                if index < self.current_select_index - self.side_card_number + 1 or index > self.current_select_index + self.side_card_number then
                    
                    local card = self.card_selector:GetCard(index)
                    if card then
--                        if card:IsShow() then
--                            card:SetShow(false)
--                            self:RemoveChild(card)
--                        end

                    end

                end
            end

        end
        
        self.old_show_select_index = self.current_select_index

    end

    for i = self.current_select_index - (self.side_card_number + 1),self.current_select_index + self.side_card_number do
        local index = i
        index = self:_FixIndexForLoop(index)
        local card = self.card_selector:GetCard(index)
        if card then
            if not card:IsShow() then
                card:SetShow(true)
                self:AddChild(card)
            end
        end
    end

    if self.side_card_number ~= 0 then
        self:_ResetCard0X1()
    end

    for i =self.side_card_number , 2,-1 do
        self:_ResetCard0X(i)
    end

    self:_ResetCard0();

    self:_ResetdCard1();
   
    if self.side_card_number ~= 0 then
        self:_ResetCard1X1()
    end

    for i = self.side_card_number - 1,1,-1 do
        self:_ResetCard1X(i)
    end
end

function CCardSelectorUI:SetSideCardNumber(side_card_number)
    self.side_card_number = side_card_number
    if not self.manual_set_card_interval_x then
        local side = 1
        if self.side_card_number ~= 0 then side = self.side_card_number end
        self.card_interval_x = (self.widget:getContentSize().width/2 - self.card_width/2)/(side)
    end
    if self.side_card_number == 0 then
		self.opacity_inverval_step_1 =255
		self.opacity_inverval_step_2=0
	else
		self.opacity_inverval_step_1 = 127
		self.opacity_inverval_step_2 = 128
    end
end

function CCardSelectorUI:SetLoop(loop)
    self.loop = loop
end

function CCardSelectorUI:IsTouchEnabled()
    return self.touch_enabled
end

function CCardSelectorUI:SetTouchEnabled(value)
    self.touch_enabled = value
    self.widget:setTouchEnabled(value)
end

--设置中心卡片位置
function CCardSelector:SetCenterCardPos(x,y)
    self.center_card_x = x
    self.center_card_y = y
    self.manual_set_center_card_x = true
end

function CCardSelectorUI:SetScaleInvervalStep1(scale)
    self.scale_interval_step_1 = scale
end

function CCardSelectorUI:SetScaleInvervalStep2(scale)
    self.scale_interval_step_2 = scale
end

function CCardSelectorUI:SetOpacityInvervalStep(opacity)
    self.opacity_inverval_step_1 = opacity
    self.opacity_inverval_step_2 = 255 - opacity
end

function CCardSelectorUI:GetMovementX()
    local index = self.current_select_index - self.card_selector:GetMinIndex()
    return (index - 1) * self.card_interval_x + self.card_interval_x - self.current_x
end

function CCardSelectorUI:IsScroll()
    if self.manual_scroll or self.auto_scroll then return true end

    if self.current_select_index == self.adjust_select_index then
        
    end
    return true
end

function CCardSelectorUI:_HighlightSelected(card,index )
	if index == self.card_selector:GetCurrentSelectIndex() then
		card:GetRootNode():setColor(cc.c3b(255,255,255))
	else
		card:GetRootNode():setColor(cc.c3b(128,128,128))
	end
end

--card之间间距
function CCardSelectorUI:SetCardIntervalX(value)
    self.card_interval_x = value
end

function CCardSelectorUI:IsMinCard()
   return self.card_selector:GetCurrentSelectIndex() == self.card_selector:GetMinIndex()
end

function CCardSelectorUI:IsMaxCard()
    return self.card_selector:GetCurrentSelectIndex() == self.card_selector:GetMaxIndex()
end

function CCardSelectorUI:AddSelectChangeEvent(event_func)
    self.select_change_event = event_func
end

return CCardSelectorUI
--endregion
