-- region *.lua
-- Date
-- 此文件由[BabeLua]插件自动生成

dxm.CClippingLoadingBarUI = class("dxm.CClippingLoadingBarUI", dxm.CBaseUI)
local CClippingLoadingBarUI = dxm.CClippingLoadingBarUI

function CClippingLoadingBarUI:ctor()
    CClippingLoadingBarUI.super.ctor(self)
end

function CClippingLoadingBarUI:Init(size, background, head_stencil, head)
    
    self.size = size
    self.head = head
    self.background = background

    -- 画一个多边形 这画一个200x200的矩形作为模板 
    local points = { cc.p(0,0), cc.p(0 + size.width, 0), cc.p(0 + size.width, 0 + size.height), cc.p(0, 0 + size.height) } 
    local white = cc.c4f(1, 1, 1, 1) 
    self.stencil = cc.DrawNode:create()
    self.stencil:drawPolygon(points, 4, white, 0, white)

    -- 裁剪一下;
    local background_clipper = cc.ClippingNode:create()
    background_clipper:setInverted(false)
    background_clipper:setStencil(self.stencil)
    background_clipper:setAnchorPoint(cc.p(0,0))

    -- 头部显示;
    local head_clipper
    if head_stencil then
        head_stencil:setAnchorPoint(cc.p(0,0))
        head_clipper = cc.ClippingNode:create()
        head_clipper:setStencil(head_stencil)
        head_clipper:setInverted(false)
        if head then
            head:setAnchorPoint(cc.p(0,1))
            head_clipper:addChild(head,1)
            head_clipper:setAnchorPoint(cc.p(0,0))
            head_clipper:setAlphaThreshold(0.05)
        end
    end

    if background then
        background_clipper:addChild(background)
    end

    if CClippingLoadingBarUI.super.Init(self) then
        if head_clipper then 
            self.widget:addChild(head_clipper)
            head_clipper:addChild(background_clipper) 
        else            
            self.widget:addChild(background_clipper)
        end
        self.widget:setContentSize(self.size)
        return true
    end
    return false
end

function CClippingLoadingBarUI:Create(...)

    local ui = CClippingLoadingBarUI.new()
    if ui == nil or ui:Init(...) == false then
        return nil
    end
    return ui
end



function CClippingLoadingBarUI:onEnter( )

end

function CClippingLoadingBarUI:onExit( )

end

function CClippingLoadingBarUI:SetPercent(percent)

    if percent>100 then percent = 100 end

    local width = self.size.width
    local height = self.size.height*percent/100
    local points = {cc.p(0,0), cc.p(0 + width, 0), cc.p(0 + width, 0 + height), cc.p(0, 0 + height)} 
    local white = cc.c4f(1, 1, 1, 1) 
    self.stencil:clear()
    self.stencil:drawPolygon(points, 4, white, 1, white);
    -- self.clipper:setStencil(self.stencil)
    if self.head then
        self.head:setPosition(cc.p(0, height))
        self.head:setVisible(percent<100)
    end
end

return CClippingLoadingBarUI

--endregion