-- region *.lua
-- Date
-- 此文件由[BabeLua]插件自动生成

dxm.CLoadingUI = class("dxm.CLoadingUI", dxm.CSystemDialogUI)

local CLoadingUI = dxm.CLoadingUI

function CLoadingUI:ctor()
    CLoadingUI.super.ctor(self)

    self.loaded_percent = 0
    self.loaded_percent_display = 0 
    self.load_completed = false
end

function CLoadingUI:Init(task_list, complete_callback)
    self.task_list = task_list or {}
    self.complete_callback = complete_callback 
    self.step_percent = math.floor(10000 / (#self.task_list + 1))
    self.step = 1   
    self.step_total = #self.task_list 
    return self:InitWithFile("csd/Common/Loading")
end

function CLoadingUI:Create(...)

    local ui = CLoadingUI.new()
    if ui == nil or ui:Init(...) == false then
        return nil
    end
    
    return ui
end

function CLoadingUI:onEnter()

    self.loaded_percent = 0

    local entry
	entry = cc.Director:getInstance():getScheduler():scheduleScriptFunc(function()
        self:_StepTask()
        self:_UpdateLoadingBar()
        if self.load_completed then
            cc.Director:getInstance():getScheduler():unscheduleScriptEntry(entry)
            self:Close()
        end
	end, 0, false)   

    self:SetLabelText(assets.tips:Get(), "AtlasLabelLoadTip")
    self:_UpdateLoadingBar()
end

function CLoadingUI:_StepTask()
    if self.step <= self.step_total then
        local task = self.task_list[self.step]
        if task then task() end
        self.loaded_percent = self.loaded_percent + self.step_percent
        self.step = self.step + 1
        -- print(""..self.step.."/"..self.step_total)
    else 
        self.loaded_percent = 10000
    end
end

function CLoadingUI:_UpdateLoadingBar()
    
    if self.loaded_percent_display == 10000 then
        self.load_completed = true
        self:SetAtlasLabelText(""..self.loaded_percent_display.."%", "AtlasLabelLoad")
        if self.complete_callback then self.complete_callback() end
    else
        local delta = 50000

        if self.loaded_percent < 10000 then
            delta = self.loaded_percent - self.loaded_percent_display
        end
        self.loaded_percent_display = self.loaded_percent_display + math.floor(delta/100)
        if self.loaded_percent_display > 10000 then
            self.loaded_percent_display = 10000
        end

        local percent = math.floor(self.loaded_percent_display/100)
        self:SetLoadingbarPercent(percent, "LoadingBar")
        self:SetAtlasLabelText(""..percent.."%", "AtlasLabelLoad")
    end

end

function CLoadingUI:onExit()

end


return CLoadingUI

-- endregion
