--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

dxm.CMessageTipUI = class("dxm.CMesssageTipsUI",dxm.CNoticeUI)

local CMessageTipUI = dxm.CMessageTipUI

function CMessageTipUI:ctor()
    CMessageTipUI.super.ctor(self)
end

function CMessageTipUI:_Init(message,font_size)
    self.message = message
    self.font_size = font_size
    self:InitWithFile("csd/Common/MessageTip")
    return true
end

function CMessageTipUI:_Create(...)
    local ui = CMessageTipUI.new()
    if ui and ui:_Init(...) then
        return ui
    end

    return nil
end

function CMessageTipUI:Show(...)
    local ui = self:_Create(...)
    if ui then
        dxm.CUIManager:GetInstancePtr():OpenUI(ui,dxm.UIOrder.kUIOrderNotice, true) 
    end
    return ui
end

function CMessageTipUI:onEnter()
    self:SetLabelText(self.message,"TextTip")
    
    self.label = self:GetWidget("TextTip")
    
    if self.label then
        self.ori_label_pos = cc.p(self.label:getPosition())
        self.ori_label_opacity = self.label:getOpacity()
        if self.font_size then
            self.label:setFontSize(self.font_size)
        end
    end

    self:PopAndMoveText(self:GetWidget("TextTip"), function() 
        self:RemoveFromParent()
    end)
end

function CMessageTipUI:onExit()
    if self.label then
        self.label:setPosition(self.ori_label_pos)
        self.label:setOpacity(self.ori_label_opacity)
    end
end

function CMessageTipUI:PopAndMoveText(node,callback)
    if not node then return end
    node:stopAllActions()
    node:setScale(0.05)

    local actions = {}
    actions[#actions + 1] = cc.Spawn:create(cc.ScaleTo:create(0.21, 1, 1))
    actions[#actions + 1] = cc.Spawn:create(cc.ScaleTo:create(0.21, 0.9, 1.1))
    actions[#actions + 1] = cc.Spawn:create(cc.ScaleTo:create(0.1, 1, 1.05))
    actions[#actions + 1] = cc.Spawn:create(cc.ScaleTo:create(0.06, 1.1, 0.9))
    actions[#actions + 1] = cc.Spawn:create(cc.ScaleTo:create(0.06, 0.95, 1.1))
    actions[#actions + 1] = cc.Spawn:create(cc.ScaleTo:create(0.06, 1.05, 0.95))
    actions[#actions + 1] = cc.Spawn:create(cc.ScaleTo:create(0.06, 1, 1))
    actions[#actions + 1] = cc.Spawn:create(cc.FadeOut:create(0.5),cc.MoveBy:create(0.5, cc.p(0,200)))

    if callback then
        actions[#actions + 1] = cc.CallFunc:create(function() callback() end)
    end

    local action = cc.Sequence:create(actions)
    node:runAction(action)
end

return CMessageTipUI
--endregion
