-- region *.lua
-- Date
-- 此文件由[BabeLua]插件自动生成


-- 新手引导;
-- 1. 裁剪功能, 点中裁剪区域就关闭引导;
-- 2. 提示功能, "PanelClose" 全屏点击区域关闭则关闭;

dxm.CNewbieGuideUI = class("dxm.CNewbieGuideUI", dxm.CGuideUI)
local CNewbieGuideUI = dxm.CNewbieGuideUI

function CNewbieGuideUI:ctor()
    CNewbieGuideUI.super.ctor(self)
end

function CNewbieGuideUI:Init(file, complete_callback)
    if not CNewbieGuideUI.super.Init(self, file) then
        return false
    end
    self.complete_callback = complete_callback 
    return true
end

function CNewbieGuideUI:Create(...)

    local ui = CNewbieGuideUI.new()
    if ui == nil or ui:Init(...) == false then
        return nil
    end
    return ui
end

function CNewbieGuideUI:onEnter( )

    local clipping = self:GetWidget("PanelClipping")
    local stencil = self:GetWidget("PanelStencil")
    local sx_mine = self:GetWidget("PanelMine")
    local panel_close = self:GetWidget("PanelClose")
    if clipping and stencil then
        self.clipping = clipping
        self.clipping_layer = dxm.CClickClippingNode:Create(0, function(click_clip) 
            if click_clip then
                if self.complete_callback then self.complete_callback() end
                self:RemoveFromParent()
            end
        end)
        self.clipping:retain()
        self.clipping:getParent():addChild(self.clipping_layer, -1)
        self.clipping:removeFromParent()
        self.clipping_layer:addChild(self.clipping)
        self.clipping_layer:SetNode(stencil)
        self:SetWidgetVisible(false, "PanelClose")
        self.clipping_layer:setOpacity(0)
        self.clipping_layer:runAction(cc.EaseOut:create(cc.FadeIn:create(0.5), 1))
        if sx_mine then
            sx_mine:setOpacity(0)
            sx_mine:runAction(cc.EaseOut:create(cc.FadeIn:create(0.5), 1))
        end
    end

    if panel_close then
        self:SetWidgetVisible(true, "PanelClose")
        local show_time = os.time()
        self:AddReleaseEvent(function() 
                local delta = os.time() - show_time
                if delta > 2 then
                    dxm.audio:playSound(assets.sound.config.sound.ui_button_release)
                    if self.complete_callback then self.complete_callback() end
                    self:RemoveFromParent() 
                end
            end, "PanelClose")
    end
end

function CNewbieGuideUI:onExit( )
    
    if self.clipping then 
        self.clipping:removeFromParent()
        self.clipping_layer:getParent():addChild(self.clipping, -1)
        self.clipping:release()
    end
end

return CNewbieGuideUI

--endregion