-- region *.lua
-- Date
-- 此文件由[BabeLua]插件自动生成


dxm.CPageViewUI = class("dxm.CPageViewUI", dxm.CBaseUI)
local CPageViewUI = dxm.CPageViewUI


function CPageViewUI:ctor()

    CPageViewUI.super.ctor(self)
    self.page_view = nil
    self.auto_increase_index = 0

    self.ui_map = {}
    self.creator_map = {}
    self.widget_map = {}
end

function CPageViewUI:Dispose()

end


function CPageViewUI:Init(change_page_callback)

	self.page_view = ccui.PageView:create()
    self.page_view:setContentSize( cc.size(display.width,display.height))
	self:set_widget(self.page_view)
	self.change_page_callback = change_page_callback
	return true
end

function CPageViewUI:Create(change_page_callback)

	local ui = CPageViewUI.new()
	if ui==nil or ui:Init(change_page_callback) == false then
        return nil
    end
	return ui
end

function CPageViewUI:onEnter()

	CPageViewUI.super.onEnter(self)

    self.page_view:addEventListener(function(sender, eventType)
        local event = {}
        if eventType == 0 then
            if  self.change_page_callback then
		        self.change_page_callback(self.page_view:getCurrentPageIndex())
	        end
        end
        if eventType == 1 then            
            self:Refresh()
        end
    end)
end

function CPageViewUI:onExit()
	self:ClearPages()
    CPageViewUI.super.onExit(self)
end

function CPageViewUI:AddPage(ui)
	if self.is_entered == false then
		return -1
	end


	local index = self.auto_increase_index
    self.auto_increase_index = self.auto_increase_index + 1

	local widget = ccui.Layout:create()
	self.page_view:insertPage(widget, index)
	widget:setContentSize(self.widget:getContentSize())
	widget:setClippingEnabled(true)
    widget:addChild(cc.Sprite:create("ccs/images/paihangban7.png"))

	self:AddChild(widget, ui)
	self.ui_map[index+1] = ui
	return index
end

function CPageViewUI:AddPageCreator(creator_callback)
	if creator_callback == nil then
		return -1
	end

	local index = self.auto_increase_index
    self.auto_increase_index = self.auto_increase_index + 1

	local widget = ccui.Layout:create()
	self.page_view:insertPage(widget, index)
	widget:setContentSize(self.widget:getContentSize())
	widget:setClippingEnabled(true)

	self.creator_map[index+1] = creator_callback
	self.widget_map[index+1] = widget
	self:Refresh()
	return index
end

function CPageViewUI:ClearPages()
	self.auto_increase_index = 0
	for key, ui in pairs(self.ui_map) do
    	if ui then
			ui:RemoveFromParent()
		end
	end
	self.ui_map = {}
	self.page_view:removeAllPages()
end

function CPageViewUI:ScrollToPage(index)

	if index ~= nil and index == -1 then
		return
	end

	self.page_view:scrollToPage(index)
end

function CPageViewUI:Refresh()
	local index = self.page_view:getCurrentPageIndex() 

    if index == -1 then index = 0 end
	self:_RefreshPage(index - 1)
	self:_RefreshPage(index)
	self:_RefreshPage(index + 1)
end

function CPageViewUI:_RefreshPage(index)

	if index < 0 then return end

	if self.ui_map[index+1] then return end

	local creator_callback = self.creator_map[index+1]
    if creator_callback == nil then return end
	local expecial_ui = creator_callback()
	if expecial_ui then
		self:AddChild(self.widget_map[index+1], expecial_ui)
		self.ui_map[index+1] = expecial_ui
	end
end

return CPageViewUI

--endregion