-- region *.lua
-- Date
-- 此文件由[BabeLua]插件自动生成


dxm.CScrollBackground = class("dxm.CScrollBackground", dxm.CBaseUI)
local CScrollBackground = dxm.CScrollBackground


function CScrollBackground:ctor()
    self.horizontal = false -- 是否横屏
    self.node1 = nil -- 滚屏第一个元素, 横屏宽度 720, 竖屏长度 1160
    self.node2 = nil -- 滚屏第二个元素, 横屏宽度 720, 竖屏长度 1160
    self.pos_node = nil -- 前景节点, 远景是相对前景移动的
    self.scale = 0.5 -- 远景的相对移动倍率
end

function CScrollBackground:Init(node1, node2, pos_node, horizontal, scale)

    self.node1 = node1
    self.node2 = node2
    self.pos_node = pos_node
    self.horizontal = horizontal
    self.scale = scale
end

function CScrollBackground:Create(...)

    local background = CScrollBackground.new()
    if background == nil or background:Init(...) == false then
        return nil
    end
    return background
end

function CScrollBackground:Update()

    if (not self.node1) or (not self.node2) or (not self.pos_node) then
        return
    end

    local posx, posy = self.pos_node:getPosition()
    local node1_posx, node1_posy = self.node1:getPosition()
    local node2_posx, node2_posy = self.node2:getPosition()
    if self.horizontal == true then
        posx = self.scale*posx
        local abs_posx = math.abs(posx) %1440
        if posx < 0 then
            if abs_posx > 720 then 
                self.node1:setPosition(cc.p(-abs_posx+1440, node1_posy)) 
            else
                self.node1:setPosition(cc.p(-abs_posx, node1_posy)) 
            end
            self.node2:setPosition(cc.p(-abs_posx+720, node2_posy))
        else
            if abs_posx < 720 then 
                self.node1:setPosition(cc.p(abs_posx, node1_posy)) 
            else
                self.node1:setPosition(cc.p(abs_posx-1440, node1_posy)) 
            end
            self.node2:setPosition(cc.p(abs_posx-720, node2_posy))
        end
    else
        posy = self.scale*posy
        local abs_posy = math.abs(posy) % 2320
        if posy < 0 then
            if abs_posy > 1160 then 
                self.node1:setPosition(cc.p(node1_posx, -abs_posy+2320)) 
            else
                self.node1:setPosition(cc.p(node1_posx, -abs_posy)) 
            end
            self.node2:setPosition(cc.p(node2_posx, -abs_posy+1160))
        else
            if abs_posy < 1160 then 
                self.node1:setPosition(cc.p(node1_posx, abs_posy)) 
            else
                self.node1:setPosition(cc.p(node1_posx, abs_posy-2320)) 
            end
            self.node2:setPosition(cc.p(node2_posx, abs_posy-1160))
        end
    end
end


return CScrollBackground

--endregion