-- region *.lua
-- Date
-- 此文件由[BabeLua]插件自动生成


dxm.CScrollViewUI = class("dxm.CScrollViewUI", dxm.CBaseUI)
local CScrollViewUI = dxm.CScrollViewUI

CScrollViewUI.SCROLLVIEW_DIR ={
    SCROLLVIEW_DIR_NONE=0,
    SCROLLVIEW_DIR_VERTICAL=1,
    SCROLLVIEW_DIR_HORIZONTAL=2,
    SCROLLVIEW_DIR_BOTH=3
}

function CScrollViewUI:ctor()
    CScrollViewUI.super.ctor(self)
    self.scroll_view = nil
    self.last_begin_index_ = 0
    self.last_end_index_ = 0
    self.scroll_view_size = { }
    self.scroll_view_size.width = 0
    self.scroll_view_size.height = 0
    self.fix_tail = 0
    self.fix_head = 0
    self.cell_ui_list = dxm.CList.new()
end

function CScrollViewUI:Dispose()
    CScrollViewUI.super.Dispose(self)

    if self.scroll_view ~= nil then
        self.scroll_view:release()
        self.scroll_view = nil
    end

    self:RemoveAllCells()
end

function CScrollViewUI:SetZOrderDesc(zorder_desc)
   self.zorder_desc = zorder_desc or true
end

function CScrollViewUI:RemoveAllCells()

    local itor = self.cell_ui_list:Begin()

    local node = nil
    while true do
        local node = itor()
        if node == nil then break end
        local cell = node.value
        if cell ~= nil then
            cell:RemoveFromParent()
        end
        self.cell_ui_list:Erase(node)
    end
end

function CScrollViewUI:Init(scroll_view)

    if scroll_view == nil then
        return false
    end

    -- self.scroll_view = tolua.cast(scroll_view, "ScrollView")
    self.scroll_view = scroll_view
    self.scroll_view:retain()

    return CScrollViewUI.super.InitWithWidget(self, self.scroll_view)
end

function CScrollViewUI:Create(scroll_view)

    local ui = CScrollViewUI.new()
    if ui == nil or ui:Init(scroll_view) == false then
        return nil
    end
    return ui
end

function CScrollViewUI:AddCell(cell)

    if cell==nil then return end
    self.cell_ui_list:PushBack(cell)
    cell.scroll_view_ui = self
end

function CScrollViewUI:RemoveCell(cell)
    if not cell then return end
    self.cell_ui_list:Remove(cell)
    cell:RemoveFromParent()
    self:InitPosition()
end

function CScrollViewUI:_GetInnerHeight()
    local itor = self.cell_ui_list:Begin()
    local node = nil
    local sum_height = 0
    while true do
        local node = itor()
        if node == nil then break end
        local cell = node.value
        if cell ~= nil then
            sum_height = sum_height + cell:GetContentSize().height
        end
    end
    return sum_height
end

function CScrollViewUI:_GetInnerWidth()
    local itor = self.cell_ui_list:Begin()
    local node = nil
    local sum_width = 0
    while true do
        local node = itor()
        if node == nil then break end
        local cell = node.value
        if cell ~= nil then
            sum_width = sum_width + cell:GetContentSize().width
        end
    end
    return sum_width
end

function CScrollViewUI:InitPosition(enable_bounce)
    if enable_bounce==nil then enable_bounce = true end
    if enable_bounce~=nil then
        self.scroll_view:setBounceEnabled(enable_bounce)
    end

    self:_InitPosition()

    local scroll_view_direction = self.scroll_view:getDirection()
    if self.scroll_view:getDirection() == CScrollViewUI.SCROLLVIEW_DIR.SCROLLVIEW_DIR_HORIZONTAL  then
        -- 滚动到左边
        -- self.scroll_view:setBounceEnabled(true)
        self.scroll_view:jumpToLeft()
    else
        -- 滚动到顶部
        -- self.scroll_view:setBounceEnabled(true)
        self.scroll_view:jumpToTop()
    end
end

function CScrollViewUI:_InitPosition()

    local scroll_view_direction = self.scroll_view:getDirection()
    if self.scroll_view:getDirection() == CScrollViewUI.SCROLLVIEW_DIR.SCROLLVIEW_DIR_HORIZONTAL  then
      self:_InitPositionHorizontal()
    else
      self:_InitPositionVertical()
    end
end

function CScrollViewUI:_InitPositionVertical()
  
    -- 初始化cell位置;
    local height = self.fix_tail
    local itor = self.cell_ui_list:End()
    while true do
        local node = itor()
        if node == nil then break end
        local cell = node.value
        if cell ~= nil then
            cell:SetPosition(0, height)
            height = height + cell:GetContentSize().height
        end
    end

    -- 初始化滚动层大小
    local inner_height = height + self.fix_head
    if inner_height >= self.scroll_view:getContentSize().height then
        self.scroll_view:setInnerContainerSize(cc.size(self.scroll_view:getInnerContainerSize().width, inner_height))
    else
        self.scroll_view:setInnerContainerSize(cc.size(self.scroll_view:getInnerContainerSize().width, self.scroll_view:getContentSize().height))

        local delta = self.scroll_view:getContentSize().height - inner_height;
        local itor = self.cell_ui_list:Begin()
        while true do
            local node = itor()
            if node == nil then break end
            local cell = node.value
            if cell ~= nil then
                cell:SetPosition(0, cell.position.y+delta)
            end
        end
    end
end

function CScrollViewUI:_InitPositionHorizontal()
    -- 初始化cell位置;
    local width = 0
    local itor = self.cell_ui_list:Begin()
    while true do
        local node = itor()
        if node == nil then break end
        local cell = node.value
        if cell ~= nil then
            cell:SetPosition(width, 0)
            width = width + cell:GetContentSize().width
        end
    end

    -- 初始化滚动层大小
    local inner_width = width
    if inner_width >= self.scroll_view:getContentSize().width then
        self.scroll_view:setInnerContainerSize(cc.size(inner_width, self.scroll_view:getInnerContainerSize().height))
        self.scroll_view:setContentSize(self.scroll_view:getContentSize())
    else
        self.scroll_view:setInnerContainerSize(cc.size(inner_width, self.scroll_view:getInnerContainerSize().height))
--        local delta = self.scroll_view:getcontentsize().width - inner_width;
--        itor = self.cell_ui_list:begin()
--        while true do
--            local node = itor()
--            if node == nil then break end
--            local cell = node.value
--            if cell ~= nil then
--                cell:setposition(cell.position.x+delta, 0)
--            end
--        end
    end
end

function CScrollViewUI:Update(dt)
    if self.scroll_view==nil or self.cell_ui_list.size==0 then return end

    if self.scroll_view:getDirection() == CScrollViewUI.SCROLLVIEW_DIR.SCROLLVIEW_DIR_HORIZONTAL  then
      self:_UpdateHorizontal()
    else
      self:_UpdateVertical()
    end
end

function CScrollViewUI:_UpdateVertical( )

    -- 获取显示区域;
    local display_bottom_y = - self.scroll_view:getInnerContainer():getPositionY()
    local display_top_y = display_bottom_y + self.scroll_view:getContentSize().height

    -- 更新显示;
    local itor = self.cell_ui_list:Begin()
    while true do
        local node = itor()
        if node == nil then break end

        local cell = node.value
        local cell_bottom_y = cell.position.y;
        local cell_top_y = cell_bottom_y + cell:GetContentSize().height
        local cell_in_display_bottom = cell_top_y<display_bottom_y
        local cell_in_display_top = cell_bottom_y>display_top_y

        if  cell_in_display_bottom or cell_in_display_top then
             if cell.is_entered==true then
                self:RemoveChild(cell)                
            end
        else
            if cell.is_entered==false then
                self:AddChild(cell)
                if self.zorder_desc==false then
                    cell.widget:setLocalZOrder(cell_bottom_y)
                else
                    cell.widget:setLocalZOrder(999999-cell_bottom_y)
                end
            end
        end
    end
end

function CScrollViewUI:_UpdateHorizontal( )
    -- 获取显示区域;
    local display_left_x = -self.scroll_view:getInnerContainer():getPositionX()
    local display_right_x = display_left_x + self.scroll_view:getContentSize().width
    
    -- 更新显示;
    local itor = self.cell_ui_list:Begin()
    while true do
        local node = itor()
        if node == nil then break end

        local cell = node.value
        local cell_left_x = cell.position.x;
        local cell_right_x = cell_left_x + cell:GetContentSize().width
        local cell_in_display_left = cell_right_x<display_left_x
        local cell_in_display_right = cell_left_x>display_right_x

        if  cell_in_display_left or cell_in_display_right then
             if cell.is_entered==true then
                self:RemoveChild(cell)
            end
        else
            if cell.is_entered==false then
                self:AddChild(cell)
                if self.zorder_desc==true then
                    cell.widget:setLocalZOrder(999999-cell_left_x)
                else
                    cell.widget:setLocalZOrder(cell_left_x)
                end
            end
        end
    end
end

function CScrollViewUI:onEnter( )
	CScrollViewUI.super.onEnter(self)

    self.update_entry = CCDirector:getInstance():getScheduler():scheduleScriptFunc(function(dt) 
            self:Update(dt) 
        end, 
        0, false)
end

function CScrollViewUI:onExit( )
	CScrollViewUI.super.onExit(self)
    CCDirector:getInstance():getScheduler():unscheduleScriptEntry(self.update_entry)
end

function CScrollViewUI:FocusCenter(cell, offset_x, offset_y)

    if not cell then return end

    offset_x = offset_x or 0
    offset_y = offset_y or 0
    local focus_x = cell.position.x + offset_x
    local focus_y = cell.position.y + offset_y
    if self.scroll_view:getDirection() == CScrollViewUI.SCROLLVIEW_DIR.SCROLLVIEW_DIR_HORIZONTAL then
        local scrollview_info = {}
        scrollview_info.pos = cc.p(self.scroll_view:getPosition())
        scrollview_info.size = self.scroll_view:getContentSize()
        scrollview_info.ipos = self.scroll_view:getInnerContainerPosition()
        scrollview_info.isize = self.scroll_view:getInnerContainerSize()
        scrollview_info.cpos = cc.p(scrollview_info.size.width/2, scrollview_info.size.height/2)
        scrollview_info.msize = {width=scrollview_info.isize.width-scrollview_info.size.width, height=scrollview_info.isize.height-scrollview_info.size.height}
 
        local posx, posy = focus_x, focus_y
        local scroll_pos_x = posx - scrollview_info.cpos.x 
        if scroll_pos_x > 0 then 
            local scroll_percent = scroll_pos_x*100/scrollview_info.msize.width
            if scroll_percent<100 then 
                self.scroll_view:jumpToPercentHorizontal(scroll_percent) 
            else
                self.scroll_view:jumpToPercentHorizontal(100) 
            end
        else
            self.scroll_view:jumpToPercentHorizontal(0)
        end           
    else
        local scrollview_info = {}
        scrollview_info.pos = cc.p(self.scroll_view:getPosition())
        scrollview_info.size = self.scroll_view:getContentSize()
        scrollview_info.ipos = self.scroll_view:getInnerContainerPosition()
        scrollview_info.isize = self.scroll_view:getInnerContainerSize()
        scrollview_info.cpos = cc.p(scrollview_info.size.width/2, scrollview_info.size.height/2)
        scrollview_info.msize = {width=scrollview_info.isize.width-scrollview_info.size.width, height=scrollview_info.isize.height-scrollview_info.size.height}
 
        -- dump(scrollview_info)
        local posx, posy = focus_x, focus_y
        -- cell 底部在中间的Y值
        local scroll_pos_y = posy - (scrollview_info.size.height - scrollview_info.cpos.y)
        if scroll_pos_y > 0 then 
            local scroll_percent =  100 - scroll_pos_y*100/scrollview_info.msize.height
            if scroll_percent>0 then 
                self.scroll_view:jumpToPercentVertical(scroll_percent) 
            else
                self.scroll_view:jumpToPercentVertical(0) 
            end
        else
            self.scroll_view:jumpToPercentVertical(100)
        end       
    end
    self:Update()
end

function CScrollViewUI:HasCellOutsideInFront()
	if self.scroll_view:getDirection() == CScrollViewUI.SCROLLVIEW_DIR.SCROLLVIEW_DIR_HORIZONTAL  then
      return self.scroll_view:getInnerContainerPosition().x < 0
    else
      return (self.scroll_view:getInnerContainerPosition().y + 
        self.scroll_view:getInnerContainerSize().height) > 
        self.scroll_view:getContentSize().height
    end
end

function CScrollViewUI:HasCellOutsideInBack()
    if self.scroll_view:getDirection() == CScrollViewUI.SCROLLVIEW_DIR.SCROLLVIEW_DIR_HORIZONTAL  then
      return (self.scroll_view:getInnerContainerPosition().x + 
        self.scroll_view:getInnerContainerSize().width) > 
        self.scroll_view:getContentSize().width
    else
      return self.scroll_view:getInnerContainerPosition().y < 0
    end
end

function CScrollViewUI:SwitchDrawer(cell, config)
    
    -- 非配置界面无法实现抽屉效果;
    if cell.widget_type ~= dxm.CBaseUI.WidgetType.config then
        return
    end

    -- 关闭当前抽屉;
    if self.current_drawer_cell then
        self:_OpenDrawer(self.current_drawer_cell, self.old_drawer_config, false)
    end

    -- 当前抽屉与要打开的抽屉是否相同;
    if self.current_drawer_cell == cell then
        self.current_drawer_cell = nil
        self.old_drawer_config = nil
    else
        self.current_drawer_cell = cell
        self.old_drawer_config = cell.widget_config
        self:_OpenDrawer(cell, config, true)  
    end 
end

function CScrollViewUI:_OpenDrawer(cell, config, scroll)

    -- 非配置界面无法实现抽屉效果;
    if cell == nil and cell.widget_type ~= dxm.CBaseUI.WidgetType.config then
        return
    end
    
    local old_size = cell:GetContentSize()
    cell:RemoveFromParent()
    cell.widget_config = config
    self:FocusShow(cell, scroll, old_size) 
end

-- cell 在显示区域中显示;
-- scroll 是否滚动到对应 cell;
-- old_size 老的大小;
function CScrollViewUI:FocusShow(cell, scroll, old_size)

    if not cell then return end

    old_size = old_size or {width=0, height=0}

    local old_scrollview_info = { }
    old_scrollview_info.pos = cc.p(self.scroll_view:getPosition())
    old_scrollview_info.size = self.scroll_view:getContentSize()
    old_scrollview_info.ipos = self.scroll_view:getInnerContainerPosition()
    old_scrollview_info.isize = self.scroll_view:getInnerContainerSize()
    old_scrollview_info.cpos = cc.p(old_scrollview_info.size.width / 2, old_scrollview_info.size.height / 2)
    old_scrollview_info.msize = { width = old_scrollview_info.isize.width - old_scrollview_info.size.width, height = old_scrollview_info.isize.height - old_scrollview_info.size.height }
 
    self:_InitPosition()

    local cell_left = cell.position.x
    local cell_width = cell:GetContentSize().width
    local cell_right = cell.position.x + cell_width

    local cell_bottom = cell.position.y
    local cell_height = cell:GetContentSize().height
    local cell_top = cell.position.y + cell_height
    if self.scroll_view:getDirection() == CScrollViewUI.SCROLLVIEW_DIR.SCROLLVIEW_DIR_HORIZONTAL then
        local scrollview_info = { }
        scrollview_info.pos = cc.p(self.scroll_view:getPosition())
        scrollview_info.size = self.scroll_view:getContentSize()
        scrollview_info.ipos = self.scroll_view:getInnerContainerPosition()
        scrollview_info.isize = self.scroll_view:getInnerContainerSize()
        scrollview_info.cpos = cc.p(scrollview_info.size.width / 2, scrollview_info.size.height / 2)
        scrollview_info.msize = { width = scrollview_info.isize.width - scrollview_info.size.width, height = scrollview_info.isize.height - scrollview_info.size.height }
 
        local posx, posy = focus_x, focus_y
        local scroll_pos_x = posx - scrollview_info.cpos.x
        if scroll_pos_x > 0 then 
            local scroll_percent = scroll_pos_x*100/scrollview_info.msize.width
            if scroll_percent<100 then 
                self.scroll_view:jumpToPercentHorizontal(scroll_percent) 
            else
                self.scroll_view:jumpToPercentHorizontal(100) 
            end
        else
            self.scroll_view:jumpToPercentHorizontal(0)
        end           
    else
        local scrollview_info = { }
        scrollview_info.pos = cc.p(self.scroll_view:getPosition())
        scrollview_info.size = self.scroll_view:getContentSize()
        scrollview_info.ipos = self.scroll_view:getInnerContainerPosition()
        scrollview_info.isize = self.scroll_view:getInnerContainerSize()
        scrollview_info.cpos = cc.p(scrollview_info.size.width / 2, scrollview_info.size.height / 2)
        scrollview_info.msize = { width = scrollview_info.isize.width - scrollview_info.size.width, height = scrollview_info.isize.height - scrollview_info.size.height }
 
        local old_scroll_pos_y = -old_scrollview_info.ipos.y - (old_size.height-cell_height)     
        if old_scroll_pos_y > 0 then 
            local scroll_percent =  100 - old_scroll_pos_y*100/scrollview_info.msize.height
            if scroll_percent>0 then 
                self.scroll_view:jumpToPercentVertical(scroll_percent) 
            else
                self.scroll_view:jumpToPercentVertical(0) 
            end            
        else
            self.scroll_view:jumpToPercentVertical(100)
        end 
        -- if true then return end

        scrollview_info.ipos = self.scroll_view:getInnerContainerPosition()

        local show_height = scrollview_info.size.height - self.fix_tail
        local show_bottom = - scrollview_info.ipos.y + self.fix_tail
        local show_top = show_bottom + show_height 
        if cell_bottom >= show_bottom and cell_bottom <= show_top and cell_top >= show_bottom and cell_top <= show_top then 
            return
        end
                
        if (cell_bottom >= show_bottom and cell_bottom <= show_top and cell_top > show_top) or (cell_height > show_height) then
            -- 顶部对齐
            cell_bottom = cell_top - show_height
        end
        
        local scroll_pos_y = cell_bottom - self.fix_tail
        if scroll_pos_y > 0 then 
            local scroll_percent =  100 - scroll_pos_y*100/scrollview_info.msize.height
            if scroll_percent>0 then 
                if scroll then
                    self.scroll_view:scrollToPercentVertical(scroll_percent, 0.5, true) 
                else
                    self.scroll_view:jumpToPercentVertical(scroll_percent) 
                end
            else
                if scroll then
                    self.scroll_view:scrollToPercentVertical(scroll_percent, 0.5, true) 
                else
                    self.scroll_view:jumpToPercentVertical(scroll_percent) 
                end
            end
            
        else
            if scroll then
                self.scroll_view:scrollToPercentVertical(100, 0.5, true) 
            else
                self.scroll_view:jumpToPercentVertical(100) 
            end
        end       
    end
    self:Update()
end



return CScrollViewUI

--endregion