-- region *.lua
-- Date
-- 此文件由[BabeLua]插件自动生成



dxm.CSpineButtonUI = class("dxm.CSpineButtonUI", dxm.CBaseUI)
local CSpineButtonUI = dxm.CSpineButtonUI

function CSpineButtonUI:ctor()
    CSpineButtonUI.super.ctor(self)
end

function CSpineButtonUI:Init(spine_name, touch_widget, flip)

    self.flip = flip or false
    self.spine_name = spine_name
    self.touch_widget = touch_widget
    return CSpineButtonUI.super.Init(self)
end

function CSpineButtonUI:Create(...)

    local ui = CSpineButtonUI.new()
    if ui == nil or ui:Init(...) == false then
        return nil
    end
    return ui
end

function CSpineButtonUI:onEnter( )
    self.animation = sSpineUtils:CreateWidgetAnimation(self.spine_name, true)
    if self.animation then     

        self.widget:addChild(self.animation) 
        
        local function TouchEvent(sender, eventType)
            if eventType == ccui.TouchEventType.began then
                -- print("Touch Down")
                self.animation:setAnimation(0, "button_click_down", false)
                self.animation:addAnimation(0, "button_down_persist", true)
            elseif eventType == ccui.TouchEventType.moved then
                -- print("Touch Move")
            elseif eventType == ccui.TouchEventType.ended then
                -- print("Touch Up")
                self.animation:setAnimation(0, "button_click_up", false)
                self.animation:addAnimation(0, "button_idle", true)
                if callback then callback() end
            elseif eventType == ccui.TouchEventType.canceled then
                -- print("Touch Cancelled")
                self.animation:setAnimation(0, "button_click_up", false)
                self.animation:addAnimation(0, "button_idle", true)
            end
        end


        self.touch_widget:addTouchEventListener(TouchEvent)
        self.touch_widget:setTouchEnabled(true)
        self.animation:addAnimation(0, "button_idle", true)
        if self.flip then
            self.animation:setScale(-1, 1)
        end
    end
end

function CSpineButtonUI:onExit( )
    if self.animation then self.animation:removeFromParent() end
end

return CSpineButtonUI

--endregion