-- region *.lua
-- Date
-- 此文件由[BabeLua]插件自动生成



dxm.CSpineUI = class("dxm.CSpineUI", dxm.CBaseUI)
local CSpineUI = dxm.CSpineUI

function CSpineUI:ctor()
    CSpineUI.super.ctor(self)
end

function CSpineUI:Init(spine_name, ...)

    self.spine_name = spine_name
    self.animation_name_list = {...}
    if not cc.FileUtils:getInstance():fullPathForFilename(self.spine_name) then
        return false
    end
    return CSpineUI.super.Init(self)
end

function CSpineUI:Create(...)

    local ui = CSpineUI.new()
    if ui == nil or ui:Init(...) == false then
        return nil
    end
    return ui
end

function CSpineUI:onEnter( )
    self.spine = sSpineUtils:CreateWidgetAnimation(self.spine_name, true)
    if self.spine then 
        local animation_count = #self.animation_name_list
        if animation_count == 1 then
            self.spine:setAnimation(0, self.animation_name_list[1], true)
        elseif animation_count > 1 then
            for i=1, animation_count do 
                if i == animation_count then
                    self.spine:addAnimation(0, self.animation_name_list[i], true)
                else
                    self.spine:addAnimation(0, self.animation_name_list[i], false)
                end
            end
        end
        self.widget:addChild(self.spine) 
    end
end

function CSpineUI:onExit( )
    if self.spine then self.spine:removeFromParent() end
end

function CSpineUI:Play(animation_list, loop_last_animation, callback)
    
    if loop_last_animation == nil then
        loop_last_animation = true
    end
    local animation_list_size = #animation_list
    if self.spine and animation_list_size>0 then

        for key, animation in ipairs(animation_list) do
            if key == 1 then
                if animation_list_size == 1 then
                    self.spine:setAnimation(0, animation_list[1], loop_last_animation)
                else
                    self.spine:setAnimation(0, animation_list[1], false)
                end
            elseif key ~= animation_list_size then                
                self.spine:addAnimation(0, animation, false)
            else
                self.spine:addAnimation(0, animation, loop_last_animation)
            end
        end

        local run_times = 1
        self.spine:setCompleteListener( function(trackIndex, loopCount)      
              
            if callback then callback(run_times, animation_list[run_times]) end 
            if run_times <= animation_list_size then
                self.spine:setCompleteListener(function() end)
            else
                run_times = run_times + 1
            end
        end)
    else
        if callback then callback(0) end
    end
end

return CSpineUI

--endregion