-- region *.lua
-- Date
-- 此文件由[BabeLua]插件自动生成

require "dxm.ui.prefab.update.update_utils"

cc.exports.update = cc.exports.update or {}

update.CUpdateCtrl = { }
cc.exports.sUpdateCtrl = update.CUpdateCtrl

local CUpdateCtrl = update.CUpdateCtrl

function CUpdateCtrl:Init()  

    require "dxm.init"

    -- branch 是提供 win32 开发测试使用的;
    local branch_name = sLocale:GetBranchName()  
    local search_paths = {}
    -- ""
    search_paths[#search_paths+1] = device.writablePath.."patch/" 
    if branch_name then search_paths[#search_paths+1] = "branches/"..branch_name.."/" end
    -- search_paths[#search_paths+1] = ""
    -- "src/
    search_paths[#search_paths+1] = device.writablePath.."patch/src/" 
    if branch_name then search_paths[#search_paths+1] = "branches/"..branch_name.."/src/" end
    search_paths[#search_paths+1] = "src/" 
    cc.FileUtils:getInstance():setSearchPaths(search_paths)

    -- 加载基本配置;
    assets.version = sJsonUtils:Load("version.manifest")

    sLocale:SetLocale()

    math.randomseed(sTimeUtils:Now())  
    sSpineUtils:SetCacheEnable(true)

end

function CUpdateCtrl:StartUpdate(complete_callback)

    -- 询问是否更新;
    cc.exports.dxm = dxm or {}
    cc.exports.config = config or {}
    config.http_url = config.http_url or "http://community.73776.com/index.php"
    config.game_id = config.game_id or "default_game"

    require "dxm.base.event"
    require "dxm.base.list"
    require "dxm.system.http_request"
    require "dxm.utils.third_platform_utils"
    require "dxm.ccext.visible_rect"
    
    -- 添加请求时闪屏，防止请求过久黑屏问题
    local scene = cc.Scene:create()
    require("dxm.ui.prefab.update.update_app"):create():run(scene)  
    local sprite = cc.Sprite:create("res/images/logo/background.png")
    if sprite then
        scene:addChild(sprite, 100000)
        sprite:setAnchorPoint(cc.p(0.5, 0.5))
        sprite:setPosition(dxm.VisibleRect:center())
    end

    local updated = false
    local http_request = dxm.CHttpRequest.new()
    local url = config.http_url.."/Sdk/index/"
    local platform = sThirdPlatformUtils:GetState("platform_id")
    print("request force update")

    http_request:Request(url, "GetFunctionListWithoutSession", 
        "platform="..platform.."&GameID="..config.game_id,
        function(code, data)  
            print("request force update", platform, config.game_id, updated)
            if updated == true then return end
            print("request force update begin")

            local  force_update = false
            if code == 0 then
                for key, value in pairs(data.function_list) do
                    if value.id == "8" then
                        force_update = (value.value=="true")
                    end
                end
            end
            package.loaded["dxm.base.event"] = nil
            package.loaded["dxm.base.list"] = nil
            package.loaded["dxm.system.http_request"] = nil
            package.loaded["dxm.utils.third_platform_utils"] = nil      
            package.loaded["dxm.ccext.visible_rect"] = nil     
            package.loaded["dxm.ui.prefab.update.update_app"] = nil          
            self:_Update(force_update, complete_callback)
            updated = true
        end)

    -- 1秒如果不能获得信息则直接进入静默更新;
    --[[
    ]]--
    local entry        
	entry = cc.Director:getInstance():getScheduler():scheduleScriptFunc(function()                
        cc.Director:getInstance():getScheduler():unscheduleScriptEntry(entry)
        if updated == true then return end
        print("request force update timeout")
        package.loaded["dxm.base.event"] = nil
        package.loaded["dxm.base.list"] = nil
        package.loaded["dxm.system.http_request"] = nil
        package.loaded["dxm.utils.third_platform_utils"] = nil      
        package.loaded["dxm.ccext.visible_rect"] = nil     
        package.loaded["dxm.ui.prefab.update.update_app"] = nil  
        self:_Update(false, complete_callback)
        updated = true
	end, 2, false)
end

function CUpdateCtrl:_Update(force_update, complete_callback)
    if force_update == true then

        sUpdateUtils:Init()
        self:Init()
        local scene = dxm.CBaseScene:Create()
        require("dxm.ui.prefab.update.update_app"):create():run(scene)   

        -- dxm.audio:playMusic(assets.sound.config.main_music, true)

        -- 更新下载库;
        cc.Director:getInstance():getScheduler():scheduleScriptFunc(function()
            dios.CApp:GetInstancePtr():RunOnce()
	    end, 0, false)

        self:_StartUpdate(complete_callback)
    else 
        require "dxm.init"
        sUpdateSystem:Init()
        self:Init()
        cc.Director:getInstance():getScheduler():scheduleScriptFunc(function()
            dios.CApp:GetInstancePtr():RunOnce()
	    end, 0, false)
        if complete_callback then complete_callback() end
    end
end

-- 开始更新;
function CUpdateCtrl:_StartUpdate(complete_callback)

    sUI:Open("dxm.ui.prefab.update.update_ui", function() 
        for k, v in pairs(package.loaded) do
            local sub = string.sub(k, 1, 3)
            if sub == "dxm" or sub == "app" or sub == "con" then
                package.loaded[k] = nil
            end
        end
        self:Init()
        if complete_callback then complete_callback() end
    end)
end

return CUpdateCtrl

-- endregion
