-- region *.lua
-- Date
-- 此文件由[BabeLua]插件自动生成

require "dxm.ui.prefab.update.update_utils"



update.CUpdateUI = class("update.CUpdateUI", dxm.CSystemDialogUI)

local CUpdateUI = update.CUpdateUI

function CUpdateUI:ctor()
    CUpdateUI.super.ctor(self)

    self.percent = 0
    self.percent_display = 0 
    self.completed = false
    self.show_label_percent = false

    self.update_percent = 0
end

function CUpdateUI:LoadWidget(config)

    sLocale:SetLocale()

    local locale_csb_file = "ccs/ccs-" ..sLocale.locale_name.."/"..config..".csb"
	
    local fullpath = cc.FileUtils:getInstance():fullPathForFilename(locale_csb_file)
    if cc.FileUtils:getInstance():isFileExist(fullpath) then
         self.config = locale_csb_file 
    else
         self.config = "ccs/"..config..".csb"
    end

    local file = self.config
    local node = cc.CSLoader:createNode(file)
    if node ==nil then
        print("[CWidgetCache] widgetFromJsonFile ", self.config, " failed")
        return nil
    end

    local action = cc.CSLoader:createTimeline(file)
    local name = node:getName()

    -- 重新建一个 widget的 node
    local new_node = ccui.Widget:create()
    new_node:setLayoutComponentEnabled(true)
    new_node:setAnchorPoint(cc.p(0, 0))
	new_node:setCascadeOpacityEnabled(true)
    new_node:setCascadeColorEnabled(true)
    local childs = node:getChildren()
    for _, v in pairs(childs) do 
        v:removeFromParent()
    end 

    for _, v in pairs(childs) do 
        new_node:addChild(v)
    end

    -- 自适应代码
    if name~="Layer" and name~="Node" then
        new_node:setContentSize(cc.size(display.width,display.height))
        ccui.Helper:doLayout(new_node)
    else
        new_node:setContentSize(node:getContentSize())
    end

    node = new_node
    return {name=self.name, widget=node, action=action}
end

function CUpdateUI:Init(complete_callback)

    self.complete_callback = complete_callback 
    self.my_csd = "csd/Common/Load2"

    local cache_node = self:LoadWidget(self.my_csd)
    if cache_node == nil then
        return
    end
    
    local action = cache_node.action
    local widget = cache_node.widget
    widget:runAction(action)

    -- 初始化界面;
    widget:setVisible(true)
    widget:setOpacity(255)
    widget:setColor(cc.c3b(255, 255, 255))
    widget:setAnchorPoint(cc.p(0, 0))
    widget:setPosition(cc.p(0, 0))
    widget:setScale(1.0)
    widget:setRotation(0)
    widget:setPosition(cc.p(0, 0))

    return self:InitWithWidget(widget)
end

function CUpdateUI:Create(...)

    local ui = CUpdateUI.new()
    if ui == nil or ui:Init(...) == false then
        return nil
    end
    
    return ui
end

function CUpdateUI:onEnter()

    self.percent = 0

    local entry
	entry = cc.Director:getInstance():getScheduler():scheduleScriptFunc(function()
        self:_Update()
        if self.completed then             
            cc.Director:getInstance():getScheduler():unscheduleScriptEntry(entry)
            local complete_callback = self.complete_callback
            self:Close()
            if complete_callback then complete_callback() end
        end
	end, 0, false)   


    sUpdateUtils:Start(function(state, done, total)
            self.update_percent = math.floor(done / total * 10000)
        end)

    sActionUtils:Delay(0.1, function()
            sUpdateUtils:CheckVersion()
        end)

    self:_SetUIStrings(self.my_csd)
    self:_DoUIScript(self.my_csd)
    self:_Update()
    self:SetLabelText(assets.tips:Get(), "AtlasLabelLoadTip")
    -- self:SetLabelText(sStringUtils:GetString("@config_update"), "AtlasLabelLoadTip")
end

function CUpdateUI:_UpdatePercent()

    if sUpdateUtils.state == sUpdateUtils.update_state_version_check then
        self.percent = 0
        self.update_percent = 0
    elseif sUpdateUtils.state == sUpdateUtils.update_state_version_checking then

        if self.percent < 10000 then
            self.percent = self.percent + 10
            if self.percent >10000 then
                self.percent = 10000
            end
        end
        
        if self.percent_display == 10000 then
            self:_Complete() -- !!! check version timeout;
        end
    elseif sUpdateUtils.state == sUpdateUtils.update_state_files_check then
        if self.percent_display ~= 10000 then 
            self.percent = 10000 
        end

        if self.percent_display == 10000 then
            -- to check files;
            sUpdateUtils:CheckFiles()
        end
    elseif sUpdateUtils.state == sUpdateUtils.update_state_files_checking then

        if self.percent < 10000 then
            self.percent = self.percent + 10
            if self.percent >10000 then
                self.percent = 10000
            end
        end
    elseif sUpdateUtils.state == sUpdateUtils.update_state_patch then
        if self.percent ~= 10000 then
            self.percent = 10000
        end
        if self.percent_display == 10000 then
            -- to download patch;
            self.percent = 0
            self.update_percent = 0
            if self.is_yys == true then
                self:SetLabelText(sStringUtils:GetString("@config_update"), "AtlasLabelLoadTip")
            end
            sUpdateUtils:DownloadPatch()
        end
    elseif sUpdateUtils.state == sUpdateUtils.update_state_patching then
        self.percent = self.update_percent

    elseif sUpdateUtils.state == sUpdateUtils.update_state_end then
        if self.percent ~= 10000 then
            self.percent = 10000
        end
        if self.percent_display == 10000 then
            self:_Complete() -- !!! update end
        end
    end
end 

function CUpdateUI:_Update()    

    self:_UpdatePercent()
    
    if self.percent_display > self.percent then
        self.percent_display = 0
    elseif self.percent_display < 10000 then
        local delta = 50000
        if self.percent < 10000 then
            delta = self.percent - self.percent_display
        end
        self.percent_display = self.percent_display + math.floor(delta/100)
        if self.percent_display > 10000 then
            self.percent_display = 10000
        end
    end

    local percent = math.floor(self.percent_display/100)
    self:SetLoadingbarPercent(percent, "LoadingBar")
    self:SetAtlasLabelText(""..percent.."%", "AtlasLabelLoad")
end

function CUpdateUI:onExit()

end

function CUpdateUI:_Complete()
    sUpdateUtils:Stop()
    self.completed = true    
end


return CUpdateUI

-- endregion
