-- region NewFile_1.lua
-- Author : IBM
-- Date   : 2015/4/27
-- 此文件由[BabeLua]插件自动生成

dxm.CActionUtils = {}
cc.exports.sActionUtils = dxm.CActionUtils
local CActionUtils = dxm.CActionUtils

function CActionUtils:UIPopup(node, end_callback)

    if not node then
        return
    end

    node:stopAllActions()

    -- 锚点居中;
    node:setAnchorPoint(cc.p(0, 0))
    node:setPosition(cc.p(0, 0))
    node:setAnchorPoint(cc.p(0.5, 0.5))
    local x = node:getPositionX() + node:getContentSize().width / 2
    local y = node:getPositionY() + node:getContentSize().height / 2
    node:setPosition(cc.p(x, y))

    local base_point_x = node:getPositionX()
    local base_point_y = node:getPositionY()

    -- 初始帧;		
    node:setScale(0);
    node:setPosition((cc.p(base_point_x, base_point_y)))

    local actions = {}
    actions[#actions + 1] = cc.Spawn:create(cc.ScaleTo:create(0.21, 0.73, 1.44))
    actions[#actions + 1] = cc.Spawn:create(cc.ScaleTo:create(0.1, 1.13, 1.30))
    actions[#actions + 1] = cc.Spawn:create(cc.ScaleTo:create(0.06, 1.33, 0.88))
    actions[#actions + 1] = cc.Spawn:create(cc.ScaleTo:create(0.06, 0.93, 1.07))
    actions[#actions + 1] = cc.Spawn:create(cc.ScaleTo:create(0.06, 1, 1))

    if begin_callback then begin_callback() end
    
    actions[#actions + 1] = cc.CallFunc:create( function()
        if end_callback then end_callback() end
    end )

    local action = cc.Sequence:create(actions);
    node:runAction(action)
end

function CActionUtils:Shake(node, end_callback)
    if not node then
        return
    end

    node:stopAllActions()

    local actions = {}
    actions[#actions + 1] = cc.Spawn:create(cc.ScaleTo:create(0.21, 0.9, 1.1))
    actions[#actions + 1] = cc.Spawn:create(cc.ScaleTo:create(0.1, 1, 1.05))
    actions[#actions + 1] = cc.Spawn:create(cc.ScaleTo:create(0.06, 1.1, 0.9))
    actions[#actions + 1] = cc.Spawn:create(cc.ScaleTo:create(0.06, 0.95, 1.1))
    actions[#actions + 1] = cc.Spawn:create(cc.ScaleTo:create(0.06, 1.05, 0.95))
    actions[#actions + 1] = cc.Spawn:create(cc.ScaleTo:create(0.06, 1, 1))
    actions[#actions + 1] = cc.CallFunc:create( function()
        if end_callback then end_callback() end
    end )

    local action = cc.Sequence:create(actions);
    node:runAction(action)
end

function CActionUtils:ShakeLoop(node, min, max)

    if not node then
        return
    end

    node:stopAllActions()
    node:setScale(1)

    min = min or 1
    max = max or 3
    local function RandomDelayAction()
        local actions = {}
        actions[#actions + 1] = cc.DelayTime:create(math.random(min, max))
        actions[#actions + 1] = cc.CallFunc:create( function()
            self:Shake(node, function() RandomDelayAction() end)
        end )
        local action = cc.Sequence:create(actions);
        node:runAction(action)
    end

    RandomDelayAction()
end

function CActionUtils:BalloonLoop(node, index)

    if not node then
        return
    end

    node:stopAllActions()
--    node:setScale(1)

    local function BalloonAction()
        local actions = {}
        
        if index == 1 then
            actions[#actions + 1] = cc.Spawn:create(cc.MoveBy:create(0.9, cc.p(3, -3)))
            actions[#actions + 1] = cc.Spawn:create(cc.MoveBy:create(0.9, cc.p(5, 5)))
            actions[#actions + 1] = cc.Spawn:create(cc.MoveBy:create(0.9, cc.p(2, 4)))
            actions[#actions + 1] = cc.Spawn:create(cc.MoveBy:create(0.9, cc.p(4, 1)))
            actions[#actions + 1] = cc.Spawn:create(cc.MoveBy:create(0.9, cc.p(4, 3)))
            actions[#actions + 1] = cc.Spawn:create(cc.MoveBy:create(0.9, cc.p(-3, 3)))
            actions[#actions + 1] = cc.Spawn:create(cc.MoveBy:create(0.9, cc.p(-5, 0)))
            actions[#actions + 1] = cc.Spawn:create(cc.MoveBy:create(0.9, cc.p(-4, -4)))
            actions[#actions + 1] = cc.Spawn:create(cc.MoveBy:create(0.9, cc.p(-4, -3)))
            actions[#actions + 1] = cc.Spawn:create(cc.MoveBy:create(0.9, cc.p(-2, -6)))
            actions[#actions + 1] = cc.CallFunc:create( function() BalloonAction() end)
        elseif index == 2 then
            actions[#actions + 1] = cc.Spawn:create(cc.MoveBy:create(0.9, cc.p(-3, 3)))
            actions[#actions + 1] = cc.Spawn:create(cc.MoveBy:create(0.9, cc.p(-5, 0)))
            actions[#actions + 1] = cc.Spawn:create(cc.MoveBy:create(0.9, cc.p(-4, -4)))
            actions[#actions + 1] = cc.Spawn:create(cc.MoveBy:create(0.9, cc.p(-4, -3)))
            actions[#actions + 1] = cc.Spawn:create(cc.MoveBy:create(0.9, cc.p(-2, -6)))
            actions[#actions + 1] = cc.Spawn:create(cc.MoveBy:create(0.9, cc.p(3, -3)))
            actions[#actions + 1] = cc.Spawn:create(cc.MoveBy:create(0.9, cc.p(5, 5)))
            actions[#actions + 1] = cc.Spawn:create(cc.MoveBy:create(0.9, cc.p(2, 4)))
            actions[#actions + 1] = cc.Spawn:create(cc.MoveBy:create(0.9, cc.p(4, 1)))
            actions[#actions + 1] = cc.Spawn:create(cc.MoveBy:create(0.9, cc.p(4, 3)))    
            actions[#actions + 1] = cc.CallFunc:create( function() BalloonAction() end)
        elseif index == 3 then
            actions[#actions + 1] = cc.Spawn:create(cc.MoveBy:create(0.9, cc.p(4, 1)))
            actions[#actions + 1] = cc.Spawn:create(cc.MoveBy:create(0.9, cc.p(4, 3))) 
            actions[#actions + 1] = cc.Spawn:create(cc.MoveBy:create(0.9, cc.p(3, -3)))
            actions[#actions + 1] = cc.Spawn:create(cc.MoveBy:create(0.9, cc.p(5, 5)))
            actions[#actions + 1] = cc.Spawn:create(cc.MoveBy:create(0.9, cc.p(2, 4)))
            actions[#actions + 1] = cc.Spawn:create(cc.MoveBy:create(0.9, cc.p(-3, 3)))
            actions[#actions + 1] = cc.Spawn:create(cc.MoveBy:create(0.9, cc.p(-5, 0)))
            actions[#actions + 1] = cc.Spawn:create(cc.MoveBy:create(0.9, cc.p(-4, -4)))
            actions[#actions + 1] = cc.Spawn:create(cc.MoveBy:create(0.9, cc.p(-4, -3)))
            actions[#actions + 1] = cc.Spawn:create(cc.MoveBy:create(0.9, cc.p(-2, -6)))          
            
            actions[#actions + 1] = cc.CallFunc:create( function() BalloonAction() end)
        end
        
        local action = cc.Sequence:create(actions);
        node:runAction(action)
    end

    BalloonAction()
end


function CActionUtils:NumberScaleAppear(node, end_callback)
    if not node then
        return
    end

    node:stopAllActions()
    node:setScale(4)
    node:setOpacity(0)

    local actions = {}
    actions[#actions + 1] = cc.Spawn:create(cc.EaseOut:create(cc.ScaleTo:create(0.5, 1), 2), cc.FadeIn:create(0.5))
    actions[#actions + 1] = cc.CallFunc:create( function()
        if end_callback then end_callback() end
    end )

    local action = cc.Sequence:create(actions);
    node:runAction(action)
end

function CActionUtils:ClickDown(node, end_callback)
    if not node then
        return
    end

    node:stopAllActions()

    local actions = {}
    actions[#actions + 1] = cc.Spawn:create(cc.ScaleTo:create(0.1, 0.9, 0.9))
    actions[#actions + 1] = cc.CallFunc:create( function()
        if end_callback then end_callback() end
    end )

    local action = cc.Sequence:create(actions);
    node:runAction(action)
end

function CActionUtils:ClickUp(node, end_callback)
    if not node then
        return
    end

    node:stopAllActions()
    node:setScale(0.8)

    local actions = {}
    actions[#actions + 1] = cc.Spawn:create(cc.ScaleTo:create(0.05, 1.1, 1.1))
    actions[#actions + 1] = cc.Spawn:create(cc.ScaleTo:create(0.05, 1, 1.05))
    -- actions[#actions + 1] = cc.Spawn:create(cc.ScaleTo:create(0.06, 1.1, 0.9))
    -- actions[#actions + 1] = cc.Spawn:create(cc.ScaleTo:create(0.06, 0.95, 1.1))
    -- actions[#actions + 1] = cc.Spawn:create(cc.ScaleTo:create(0.06, 1.05, 0.95))
    actions[#actions + 1] = cc.Spawn:create(cc.ScaleTo:create(0.03, 1, 1))
    actions[#actions + 1] = cc.CallFunc:create( function()
        if end_callback then end_callback() end
    end )

    local action = cc.Sequence:create(actions);
    node:runAction(action)
end


function CActionUtils:Warning(node)
    if not node then
        return
    end

    node:stopAllActions()
    node:setScale(1)

    local actions = {}
    actions[#actions + 1] = cc.Spawn:create(cc.TintTo:create(0.2, cc.c3b(255, 0, 0)), cc.ScaleTo:create(0.2, 1.4))
    actions[#actions + 1] = cc.Spawn:create(cc.TintTo:create(0.2, cc.c3b(255, 255, 255)), cc.ScaleTo:create(0.2, 1))

    local action = cc.RepeatForever:create(cc.Sequence:create(actions))

    node:runAction(action)
end

function CActionUtils:Delay(time, callback, ref_node)
    
    if ref_node then ref_node:retain() end
    local entry        
	entry = cc.Director:getInstance():getScheduler():scheduleScriptFunc(function()        
        cc.Director:getInstance():getScheduler():unscheduleScriptEntry(entry)
		if (not ref_node or ref_node:isRunning()) and callback then callback() end
        if ref_node then ref_node:release() end
	end, time, false)
end


function CActionUtils:Popup(node, end_callback)

    if not node then
        return
    end

    node:stopAllActions()

    -- 初始帧;		
    node:setScale(0);

    local actions = {}
    actions[#actions + 1] = cc.Spawn:create(cc.ScaleTo:create(0.06, 0.73))
    actions[#actions + 1] = cc.Spawn:create(cc.ScaleTo:create(0.06, 1.13))
    actions[#actions + 1] = cc.Spawn:create(cc.ScaleTo:create(0.06, 1.33))
    actions[#actions + 1] = cc.Spawn:create(cc.ScaleTo:create(0.06, 0.93))
    actions[#actions + 1] = cc.Spawn:create(cc.ScaleTo:create(0.06, 1))
    
    actions[#actions + 1] = cc.CallFunc:create( function()
        if end_callback then end_callback() end
    end )

    local action = cc.Sequence:create(actions);
    node:runAction(action)
end

function CActionUtils:Popdown(node, end_callback)

    if not node then
        return
    end

    node:stopAllActions()

    local actions = {}
    actions[#actions + 1] = cc.Spawn:create(cc.ScaleTo:create(0.06, 1.33))
    actions[#actions + 1] = cc.Spawn:create(cc.ScaleTo:create(0.06, 1.13))
    actions[#actions + 1] = cc.Spawn:create(cc.ScaleTo:create(0.06, 1))
    actions[#actions + 1] = cc.Spawn:create(cc.ScaleTo:create(0.06, 0.93))
    actions[#actions + 1] = cc.Spawn:create(cc.ScaleTo:create(0.06, 0.73))
    
    actions[#actions + 1] = cc.CallFunc:create( function()
        if end_callback then end_callback() end
    end )

    local action = cc.Sequence:create(actions);
    node:runAction(action)
end


return CActionUtils

-- endregion
