-- region *.lua
-- Date
-- 此文件由[BabeLua]插件自动生成

dxm.CJsonUtils = class("dxm.CJsonUtils")

cc.exports.sJsonUtils = dxm.CJsonUtils
local CJsonUtils = dxm.CJsonUtils

if cjson then
    json = {}
    local function jsontran(orig)
        local orig_type = type(orig)
        if orig_type == 'table' then
            for orig_key, orig_value in next, orig, nil do
                orig[jsontran(orig_key)] = jsontran(orig_value)
            end
            -- setmetatable(copy, deepcopy(getmetatable(orig)))
        else -- number, string, boolean, etc
            if orig == cjson.null then            
                orig = nil
            end
        end
        return orig
    end

    function json.decode(value)
        return jsontran(cjson.decode(value))
    end

    function json.encode(value)
        return cjson.encode(value)
    end
end

function CJsonUtils:Encode(values)

    if type(values) ~= "table" then
        return "{}"
    end
       
    local contents = json.encode(values)
    if type(contents) == "string" then
        return contents
    end
    return "{}"
end

function CJsonUtils:Decode(contents)

    if contents and #contents ~= 0 then 
        local values = json.decode(contents)
        if type(values) == "table" then
            return values
        end
    end
    return {}
end


function CJsonUtils:Load(file)

    local fullpath = cc.FileUtils:getInstance():fullPathForFilename(file)

    local file = sFileUtils:Read(fullpath)
    if not file then
        return {}
    end

    local contents = file:GetString()
    if #contents ~= 0 then 
        local values = json.decode(contents)
        if type(values) == "table" then
            return values
        end
    end
    return {}
end


function CJsonUtils:Save(file, values)

    if type(values) ~= "table" then
        return false
    end
    local filename = file
    local ret = false
    local s = json.encode(values)
    if type(s) == "string" then
        if device.platform == "windows" then
            ret = sFileUtils:Write(filename, s)
        else
            ret = sFileUtils:WriteSafe(filename, s)
        end
    end
    return ret
end


return CJsonUtils

-- endregion
