--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

dxm = dxm or {}
dxm.CShaderUtils = {}
cc.exports.sShaderUtils = dxm.CShaderUtils
local CShaderUtils = dxm.CShaderUtils

local ccPositionTexture_vert = 
        "attribute vec4 a_position;\n"..
        "attribute vec2 a_texCoord;\n"..
        "attribute vec4 a_color;\n"..

        "#ifdef GL_ES\n"..
        "varying lowp vec4 v_fragmentColor;\n"..
        "varying mediump vec2 v_texCoord;\n"..
        "#else\n"..
        "varying vec4 v_fragmentColor;\n"..
        "varying vec2 v_texCoord;\n"..
        "#endif\n"..

        "void main()\n"..
        "{\n"..
            "gl_Position = CC_PMatrix * a_position;\n"..
            "v_fragmentColor = a_color;\n"..
            "v_texCoord = a_texCoord;\n"..
        "}\n"

local ccPositionTexture_frag =
        "#ifdef GL_ES\n                                   "..
        "precision lowp float;\n                          "..
        "#endif\n                                         "..

        "varying vec2 v_texCoord;\n                       "..

        "void main()\n                                    "..
        "{\n                                              "..
            "gl_FragColor =  texture2D(CC_Texture0, v_texCoord);\n"..
        "}"

local gray_fshader = 
			"#ifdef GL_ES \n" ..  
                          "precision mediump float; \n" ..  
                            "#endif \n" ..  
                            "varying vec4 v_fragmentColor; \n" ..  
                            "varying vec2 v_texCoord; \n" ..  
                            "void main(void) \n" ..  
                            "{ \n" ..  
                             "vec4 c = texture2D(CC_Texture0, v_texCoord); \n" ..  
                            "gl_FragColor.rgb = vec3(0.4*c.r + 0.4*c.g +0.4*c.b); \n"..  
                            "gl_FragColor.a = c.a; \n"..  
                            "}"  

local gaussian_fshader =
"#ifdef GL_ES\n" ..  
"precision mediump float;\n" ..  
"#endif\n" ..  
"\n" ..  
"varying vec4 v_fragmentColor;\n" ..  
"varying vec2 v_texCoord;\n" ..  
"\n" ..  
"uniform vec2 resolution;\n" ..  
"uniform float blurRadius;\n" ..  
"uniform float sampleNum;\n" ..  
"\n" ..  
"vec3 blur(vec2);\n" ..  
"\n" ..  
"void main(void)\n" ..  
"{\n" ..  
"	vec3 col = blur(v_texCoord);\n" ..  
"	gl_FragColor = vec4(col, 1.0) * v_fragmentColor;\n" ..  
"}\n" ..  
"\n" ..  
"vec3 blur(vec2 p)\n" ..  
"{\n" ..  
"    if (blurRadius > 0.0 && sampleNum > 1.0)\n" ..  
"    {\n" ..  
"        vec3 col = vec3(0);\n" ..  
"        vec2 unit = 1.0 / resolution.xy;\n" ..  
"        \n" ..  
"        float r = blurRadius;\n" ..  
"        float sampleStep = r / sampleNum;\n" ..  
"        \n" ..  
"        float count = 0.0;\n" ..  
"        \n" ..  
"        for(float x = -r; x < r; x += sampleStep)\n" ..  
"        {\n" ..  
"            for(float y = -r; y < r; y += sampleStep)\n" ..  
"            {\n" ..  
"                float weight = (r - abs(x)) * (r - abs(y));\n" ..  
"                col += texture2D(CC_Texture0, p + vec2(x * unit.x, y * unit.y)).rgb * weight;\n" ..  
"                count += weight;\n" ..  
"            }\n" ..  
"        }\n" ..  
"        \n" ..  
"        return col / count;\n" ..  
"    }\n" ..  
"    \n" ..  
"    return texture2D(CC_Texture0, p).rgb;\n" ..  
"}"

function CShaderUtils:AddShader(node,vshader,fshader)
    if not node then
        return
    end

    if not vshader then
       vshader = ccPositionTexture_vert
    end
    
    if not fshader then
        fshader = ccPositionTexture_frag
    end

    local pProgram = cc.GLProgram:createWithByteArrays(vshader,fshader)  
    pProgram:bindAttribLocation(cc.ATTRIBUTE_NAME_POSITION,cc.VERTEX_ATTRIB_POSITION)  
    pProgram:bindAttribLocation(cc.ATTRIBUTE_NAME_COLOR,cc.VERTEX_ATTRIB_COLOR)  
    pProgram:bindAttribLocation(cc.ATTRIBUTE_NAME_TEX_COORD,cc.VERTEX_ATTRIB_FLAG_TEX_COORDS)  
    pProgram:link()  
    pProgram:updateUniforms()  
    node:setGLProgram(pProgram)
end

function CShaderUtils:AddDefaultShader(node)
    self:AddShader(node,ccPositionTexture_vert,ccPositionTexture_frag)
end

function CShaderUtils:AddGray(node)
	CShaderUtils:AddShader(node,nil,gray_fshader)
end

function CShaderUtils:AddGaussian(node)
    CShaderUtils:AddShader(node,ccPositionTexture_vert,gaussian_fshader)

    local pProgram = node:getGLProgram()
    local glprogramstate = cc.GLProgramState:getOrCreateWithGLProgram(pProgram)

    glprogramstate:setUniformVec2("resolution", cc.p(85,121));
    glprogramstate:setUniformFloat("blurRadius", 5);
    glprogramstate:setUniformFloat("sampleNum", 4);

    pProgram:updateUniforms()
end

function CShaderUtils:RemoveGray(node)
    CShaderUtils:AddDefaultShader(node)
end

return CShaderUtils
--endregion


--endregion
