-- region *.lua
-- Date
-- 此文件由[BabeLua]插件自动生成

dxm.CSpineUtils = { }
cc.exports.sSpineUtils = dxm.CSpineUtils

local CSpineUtils=dxm.CSpineUtils

function CSpineUtils:CreateNodeSkeletonAnimation(json_name, atlas_name, use_cache)
    use_cache = use_cache or true
    return spine.CSpineHelper:GetInstancePtr():CreateWidgetSkeletonAnimation(json_name, atlas_name, use_cache)
end

function CSpineUtils:CreateWidgetSkeletonAnimation(json_name, atlas_name, use_cache)
    use_cache = use_cache or true
    return spine.CSpineHelper:GetInstancePtr():CreateWidgetSkeletonAnimation(json_name, atlas_name, use_cache)
end

function CSpineUtils:Clear()
    spine.CSpineHelper:GetInstancePtr():Clear()
end

function CSpineUtils:SetCacheEnable(enable)
    spine.CSpineHelper:GetInstancePtr():set_cache_enable(enable)
end

function CSpineUtils:CreateWidgetAnimation(spine_name, use_cache, default_animation)
    use_cache = use_cache or true
    local spine_json = spine_name.."/skeleton.json"
    local spine_atlas = spine_name.."/skeleton.atlas"
    local animation = self:CreateWidgetSkeletonAnimation(spine_json, spine_atlas, use_cache)
    if default_animation~=nil then self:SetAnimation(animation, default_animation, true) end    
    return animation
end

function CSpineUtils:CreateNodeAnimation(spine_name, use_cache, default_animation)
    use_cache = use_cache or true
    local spine_json = spine_name.."/skeleton.json"
    local spine_atlas = spine_name.."/skeleton.atlas"
    local animation = self:CreateNodeSkeletonAnimation(spine_json, spine_atlas, use_cache)
    if default_animation~=nil then self:SetAnimation(animation, default_animation, true) end
    return animation
end

function CSpineUtils:SetAnimation(spine, animation_name, loop)
    if spine==nil then return end
    spine:setAnimation(0, animation_name, loop)
end

function CSpineUtils:AddAnimation(spine, animation_name, loop)
    if spine==nil then return end
    spine:addAnimation(0, animation_name, loop)
end

-- PlayEffect(spine, animation_name, callback, run_times, zorder)
-- PlayEffect(spine_name, animation_name, parent, x, y, callback, run_times, zorder)
function CSpineUtils:PlayEffect(...)
    
    local arg = {...}
    if tolua.type(arg[1]) == "string" then
        return self:_PlayNewEffect(...)
    else
        return self:_PlaySpineEffect(...)
    end
end

-- PlayFlyEffect(spine_name, animation_name, parent, duration, x, y, target_x, target_y, callback, zorder)
-- PlayFlyEffect(spine, animation_name, duration, x, y, target_x, target_y, callback, zorder)
function CSpineUtils:PlayFlyEffect(...)

    local arg = {...}
    if tolua.type(arg[1]) == "string" then
        return self:_PlayNewFlyEffect(...)
    else
        return self:_PlaySpineFlyEffect(...)
    end
end

function CSpineUtils:_PlayNewEffect(spine_name, animation_name, parent, x, y, callback, run_times, zorder)
    
    run_times = run_times or 1
    zorder = zorder or 10
    x = x or 0
    y = y or 0
    local spine = self:CreateWidgetAnimation(spine_name, true)
    if spine then
        spine:setAnimation(0, animation_name, false)
        spine:setCompleteListener( function(trackIndex, loopCount)
            if run_times <= loopCount then
                local a_spine_name = spine_name
                if callback then callback() end  
                spine:retain()
                spine:removeFromParent()
                -- 延后一帧干掉spine, 否则会崩溃哦,  ANIMATION_END 是在 update 执行, ANIMATION_END 中干掉自己后还会执行更新代码, 
                -- 导致更新时候数据已经被释放而崩溃
                local entry        
	            entry = cc.Director:getInstance():getScheduler():scheduleScriptFunc(function()
		            cc.Director:getInstance():getScheduler():unscheduleScriptEntry(entry)
		            -- spine:removeFromParent()
                    spine:release()
	            end, 0.01, false)
            else
                spine:setAnimation(0, animation_name, false)
            end
        end)
        parent:addChild(spine, zorder)
        spine:setPosition(cc.p(x, y))
    end
    return spine
end

function CSpineUtils:_PlayNewFlyEffect(spine_name, animation_name, parent, duration, x, y, target_x, target_y, callback, zorder)
    
    zorder = zorder or 10
    local spine = self:CreateWidgetAnimation(spine_name, true)
    if spine then
        spine:setAnimation(0, animation_name, true)       
        parent:addChild(spine, zorder)
        spine:setPosition(cc.p(x, y))

        local actions = {}
        actions[#actions+1] = cc.MoveTo:create(duration, cc.p(target_x, target_y))
        actions[#actions+1] = cc.CallFunc:create( function()
            if callback then callback() end
            spine:removeFromParent()
        end )
        local action= cc.Sequence:create(actions)
        spine:runAction(action)
    end
    return spine
end

function CSpineUtils:_PlaySpineEffect(spine, animation_name, callback, run_times, zorder)
    
    run_times = run_times or 1
    zorder = zorder or 10
    if spine then
        spine:setAnimation(0, animation_name, false)
        spine:setCompleteListener( function(trackIndex, loopCount)
            if run_times <= loopCount then
                spine:setCompleteListener(function() end)
                spine:retain()
                -- 延后一帧干掉spine, 否则会崩溃哦,  ANIMATION_END 是在 update 执行, ANIMATION_END 中干掉自己后还会执行更新代码, 
                -- 导致更新时候数据已经被释放而崩溃
                local entry        
	            entry = cc.Director:getInstance():getScheduler():scheduleScriptFunc(function()
		            cc.Director:getInstance():getScheduler():unscheduleScriptEntry(entry)
                    spine:release()
	            end, 0.01, false)
                if callback then callback() end 
            else
                spine:setAnimation(0, animation_name, false) 
            end
        end)
    end
    return spine
end

function CSpineUtils:_PlaySpineFlyEffect(spine, animation_name, duration, x, y, target_x, target_y, callback, zorder)
    
    zorder = zorder or 10
    if spine then
        spine:setAnimation(0, animation_name, true)       
        spine:setPosition(cc.p(x, y))

        local actions = {}
        actions[#actions+1] = cc.MoveTo:create(duration, cc.p(target_x, target_y))
        actions[#actions+1] = cc.CallFunc:create( function()
            if callback then callback() end
        end )
        local action= cc.Sequence:create(actions)
        spine:runAction(action)
    end
    return spine
end

return CSpineUtils

-- endregion
