-- region *.lua
-- Date
-- 此文件由[BabeLua]插件自动生成

dxm.CUIUtils = { }

local CUIUtils = dxm.CUIUtils
cc.exports.sUI = dxm.CUIUtils

-- 打开界面
function CUIUtils:Open(...)

    return dxm.UIHelper:Open(...)
end

function CUIUtils:Close(param)

    return dxm.UIHelper:Close(param)
end

function CUIUtils:OpenWithReplaceTop(...)

    return dxm.UIHelper:OpenWithReplaceTop(...)
end

function CUIUtils:OpenWithPushStack(...)

    return dxm.UIHelper:OpenWithPushStack(...)
end

function CUIUtils:OpenWithClearStack(...)

    return dxm.UIHelper:OpenWithClearStack(...)
end

function CUIUtils:OpenWithGame(...)

    return dxm.UIHelper:OpenWithGame(...)
end

function CUIUtils:OpenWithSystem(...)

    return dxm.UIHelper:OpenWithSystem(...)
end

function CUIUtils:CloseAllGameDialog(...)

    return dxm.CUIManager:GetInstancePtr():CloseAllGameDialog(...)
end

function CUIUtils:LockTouch(...)
    
    dxm.CUIManager:GetInstancePtr():LockTouch()
end


function CUIUtils:UnlockTouch(...)
    
    dxm.CUIManager:GetInstancePtr():UnlockTouch()
end

-- 缓存界面
function CUIUtils:CacheWidget(config, count)
    dxm.UIHelper:CacheWidget(config, count)
end

function CUIUtils:UncacheWidget(config)
    dxm.UIHelper:UncacheWidget(config, count)
end

function CUIUtils:UncacheAllWidget()
    dxm.UIHelper:UncacheAllWidget()
end

-- 添加 spine 动画
function CUIUtils:AddSpineUI(ui, parent_widget, spine_name, ...)

    if not ui then return nil end

    if tolua.type(parent_widget) == "string" then
        parent_widget = ui:GetWidget(parent_widget)
    end
    if not parent_widget then return nil end

    local spine_ui = dxm.CSpineUI:Create(spine_name, ...) 
    if spine_ui then 
        ui:AddChild(parent_widget, spine_ui) 
    end
    return spine_ui 
end

function CUIUtils:AddSpineButtonUI(ui, parent_widget, touch_widget, spine_name, flip)

    if not ui then return end

    flip = flip or false
    if tolua.type(parent_widget) == "string" then
        parent_widget = ui:GetWidget(parent_widget)
    end

    if tolua.type(touch_widget) == "string" then
        touch_widget = ui:GetWidget(touch_widget)
    end

    if not parent_widget  or not touch_widget then return end 
    
    local spine_ui = dxm.CSpineButtonUI:Create(spine_name, touch_widget, flip) 
    if spine_ui then ui:AddChild(parent_widget, spine_ui) end
    return spine_ui
end

-- 果冻按钮随机播放;
function CUIUtils:ShakeLoop(ui, widget)
    
    if not ui then return end
    
    if tolua.type(widget) == "string" then
        widget = ui:GetWidget(widget)
    end
    if not widget then return end 
    sActionUtils:ShakeLoop(widget)
end

-- 气球动画;
function CUIUtils:BalloonLoop(ui, widget,index)
    
    if not ui then return end
    
    if tolua.type(widget) == "string" then
        widget = ui:GetWidget(widget)
    end
    if not widget then return end 
    sActionUtils:BalloonLoop(widget,index)
end

-- 让普通按钮动起来;
function CUIUtils:ShakeClick(ui, widget, callback)

    if not ui then return end

    if tolua.type(widget) == "string" then
        widget = ui:GetWidget(widget)
    end
    if not widget then return end

    local function TouchEvent(sender, eventType)
        if eventType == ccui.TouchEventType.began then
            -- print("Touch Down")
            sActionUtils:ClickDown(widget)
        elseif eventType == ccui.TouchEventType.moved then
            -- print("Touch Move")
        elseif eventType == ccui.TouchEventType.ended then
            -- print("Touch Up")
            sUI:LockTouch()
            sActionUtils:ClickUp(widget, function() 
                sUI:UnlockTouch()
                if callback then callback() end
            end)
        elseif eventType == ccui.TouchEventType.canceled then
            -- print("Touch Cancelled")
            sActionUtils:ClickUp(widget)
        end
    end

    widget:addTouchEventListener(TouchEvent)
    widget:setTouchEnabled(true)
end

-- 使用 lua 的统一界面打开动画(该动画是程序完成的, 让美术能够重用)
function CUIUtils:EnableOpenUILuaAction(ui)

    if not ui then return end
    ui.open_ui_lua_action_enable = true
end

-- Create(module_path, ...)
-- Create(check_unique, module_path, ...)
function CUIUtils:Create(...)

    return dxm.UIHelper:Create(...)
end

function CUIUtils:GetShortcut(...)
    
    return dxm.UIHelper:GetShortcut(...)
end


return CUIUtils

--endregion
